@s HINSTANCE int
@s LPSTR int
@s GLdouble double
@s GLfloat float
@s GLint int
@s GLuint int
@s GLubyte int
@s line i
@s muiObject int
@s TextureList int
@s Global extern
\def\Math{{\it Mathematica\/ }}
\def\ML{{\it MathLink\/ }}
@* OpenGL/GLUT based viewer for \Math.
@d BANNER "GL Viewer for Mathematica"
@d VERSION "2.2"

@c
#ifdef __WIN32__
#  define ARCH "Win32"
#elif defined(__linux__)
#  define ARCH "Linux"
#elif defined(__sgi)
#  define ARCH "Silicon Graphics"
#elif MACINTOSH_MATHLINK
#  define ARCH "Macintosh"
#else
#  define ARCH "Solaris"
#endif
/* do nothing */
#ifdef __WIN32__
#  define MVSleep(ms) Sleep(ms)
#elif MACINTOSH_MATHLINK
# define MVSleep(ms)     MacintoshSleep((UInt32) ms)
#else
#  define MVSleep(ms) usleep(ms)
#endif

#if !MACINTOSH_MATHLINK
#  define HAVE_GLUT_SUBWINDOW 1
#endif
#if MACINTOSH_MATHLINK
#  define DBL_FMT "%Lg"
#else
#  define DBL_FMT "%lg"
#endif

@<Header@>@;
#if MACINTOSH_MATHLINK
#  define RGBColor RGBColor__
#endif
#ifdef __sgi
#define __UNDEF_BACKBUFFER
#endif
#ifndef MAX
#  define MAX(a,b) ((a)>(b) ? (a) : (b))
#endif
#ifndef MIN
#  define MIN(a,b) ((a)<(b) ? (a) : (b))
#endif
#define MAX3(a,b,c) ((a)>(b) ? MAX(a,c) : MAX(b,c))
#define MIN3(a,b,c) ((a)<(b) ? MIN(a,c) : MIN(b,c))

@<Data structures@>@;
void CreateObject(void);
@<Global values@>@;
@<Function prototypes@>@;
@<String scanning@>@;
@<Vector operations in cartesian cordinates@>@;
@<Octal tree of points@>@;
@<Memory management@>@;
@<Utilities@>@;
@<Functions for texture mapping@>@;
@<Read ThreeSript files@>@;
@<Average the normal vectors for the points@>@;
@<Count the length of the polygon/line list@>@;
@<Functions for polygon simplification@>@;
@<Set the background color@>@;
@<Axis drawing@>@;
@<Display the data structure with OpenGL@>@;
@<\Math-like printing@>@;
@<Trackball function@>@;
@<Write POVray file@>@;
@<Write Apple QuickDraw 3D ASCII files@>@;
@<Write Virtual Reality files@>@;
@<Stuff to write a DXF file@>@;
@<Stuff to read a DXF file@>@;
@<Stuff for Geomviews \.{OFF} files@>@;
@<Write PostScript@>@;

@<Macintosh specials@>@;
@<View point control window@>@;
@<Light control window@>@;
@<Axis editor creation@>@;
@<Display function@>@;
@<Animation function for spin@>@;
@<Mouse function call back@>@;
@<Mouse motion call back@>@;
@<Mouse enter call back@>@;
@<New reshape function to store the window size@>@;
@<Microsoft Windows specials@>@;
@<Handle events inside the File menu@>@;
@<Handle events inside the Spin menu @>@;
@<Handle events inside the Rotate menu@>@;
@<Handle events inside of the Appearence menu@>@;
@<Handle events from the main menu@>@;
@<Create the main menu@>@;
@<Exit function@>@;
@<\ML-Functions@>@;
@<Create the package \.{OpenGLViewer.m}@>@;
@<Main@>@;
@<Templates for \.{mprep}@>


@* The display. This function will be responsible for the redrawing of the objects
  in the scene.
@d TWO_PI (2.0*3.14159265358979324)
@d PI 3.14159265358979324
@d SQRT3 (1.73205080756887729)
@<Display function@>=
void MVDisplay(void) {

   if(MakeNewView) {
     glPopMatrix();
     glPushMatrix();
     glTranslated(ZoomMove.x,ZoomMove.y,ZoomMove.z);
     MakeNewView=GL_FALSE;
    }
   if(MakeNewModel) {
     CreateObject();
     MakeNewModel=GL_FALSE;
    }
   if (DoReset) {
     glPopMatrix(); /* get the old matrix */
     glPushMatrix(); /* restore it for the next call */
     glTranslated(ZoomMove.x+CenterOfScene.x,
          ZoomMove.y+CenterOfScene.y,
          ZoomMove.z+CenterOfScene.z);
     if(DoTracking)
       glRotated(TrackAngle*ToDegree, TrackAxis.x, TrackAxis.y, TrackAxis.z);
     glTranslated(-CenterOfScene.x,-CenterOfScene.y,-CenterOfScene.z);
     if(DoReset) DoReset=GL_FALSE;
   }
  else if(DoTracking) {
    if(!DoTrackSpin && GetMouseTrack) {
      Point3D axis;
      
      MVTrackball(&TrackAngle,&axis,ScreenXStart,ScreenYStart,ScreenX,ScreenY);
      if(ROTATE_X==(DoRotate & ROTATE_X)) TrackAxis=XUnitVector;
      else if(ROTATE_Y==(DoRotate & ROTATE_Y)) TrackAxis=YUnitVector;
      else if(ROTATE_Z==(DoRotate & ROTATE_Z)) TrackAxis=ZUnitVector;
      else TrackAxis=axis;
      DTrackAngle=MIN(TWO_PI/90.0,TrackAngle);
     }
    else
      TrackAngle+=DTrackAngle;
   }
  if(TrackAngle) {
    @<Do the rotation arround the track angle@>@;
   }
  if(!DoPSOutput) glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  if(ObjID>0)
    glCallList(ObjID);
  if(!DoPSOutput) {
#if defined(__UNDEF_BACKBUFFER)
  glPixelStorei(GL_PACK_ALIGNMENT,1);
  glReadPixels(0,0,ScreenWidth,ScreenHeight,GL_RGB,GL_UNSIGNED_BYTE,DrawBufferCopy);    
#endif
    glutSwapBuffers();
   }
}

@ @<Do the rotation arround the track angle@>=
     glPopMatrix(); /* get the old matrix */
     glPushMatrix(); /* restore it for the next call */
     glTranslated(ZoomMove.x+CenterOfScene.x,
          ZoomMove.y+CenterOfScene.y,
          ZoomMove.z+CenterOfScene.z);
     glRotated(TrackAngle*ToDegree, TrackAxis.x, TrackAxis.y, TrackAxis.z);
     glTranslated(-CenterOfScene.x,-CenterOfScene.y,-CenterOfScene.z);

@ @<Animation function for spin@>=
void MVAnimate(void)
{ 
  if(MathLinkMode && MathLinkActive) {
    if (!ProcessMathLink(&LinkToMath)) exit(0);
#ifdef __WIN32__
    MLCallYieldFunction(
      MLYieldFunction(LinkToMath),
      LinkToMath,(MLYieldParameters) 0
     );
#endif
    MVSleep(50);
   }

  if(DoTracking && MouseInsideMain)
    glutPostRedisplay();
  else
    MVSleep(50);  
}


@ @<Mouse function call back@>=
void MVMouseButton(int btn, int state, int x, int y)
{
  if(btn != GLUT_LEFT_BUTTON || !(DoTracking || DoRotate)) return;
  switch(state) {
    case GLUT_DOWN :
      ScreenXStart=ScreenX=x;
      ScreenYStart=ScreenY=y;
      DoTrackSpin=GL_FALSE;
      break;
    case GLUT_UP :
      ScreenX=x;
      ScreenY=y;
      if(!DoRotate) DoTrackSpin=GL_TRUE;
      break;
   }
}

@ @<Mouse motion call back@>=
void MVMouseMove(int x, int y)
{
  if(!DoTracking) return;
  ScreenX=x;
  ScreenY=y;
  glutPostRedisplay();
}

@ @<Mouse enter call back@>=
void MVMouseEnterMain(int state)
{
  if(GLUT_ENTERED==state && glutGetWindow()!=MVDrawWindow) {
    glutSetWindow(MVDrawWindow);
   }
  if(GLUT_ENTERED==state) 
    MouseInsideMain=GL_TRUE;
  else
    MouseInsideMain=GL_FALSE;
}

@ @<New reshape function to store the window size@>=
void MVReshape(int w, int h)
{
  glViewport(0,0,w,h);
  ScreenWidth=w;
  ScreenHeight=h;
#if defined(__UNDEF_BACKBUFFER)
  if(DrawBufferCopy) free(DrawBufferCopy);
  DrawBufferSize=(size_t) 3L*w*h;
  DrawBufferCopy=(GLubyte *)calloc(DrawBufferSize,sizeof(GLubyte));
#endif
}


@ @<Trackball function@>=
void MVTrackball(double *angle,
         Point3D *axis,
         int x1, int y1,
         int x2, int y2)
{ double phi1,theta1,phi2,theta2,n,arg;
  Point3D v1,v2;

  phi1=PI*(2.0*x1-ScreenWidth)/((double) ScreenWidth);
  phi2=PI*(2.0*x2-ScreenWidth)/((double) ScreenWidth);
  theta1=PI*(ScreenHeight-y1)/((double) ScreenHeight);
  theta2=PI*(ScreenHeight-y2)/((double) ScreenHeight);
  CartesianFromSpherical(1.0,theta1,phi1,&v1);
  CartesianFromSpherical(1.0,theta2,phi2,&v2);
  Cross(axis,&v2,&v1);
  n=Norm(axis);
  if(n>0.0) {
    axis->x/=n;
    axis->y/=n;
    axis->z/=n;
   }
  else {
    axis->x=axis->y=0.0;
    axis->z=1.0;
   }
  if(ROTATE_Z==(DoRotate & ROTATE_Z)) {
    *angle=phi2-phi1;
    return;
   }
  else if ((ROTATE_X ==(DoRotate & ROTATE_X)) || 
	   (ROTATE_Y==(DoRotate & ROTATE_Y))) {
    *angle=TWO_PI*(y2-y1)/((double) ScreenHeight);
    return;
   }
  n=Norm(&v1);
  if(n>0.0) {
    v1.x/=n;
    v1.y/=n;
    v1.z/=n;
   }
  n=Norm(&v2);
  if(n>0.0) {
    v2.x/=n;
    v2.y/=n;
    v2.z/=n;
   }
  arg=Dot(&v1,&v2);
  if(arg<-1.) arg=-1.0;
  else if (arg>1.0) arg=1.0;
  *angle=acos(arg);
}

@* Commandline interface.

@ @<Create the command line options@>=
  cmdln=DeclareCmdArg("mvfile",CMD_STRING,&ThreeScriptName,"       3Script input file.");
  cmdln=AppendCmdArg(DeclareCmdArg("mvs",CMD_SWITCH,&SmoothShading,
           "shows smooth/flat input data"),cmdln);
  cmdln=AppendCmdArg(DeclareCmdArg("mvw",CMD_SWITCH,&WireFrame,
           "show data as WireFrame"),cmdln);
  cmdln=AppendCmdArg(DeclareCmdArg("mvo",CMD_SWITCH,&PolyOutline,
           "show polygon outline"),cmdln);
  cmdln=AppendCmdArg(DeclareCmdArg("mvct",CMD_SWITCH,&COMTriangulation,
           "triangulate n-gons (n>4) with a new point in the center"),cmdln);

  cmdln=AppendCmdArg(DeclareCmdArg("mvts",CMD_DOUBLE,&LineTubeSize,
           "tube size of lines -- if given lines appear as tubes"),cmdln);
  cmdln=AppendCmdArg(DeclareCmdArg("mvta",CMD_DOUBLE,&LineSegmentAngle,
           "maximum angle for smooth line continuation"),cmdln);
  cmdln=AppendCmdArg(DeclareCmdArg("mvps",CMD_DOUBLE,&PointSphereSize,
           "sphere size of points -- if given points appear as spheres"),cmdln);
  cmdln=AppendCmdArg(
         DeclareCmdArg("mvpov",CMD_STRING,&POVOutName,
           "       POVRay output file."),
         cmdln);
  cmdln=AppendCmdArg(
         DeclareCmdArg("mvdxf",CMD_STRING,&DXFOutName,
           "       DXF output file."),
         cmdln);
  cmdln=AppendCmdArg(
         DeclareCmdArg("mv3dm",CMD_STRING,&QD3dOutName,
           "       QuickDraw3D output file."),
         cmdln);
  cmdln=AppendCmdArg(
         DeclareCmdArg("mvwrl",CMD_STRING,&VRMLOutName,
           "       VMRL 2.0 output file."),
         cmdln);
  cmdln=AppendCmdArg(DeclareCmdArg("mvue",CMD_SWITCH,&UseVRMLExtrusion,
           "use Extrusions in VRML export"),cmdln);
  cmdln=AppendCmdArg(
         DeclareCmdArg("mvindxf",CMD_STRING,&DXFInputName,"     DXF input file."),
         cmdln);
  cmdln=AppendCmdArg(
         DeclareCmdArg("mvinoff",CMD_STRING,&OFFInputName,"     OFF input file."),
         cmdln);
  cmdln=AppendCmdArg(
         DeclareCmdArg("mvtex",CMD_STRING,&TextureName,
           "       PNG file of texture."),
         cmdln);
  cmdln=AppendCmdArg(
         DeclareCmdArg("mvtxm",CMD_STRING,&TexMapType,
           "       mapping type of the texture {planar,cylindrical,spherical,torus}."),
         cmdln);
  cmdln=AppendCmdArg(DeclareCmdArg("mvno",CMD_SWITCH,&NoDisplay,
           "run as filter and do not display the 3Script"),cmdln);
  cmdln=AppendCmdArg(DeclareCmdArg("mvcp",CMD_SWITCH,&MakePackage,
           "Create OpenGLViewer.m package"),cmdln);
  cmdln=AppendCmdArg(DeclareCmdArg("mvpr",CMD_DOUBLE,&PolyReduceFactor,
           "        value for polygon reduction polygons with distance less are removed."),cmdln);
  cmdln=AppendCmdArg(DeclareCmdArg("mvrit",CMD_INTEGER,&PolyReduceIterations,
           "        number for polygon reduction iterations."),cmdln);



@ @<Write the help message and |return|@>=
#ifndef __WIN32__
  HelpCmdArg(BANNER,cmdln);
#else
  MessageBox(MLIconWindow,
    "(c) Jens-Peer Kuska 1997-99\n\n"
    "usage:  -mvfile 3script -opt val ..\n\n"@|
    "-mvfile <3script>    show 3Script\n"@|
    "-mvindxf <dxf file>  show dxf file\n"@|
    "-mvinoff <off file>  show off file\n\n"@|
    "-mvpov <pov file>    write POVRay file\n"@|
    "-mv3dm <3dmf file>   write QuickDraw3D file\n"@|
    "-mvwrl <wrl file>    write VRML 2 file\n"@|
    "-mvdxf <dxf file>    write dxf file\n\n"@|
    "-mvtex <png file>    use png file as texture\n"@|
    "-mvtxm p|c|s|t       texture map type\n\n"@|
    "+|-mvno            run as filter don't render\n"@|
    "+|-mvs               turn smooth shading on|off\n"@|
    "+|-mvw              wire frame on|off\n"@|
    "+|-mvo               polygon outlines on|off\n"@|
    "-mvts <real>    tube size of lines\n"@|
    "-mvps <real>   point sphere size\n"@|
    "+|-mvcp             create Mathematica package\n\n"@|
    "-mvpr <real>    polygon reduction factor\n"@|
    "-mvrit <int>        iterations for polygon reduction\n",
    "MathGL3d "VERSION,
    MB_OK | MB_ICONINFORMATION | MB_TASKMODAL |MB_SETFOREGROUND);
#endif
  return 1;

@ @<Evaluate the command line options@>=
#if !MACINTOSH_MATHLINK
   if (argc<=1) {
     @<Write the help message and |return|@>@;
    }
#endif    
#ifdef __WIN32__
   cmdln=ScanCommandline(cmdln,_argc,_argv);
#else
   cmdln=ScanCommandline(cmdln,argc,argv);
#endif
   if(*ThreeScriptName) {
     Read3Script(ThreeScriptName);
     AveragedNormals(Polygons);
    }
   if(!(*ThreeScriptName) && *DXFInputName) {
     ReadDXF(DXFInputName);
     AveragedNormals(Polygons);
    }
   if(!(*ThreeScriptName) && !(*DXFInputName) && *OFFInputName) {
     ReadOFF(OFFInputName);
     AveragedNormals(Polygons);
    }
   if(MakePackage && CreateOGLPackage(argc,argv))
      return 0;
   if(PolyReduceIterations>0 && PolyReduceFactor>0.0 && Polygons) {
     SimplifyPolygones(PolyReduceIterations, PolyReduceFactor,
         OctalPointTree);
    }

   @<Calculate the $\cos$ of |LineSegmentAngle|@>@;
#ifdef __WIN32__
   MathLinkMode=IsMathLinkCall(_argc,_argv);
#else
   MathLinkMode=IsMathLinkCall(argc,argv);
#endif
   @<Initialise the \ML-connection@>@;
   if(*ThreeScriptName && *POVOutName)
     WritePOVray(POVOutName,SmoothShading,"mvs","mvm");
   if(*ThreeScriptName && *DXFOutName)
     WriteDXF(DXFOutName);
   if(*ThreeScriptName && *QD3dOutName)
     Write3DMF(QD3dOutName,GL_TRUE,GL_TRUE);
   if(*ThreeScriptName && *VRMLOutName)
     WriteVRML(VRMLOutName,GL_FALSE,UseVRMLExtrusion,"mvs","mvm");
   if(*TextureName) {
     Textures=ReadPNGTexture(Textures,TextureName,1.0,GL_FALSE);
     if(Textures)
       @<Create the texture mapping from the command line@>@;
    }
   if(NoDisplay) {
     RemoveCmdArgs(cmdln);
     return 0;
    }

@ @<Calculate the $\cos$ of |LineSegmentAngle|@>=
   CosSkipCont=cos(ToRadian*(fabs(LineSegmentAngle)<MaxLSAngle? LineSegmentAngle : MaxLSAngle));

@ @<Global values@>=
char ThreeScriptName[256]="";
char DXFInputName[256]="";
char OFFInputName[256]="";
char TextureName[256]="";
char TexMapType[256]="planar";
int SmoothShading=GL_FALSE;
int WireFrame=GL_FALSE;
int PolyOutline=GL_FALSE;
int COMTriangulation=GL_FALSE; /* triangulate with a new point in the center */
Point3D ZoomMove={0.,0.,0.};
Point3D CenterOfScene={0.0,0.0,0.0};
Point3D ScaleOfScene={1.0,1.0,1.0};
Point3D BoxRatios={1.0,1.0,1.0};
const Point3D XUnitVector={1.0,0.0,0.0};
const Point3D YUnitVector={0.0,1.0,0.0};
const Point3D ZUnitVector={0.0,0.0,1.0};
double MaxScaleOfScene=1.0;
int MakeNewView=GL_FALSE;
double RadialZoom=1.0;

@ Output file names to run as filter.
@<Global values@>=
char POVOutName[256]="";
char DXFOutName[256]="";
char QD3dOutName[256]="";
char VRMLOutName[256]="";
int UseVRMLExtrusion=GL_TRUE;
int NoDisplay=GL_FALSE;
int MakePackage=GL_FALSE;

@ |LineTubeSize| controls the appearence of lines. If it is unequal to 0 lines are drawn as tubes.
  Simmilar to |LineTubeSize| the variable |PointSphereSize| controls the
  appearence of points. If |PointSphereSize| is greather than zero points are
  drawn as spheres of that size.
  When lines are continued we will only use smooth continuation for
  line segments with an angle less than |LineSegmentAngle|. The maximum allowed
  angle where continuation is possible is |MaxLSAngle|.
@d MaxLSAngle (75.0)
@<Global values@>=
double LineTubeSize=0.0;
int BlackBackground=GL_TRUE;
int MouseInsideMain=GL_TRUE;
int TubeSegments=12;
int LineColor=1.0;
double LineSegmentAngle=30.; /* degree */
double CosSkipCont;
double PointSphereSize=0.0;
const RGBColor Black={0.0,0.0,0.0};
const RGBColor White={1.0,1.0,1.0};
RGBColor ClearColor;
Point3D XAxis={1.0,0.0,0.0};
Point3D YAxis={0.0,1.0,0.0};
Point3D ZAxis={0.0,0.0,1.0};
const Point3D ZeroPoint={0.0,0.0,0.0};

@ @<Global values@>=
int MakeNewModel=GL_FALSE;
int MVFaceFlip=GL_FALSE;
int DoReset=GL_FALSE;
int DoTracking=GL_FALSE;
int DoTrackSpin=GL_FALSE;
int DoRotate=GL_FALSE;
int GetMouseTrack=GL_TRUE;
int ScreenX,ScreenY;
int ScreenXStart,ScreenYStart;
#if defined(__UNDEF_BACKBUFFER)
size_t DrawBufferSize=0;
GLubyte *DrawBufferCopy=NULL;
#endif
Point3D TrackAxis;
double TrackAngle,DTrackAngle;
int ScreenWidth,ScreenHeight;

@* The menu initialisation.
@d MENU_ID_SAVE_BASE           (100)
@d MENU_ID_SAVEPOVRAY          (101)
@d MENU_ID_SAVE_3DMF           (102)
@d MENU_ID_SAVE_VRML           (103)
@d MENU_ID_SAVEPOSTSCRIPT      (104)
@d MENU_ID_SAVE_BITMAP_EPS     (105)
@d MENU_ID_SAVE_DXF            (106)
@d MENU_ID_SAVE_OFF            (107)
@d MENU_ID_SAVE_PNG            (108)
@d MENU_ID_LOAD_XXX            (121)

@d MENU_ID_SPIN_X          (201)
@d MENU_ID_SPIN_Y          (202)
@d MENU_ID_SPIN_Z          (203)
@d MENU_ID_SPIN_SLOW       (204)
@d MENU_ID_SPIN_FAST       (205)
@d MENU_ID_SPIN_TRACKBALL  (206)
@d MENU_ID_STOP            (207)

@d MENU_ID_ROTATE       (501)
@d MENU_ID_ROTATE_X     (502)
@d MENU_ID_ROTATE_Y     (503)
@d MENU_ID_ROTATE_Z     (504)

@d MENU_ID_SHOW_SMOOTH  (301)
@d MENU_ID_SHOW_FLAT    (302)
@d MENU_ID_SHOW_WIRE    (303)
@d MENU_ID_TOGGLE_BACK  (304)
@d MENU_ID_SHOW_OUTLINE (305)

@d MENU_ID_VIEWCONTROL  (401)
@d MENU_ID_LIGHTCONTROL (402)
@d MENU_ID_AXISCONTROL  (403)
@d MENU_ID_ABOUT        (404)
@d MENU_ID_RESET        (405)
@d MENU_ID_FLIP_FACE    (406)
@d MENU_ID_ZOOM_IN      (407)
@d MENU_ID_ZOOM_OUT     (408)
@d MENU_ID_CLEAR        (409)
@d MENU_ID_QUIT         (666)

@<Global values@>=
int menuIDMain;
int menuIDFiles;
int menuIDSpin;
int menuIDRotate;
int menuIDAppear;

@ Create the main menu and attatch it to the right mouse button
@<Create the main menu@>=
void MVCreateMainMenu(void) {

   @<Submenu for files@>@;
   @<Submenu for spin of the object@>@;
   @<Submenu for the rotation of the object@>@;
   @<Submenu for the appearence of the object@>@;
   menuIDMain=glutCreateMenu(MVWinMainMenu);
   glutAddSubMenu("Files...",menuIDFiles);
   glutAddSubMenu("Spin...",menuIDSpin);
   glutAddSubMenu("Rotate ...",menuIDRotate);
   glutAddSubMenu("Appearence ...",menuIDAppear);
   glutAddMenuEntry("Change view point",MENU_ID_VIEWCONTROL);
   glutAddMenuEntry("Change lights",MENU_ID_LIGHTCONTROL);
   glutAddMenuEntry("Axis Editor",MENU_ID_AXISCONTROL);
   glutAddMenuEntry("Reset view",MENU_ID_RESET);
   glutAddMenuEntry("Zoom out",MENU_ID_ZOOM_OUT);
   glutAddMenuEntry("Zoom in",MENU_ID_ZOOM_IN);
   glutAddMenuEntry("Flip faces",MENU_ID_FLIP_FACE);
   glutAddMenuEntry("Clear window",MENU_ID_CLEAR);
#ifdef __WIN32__
   if(MathLinkMode)
     glutAddMenuEntry("About",MENU_ID_ABOUT);
#endif
   if(! MathLinkMode) {
     glutAddMenuEntry("About",MENU_ID_ABOUT);
     glutAddMenuEntry("Quit",MENU_ID_QUIT);
    }

   glutAttachMenu(GLUT_RIGHT_BUTTON);
  }

@ @<Macintosh specials@>=
#if MACINTOSH_MATHLINK
  @<Wait for a Macintosh event@>@;
  @<Place the preview window |winid| relative to the main window@>@;
  @<Create a new file with name, type and creator@>@;
  @<Get Macintosh full path@>@;
  @<Macintosh dialog to load a file@>@;  
  @<Ask for a file name to save the file@>@;
#endif

@ @<Wait for a Macintosh event@>=
void MacintoshSleep(UInt32);

void MacintoshSleep(UInt32 ms)
{ EventRecord theEvent;
  EventMask mask=everyEvent;
  UInt32 sleep=1;

  Delay(1,&sleep);
} 

@ Since the GLUT on a Macintosh has no subwindow support the preview window
must be placed manual.
@<Place the preview window |winid| relative to the main window@>=
int MacPreviewPlacement(int , int, int);
int MacPreviewPlacement(int parent,int winid,int activeid)
{ int x,y,wy,wx,cwy,cwx;

  glutSetWindow(MVDrawWindow);
  x=glutGet(GLUT_WINDOW_X);
  y=glutGet(GLUT_WINDOW_Y);
  wx=glutGet(GLUT_WINDOW_WIDTH);
  wy=glutGet(GLUT_WINDOW_HEIGHT);
  glutSetWindow(winid);
  cwx=glutGet(GLUT_WINDOW_WIDTH);
  cwy=glutGet(GLUT_WINDOW_HEIGHT);
  glutPositionWindow(x,y+wy);
  glutPopWindow();
  glutShowWindow();
  glutPostRedisplay();
  glutSetWindow(parent);
  glutShowWindow();
  muiSetActiveUIList(activeid);
#if 0  
  fprintf(stderr,"MUI Lists View   -> %d   Light-> %d   Axis->%d\n",
    VCWindow ? VCWindow->muiID : -1,
    LCWindow ? LCWindow->muiID : -1,
    AxisWindow ? AxisWindow->muiID: -1);
  fprintf(stderr,"MUI       Active ->%d\n",muiGetActiveUIList());
#endif  
  return winid;
}

@ Since the file types are needed a |MacCreateFile| will create a file
with a given type and creator.
@ @<Function prototypes@>+=
FILE  *MacCreateFile(const char *filename,unsigned long ftype, unsigned long creator);

@ @<Create a new file with name, type and creator@>=
FILE  *MacCreateFile(const char *filename,unsigned long ftype, unsigned long creator)
{
  FSSpec fspec;
  OSErr err;
  short int fileRef;
  int i;
  FILE *f;
  unsigned char macfname[256];
  
  macfname[0]=strlen(filename); /* Mac's use Pascal strings as file names */
  for(i=0; i<strlen(filename); i++) /* let's make a Pascal string */
    macfname[i+1]=(unsigned char) filename[i];
  err=FSMakeFSSpec(0L,0L,(const unsigned char *)macfname,&fspec);
  if(err==noErr || err==fnfErr) {
    if(err==noErr) 
      FSpDelete(&fspec);
    err=FSpCreate(&fspec,creator,ftype,smSystemScript);
    if(err==noErr) {
      err=FSpOpenDF(&fspec,fsCurPerm,&fileRef);
      if(err==noErr) FSClose(fileRef);
     }
    else {
      fprintf(stderr,"Error %d create the file %s of the given type ...\n",err,filename);  
      return NULL;
     }   
   }
  else {
    fprintf(stderr,"Error creating FSSpec %d...\n",err);  
    return NULL;
   } 
  f=fopen(filename,"a");
  return f; 
}


@ Get the full path of a file from the volum information and the 
  directory number.
@ @<Function prototypes@>+=
void MacGetFullPath(char *fullPath,
                    long int dirID,
                    int vRefNum);
                    
@ @<Get Macintosh full path@>=
void MacGetFullPath(char *fullPath,
                    long int dirID,
                    int vRefNum)
{
  CInfoPBRec myPB;
  unsigned char dirName[255];
  char cdir[255];
  OSErr myErr;
  int i;
  
  myPB.dirInfo.ioNamePtr=dirName;
  myPB.dirInfo.ioVRefNum=vRefNum;
  myPB.dirInfo.ioDrParID=dirID;
  myPB.dirInfo.ioFDirIndex=-1;
  do {
    myPB.dirInfo.ioDrDirID=myPB.dirInfo.ioDrParID;
    myErr=PBGetCatInfo(&myPB,GL_FALSE);
    for(i=0; i<dirName[0]; i++)
      cdir[i]=dirName[i+1];
    cdir[i++]=':'; @+ cdir[i]='\0';  
    strncat(cdir,fullPath,255);
    strcpy(fullPath,cdir);
  } while(myPB.dirInfo.ioDrDirID!=fsRtDirID);  
}                      

@ The Macintosh version load 3Scripts, DXF and OFF files
  with a menu command.
@ @<Function prototypes@>+=
int MacQueryLoadFilename(char *);
  
@ @<Macintosh dialog to load a file@>=   
int MacQueryLoadFilename(char *filename)
{ short numTypes=1;
  SFTypeList loadTypes={'TEXT',0};  
  StandardFileReply theSFReply;
  int n, i;
  
  StandardGetFile(NULL,numTypes,loadTypes,&theSFReply);
  if(theSFReply.sfGood) {
    n=theSFReply.sfFile.name[0]; /* length of the string */
    for(i=0; i<n; i++)
      filename[i]=theSFReply.sfFile.name[i+1];
    filename[n]='\0';    
    MacGetFullPath(filename,theSFReply.sfFile.parID,theSFReply.sfFile.vRefNum);
    return GL_TRUE;
   }
  else
    return GL_FALSE;
}

@ @<Function prototypes@>+=
int MacQuerySaveFilename(char *cprompt, char *filename);

@ @<Ask for a file name to save the file@>=
int MacQuerySaveFilename(char *cprompt, char *filename)
{ StandardFileReply theSFReply;
  int n, i;
  unsigned char fsuggest[256];
  unsigned char prompt[256];
  
  n=prompt[0]=strlen(cprompt);
  for(i=0; i<n; i++) 
    prompt[i+1]=cprompt[i];
  n=fsuggest[0]=strlen(filename);
  for(i=0; i<n; i++)
    fsuggest[i+1]=filename[i];
   
  StandardPutFile(prompt, fsuggest, &theSFReply);
  if(theSFReply.sfGood) {
    n=theSFReply.sfFile.name[0]; /* length of the string */
    for(i=0; i<n; i++)
      filename[i]=theSFReply.sfFile.name[i+1];
    filename[n]='\0';    
    MacGetFullPath(filename,theSFReply.sfFile.parID,theSFReply.sfFile.vRefNum);
    return GL_TRUE;
   }
  else
    return GL_FALSE;
}


@ @<Microsoft Windows specials@>=
#ifdef __WIN32__
DWORD AboutThreadID;
char GlVersion[512]="";
char GlVendor[512]="";
char GlRender[512]="";
char MlLinkName[512]="None";
#pragma argsused
DWORD WINAPI AboutThread(LPVOID p)
{ char msg[2048];

   sprintf(msg,
           "Version " VERSION "\ncompiled: "__DATE__@|
           "\n(c) Jens-Peer Kuska 1997-99\n"@|
           "e-mail:  kuska@@informatik.uni-leipzig.de\n\n"@|
           "OpenGL\n  %s\n  %s\n  %s\n\n"
           "MathLink\n  %s\n\n"
           "Export prefix  : %s\n"@|
           "Unique Points  : %d of %d\n"@|
           "Polygon number : %ld\n"@|
           "Line number    : %ld\n"@|
           "Point number   : %ld\n"@|
           "Mesh number    : %ld\n"@|
           "Texture number : %ld\n",
          GlVendor,
          GlVersion,
          GlRender,
          MlLinkName,
          WriteFilePrefix,
          PoolSize,MaxPoolSize,
          LengthLinePolyList(Polygons),
          LengthLinePolyList(Lines),
          LengthPointList(Points),
          LengthMesh3DList(Meshes),
          LengthTextureList(Textures)
         );
       MessageBox(MLIconWindow,
         msg,@|
         "About MathGL3d",MB_OK | MB_ICONINFORMATION | MB_TASKMODAL |MB_SETFOREGROUND);
       return 0;
}

#endif

@ Event handling in the main menu.
@<Handle events from the main menu@>=
void MVWinMainMenu(int what)
{ double vr,vtheta,vphi;

   switch(what) {
     case MENU_ID_VIEWCONTROL :
       @<Reset the global parameter@>@;
       @<Hide the light control dialog@>@;
       @<Hide the axis control dialog@>@;
       if(!VCWindow) 
         VCWindow=CreateViewControl();
       CopyToVCWindow();
       glutSetWindow(VCWindow->PreviewWinID);
       glutShowWindow();      
       glutPostRedisplay();
       glutSetWindow(VCWindow->WinID);
       glutShowWindow();
       glutPostRedisplay();
       break;
     case MENU_ID_LIGHTCONTROL :
       @<Reset the global parameter@>@;
       @<Hide the view point control dialog@>@;
       @<Hide the axis control dialog@>@;
       if(!LCWindow) 
         LCWindow=CreateLightControl();
       CopyToLCWindow();
       glutSetWindow(LCWindow->PreviewWinID);
       glutShowWindow();
       glutPostRedisplay();
       glutSetWindow(LCWindow->WinID);
       glutShowWindow();
       glutPostRedisplay();
       break;
     case MENU_ID_AXISCONTROL :
       @<Reset the global parameter@>@;
       @<Hide the view point control dialog@>@;
       @<Hide the light control dialog@>@;
       if(!AxisWindow)
         AxisWindow=CreateAxisControl();
       CopyToAxisWindow();
       glutSetWindow(AxisWindow->PreviewWinID);
       glutShowWindow();
       SetBackgroundColor(BlackBackground);
       glutPostRedisplay();
       glutSetWindow(AxisWindow->WinID);
       glutShowWindow();
       glutPostRedisplay();
       break;
     case MENU_ID_RESET:
       @<Reset the global parameter@>@;
       break;
     case MENU_ID_FLIP_FACE :
       ReversePolygons(Polygons);
       AveragedNormals(Polygons);
       Meshes=FlipMeshNormals(Meshes);
       MVFaceFlip=!MVFaceFlip;
       MakeNewModel=GL_TRUE;
       break;
     case MENU_ID_ZOOM_OUT :
       RadialZoom*=1.5;
       @<Recalculate the zoom translation@>@;
       break;
     case MENU_ID_ZOOM_IN :
       RadialZoom/=1.5;
       @<Recalculate the zoom translation@>@;
       break;
     case MENU_ID_ABOUT:
#ifdef __WIN32__
       strcpy(GlVendor,(char *)glGetString(GL_VENDOR));
       strcpy(GlVersion,(char *)glGetString(GL_VERSION));
       strcpy(GlRender,(char *)glGetString(GL_RENDERER));
       if(MathLinkMode)
         strcpy(MlLinkName,MLName(LinkToMath));
       CreateThread(NULL,8096,(LPTHREAD_START_ROUTINE) AboutThread,
                    NULL,0,&AboutThreadID);
#else
      { int i;

       printf(BANNER
          " (c) Jens-Peer Kuska  Version " VERSION    @|
          "\nfor " ARCH "\ncompiled at "__DATE__ "\n");
       printf("OpenGL:\n\t%s\n\t%s\n\t%s\n",
	      glGetString(GL_VENDOR),glGetString(GL_VERSION),
	      glGetString(GL_RENDERER));
       if(*ThreeScriptName)
         printf("3Script file   : %s\n",ThreeScriptName);
       printf("File write     : %s*.*\n",WriteFilePrefix);
       if(*DXFInputName)
         printf("DXF file       : %s\n",DXFInputName);
       printf("Screen         : %d x %d\n",ScreenWidth,ScreenHeight);
       printf("Center         : {"DBL_FMT", "DBL_FMT", "DBL_FMT"}\n",
          CenterOfScene.x,CenterOfScene.y,CenterOfScene.z);
       printf("Scaling        : {"DBL_FMT", "DBL_FMT", "DBL_FMT"}\n",
          ScaleOfScene.x,ScaleOfScene.y,ScaleOfScene.z);
       printf("View point     : {"DBL_FMT", "DBL_FMT", "DBL_FMT"}\n",
	  ViewPoint.x,ViewPoint.y,ViewPoint.z);
       if(ObjID>0)
         printf("Compiled obj   : %d\n",ObjID);
       if(PoolSize)
         printf("Unique Points  : %d of %d\n",PoolSize,MaxPoolSize);
       printf("Polygon number : %ld\n",LengthLinePolyList(Polygons));
       printf("Line number    : %ld\n",LengthLinePolyList(Lines));
       printf("Point number   : %ld\n",LengthPointList(Points));
       printf("Mesh number    : %ld\n",LengthMesh3DList(Meshes));
       printf("Texture number : %ld\n",LengthTextureList(Textures));
       printf("Polygon shading: %s\n",SmoothShading ?  "Smooth" : "Flat" );
       printf("Wire frame     : %s\n",WireFrame ? "On" : "Off");
       printf("Poly Outlines  : %s\n",PolyOutline ? "On" : "Off");
       printf("Tracking mode  : %s\n",DoTracking ? "On" : "Off");
       printf("Light sources  :\n");
       for(i=0; i<LightNo; i++)
         printf("\t Light[[%d]] -> {{"DBL_FMT
                ", "DBL_FMT", "DBL_FMT
                "},RGBColor["DBL_FMT", "DBL_FMT", "DBL_FMT"]}\n",
		i,
		LightPosition[i].x,
		LightPosition[i].y,
		LightPosition[i].z,
		LightColor[i].r,
		LightColor[i].g,
		LightColor[i].b);
     }
#endif
       break;
     case MENU_ID_CLEAR:
       mvClearContents();
       break;
     case MENU_ID_QUIT :
       exit(0);
       break;
    }
   glutPostRedisplay();
}

@ @<Reset the global parameter@>=
 DoReset=GL_TRUE;
 DoTracking=DoTrackSpin=GL_FALSE;
 DoRotate=GL_FALSE;
 ZoomMove.x=ZoomMove.y=ZoomMove.z=0.0;
 RadialZoom=1.0;
 TrackAngle=0.0;
 TrackAxis.x=TrackAxis.y=0.0;
 TrackAxis.z=1.0;
 ScreenXStart=ScreenX=0;
 ScreenYStart=ScreenY=0;
 BlackBackground=GL_TRUE;
 SetBackgroundColor(BlackBackground);
 glutSetCursor(GLUT_CURSOR_LEFT_ARROW);
 Axis.AxisType=NoAxis;

@ @<Recalculate the zoom translation@>=
  SphericalFromCartesian(&ViewPoint, &vr,  &vtheta, &vphi);
  ZoomMove.x=ViewPoint.x-RadialZoom*vr*cos(vphi)*sin(vtheta);
  ZoomMove.y=ViewPoint.y-RadialZoom*vr*sin(vphi)*sin(vtheta);
  ZoomMove.z=ViewPoint.z-RadialZoom*vr*cos(vtheta);

  MakeNewView=GL_TRUE;


@ Create the Files-menu.
@<Submenu for files@>=
menuIDFiles=glutCreateMenu(MVWinFileMenu);
#if MACINTOSH_MATHLINK
glutAddMenuEntry("Load 3Script, DXF ..",MENU_ID_LOAD_XXX);
#endif
glutAddMenuEntry("Save POVRay file",MENU_ID_SAVEPOVRAY);
glutAddMenuEntry("Save QuickDraw 3D",MENU_ID_SAVE_3DMF);
glutAddMenuEntry("Save VRML 2.0",MENU_ID_SAVE_VRML);
glutAddMenuEntry("Save PostScript file",MENU_ID_SAVEPOSTSCRIPT);
glutAddMenuEntry("Save DXF file",MENU_ID_SAVE_DXF);
glutAddMenuEntry("Save OFF file",MENU_ID_SAVE_OFF);
glutAddMenuEntry("Save PNG bitmap",MENU_ID_SAVE_PNG);
glutAddMenuEntry("Save EPS bitmap",MENU_ID_SAVE_BITMAP_EPS);


@ @<Global values@>+=
char WriteFilePrefix[256]="mview3d";


@ MS-Windows file dialog.
@<Query file name@>=
char *MVQuerySaveFilename(char *suggest,
                          char *filter,
                          char *ext,
                          int len, int *fail)
{
#ifdef __WIN32__
  OPENFILENAME ofn;

  ofn.lStructSize=sizeof(ofn);
  ofn.hwndOwner=GetForegroundWindow();
  ofn.hInstance=NULL;
  ofn.lpstrFilter=filter;
  ofn.lpstrCustomFilter=NULL;
  ofn.nMaxCustFilter=0;
  ofn.nFilterIndex=1;
  ofn.lpstrFile=suggest;
  ofn.nMaxFile=len;
  ofn.lpstrTitle=NULL;
  ofn.lpstrInitialDir=NULL;
  ofn.Flags=OFN_HIDEREADONLY | OFN_PATHMUSTEXIST | OFN_EXPLORER | OFN_LONGNAMES;
  ofn.nFileOffset=0;
  ofn.nFileExtension=0;
  ofn.lpstrDefExt=ext;
  ofn.lCustData=0L;
  ofn.lpfnHook=0L;
  ofn.lpTemplateName=(LPSTR) NULL;
  ofn.lpstrTitle="MathGL3d - Save";
  *fail=!GetSaveFileName(&ofn);
  return (*fail ? NULL : suggest);
#else
  *fail=GL_FALSE;
  return suggest;
#endif
}

@ MS thread for saving of output formats.
@<Microsoft Windows specials@>+=
@<Query file name@>@;


@ @<Handle events inside the File menu@>=
void MVWinFileMenu(int what)
{ char fname[256];
  int res=GL_FALSE;

  strcpy(fname,WriteFilePrefix);
  switch(what) {
#if MACINTOSH_MATHLINK
    case MENU_ID_LOAD_XXX :
      if(MacQueryLoadFilename(fname)) {
         glutSetCursor(GLUT_CURSOR_WAIT);
         if(strstr(fname,".ts") || strstr(fname,".TS")) {
           res=Read3Script(fname);
          } 
         else if (strstr(fname,".dxf") || strstr(fname,".DXF")) {
           res=ReadDXF(fname);
          }
         glutSetCursor(GLUT_CURSOR_LEFT_ARROW); 
         if(!res) {
           AveragedNormals(Polygons);
           glutSetWindow(MVDrawWindow);
           glutPopWindow();
           glutShowWindow();
           @<Update the object and the viewpoint@>@;
           glFinish();       
           @<Reset the global parameter@>@;
          }
         aglUpdateCurrent(); 
       }
      break;
#endif  
    case MENU_ID_SAVEPOVRAY :
      glutSetCursor(GLUT_CURSOR_WAIT);
      strcat(fname,SmoothShading ? "s.pov": "f.pov");
#if MACINTOSH_MATHLINK
     if(MacQuerySaveFilename("Save POV-Ray file as:",fname)) {
       WritePOVray(fname,SmoothShading,"mvs","mvm");
      }  
#else      
      WritePOVray(fname,SmoothShading,"mvs","mvm");
#endif 
      glutSetCursor(GLUT_CURSOR_LEFT_ARROW);
      break;
    case MENU_ID_SAVE_3DMF :
      glutSetCursor(GLUT_CURSOR_WAIT);
      strcat(fname,".3dmf");
#if MACINTOSH_MATHLINK
     if(MacQuerySaveFilename("Save QuickDraw3D file as:",fname)) {
       Write3DMF(fname,GL_TRUE,GL_TRUE);
      }  
#else       
      Write3DMF(fname,GL_TRUE,GL_TRUE);
#endif      
      glutSetCursor(GLUT_CURSOR_LEFT_ARROW);
      break;
    case MENU_ID_SAVE_VRML :
      glutSetCursor(GLUT_CURSOR_WAIT);
      strcat(fname,".wrl");
#if MACINTOSH_MATHLINK
     if(MacQuerySaveFilename("Save VRML 2.0 file as:",fname)) {
       WriteVRML(fname,GL_FALSE,UseVRMLExtrusion,"mvs","mvm");
      }  
#else       
      WriteVRML(fname,GL_FALSE,UseVRMLExtrusion,"mvs","mvm");
#endif
      glutSetCursor(GLUT_CURSOR_LEFT_ARROW);
      break;
    case MENU_ID_SAVEPOSTSCRIPT :
      glutSetCursor(GLUT_CURSOR_WAIT);
      strcat(fname,".eps");
#if MACINTOSH_MATHLINK
     if(MacQuerySaveFilename("Save PostScrip file as:",fname)) {
       WritePostScript(fname);
      }  
#else       
      WritePostScript(fname);
#endif      
      glutSetCursor(GLUT_CURSOR_LEFT_ARROW);
      break;
    case MENU_ID_SAVE_DXF :
      glutSetCursor(GLUT_CURSOR_WAIT);
      strcat(fname,".dxf");
#if MACINTOSH_MATHLINK
     if(MacQuerySaveFilename("Save DXF file as:",fname)) {
       WriteDXF(fname);
      }  
#else       
      WriteDXF(fname);
#endif
      glutSetCursor(GLUT_CURSOR_LEFT_ARROW);
      break;
    case MENU_ID_SAVE_OFF :
      glutSetCursor(GLUT_CURSOR_WAIT);
      strcat(fname,".off");
#if MACINTOSH_MATHLINK
     if(MacQuerySaveFilename("Save Geomview file as:",fname)) {
       WriteOFF(fname);
      }  
#else       
      WriteOFF(fname);
#endif
      glutSetCursor(GLUT_CURSOR_LEFT_ARROW);
      break;
    case MENU_ID_SAVE_PNG :
      strcat(fname,".png");
#if MACINTOSH_MATHLINK
     if(MacQuerySaveFilename("Save PNG file as:",fname)) {
        @<Select the main window@>@;
        PNGSaveFrameBuffer(fname,
          0,0,glutGet(GLUT_WINDOW_WIDTH),
            glutGet(GLUT_WINDOW_HEIGHT),GL_FALSE,1.0);
      }  
#else       
#  if defined(__UNDEF_BACKBUFFER)
    PNGSaveBitmap(fname,
     ScreenWidth,ScreenHeight,GL_RGB,
     DrawBufferCopy,GL_FALSE,1.0);  
#  else
     PNGSaveFrameBuffer(fname,
        0,0,glutGet(GLUT_WINDOW_WIDTH),
            glutGet(GLUT_WINDOW_HEIGHT),GL_FALSE,1.0);
#  endif
#endif
      break;
    case MENU_ID_SAVE_BITMAP_EPS:
      strcat(fname,"bm.eps");
#if MACINTOSH_MATHLINK
      if(MacQuerySaveFilename("Save PostScrip file as:",fname)) {
        @<Select the main window@>@;
        EPSSaveFrameBuffer(fname,
          0,0,glutGet(GLUT_WINDOW_WIDTH),glutGet(GLUT_WINDOW_HEIGHT));
       }
#else
#  if defined(__UNDEF_BACKBUFFER)
    EPSSaveBitmap(fname,
      0,0,ScreenWidth,ScreenHeight,3,DrawBufferCopy,ScreenWidth/72.);
#  else
       EPSSaveFrameBuffer(fname,
        0,0,glutGet(GLUT_WINDOW_WIDTH),glutGet(GLUT_WINDOW_HEIGHT));
#  endif
#endif
      break;
   }
  glutPostRedisplay();
}

@ @<Select the main window@>=
 glutSetWindow(MVDrawWindow);
 glutPopWindow();
 glutShowWindow();      

@ @<Submenu for spin of the object@>=
menuIDSpin=glutCreateMenu(MVWinSpinMenu);
glutAddMenuEntry("Trackball",MENU_ID_SPIN_TRACKBALL);
glutAddMenuEntry("X axes spin",MENU_ID_SPIN_X);
glutAddMenuEntry("Y axes spin",MENU_ID_SPIN_Y);
glutAddMenuEntry("Z axes spin",MENU_ID_SPIN_Z);
glutAddMenuEntry("Spin slower",MENU_ID_SPIN_SLOW);
glutAddMenuEntry("Spin faster",MENU_ID_SPIN_FAST);
glutAddMenuEntry("Halt",MENU_ID_STOP);

@ @<Handle events inside the Spin menu @>=
void MVWinSpinMenu(int what)
{
  @<Hide all control dialog windows@>@;
  DoRotate=GL_FALSE;
  switch(what) {
    case MENU_ID_SPIN_TRACKBALL :
      GetMouseTrack=GL_TRUE;
      @<Switch the tracking mode@>@;
      break;
    case MENU_ID_SPIN_X :
      TrackAxis.x=1.0; @+ TrackAxis.y=TrackAxis.z=0.0;
      @<Set spin parameter for a fixed axis@>@;
      break;
    case MENU_ID_SPIN_Y :
      TrackAxis.y=1.0; @+ TrackAxis.x=TrackAxis.z=0.0;
      @<Set spin parameter for a fixed axis@>@;
      break;
    case MENU_ID_SPIN_Z :
      TrackAxis.z=1.0; @+ TrackAxis.x=TrackAxis.y=0.0;
      @<Set spin parameter for a fixed axis@>@;
      break;
    case MENU_ID_SPIN_SLOW :
       DTrackAngle*=0.5;
      break;
    case MENU_ID_SPIN_FAST :
      DTrackAngle*=2.0;
      break;
    case MENU_ID_STOP :
      @<Stop spining by parameter reset@>@;
      break;
  }
  glutPostRedisplay();
}

@ @<Stop spining by parameter reset@>=
  DoTrackSpin=GL_FALSE;
  TrackAngle=0.0;
  DoTracking=GL_FALSE;
  glutSetCursor(GLUT_CURSOR_LEFT_ARROW);


@ @<Switch the tracking mode@>=
 DoTracking =GL_TRUE;
 DoTrackSpin=GL_FALSE;
 glutSetCursor(GLUT_CURSOR_INFO);

@ @<Set spin parameter for a fixed axis@>=
DoTrackSpin=DoTracking=GL_TRUE;
GetMouseTrack=GL_FALSE;
TrackAngle=0.0;
DTrackAngle=TWO_PI/80.;
glutSetCursor(GLUT_CURSOR_LEFT_ARROW);

@ @<Submenu for the rotation of the object@>=
menuIDRotate=glutCreateMenu(MVWinRotateMenu);
glutAddMenuEntry("Free rotation",MENU_ID_ROTATE);
glutAddMenuEntry("X axes rotation",MENU_ID_ROTATE_X);
glutAddMenuEntry("Y axes rotation",MENU_ID_ROTATE_Y);
glutAddMenuEntry("Z axes rotation",MENU_ID_ROTATE_Z);

@ @d ROTATE_X 2
  @d ROTATE_Y 4
  @d ROTATE_Z 8

@<Handle events inside the Rotate menu@>=
void MVWinRotateMenu(int what)
{
   @<Hide all control dialog windows@>@;
  DoTrackSpin=GL_FALSE;
  DoRotate=GL_FALSE;
  TrackAngle=0.0;
  TrackAxis.x=TrackAxis.y=0.0;
  TrackAxis.z=1.0;
  ScreenXStart=ScreenX;
  ScreenYStart=ScreenY;
  switch(what) {
    case MENU_ID_ROTATE :
      GetMouseTrack=GL_TRUE;
      DoRotate=GL_TRUE;
      @<Switch the tracking mode@>@;
      break;
    case MENU_ID_ROTATE_X :
      GetMouseTrack=GL_TRUE;
      DoRotate=GL_TRUE | ROTATE_X;
      TrackAxis.x=1.0; @+ TrackAxis.y=TrackAxis.z=0.0;
      @<Switch the tracking mode@>@;
      glutSetCursor(GLUT_CURSOR_UP_DOWN);
      break;
    case MENU_ID_ROTATE_Y :
      GetMouseTrack=GL_TRUE;
      DoRotate=GL_TRUE | ROTATE_Y;
      TrackAxis.x=TrackAxis.z=0.0; @+ TrackAxis.y=1.0;
      @<Switch the tracking mode@>@;
      glutSetCursor(GLUT_CURSOR_UP_DOWN);
      break;
    case MENU_ID_ROTATE_Z :
      GetMouseTrack=GL_TRUE;
      DoRotate=GL_TRUE | ROTATE_Z;
      TrackAxis.x=TrackAxis.y=0.0; @+ TrackAxis.z=1.0;
      @<Switch the tracking mode@>@;
      glutSetCursor(GLUT_CURSOR_LEFT_RIGHT);
      break;
   }
  glutPostRedisplay();
}

@ @<Submenu for the appearence of the object@>=
menuIDAppear=glutCreateMenu(MVWinAppearMenu);
glutAddMenuEntry("Smooth surface",MENU_ID_SHOW_SMOOTH);
glutAddMenuEntry("Flat surface",MENU_ID_SHOW_FLAT);
glutAddMenuEntry("Wire frame",MENU_ID_SHOW_WIRE);
glutAddMenuEntry("Toggle b/gray backround",MENU_ID_TOGGLE_BACK);
glutAddMenuEntry("Toggle polyon outlines",MENU_ID_SHOW_OUTLINE);

@ @<Set the background color@>=
void SetBackgroundColor(int isBlack);
void SetBackgroundColor(int isBlack)
 {
   if(isBlack) {
     LineColor=1.0;
     ClearColor.r=ClearColor.g=ClearColor.b=0.;
     glClearColor(0.0,0.0,0.0,1.0);
    }
   else {
     ClearColor.r=ClearColor.g=ClearColor.b=0.8;
     glClearColor(0.8,0.8,0.8,1.0);
     LineColor=0.0;
    }
 }


@ @<Handle events inside of the Appearence menu@>=
void MVWinAppearMenu(int what);
void MVWinAppearMenu(int what)
{
   switch(what) {
     case MENU_ID_SHOW_SMOOTH :
        SmoothShading=GL_TRUE;
        WireFrame=GL_FALSE;
        break;
     case MENU_ID_SHOW_FLAT :
        SmoothShading=GL_FALSE;
        WireFrame=GL_FALSE;
        break;
     case MENU_ID_SHOW_WIRE :
        WireFrame=GL_TRUE;
        PolyOutline=GL_FALSE;
        break;
     case MENU_ID_TOGGLE_BACK:
        BlackBackground=!BlackBackground;
        SetBackgroundColor(BlackBackground);
	break;
     case MENU_ID_SHOW_OUTLINE:
        if(!WireFrame) PolyOutline=!PolyOutline;
        break;
    }
   MakeNewModel=GL_TRUE;
   glutPostRedisplay();
}


@ The |exit| function.
@<Exit function@>=
void MathViewExit(void);
void MathViewExit(void)
{ int i;
  if (PointPool) free(PointPool);
  if(NormalPool)
    for(i=0; i<PoolSize; i++)
      if(NormalPool[i]) free(NormalPool[i]);
  free(NormalPool);
  Points=RemovePointList(Points);
  OctalPointTree=RemovePointOctTree(OctalPointTree);
  Lines=RemoveLinePolyList(Lines);
  Polygons=RemoveLinePolyList(Polygons);
  Meshes=RemoveMesh3DList(Meshes);
  Textures=RemoveTextureList(Textures);
  SceneTextureMap=DeleteTextureMapping(SceneTextureMap);
  if(VCWindow) free(VCWindow);
  if (LCWindow) free (LCWindow);
  if(AxisWindow) free(AxisWindow);
  if(MathLinkMode) {
    @<Close \ML-connection@>@;
   }
}

@ This is for easy calling of the \ML program. Since the
  |argv[0]| includes the location of the program a \Math-package is
  created with that setup the \.{Install[]} command.
@d MVPACKAGE_NAME "OpenGLViewer.m"
@<Create the package \.{OpenGLViewer.m}@>=
#pragma argsused
int CreateOGLPackage(int argc, char *argv[]);
int CreateOGLPackage(int argc, char *argv[])
{ FILE *f;
  char Self[1024];
  int i,n;
#ifdef __WIN32__
  argc=_argc;
  argv=_argv;
#endif
  strcpy(Self,argv[0]);
  n=strlen(Self);
  for(i=0; i<n; i++)
    Self[i]=Self[i]=='\\' ? '/' : tolower(Self[i]);
  f=fopen(MVPACKAGE_NAME,"w");
  if(!f) return GL_FALSE;
  fprintf(f,"(* File : %s, eventual edit the $MVTexturePath value.  *)\n"
	    "(* (c) Jens-Peer Kuska 1997,98,99     *)\n"
	    "(* The file is automatical generated by the +mvcp switch   *)\n",
	  MVPACKAGE_NAME);
  fprintf(f,"(* Mathematica startup file of \"%s\" *)\n"
	    "(* Version %s *)\n",BANNER,VERSION);
  fprintf(f,"(* For %s compiled at %s *)\n\n", ARCH, __DATE__);
  fprintf(f,"Begin[\"System`\"]\n"@|
	    "  If[!MemberQ[Links[],$MVLink],\n"@|
            "    $MVLink=Install[LinkOpen[\"%s -mathlink\"]],\n"@|
	    "    Print[\"The OpenGLViewer is running.\"]\n"@|
	    "   ];\n",Self);
#ifdef __WIN32__
  fprintf(f,"MVShowWindow[];\n");
#endif
  fprintf(f,"Unprotect[MVClose];\n\n"
            "Clear[MVClose];\n\n"
            "MVClose[]:=Uninstall[$MVLink]\n\n"
            "Protect[MVClose];\n\n");
  fprintf(f,"End[];\n\n");
  fprintf(f,"AppendTo[$MVTexturePath,{\"..\",\"..\",\"Textures\"}];\n");
  fclose(f);
#ifdef __WIN32__
  MessageBox(MLIconWindow,
    "Mathematica package\nOpenGLViewer.m\ngenerated.",@|
    "OpenGLViewer Package",MB_OK | MB_ICONINFORMATION | MB_TASKMODAL |MB_SETFOREGROUND);
#else
  printf("Mathematica package %s generated.\n",MVPACKAGE_NAME);
#endif
  return GL_TRUE;
}

@* The main function.
@ This step is for Microsofts OpenGL 1.1. The libraries
   assume that floating point exceptions are masked, just
   as they are by default with Microsoft tools. Borland
   development tools leave the X86 unmasked by default.
@ @<Mask floating point exceptions@>=
#if defined(__WIN32__) && defined(__BORLANDC__)
   _control87(MCW_EM,MCW_EM);
#endif

@ @<Initialize the global values form other modules@>=
Textures=NULL;
TextureCount=1;

@ @<Main@>=
#ifdef __WIN32__
#pragma argsused
int PASCAL WinMain(HINSTANCE hCurInstance,
                   HINSTANCE hPrevInstance,
                   LPSTR lpCmdLine, int nCmdShow) {
char *argv[32];
int argc,i;
char **argv_end=argv+32;
char buff[512];
char *buff_start=buff;
#else
int main(int argc, char *argv[]) {
#endif
   CmdArgLst *cmdln;
   long int err;
   void MathViewExit(void);

   @<Initialize the global values form other modules@>@;
#ifdef __WIN32__
    MLScanString(argv,&argv_end,&lpCmdLine,&buff_start);
    argc=argv_end-argv;
    for(i=argc; i>0; i--)
      argv[i]=argv[i-1];
    argv[0]="mathview3d";
    argc++;
#endif
   @<Create the command line options@>@;
   atexit(MathViewExit);
   @<Mask floating point exceptions@>@;
#ifdef __WIN32__
   glutInit(&_argc,_argv);
#else
   glutInit(&argc,argv);
#endif
   @<Evaluate the command line options@>@;
   RemoveCmdArgs(cmdln);
   glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH);
#if MACINTOSH_MATHLINK
   glutInitWindowSize(300,300);
   glutInitWindowPosition(glutGet(GLUT_SCREEN_WIDTH)-310,10);
#endif   
   MVDrawWindow=glutCreateWindow(BANNER);
#if MACINTOSH_MATHLINK || defined(__WIN32__)
   glutReshapeWindow(300,300);
#else
   glutReshapeWindow(400,400);
#endif
   MVCreateMainMenu();
   glutMouseFunc(MVMouseButton);
   glutMotionFunc(MVMouseMove);
   glutDisplayFunc(MVDisplay);
   glutReshapeFunc(MVReshape);
   glutEntryFunc(MVMouseEnterMain);
   glutIdleFunc(MVAnimate);
   InitView(GL_TRUE);  
#if MACINTOSH_MATHLINK
   glutInitWindowPosition(0,0);   
#endif  
   glutMainLoop();
   return 0;
 }

@* Datastructures.
@<Data structures@>=
@<2D Point@>@;
@<3D Point@>@;
@<RGB color@>@;
@<List of Points@>@;
@<List of Lines or Polygons@>@;
@<Rectangular mesh@>@;
@<Data structure for Quaternion@>@;

@ @<2D Point@>=
typedef struct Point2D { double x,y; } Point2D;

@ @<3D Point@>=
typedef struct Point3D { double x,y,z; } Point3D;

@ The coordinates of all points in the scene will be stored in |PointPool|.
  If one of the points belong to a surface, than the corresponding entry in
  |NormalPool[i]| is unequal to |NULL| and will store a averaged normal vector.

@<Global values@>=
Point3D *PointPool=NULL;
Point3D **NormalPool=NULL;
int PoolSize=0;
int MaxPoolSize=0;

@ @<\Math like print of points@>=
void MathPrintPosition(FILE *f, int index)
{ Point3D *p;

  p=PointPool+index;
  fprintf(f,"{ "DBL_FMT", "DBL_FMT", "DBL_FMT"}",p->x,p->y,p->z);
}

@ @<\Math-like printing@>=
@<\Math like print of points@>@;

@ @<RGB color@>=
typedef struct RGBColor { double r,g,b; } RGBColor;

@ @<List of Points@>=
typedef struct PointList {
               RGBColor color;
               double size;
               int point;
               struct PointList *next;
         } PointList;

@ @<New point in the point list@>=
PointList *PrependPointList(PointList *lst, int index,
                 double size,
                 double red, double green, double blue)
{ PointList *head;

  head=(PointList *)malloc(sizeof(PointList));
  head->next=lst;
  head->point=index;
  head->size=size;
  head->color.r=red;
  head->color.g=green;
  head->color.b=blue;
  return head;
}

@ @<Remove point list@>=
PointList *RemovePointList(PointList *lst)
{ PointList *head;

  while(lst) {
    head=lst;
    lst=lst->next;
    free(head);
   }
  return NULL;
}

@ @<Length of a point list@>=
int LengthPointList(PointList *lst)
{
  int len=0;

  while(lst) {
    len++;
    lst=lst->next;
   }
  return len;
}
@ @<Memory management@>=
@<New point in the point list@>@;
@<Remove point list@>@;
@ @<\Math like print of point lists@>=
void MathPrintPointList(FILE *f, PointList *lst)
{
  fprintf(f,"{");
  while(lst) {
     fprintf(f,"\t{PointSize["DBL_FMT"], RGBColor["DBL_FMT", "DBL_FMT", "
             DBL_FMT"], Point[",
        lst->size,
        lst->color.r,
        lst->color.g,
        lst->color.b);
     MathPrintPosition(f,lst->point);
     fprintf(f,"]}");
     if(lst->next) fprintf(f,",\n");
     lst=lst->next;
    }
  fprintf(f,"}");
 }

@ @<\Math-like printing@>=
@<\Math like print of point lists@>@;

@ The data structure for polygons and lines.
The texture coordinates will only used by polygons if a scene texture
is given. Since the texture mapping for spherical, cylindrical and the torus
map are not unique we must store the texture coordinates inside of the
polygon and can't use a global texture position table.
We use a double linked list here. The double linked list is needed to
remove polygons when a polygon reduction is performed.
@d Line3D (1) @d Polygon3D (2)
@<List of Lines or Polygons@>=
typedef struct LinePolyList {
                     short int what;
                     RGBColor color;
                     int    aux1;
                     double aux2;
                     int *points;
                     Point3D *pTexturePoints;
                     int pno;
                     int pTexQuadrants;
                     struct LinePolyList *prev;
                     struct LinePolyList *next;
                    } LinePolyList;

@ \Math produces polygones of more than three points.
 |PrependLinePolyList| will
  triangulate the incomming polygons at definition.
@<Prepend line or polygon to |lst|@>=
LinePolyList *PrependLinePolyList(LinePolyList *lst,
                     short int what,
                     int *lpoints,
                     int pno,
                     double r, double g, double b)
{ LinePolyList *head;
  int tri[3], *newpoints,nold;
  int i,j;

  if(lst && Line3D==what && lpoints[0]==lst->points[lst->pno-1]) {
    @<Glue continued lines to one and |return|@>@;
   }
  if(Polygon3D==what && pno>3) {
    if(COMTriangulation)
      @<Add a center point for triangulation of $n$-gons@>@;
    else
      @<Triangulate and store $n$-gons@>@;
   }
  head=(LinePolyList *)malloc(sizeof(LinePolyList));
  if(!head) {
    fprintf(stderr,"Panic ... can't allocate memory for LinePolyList.");
    return lst;
   }
  head->prev=NULL; 
  head->next=lst;
  if (lst) lst->prev=head;
  head->what=what;
  head->pTexturePoints=NULL;    /* let the data empty for texture mapping */
  head->pTexQuadrants=0;
  head->pno=pno;
  head->points=(int *)calloc(pno,sizeof(int));
  /* copy line points and remove multiple succesive points */
  head->points[0]=lpoints[0];
  for(i=j=1; i<pno; i++)
    if(lpoints[i-1]!=lpoints[i])
      head->points[j++]=lpoints[i];
  if(j!=pno) head->pno=j;
  head->color.r=r;
  head->color.g=g;
  head->color.b=b;
  head->aux1=-1;
  head->aux2=-1.0;
  return head;
}

@ We may also remove the first element of the list.
  In this case the head of the remainig list becomes indefinite
  when it is removed. To solve this problem we pass a pointer to
  the begin of the list.  
@<Remove a single polygon/line form the list@>=
LinePolyList *DeleteSinglePolygon(LinePolyList *lstBegin, LinePolyList *lst)
{ LinePolyList *head,*tail;

  if(!lst) return lst;
  if(NULL==(lst->prev)) {
    tail=lst->next;
    @<Recycle the storrage of a single polygon@>@;
    if(tail) tail->prev=NULL;
    return tail;
   }
  head=lst->prev;
  tail=lst->next;
  head->next=tail;
  if(tail) tail->prev=head;
  @<Recycle the storrage of a single polygon@>@; 
  return lstBegin;
} 

@ @<Remove a line polygon list@>=
LinePolyList *RemoveLinePolyList(LinePolyList *lst)
{ LinePolyList *head;

  while(lst) {
    head=lst->next;
    @<Recycle the storrage of a single polygon@>@; 
    lst=head;
   }
  return NULL;
}

@ @<Recycle the storrage of a single polygon@>=
    free(lst->points);
    if(lst->pTexturePoints) free(lst->pTexturePoints);
    free(lst);


@ @<Join two line polygon lists@>=
LinePolyList *JoinLinePolyList(LinePolyList *l1,LinePolyList *l2)
{ LinePolyList *head;
  
  head=l1;
  while(head->prev) head=head->prev;
  while(l1->next) l1=l1->next;
  while(l2->prev) l2=l2->prev;
  l1->next=l2;
  l2->prev=l1;
  return head;
  
}

@ \Math's \.{ParametricPlot3D} has the habit to produce a sequence
  of single line segments of the pattern
  \.{\{\_\_\_, Line[\{a\_\_,b\_\}], Line[\{b\_,c\_\_\}], \_\_\_\}}.
  we will glue this lines to one long line.
@ @<Glue continued lines to one and |return|@>=
    nold=lst->pno;
    newpoints=(int *)calloc(nold+pno-1,sizeof(int));
    memcpy(newpoints,lst->points,nold*sizeof(int));
    memcpy(newpoints+nold,lpoints+1,(pno-1)*sizeof(int));
    free(lst->points);
    lst->points=newpoints;
    lst->pno += pno-1;
    return lst;


@ @<Triangulate and store $n$-gons@>=
{ int i;

  head=PrependLinePolyList(lst,what,lpoints,3,r,g,b);
  for(i=1; i<pno-1; i++)
    lpoints[i]=lpoints[i+1];
  return PrependLinePolyList(head,what,lpoints,pno-1,r,g,b);
}

@ @<Add a center point for triangulation of $n$-gons@>=
{ Point3D cntr={0.0,0.0,0.0};
  int i;

  head=lst;
  /* calculate the center of the $n$-gon */
  for(i=0; i<pno; i++) {
    cntr.x+=PointPool[lpoints[i]].x;
    cntr.y+=PointPool[lpoints[i]].y;
    cntr.z+=PointPool[lpoints[i]].z;
   }
  cntr.x/=pno;
  cntr.y/=pno;
  cntr.z/=pno;
  /* store the center of the polygon as new point in the pool */
  tri[0]=AddToPointPool(cntr.x,cntr.y,cntr.z);
  /* now we make triangles from the center to two eges */
  for(i=1; i<pno; i++) {
    tri[1]=lpoints[i-1];
    tri[2]=lpoints[i];
    head=PrependLinePolyList(head,what,tri,3,r,g,b);
   }
  tri[1]=lpoints[pno-1];
  tri[2]=lpoints[0];
  return PrependLinePolyList(head,what,tri,3,r,g,b);
}

@ @<Count the length of the polygon/line list@>=
long int LengthLinePolyList(LinePolyList *lst)
{
  long int len=0;

  while(lst) {
    len++;
    lst=lst->next;
   }
  return len;
}

@ @<Reverse the order of points in the polygons@>=
void ReversePolygons(LinePolyList *lst)
{ int n,tmp;
  Point3D texTmp;
  while(lst) {
    if(Polygon3D==lst->what) {
      n=lst->pno;
      if(3==n) {
         tmp=lst->points[2];
         lst->points[2]=lst->points[0];
        lst->points[0]=tmp;
        if(lst->pTexturePoints) {
          texTmp=lst->pTexturePoints[2];
          lst->pTexturePoints[2]=lst->pTexturePoints[0];
          lst->pTexturePoints[0]=texTmp;
         } 
       }
     }
    lst=lst->next;
   }
}


@ @<Utilities@>=
    @<Length of a point list@>@;
    @<Remove a line polygon list@>@;
    @<Join two line polygon lists@>@;
    @<Reverse the order of points in the polygons@>@;
    @<|Mesh3DList| Utilities@>@;
    @<Quaternion utilities@>@;

@ @<Memory management@>=
@<Prepend line or polygon to |lst|@>@;
@<Remove a single polygon/line form the list@>@;

@ @<\Math like print of polygons and lines@>=
void MathPrintLinePolyList(FILE *f, LinePolyList *lst)
{ int i;

  fprintf(f,"{");
  while(lst) {
    fprintf(f,"%s[{",Line3D==lst->what ? "Line" : "Polygon");
    for(i=0; i<lst->pno; i++) {
      MathPrintPosition(f,lst->points[i]);
      if(i!= lst->pno - 1)
        fprintf(f,",");
     }
    fprintf(f,lst->next ? "}]},\n" : "}]}");
   lst=lst->next;
    }
  fprintf(f,"}\n");
}


@ @<\Math-like printing@>=
@<\Math like print of polygons and lines@>@;

@ @<Cyclic index |j1|, |j2| and |j3|@>=
  j1=lst->points[0==i ? lst->pno-1: i-1];
  j2=lst->points[i];
  j3=lst->points[lst->pno-1 == i ? 0 : i+1];

@ Calculate the averaged normals for the points in polygons.
@<Average the normal vectors for the points@>=
void AveragedNormals(LinePolyList *lst)
{ int i,j1,j2,j3;
  Point3D normal;
  int *cnt,res;
  double n;

  if(!PoolSize) return;
  cnt=(int *)calloc(PoolSize,sizeof(int));
  for(i=0; i<PoolSize; i++) cnt[i]=0;
  while (lst) {
    for(i=0; i<lst->pno; i++) {
      @<Cyclic index |j1|, |j2| and |j3|@>@;
      res=SurfaceNormal(&normal,PointPool+j1,PointPool+j2,PointPool+j3);
      if(!res) continue;
      if(!NormalPool[j2]) {
        NormalPool[j2]=(Point3D *)malloc(sizeof(Point3D));
        NormalPool[j2]->x=NormalPool[j2]->y=NormalPool[j2]->z=0.0;
       }
      NormalPool[j2]->x+=normal.x;
      NormalPool[j2]->y+=normal.y;
      NormalPool[j2]->z+=normal.z;
      cnt[j2]++;
    }
   lst=lst->next;
  }
 for(i=0; i<PoolSize; i++)
   if(cnt[i] && NormalPool[i]) {
     NormalPool[i]->x/=cnt[i];
     NormalPool[i]->y/=cnt[i];
     NormalPool[i]->z/=cnt[i];
     n=Norm(NormalPool[i]);
     if(n>0.0) {
       NormalPool[i]->x/=n;
       NormalPool[i]->y/=n;
       NormalPool[i]->z/=n;
      }
     else {
       free(NormalPool[i]);
       NormalPool[i]=NULL;
      }
    }
 free(cnt);
}


@ A linear search of equivalent points is a bit to slow for large polygon
numbers. An octree is used for faster location of the points.
We will use the octree also for polygon reduction. For fast
access to the polygons with a common vertex we store pointers to
the polygons in an array |vpoly| with |polyNo| entries.
@<Data structures@>+=
typedef struct PointOctTree {
                   int point;
                   int polyNo;  
                   LinePolyList **vpoly; 
                   struct PointOctTree *leafs[8];
                  }  PointOctTree;

@ The function returns the index of the point if the point is in the tree, -1 otherwise.
@d NOT_FOUND (-1)
@<Octal tree of points@>=
  @<Insert a point into an octtree@>@;
  @<Locate a point in the octtree@>@;
  @<Remove the octree@>@;
  @<Insert a polygon at vertex |pIndex| into the octtree@>@;
  @<Remove a polygon at vertex |pIndex| into the octtree@>@;
  @<Strip polygon lists from octtree@>@;

@ @<Insert a point into an octtree@>=
PointOctTree *InsertPointOctTree(int pIndex, PointOctTree *root)
{ PointOctTree *tree=root,*next;
  Point3D *tp,*p;
  int index;

  if(!root) {
    @<Create the an entry of the octtree as |next|@>@;
    return next;
   }    
  p=PointPool + pIndex;
  while(tree) {
     tp=PointPool + tree->point;
     index=0;
     @<Find the |index| to continue the tree search@>@;
     next=tree->leafs[index];
     if(next) 
       tree=next;
     else {
       @<Create the an entry of the octtree as |next|@>@;
       tree->leafs[index]=next;
       break;  
      }        
   }
  return root;
}


@ When the tree is constructed we assume that no polygons have this
vertex common.

@<Create the an entry of the octtree as |next|@>=
{ int i;
  
  next=(PointOctTree *)malloc(sizeof(PointOctTree));
  for(i=0; i<8; i++)
     next->leafs[i]=NULL;
  next->point=pIndex;
  next->polyNo=0;
  next->vpoly=NULL;
}

@ @<Locate a point in the octtree@>=
int InOctTreeQ(Point3D *p, PointOctTree *tree)
{ Point3D *tp;
  double d;
  int index=0;

  if(!tree) return NOT_FOUND;
  tp=PointPool+tree->point;
  d=fabs(p->x-tp->x)+fabs(p->y-tp->y)+fabs(p->z-tp->z);
  if(d<TINY) return tree->point;
  @<Find the |index| to continue the tree search@>@;
  return InOctTreeQ(p,tree->leafs[index]); 
}
 
@ @<Find the |index| to continue the tree search@>=
  if(p->x > tp->x) index|=1;
  if(p->y > tp->y) index|=2;
  if(p->z > tp->z) index|=4;


@ @<Remove the octree@>=
PointOctTree *RemovePointOctTree(PointOctTree *tree)
{ int i;
 
  if(!tree) return NULL;
  for(i=0; i<8; i++)
    if(tree->leafs[i]) 
       RemovePointOctTree(tree->leafs[i]);
  if(tree->vpoly) free(tree->vpoly);
  free(tree);
  return 0;
}


@ For the polygon reduction we must find
all polygons that have a vertex in common. To reduce the search
the polygons with this vertex are stored in the |vpoly| part of
the octtree of the points. Here we insert a polygon |poly| with
a vertex |pIndex| into the tree.
@<Insert a polygon at vertex |pIndex| into the octtree@>=
int InsertPolyInOctTree(PointOctTree *root, LinePolyList *poly, int pIndex)
{ Point3D *p, *tp;
  int index;

  if(!root) return NOT_FOUND; /* this can't happen */
  if(pIndex==root->point) {
    @<Add the polygon to the array in |root->vpoly|@>@; 
    return pIndex; 
   }
  p=PointPool+pIndex;
  tp=PointPool+root->point;  
  index=0;
  @<Find the |index| to continue the tree search@>@;
  return InsertPolyInOctTree(root->leafs[index],poly,pIndex);
}

@ @<Add the polygon to the array in |root->vpoly|@>=
if(root->vpoly) {
  LinePolyList **newvp;

  newvp=(LinePolyList **)realloc(root->vpoly,(root->polyNo+1)*sizeof(LinePolyList *));
  if(!newvp) {
    newvp=(LinePolyList **)calloc((root->polyNo+1),sizeof(LinePolyList *));
    if(!newvp) {
      fprintf(stderr,"Panic can't allocate memory for polygon vertex link.");
      return NOT_FOUND;
     }
    memcpy(*newvp,*(root->vpoly),root->polyNo*sizeof(LinePolyList));
    free(root->vpoly);
   }
  newvp[root->polyNo]=poly;
  (root->polyNo)++;
  root->vpoly=newvp; 
 }
else {
  root->vpoly=(LinePolyList **)malloc(sizeof(LinePolyList *));
  *(root->vpoly)=poly;
  root->polyNo=1;
 }  


@ During the vertex reduction we will also remove polygons form the
  octal tree as well as from the polygon list.
@<Remove a polygon at vertex |pIndex| into the octtree@>=
int RemovePolyFromOctTree(PointOctTree *root, LinePolyList *poly, int pIndex)
{ Point3D *p, *tp;
  int index;

  if(!root) return NOT_FOUND; /* this can't happen */
  if(pIndex==root->point) {
    @<Remove the polygon from the array in |root->vpoly|@>@; 
    return pIndex; 
   }
  p=PointPool+pIndex;
  tp=PointPool+root->point;  
  index=0;
  @<Find the |index| to continue the tree search@>@;
  return RemovePolyFromOctTree(root->leafs[index],poly,pIndex);
}

@ @<Remove the polygon from the array in |root->vpoly|@>=
if(root->vpoly) {
  LinePolyList **newvp;
  int i,k;

  k=0;
  while(k<root->polyNo && poly != root->vpoly[k]) k++; /* search the polygon in the array */
  if(k==root->polyNo) {
    fprintf(stderr,"Can't find the polygon in tree.\n");
    return pIndex;
   }
  for(i=k; i<root->polyNo-1; i++) /* overwrite the old polygon */
    root->vpoly[i]=root->vpoly[i+1];
  (root->polyNo)--;  
  if(0==root->polyNo) {
    free(root->vpoly);
    root->vpoly=NULL;
    return pIndex;
   }
  newvp=(LinePolyList **)realloc(root->vpoly,(root->polyNo)*sizeof(LinePolyList *));
  if(!newvp) {
    newvp=(LinePolyList **)calloc((root->polyNo),sizeof(LinePolyList *));
    if(!newvp) {
      fprintf(stderr,"Panic can't allocate memory for polygon vertex link.");
      return NOT_FOUND;
     }
    memcpy(*newvp,*(root->vpoly),root->polyNo*sizeof(LinePolyList));
    free(root->vpoly);
   }
  root->vpoly=newvp; 
 }  


@ Strip the polygon information from the octal tree.
@<Strip polygon lists from octtree@>=
void StripPolygonsFromOctTree(PointOctTree *tree)
{ int i;

  if(!tree) return;
  if(tree->vpoly) free(tree->vpoly);
  tree->vpoly=NULL;
  tree->polyNo=0;
  for(i=0; i<8; i++)
    if(tree->leafs[i]) StripPolygonsFromOctTree(tree->leafs[i]);
}


@ @<Global values@>=
PointList    *Points=NULL;
PointOctTree *OctalPointTree=NULL;
LinePolyList *Lines=NULL;
LinePolyList *Polygons=NULL;

@ Here we allocate the storrage for the point pool and the pool of normals.
@d INIT_POOLSIZE 8192
@d POOL_INC 1024
@d TINY (0.1e-8)
@d MachineEpsilon (2.22044604925031308e-16)
@<Function prototypes@>=
int AddToPointPool(double x, double y, double z);
@ @<Add a new position to the |PointPool|@>=
int AddToPointPool(double x, double y, double z)
{ int pn,i;
  Point3D newp,*pos, **nvec;

  if (!PointPool) { /* first call */
    PointPool=(Point3D *)calloc(MaxPoolSize=INIT_POOLSIZE,sizeof(Point3D));
    NormalPool=(Point3D **)calloc(INIT_POOLSIZE,sizeof(Point3D *));
    for(i=0; i<MaxPoolSize; i++)
      NormalPool[i]=NULL;
    PoolSize=0;
   }
  pn=PoolSize;
  pos=PointPool;
  newp.x=x; @+
  newp.y=y; @+
  newp.z=z; 
  i=InOctTreeQ(&newp,OctalPointTree);
  if(NOT_FOUND<i) return i;
  if(pn==MaxPoolSize) { /* add |POOL_INC| points to the point pool */
     pos=(Point3D *) calloc(MaxPoolSize+POOL_INC,sizeof(Point3D));
     if(!pos) {
       fprintf(stderr,"Panic ... failed to reallocate PointPool.\n");
       exit(1);
      }
     memcpy(pos,PointPool,MaxPoolSize*sizeof(Point3D));
     free(PointPool);
     PointPool=pos;
     /* add |POOL_INC| points to the normal pool */
     nvec=(Point3D **)calloc(MaxPoolSize+POOL_INC,sizeof(Point3D *));
     if(!nvec) {
       fprintf(stderr,"Panic ... failed to reallocate NormalPool.\n");
       exit(1);
      } 
     memcpy(nvec,NormalPool,MaxPoolSize*sizeof(Point3D*));
     free(NormalPool);
     NormalPool=nvec;
     MaxPoolSize+=POOL_INC;
         for(i=PoolSize; i<MaxPoolSize; i++)
           NormalPool[i]=NULL;
    }
    /* insert the new point */
  PointPool[pn].x=x;
  PointPool[pn].y=y;
  PointPool[pn].z=z;
  OctalPointTree=InsertPointOctTree(pn,OctalPointTree);
  @<Update the bounding box@>@;
  return PoolSize++;
}

@ @<Update the bounding box@>=
  if(BoundP1.x>x) BoundP1.x=x;
  if(BoundP2.x<x) BoundP2.x=x;
  if(BoundP1.y>y) BoundP1.y=y;
  if(BoundP2.y<y) BoundP2.y=y;
  if(BoundP1.z>z) BoundP1.z=z;
  if(BoundP2.z<z) BoundP2.z=z;

@* Texture mapping.
The texture mapping determines how the two dimensional texture coordinates
are determined from the three dimensional coordiantes of the point.
To align the three dimensional point  with the texture in the $xy$-plane
a translation (stored in |translation|) a rotation and a scaling can be applied
as linear transformation.
The planar maping uses the usual cartesian, the cylindrical
mapping cylindrical and the spherical mapping spherical coordiantes.
This works for the scene as well as for the meshes. The meshes have an extra
mapping type that bases on the parametrisation of the mesh or its transposed.

@d TEXTURE_MAP_PLANAR      (2)
@d TEXTURE_MAP_CYLINDRICAL (4)
@d TEXTURE_MAP_SPHERICAL   (8)
@d TEXTURE_MAP_TORUS       (16)
@d TEXTURE_MAP_MESH_ST     (128)
@d TEXTURE_MAP_MESH_TS     (256)


@<Functions for texture mapping@>=
@<Map space coordinates@>@;
@<Fill the texture coordinate entries of the polygons@>@;
@<Texture mapping for meshes@>@;

@ Constants to repeated in the $s$ or $t$ direction the two constants

|TILE_TEXTURE_S| and |TILE_TEXTURE_T| are used.
@d TILE_TEXTURE_S          (2)
@d TILE_TEXTURE_T          (4)

@ We will allow the transformation of the three dimensional points
in the texture mapping.

@<Data structures@>+=
typedef struct TextureMapping {
                  int type;
                  int tileTexture;
                  Point3D *translate;
                  Point3D *axis;
                  double angle;
                  Point3D *scale;
                  double scaleS,scaleT;
                  TextureList *tex;
                 }  TextureMapping;


@ The meshes have its own local texture mapping.
The scene with polygons and points uses |SceneTextureMap|.
@d SceneTextureID (SceneTextureMap->tex->texName)

@<Global values@>=
TextureMapping *SceneTextureMap=NULL;

@ @<Memory management@>+=
TextureMapping *CreateTextureMapping(
                     int how,
                     int repeat,
                     Point3D *move,
                     Point3D *raxis,
                     double alpha,
                     Point3D *scale,
                     double scS,double scT,
                     TextureList *which)
{ TextureMapping *tm;

  @<Allocate the storrage for the texture mapping@>@;
  @<Save the translation of the texture mapping@>@;
  @<Save the rotation of the texture mapping@>@;
  @<Save the scaling of the texture mapping@>@;
  return tm;
}

@ @<Memory management@>+=
TextureMapping *DefaultTextureMapping(TextureList *which)

{ const int repeat=TILE_TEXTURE_S | TILE_TEXTURE_T;
  const double scT=1.0,scS=1.0;
  int how;
  TextureMapping *tm;
  Point3D *scale, *move;
  char *c;

  @<Get the commandline map type@>@;
  @<Allocate the storrage for the texture mapping@>@;
  @<Save the translation of the texture mapping@>@;
  @<Save the scaling of the texture mapping@>@;
  tm->axis=NULL;
  tm->angle=0.0;
  if(scale) free(scale);
  if(move) free(move);
  return tm;
}

@ @<Get the commandline map type@>=
c=TexMapType;
scale=malloc(sizeof(Point3D));
move=malloc(sizeof(Point3D));
while(*c) *(c++)=tolower(*c);
switch(*TexMapType) {
 case 'p' :
   how=TEXTURE_MAP_PLANAR;
   scale->x=(BoundP2.x-BoundP1.x);
   scale->y=(BoundP2.y-BoundP1.y);
   scale->z=(BoundP2.z-BoundP1.z);
   *move=BoundP1;
   if(scale->x!=0.0) scale->x=1.0/scale->x;
   if(scale->y!=0.0) scale->y=1.0/scale->y;
   if(scale->z!=0.0) scale->z=1.0/scale->z;
   break;
 case 'c' :
   how=TEXTURE_MAP_CYLINDRICAL;
   @<Set |move| to the center of the scene@>@;
   move->z=BoundP1.z;
   scale->x=scale->y=1.0;
   scale->z=BoundP2.z-BoundP1.z;
   if(scale->z!=0.0) scale->z=1.0/scale->z;
   break;
 case 's' :
   how=TEXTURE_MAP_SPHERICAL;
   @<Set |move| to the center of the scene@>@;
   free(scale);
   scale=NULL;
   break;
 case 't' : how=TEXTURE_MAP_TORUS;
   @<Set |move| to the center of the scene@>@;
   free(scale);
   scale=NULL;
   break;
 default  :
   how=TEXTURE_MAP_PLANAR;
   free(scale);
   free(move);
   scale=move=NULL;
   break;
}

@ @<Set |move| to the center of the scene@>=
move->x=0.5*(BoundP1.x+BoundP2.x);
move->y=0.5*(BoundP1.y+BoundP2.y);
move->z=0.5*(BoundP1.z+BoundP2.z);

@ @<Allocate the storrage for the texture mapping@>=
  if(!which) return NULL;
  tm=(TextureMapping *)malloc(sizeof(TextureMapping));
  if(!tm) return NULL;
  tm->type=how;
  tm->tileTexture=repeat;
  tm->tex=which;

@ @<Save the translation of the texture mapping@>=
  if(move) {
    tm->translate=(Point3D *)malloc(sizeof(Point3D));
    *(tm->translate)=*move;
   }
  else
    tm->translate=NULL;

@ @<Save the rotation of the texture mapping@>=
  if(raxis) {
    tm->axis=(Point3D *)malloc(sizeof(Point3D));
    *(tm->axis)=*raxis;
    tm->angle=alpha;
   }
  else
    tm->axis=NULL;

@ @<Save the scaling of the texture mapping@>=
  if(scale) {
    tm->scale=(Point3D *)malloc(sizeof(Point3D));
    *(tm->scale)=*scale;
   }
  else
    tm->scale=NULL;
  tm->scaleS=scS;
  tm->scaleT=scT;

@ @<Memory management@>+=
TextureMapping *DeleteTextureMapping(TextureMapping *tm)
{
  if(!tm) return NULL;
  if(tm->translate) free(tm->translate);
  if(tm->axis) free(tm->axis);
  if(tm->scale) free(tm->scale);
  free(tm);
  return NULL;
}


@ The coordinates $x$, $y$ and $z$ are mapped to the new coordinates
  $x^*$, $y^*$, and $z^*$. The texture coordinates $s$ and $t$ are obtained
  from the new points simply by setting $s=x^*$ and $t=y^*$. For the spherical,
  cylindrical, and torus mapping we have to save the quadrants where the linear
  transformed points located. So we can later resolve the crossing of the
  $y=0$ line. |UpdateTextureCoordinates| return the quadrants in the $xy$ plane
  where the linear transformed points located as result. When the function is
  used for the array of |Mesh3DList->mPoints| the information that a polygon
  cross the positive $x$-axis is use less. For that case the
  |quad| (if not |NULL|)variable store the quadrants of the individual
  points and for meshes this information is used later.

@d InQuadrant1  1
@d InQuadrant2  2
@d InQuadrant3  4
@d InQuadrant4  8
@<Map space coordinates@>=
int UpdateTextureCoordinates(TextureMapping *map,
                              Point3D *tp, Point3D *p, int *quad,int n)
{ int mtype;
  int i;
  Point3D *move,*axis;
  Point3D *scale;
  double nx,ny,nz,st,ct;
  double ox,oy,oz,x,y,z;
  double rmat[3][3];
  int Quadrant, xyQuadrant;

  if(!map) return 0;
  Quadrant=0;
  @<Copy the transformation parameters from |map|@>@;
  if(axis)
    @<Make rotation matrix |rmat| from the normal and the angle@>@;
  for(i=0; i<n; i++,p++,tp++) {
    @<Make the linear transformations of point |*p|@>@;
    @<Check the position of the transformed points@>@;
    switch(mtype) {
      case TEXTURE_MAP_PLANAR :
        @<Apply the planar mapping@>@;
        break;
      case TEXTURE_MAP_CYLINDRICAL:
        @<Apply the cylindrical mapping@>@;
        break;
      case TEXTURE_MAP_SPHERICAL:
        @<Apply the spherical mapping@>@;
        break;
      case TEXTURE_MAP_TORUS:
        @<Apply the torus mapping@>@;
        break;
      default :
        @<Apply the planar mapping@>@;
        break;
     }

   }
  return Quadrant;
}

@ @<Check the position of the transformed points@>=
if(x>=0.0 && y>=0.0)
  xyQuadrant=InQuadrant1;
else if(x<0.0 && y>=0.0)
  xyQuadrant=InQuadrant2;
else if(x<0.0 && y<0.0)
  xyQuadrant=InQuadrant3;
else if(x>=0.0 && y<0.0)
  xyQuadrant=InQuadrant4;
if(quad) quad[i]=xyQuadrant;
Quadrant|=xyQuadrant;

@ Calclulate the texture coordinates for the polygons.
@<Fill the texture coordinate entries of the polygons@>=
void  UpdatePolygonTextureCoord(TextureMapping *map,LinePolyList *lst)
{ Point3D *p;
  int i;

  while (lst) {
    p=(Point3D *)calloc(lst->pno,sizeof(Point3D));
    if(!lst->pTexturePoints)
      lst->pTexturePoints=(Point3D *)calloc(lst->pno,sizeof(Point3D));
    for(i=0; i<lst->pno; i++) {
      p[i]=PointPool[lst->points[i]];
      lst->pTexturePoints[i]=ZeroPoint;
     }
    lst->pTexQuadrants=
      UpdateTextureCoordinates(map,lst->pTexturePoints,p,NULL,lst->pno);
    free(p);
    lst=lst->next;
   }
}

@ @<Copy the transformation parameters from |map|@>=
  mtype=map->type;
  move=map->translate;
  axis=map->axis;
  scale=map->scale;
  if(axis) {
    nx=map->axis->x;
    ny=map->axis->y;
    nz=map->axis->z;
    ct=cos(map->angle);
    st=sin(map->angle);
   }

@ The result of the linear transformations is stored in |x|, |y| and |z|
@<Make the linear transformations of point |*p|@>=
if(move) {
  ox=p->x-move->x;
  oy=p->y-move->y;
  oz=p->z-move->z;
 }
else {
  ox=p->x;
  oy=p->y;
  oz=p->z;
 }
if(axis)
  @<Matrix multiplication for rotation@>@;
else {
  x=ox;
  y=oy;
  z=oz;
 }
if(scale) {
  x*=scale->x;
  y*=scale->y;
  z*=scale->z;
 }


@ @<Apply the planar mapping@>=
tp->x=x;
tp->y=y;
tp->z=z;

@ @<Apply the cylindrical mapping@>=
{ double r,phi;

   r=sqrt(x*x+y*y);
   phi=atan2(y,(x!=0.0 ? x : TINY));
   if(phi<0.0) phi+=TWO_PI;
   tp->x=phi/TWO_PI;
   tp->y=z;
   tp->z=r;
}


@ @<Apply the spherical mapping@>=
{ double r,th,phi;

  r=sqrt(x*x+y*y+z*z);
  phi=atan2(y,(x!=0.0 ? x : TINY));
  if(phi<0.0) phi+=TWO_PI;
  th=r>0.0 && fabs(z)<r ? acos(z/r) : (z>0.0 ? 0.0 : PI ) ;
  tp->x=phi/TWO_PI;
  tp->y=1.-th/PI;
  tp->z=r;
}

@ The mapping to a torus uses the equation
$$\eqalign{x&=r\,\left( 1 + \cos (2\,\pi \,\theta ) \right) \,\cos (2\,\pi \,\phi )\cr
           y&=r\,\left( 1 + \cos (2\,\pi \,\theta ) \right) \,\sin (2\,\pi \,\phi )\cr
           z&=r\,\sin (2\,\pi \,\theta )\cr
    }
$$
This gives
$$\eqalign{
   r   &= {{x^2 + y^2 + z^2}\over {2\,\sqrt{x^2 + y^2}}} \cr
  \phi &= {1\over 2\pi}\arctan(y/x)\cr
  \theta&={1\over 2\pi}
    (\pi +sign(z)\,\arccos (-1 + {2\,\left( {x^2} + {y^2} \right) \over
                              x^2 + y^2 + z^2})\cr
}$$

@ @<Apply the torus mapping@>=
{ double r1,rho,r,th,phi;

  r1=(rho=x*x+y*y)+z*z;
  if(rho<TINY) rho=TINY;
  r=0.5*r1/sqrt(rho);
  phi=atan2(y,(x!=0.0 ? x : TINY));
  if(phi<0.0) phi+=TWO_PI;
  th=(z>0.0 ? 1.0: -1.0)*acos(r1>TINY ?-1.0+2.0*rho/r1 : 1.0)+PI;
  tp->x=phi/TWO_PI;
  tp->y=th/TWO_PI;
  tp->z=r;
}


@ The mesh data have a natural texture mapping.
@<Texture mapping for meshes@>=
void UpdateMeshTextureCoordinates(Mesh3DList *mesh)
{ int mtype;
  Point3D *tp;
  int i,j;
  double n,m;

  while(mesh) {
    if(mesh->mTexture) {
      mtype=mesh->mTexture->type;
      if((TEXTURE_MAP_MESH_ST==mtype) || (TEXTURE_MAP_MESH_TS==mtype))
        @<Calculate the parametric mapping for the mesh@>@;
      else
        @<Calculate the mapping for the mesh@>@;
     }
    mesh=mesh->next;
   }
}

@ For spherical, cylindrical and torus mapping we need the
  expanded points and not the unique points from
  |mesh->mPoints|. The |xyQuadrants| array counts the position
  where the texture points of the mesh are placed before the (nonlinear)
  transformation takes place. The mesh is broken in to polygons later but
  we resolve the multiple mapping of texture points along the positive
  $x$-axis here.

@<Calculate the mapping for the mesh@>=
{
  Point3D *mp;
  int *xyQuadrants, quad;
  int i,j,mu;

  mp=(Point3D *)calloc(mu=mesh->dimU*mesh->dimV,sizeof(Point3D));
  xyQuadrants=(int *)calloc(mu,sizeof(int));
  for(i=0; i<mu; i++) xyQuadrants[i]=0;
  for(i=0; i<mesh->dimU; i++)
    for(j=0; j<mesh->dimV; j++)
      mp[MeshIndexExpanded(mesh,i,j)]=MeshCoord(mesh,i,j);
  UpdateTextureCoordinates(
    mesh->mTexture,
    mesh->mTexturePoints,
    mp,xyQuadrants,mu);
  @<Resolve the azimutal mapping@>@;
  free(mp);
  free(xyQuadrants);
}

@ @<Resolve the azimutal mapping@>=
if(mesh->mTexture->type>TEXTURE_MAP_PLANAR) {
  Point3D *p;

  for(i=0; i<mesh->dimU-1; i++)
    for(j=0; j<mesh->dimV-1; j++) {
      /* corners of the first triangle */
      quad=xyQuadrants[MeshIndexExpanded(mesh,i,j)] |
           xyQuadrants[MeshIndexExpanded(mesh,i+1,j)] |
           xyQuadrants[MeshIndexExpanded(mesh,i+1,j+1)];
      if(((quad & InQuadrant1)==InQuadrant1) &&
         ((quad & InQuadrant4)==InQuadrant4)) {
        p=MeshTexCoordPtr(mesh,i,j);
        @<Shift the $\phi$-texture coordinate@>@;
        p=MeshTexCoordPtr(mesh,i+1,j);
        @<Shift the $\phi$-texture coordinate@>@;
        p=MeshTexCoordPtr(mesh,i+1,j+1);
        @<Shift the $\phi$-texture coordinate@>@;
       }
      /* corners of the second triangle */
      quad=xyQuadrants[MeshIndexExpanded(mesh,i+1,j+1)] |@|
           xyQuadrants[MeshIndexExpanded(mesh,i,j+1)] |  @|
           xyQuadrants[MeshIndexExpanded(mesh,i,j)];
      if(((quad & InQuadrant1)==InQuadrant1) &&
          ((quad & InQuadrant4)==InQuadrant4)) {
        p=MeshTexCoordPtr(mesh,i,j+1);
        @<Shift the $\phi$-texture coordinate@>@;
       }
     }
}

@ @<Shift the $\phi$-texture coordinate@>=
p->x=(fabs(p->x)<0.5) ? 1.0+p->x : p->x;

@ @<Calculate the parametric mapping for the mesh@>=
{
  n=mesh->dimU-1;
  m=mesh->dimV-1;
  for(i=0; i<mesh->dimU; i++)
    for(j=0; j<mesh->dimV; j++) {
      tp=MeshTexCoordPtr(mesh,i,j);
      tp->z=0.0;
      if(TEXTURE_MAP_MESH_ST==mtype) {
        tp->x=((double) i/(double) n);
        tp->y=((double) j/(double) m);
       }
      else {
        tp->y=((double) i/(double) n);
        tp->x=((double) j/(double) m);
       }
     } /* |for| */
}

@  At first we look if we have polygons. If yes we will create the
   texture for the scene. In the case of meshes we create texture mapping
   for the individual mesh.
@<Create the texture mapping from the command line@>=
{

  if(Polygons) {
    SceneTextureMap=DefaultTextureMapping(Textures);
    if(SceneTextureMap)
      UpdatePolygonTextureCoord(SceneTextureMap,Polygons);
   }
   else if(Meshes) {
     MeshTexMap(Meshes)=DefaultTextureMapping(Textures);
     if(MeshTexMap(Meshes))
       UpdateMeshTextureCoordinates(Meshes);
    }
}

@*Rectangular Mesh. For texture maping and storrage saving a rectangular
  mesh structure is introduced. Every mesh in the list will
  have a |name| and |mPointNo| unique points and normals. The
  rectangular structure is stored in the integer array |mesh|
  that contains only indexes to the coordinates and normals.
@d MESH_OPEN         (0)
@d MESH_UCLOSED      (1)
@d MESH_VCLOSED      (2)
@d MESH_VERTEX_COLOR (4)
@d MESH_FACE_COLOR   (8)
@d MeshID(m)            (m ? (m->meshID) : -1)
@d MeshIndexExpanded(m,i,j) ((j)+(m->dimV)*(i))
@d MeshIndex(m,i,j)     (m->mesh[(j)+(m->dimV)*(i)])
@d MeshCoord(m,i,j)      m->mPoints[m->mesh[(j)+(m->dimV)*(i)]]
@d MeshNormal(m,i,j)     m->mNormals[m->mesh[(j)+(m->dimV)*(i)]]
@d MeshCoordPtr(m,i,j)  (m->mPoints+m->mesh[(j)+(m->dimV)*(i)])
@d MeshNormalPtr(m,i,j) (m->mNormals+m->mesh[(j)+(m->dimV)*(i)])
@d MeshTexCoordPtr(m,i,j) (m->mTexturePoints+(j)+(m->dimV)*(i))
@d MeshColorPtr(m,i,j)  (m->mpolyColors+(j)+(m->cDimV)*(i))
@d MeshTexMap(m)        (m->mTexture)
@d MeshTextureQ(m)      (m->mTexture!=NULL)
@d MeshTextureID(m)     (m->mTexture->tex->texName)
@d MeshTextureFile(m)   (m->mTexture->tex->texSaveName)
@d MeshTextureType(m)   (m->mTexture->tex->texType)
@<Rectangular mesh@>=
typedef struct Mesh3DList {
                  char name[256];
                  int meshID;
                  int dimU, dimV;
                  int mu;
                  int mPointNo;
                  Point3D *mPoints;
                  Point3D *mNormals;
                  Point3D *mTexturePoints;
                  int *mesh;
                  int cDimU, cDimV;
                  RGBColor *mpolyColors;
                  int attrib;
                  int    aux1;
                  double aux2;
                  RGBColor mColor;
                  struct TextureMapping *mTexture;
                  struct Mesh3DList *next;
                 } Mesh3DList;

@ The |MeshCount| starts with 2 because the number one is reserved for the group of 
polygons, lines, $\ldots$
 @<Global values@>=
Mesh3DList *Meshes=0;
static int MeshCount=2;
@ @<|Mesh3DList| Utilities@>=
@<Revert the normals of all meshes@>@;
@<Length of a mesh list@>@;

@ @<Memory management@>+=
Mesh3DList *PrependMesh3DList(Mesh3DList *lst,
                          int ndim,int mdim,
                          Point3D *data2d,
                          RGBColor *c,
                          int nc,int mc,
                          double *colors)
{ Mesh3DList *head;
  Point3D *p,normij;
  int n,m,i,j,found;
  int *count;

  head=(Mesh3DList *)malloc(sizeof(Mesh3DList));
  if(!head) return lst;
  head->next=lst;
  head->aux1=0;
  head->aux2=0.0;
  head->attrib=MESH_OPEN;
  head->mTexture=NULL;
  if(NULL==c)
    head->mColor.r=head->mColor.g=head->mColor.b=1.0;
  else
    head->mColor=*c;
  /* create a unique name */
  head->meshID=MeshCount;
  sprintf(head->name,"MVMesh3D[%d]",MeshCount++);
  /* copy an optional color array */
  head->cDimU=nc;
  head->cDimV=mc;
  if(colors) {
    head->mpolyColors=(RGBColor *)calloc(nc*mc,sizeof(RGBColor));
    memcpy(head->mpolyColors,colors,3*nc*mc*sizeof(double));
    if(nc==ndim && mc==mdim)
      head->attrib|=MESH_VERTEX_COLOR;
    else
      head->attrib|=MESH_FACE_COLOR;
   }
  else
    head->mpolyColors=NULL;
  /* copy the dimensions */
  head->dimU=ndim;
  head->dimV=mdim;
  head->mu=ndim*mdim;
  /* create the storrage for the data */
  head->mPoints=(Point3D *)calloc(head->mu,sizeof(Point3D));
  head->mNormals=(Point3D *)calloc(head->mu,sizeof(Point3D));
  head->mTexturePoints=(Point3D *)calloc(head->mu,sizeof(Point3D));
  head->mPointNo=0;
  head->mesh=(int *)calloc(head->mu,sizeof(int));
  @<Store the unique points from |data2d|@>@;
  @<Create the normals for the mesh@>@;
  @<Check if the surface is closed in $u$-direction@>@;
  @<Check if the surface is closed in $v$-direction@>@;
  return head;
}

@ When the mesh is initialized we scan the
  data in |data2d| for multiple points and
  store only the unique ones in |head->mPoints|.
@<Store the unique points from |data2d|@>=
  for(m=0; m<head->mu; m++) {
    found=GL_FALSE;
    for(i=0; i<head->mPointNo; i++) {
      p=head->mPoints+i;
      if((fabs(data2d[m].x-p->x)+
          fabs(data2d[m].y-p->y)+
          fabs(data2d[m].z-p->z))<TINY) {
        found=GL_TRUE;
        break;
       }
     }
    if(!found) { /* new point */
     head->mPoints[head->mPointNo]=data2d[m];
     head->mNormals[head->mPointNo]=ZeroPoint;
     i=head->mPointNo++;      /* set |i| to the new value */
    }
    head->mesh[m]=i; /* set the entry in the mesh */
   }

@ @<Create the normals for the mesh@>=
  count=(int *)calloc(head->mu,sizeof(int));
  for(i=0; i<head->mPointNo; i++)
    count[i]=0;
  n=head->dimU-1;
  m=head->dimV-1;
  @<Normal vectors from the right upper quadrant@>@;
  @<Normal vectors from the left upper quadrant@>@;
  @<Normal vectors from the left lower quadrant@>@;
  @<Normal vectors from the right lower quadrant@>@;
  for(i=0; i<head->mPointNo; i++)
    if(count[i]) {
      double absn;
      head->mNormals[i].x/=count[i];
      head->mNormals[i].y/=count[i];
      head->mNormals[i].z/=count[i];
      absn=Norm(head->mNormals + i);
      if(absn!=0.0) {
        absn=1.0/absn;
        head->mNormals[i].x*=absn;
        head->mNormals[i].y*=absn;
        head->mNormals[i].z*=absn;
       }
      else {
        head->mNormals[i].x=0.0;
        head->mNormals[i].y=0.0;
        head->mNormals[i].z=1.0;
       }
     }
  free(count);

@ @<Increment the normal at $(i,j)$@>=
      MeshNormal(head,i,j).x+=normij.x;
      MeshNormal(head,i,j).y+=normij.y;
      MeshNormal(head,i,j).z+=normij.z;
      count[MeshIndex(head,i,j)]++;

@ @<Normal vectors from the right upper quadrant@>=
  for(i=0; i<n; i++)
    for(j=0; j<m; j++) {
      SurfaceNormal(&normij,MeshCoordPtr(head,i,j+1),
                            MeshCoordPtr(head,i,j),
                            MeshCoordPtr(head,i+1,j));
      @<Increment the normal at $(i,j)$@>@;
     }

@ @<Normal vectors from the left upper quadrant@>=
  for(i=1; i<head->dimU; i++)
    for(j=0; j<m; j++) {
      SurfaceNormal(&normij,MeshCoordPtr(head,i-1,j),
                            MeshCoordPtr(head,i,j),
                            MeshCoordPtr(head,i,j+1));
      @<Increment the normal at $(i,j)$@>@;
     }

@ @<Normal vectors from the left lower quadrant@>=
  for(i=1; i<head->dimU; i++)
    for(j=1; j<head->dimV; j++) {
      SurfaceNormal(&normij,MeshCoordPtr(head,i,j-1),
                            MeshCoordPtr(head,i,j),
                            MeshCoordPtr(head,i-1,j));
      @<Increment the normal at $(i,j)$@>@;
     }

@ @<Normal vectors from the right lower quadrant@>=
  for(i=0; i<n; i++)
    for(j=1; j<head->dimV; j++) {
      SurfaceNormal(&normij,MeshCoordPtr(head,i+1,j),
                            MeshCoordPtr(head,i,j),
                            MeshCoordPtr(head,i,j-1));
      @<Increment the normal at $(i,j)$@>@;
     }

@ @<Check if the surface is closed in $u$-direction@>=
found=GL_TRUE;
for(j=0; j<head->dimV && found; j++)
  found=found && (MeshIndex(head,0,j)==MeshIndex(head,head->dimU-1,j));
if(found) head->attrib |= MESH_UCLOSED;

@ @<Check if the surface is closed in $v$-direction@>=
found=GL_TRUE;
for(i=0; i<head->dimU && found; i++)
  found=found && (MeshIndex(head,i,0)==MeshIndex(head,i,head->dimV-1));
if(found) head->attrib |= MESH_VCLOSED;

@ Flip the normals of a mesh.
@<Revert the normals of all meshes@>=
Mesh3DList *FlipMeshNormals(Mesh3DList *lst)
{ int i,n;
  Point3D *normi;
  Mesh3DList *head=lst;
  while(lst) {
    n=lst->mPointNo;
    for(i=0; i<n; i++) {
      normi=lst->mNormals+i;
      normi->x=-normi->x;
      normi->y=-normi->y;
      normi->z=-normi->z;
     }
    lst=lst->next;
   }
  return head;
}

@ Count the number of elements in a |Mesh3DList|.
@<Length of a mesh list@>=
int LengthMesh3DList(Mesh3DList *lst)
{ int n=0;

  while(lst) {
    n++;
    lst=lst->next;
   }
  return n;
}

@ Delete the list of meshs.
@<Memory management@>+=
Mesh3DList *RemoveMesh3DList(Mesh3DList *lst)
{ Mesh3DList *tail;

  while(lst) {
    tail=lst->next;
    if(lst->mpolyColors) free(lst->mpolyColors);
    if(lst->mTexture) DeleteTextureMapping(lst->mTexture);
    free(lst->mPoints);
    free(lst->mNormals);
    free(lst->mTexturePoints);
    free(lst->mesh);
    free(lst);
    lst=tail;
   }
 return lst;
}


@* Global data for the scene.
@ @<Memory management@>=
@<Add a new position to the |PointPool|@>@;

@ @d MAX_LIGHT (8)
@<Global values@>=
Point3D ViewPoint={1.3,-2.4,2.0};
Point3D ViewVertical={0.,0.,1.};
RGBColor AmbientColor;
Point3D BoundP1,BoundP2;
Point3D LightPosition[MAX_LIGHT];
RGBColor   LightColor[MAX_LIGHT];
int LightNo=0;
int PolygonEdge=1;

@* Vector operations.
			  
@<Vector operations in cartesian cordinates@>=
@<Swap to 3d points @>@;
@<Dot product@>@;
@<Cross product@>@;
@<Norm of a vector@>@;
@<Spherical coordinates@>@;
@<Cartesian from spherical@>@;
@<Surface normal@>@;
@<Find the two other unit vectors for $v_1$@>@;
@<Gram Schmidt orthogonalization@>@;
@<Calculate a point |p| on the cone@>@;
@<Distance between a point and three coordinates@>@;
@<Estimate near and far plane from the bounding box@>@;

@ @<Swap to 3d points @>=
void SwapPoint3D(Point3D *p, Point3D *q)
{ Point3D tmp;

  tmp=*p;
  *p=*q;
  *q=tmp;
}

@ @<Dot product@>=
double Dot(Point3D *p1, Point3D *p2)
{
  return p1->x * p2->x + p1->y * p2->y + p1->z * p2->z;
}

@ @<Cross product@>=
void Cross(Point3D *c, Point3D *a, Point3D *b)
{
 c->x=-a->z * b->y+a->y * b->z;
 c->y= a->z * b->x-a->x * b->z;
 c->z=-a->y * b->x+a->x * b->y;
}

@ @<Norm of a vector@>=
double Norm(Point3D *p)
{ double n2;

  n2=fabs(Dot(p,p));
  return sqrt(n2);
}

@ @<Surface normal@>=
int SurfaceNormal(Point3D *nrm,
       Point3D *p1, Point3D *p2, Point3D *p3)
{ Point3D v1,v2;
  double n;

  v1.x=p2->x-p1->x;
  v1.y=p2->y-p1->y;
  v1.z=p2->z-p1->z;
  v2.x=p3->x-p2->x;
  v2.y=p3->y-p2->y;
  v2.z=p3->z-p2->z;
  Cross(nrm,&v1,&v2);
  n=Norm(nrm);
  if(n!=0.0) {
    nrm->x/=n;
    nrm->y/=n;
    nrm->z/=n;
    return GL_TRUE;
   }
  return GL_FALSE;

}

@ @<Spherical coordinates@>=
void SphericalFromCartesian(Point3D *p,
       double *r, double *theta, double *phi)
{ double arg;
  *r=Norm(p);

  if((fabs(p->x)<TINY) && (fabs(p->y)<TINY))
    *phi=atan2(p->y,TINY);
  else
    *phi=atan2(p->y,p->x);
  if(*r==0.0)
    *theta=0.0;
  else {
    if(fabs(*r)<TINY) *r=TINY;
    arg=p->z/(*r);
    if(arg>=1.0) arg=1.0-TINY;
    if(arg<=-1.0) arg=-1.0+TINY;
    *theta=acos(arg);
   }
}

@ @<Cartesian from spherical@>=
void CartesianFromSpherical(double r, double theta, double phi,
               Point3D *p)
{ double st;

  st=r*sin(theta);
  p->x=cos(phi)*st;
  p->y=sin(phi)*st;
  p->z=r*cos(theta);
}

@ To draw lines as cones we need for a normalised vector $v_1$ the two
  orthogonal vectors $v_2$ and $v_3$.
@d sign(a) (a>0.0 ? 1. : -1.)

@<Find the two other unit vectors for $v_1$@>=
void OrthogonalSet(Point3D *v1, Point3D *v2, Point3D *v3)
{ double a,b,c,n,*p;
  int i;

  a=v1->x; @+ b=v1->y; @+ c=v1->z;
  p= (double *) v1;
  i=0;
  if(fabs(p[i])<fabs(p[1])) i=1;
  if(fabs(p[i])<fabs(p[2])) i=2;
  switch (i) {
    case 0 :
      @<Calcultate $v_2$ und $v_3$ for maximal x-component in $v_1$@>@;
      break;
    case 1 :
      @<Calcultate $v_2$ und $v_3$ for maximal y-component in $v_1$@>@;
      break;
    case 2 :
      @<Calcultate $v_2$ und $v_3$ for maximal z-component in $v_1$@>@;
      break;
  }
}

@ @<Calcultate $v_2$ und $v_3$ for maximal z-component in $v_1$@>=
n=sqrt(fabs(b*b+c*c));
if(n>0.0) {
  v2->x=n;
  v2->y=-a*b/n;
  v2->z=-a*c/n;

  v3->x=0.0;
  v3->y=fabs(c)/n;
  v3->z=- b*sign(c)/n;
}
else {
  v2->x=1.0; @+ v2->y=v2->z=0.0;
  v3->y=1.0; @+ v2->x=v2->z=0.0;
}

@ @<Calcultate $v_2$ und $v_3$ for maximal x-component in $v_1$@>=
n=sqrt(fabs(a*a+c*c));
if(n>0.0) {
  v2->x=- a*b/n,
  v2->y= n;
  v2->z= - b*c/n;

  v3->x=- c*sign(a)/n;
  v3->y=0.;
  v3->z=fabs(a)/n;
 }
else {
  v2->y=1.0; @+ v2->x=v2->z=0.0;
  v3->z=1.0; @+ v2->x=v2->y=0.0;
}

@ @<Calcultate $v_2$ und $v_3$ for maximal y-component in $v_1$@>=
n=sqrt(fabs(b*b+c*c));
if(n>0.0 ) {
  v2->x=n;
  v2->y=-a*b/n;
  v2->z=-a*c/n;

  v3->x=0.0;
  v3->y=-c*sign(b)/n;
  v3->z=fabs(b)/n;
 }
else {
  v2->z=1.0; @+ v2->x=v2->y=0.0;
  v3->x=1.0; @+ v2->y=v2->z=0.0;
}


@ @<Gram Schmidt orthogonalization@>=
void GramSchmidt(Point3D *e1, Point3D *e2, Point3D *e3)
  { double d12,d13,d23, n;

    d12=Dot(e1,e2);
    e2->x -= d12 * e1->x;
    e2->y -= d12 * e1->y;
    e2->z -= d12 * e1->z;
    n=Norm(e2);
    e2->x/=n; @+    e2->y/=n; @+    e2->z/=n;
    d13=Dot(e1,e3);
    e3->x -= d13 * e1->x;
    e3->y -= d13 * e1->y;
    e3->z -= d13 * e1->z;
    n=Norm(e3);
    e3->x/=n; @+    e3->y/=n; @+    e3->z/=n;
    d23=Dot(e2,e3);
    e3->x -= d23 * e2->x;
    e3->y -= d23 * e2->y;
    e3->z -= d23 * e2->z;
    n=Norm(e3);
    e3->x/=n; @+    e3->y/=n; @+    e3->z/=n;
  }

@ @d sqr(a) ((a)*(a))
@<Calculate a point |p| on the cone@>=
void ConePoint(double r, double phi, Point3D *u, Point3D *v, Point3D *p)
{ double cphi,sphi;

  cphi=r*cos(phi);
  sphi=r*sin(phi);
  p->x=(cphi*u->x+sphi*v->x);
  p->y=(cphi*u->y+sphi*v->y);
  p->z=(cphi*u->z+sphi*v->z);

}

@ @d IncPoint3D(p,inc) {p.x+=inc.x; p.y+=inc.y; p.z+=inc.z;}
  @d AddPoint3D(res,a,b) {res.x=a.x+b.x; res.y=a.y+b.y; res.z=a.z+b.z; }

@<Make a cone along $p_1$ and $p_2$@>=
void MakeCone(Point3D *p1, Point3D *p2, double r, int n)
{ Point3D v1,v2,v3,vn,p[4],testn;
  double norm;
  double dphi;
  int i,interchange;

  v1.x=p2->x-p1->x;
  v1.y=p2->y-p1->y;
  v1.z=p2->z-p1->z;
  norm=Norm(&v1);
  v1.x/=norm; @+  v1.y/=norm; @+ v1.z/=norm;
  OrthogonalSet(&v1,&v2,&v3);

  v1.x=p2->x-p1->x;
  v1.y=p2->y-p1->y;
  v1.z=p2->z-p1->z;
  dphi=TWO_PI/n;
  @<Test triangle orientation@>@;
  ConePoint(r,0.0,&v2,&v3, p);
  vn=*p;
  IncPoint3D(p[0],(*p1))@;
  AddPoint3D(p[1],p[0],v1)@;
  glBegin(GL_TRIANGLE_STRIP);
    glNormal3dv((GLdouble *) (&vn));
    glVertex3dv((GLdouble *) p);
    glVertex3dv((GLdouble *) (p+1));
    for(i=1; i<=n; i++) {
      ConePoint(r,i*dphi,&v2,&v3,p+2);
      vn=p[2];
      IncPoint3D(p[2],(*p1))@;
      AddPoint3D(p[3],p[2],v1)@;
      glNormal3dv((GLdouble *) (&vn));
      glVertex3dv((GLdouble *) (p+2));
      glVertex3dv((GLdouble *) (p+3));

    }
  glEnd();

}

@ The thet for the triangle orientation is a bit different
   for cutted cones from continued ones but the idea is the same.
@<Test triangle orientation@>=
  /* make the test triangle */
  ConePoint(r,0.0,&v2,&v3,p);
  IncPoint3D(p[0],(*p1));
  p[1]=p[0];
  IncPoint3D(p[1],v1);

  ConePoint(r,dphi,&v2,&v3,p+2);
  IncPoint3D(p[2],(*p1));

  SurfaceNormal(&testn,p,p+1,p+2);
  interchange=Dot(&testn,&v2)<0.0;
  if(interchange) { /* swap the unit vectors */
    SwapPoint3D(&v2,&v3);
   }
  if(MVFaceFlip) { /* swap the unit vectors */
    SwapPoint3D(&v2,&v3);
   }

@ @<Make a continued cone along $p_1$ and $p_2$ to $p_3$@>=
void MakeConeContinued(Point3D *p1, Point3D *p2, Point3D *p3,
               double r, int n)
{ Point3D v1,v2,v3,u1,u2,u3,vn1,vn2,p[4];
  Point3D testn;
  double norm;
  double dphi;
  int i,interchange;

  @<Prepare the local frame from |p1|, |p2| and |p3|@>@;
  @<Skip continuation if the angle between the vectors is to large@>@;
  u2=v2; @+  u3=v3;
  GramSchmidt(&u1,&u2,&u3);
  dphi=TWO_PI/n;
  @<Check the orientation of the triangle strips@>@;
  ConePoint(r,0.0,&v2,&v3, p);
  vn1=*p;
  IncPoint3D(p[0],(*p1))@;
  ConePoint(r,0.0,&u2,&u3,p+1);
  vn2=p[1];
  IncPoint3D(p[1],(*p2))
  glBegin(GL_TRIANGLE_STRIP);
    glNormal3dv((GLdouble *) (&vn1));
    glVertex3dv((GLdouble *) p);
    glNormal3dv((GLdouble *) (&vn2));
    glVertex3dv((GLdouble *) (p+1));
    for(i=1; i<=n; i++) {
      ConePoint(r,i*dphi,&v2,&v3,p+2);
      vn1=p[2];
      IncPoint3D(p[2],(*p1))@;
      ConePoint(r,i*dphi,&u2,&u3,p+3);
      vn2=p[3];
      IncPoint3D(p[3],(*p2));
      glNormal3dv((GLdouble *) (&vn1));
      glVertex3dv((GLdouble *) (p+2));

      glNormal3dv((GLdouble *) (&vn2));
      glVertex3dv((GLdouble *) (p+3));
    }
  glEnd();

}

@ @<Prepare the local frame from |p1|, |p2| and |p3|@>=
  v1.x=p2->x-p1->x; @+ v1.y=p2->y-p1->y; @+ v1.z=p2->z-p1->z;
  norm=Norm(&v1);
  v1.x/=norm; @+  v1.y/=norm; @+ v1.z/=norm;
  u1.x=p3->x-p2->x;@+  u1.y=p3->y-p2->y; @+  u1.z=p3->z-p2->z;
  norm=Norm(&u1);
  u1.x/=norm; @+  u1.y/=norm; @+ u1.z/=norm;
  Cross(&v2,&v1,&u1);
  if(fabs(v2.x)+fabs(v2.y)+fabs(v2.z)< TINY) {
    OrthogonalSet(&v1,&v2,&v3);
   }
  v3.x=v3.y=v3.z=1.0;
  GramSchmidt(&v1,&v2,&v3);

@ @<Skip continuation if the angle between the vectors is to large@>=
  if(Dot(&u1,&v1)<CosSkipCont) {
    MakeCone(p1,p2,r,n);
    return;
   }

@ At some positions of the curve the meaning of |u2| and |u3| and
  |v2| and |v3| changes and the resulting triangle strip is orineted inside.
  The check for the orientation creates a test triangle and compares it
  to the orientation of the |v2| vector that points outside.
  If the orientation of the test triangle is inward the vectors perpendicular
  to the curve (tangent) are interchanged.

@<Check the orientation of the triangle strips@>=
  /* make the test triangle */
  ConePoint(r,0.0,&v2,&v3,p);
  IncPoint3D(p[0],(*p1));
  ConePoint(r,0.0,&u2,&u3,p+1);
  IncPoint3D(p[1],(*p2));
  ConePoint(r,dphi,&v2,&v3,p+2);
  IncPoint3D(p[2],(*p1));

  SurfaceNormal(&testn,p,p+1,p+2);
  interchange=Dot(&testn,&v2)<0.0;
  if(interchange) { /* swap the unit vectors */
    SwapPoint3D(&v2,&v3);
    SwapPoint3D(&u2,&u3);
   }
  if(MVFaceFlip) { /* swap the unit vectors */
    SwapPoint3D(&v2,&v3);
    SwapPoint3D(&u2,&u3);
   }

@ @<Distance between a point and three coordinates@>=
double DistancePointCoord(Point3D *p, double x, double y, double z)
{ double dx,dy,dz;

  dx=p->x-x;
  dy=p->y-y;
  dz=p->z-z;
  return sqrt(dx*dx+dy*dy+dz*dz); 
}

@ @d AssignMinMax(min,max,d) if((d)<min) min=(d); else if ((d)>max) max=d;

@<Estimate near and far plane from the bounding box@>=
void EstimateViewDepth(double *nearp, double *farp,
       Point3D *vp, Point3D *p1, Point3D *p2)
{ double d;

  *nearp=*farp=DistancePointCoord(vp,p1->x,p1->y,p1->z);
  d=DistancePointCoord(vp,p2->x,p1->y,p1->z);
  AssignMinMax(*nearp,*farp,d)@;
  d=DistancePointCoord(vp,p2->x,p2->y,p1->z);
  AssignMinMax(*nearp,*farp,d)@;
  d=DistancePointCoord(vp,p1->x,p2->y,p1->z);
  AssignMinMax(*nearp,*farp,d)@;
  d=DistancePointCoord(vp,p1->x,p1->y,p2->z);
  AssignMinMax(*nearp,*farp,d)@;
  d=DistancePointCoord(vp,p2->x,p1->y,p2->z);
  AssignMinMax(*nearp,*farp,d)@;
  d=DistancePointCoord(vp,p2->x,p2->y,p2->z);
  AssignMinMax(*nearp,*farp,d)@;
  d=DistancePointCoord(vp,p1->x,p2->y,p2->z);
  AssignMinMax(*nearp,*farp,d)@;
  *farp*=SQRT3;
}


@* Polygon reduction.
@<Functions for polygon simplification@>=
  @<Distance of a point to a line in 3d@>@;
  @<Normalize 2d vector@>@;
  @<Side of line test@>@;
  @<Test a 2d point again the 2d polygon@>@;
  @<Rotate an integer array left@>@;
  @<Rotate an integer array right@>@;
  @<Reverse an integer array@>@;
  @<Rotate 2d points right@>@;
  @<Swap polygon pointers@>@;
  @<Order the polygones at a single vertex@>@;
  @<Calcluate an approximate plane for a polygon@>@;
  @<Tessellate the outer polygon@>@;
  @<Search the octal tree for removable verticies@>@;
  @<Simplify the polygones in the scene@>@;


@ @<Simplify the polygones in the scene@>=
int SimplifyPolygones(int iter, double tol, PointOctTree *tree)
{ LinePolyList *plst;
  int i,it,len1,len2,len3;

  len1=len2=LengthLinePolyList(Polygons);
  for(it=0; it<iter; it++) {
    @<Insert the polygons into the octal tree@>@;
    ReducePolygons(tol,tree,tree);
    StripPolygonsFromOctTree(tree);
    len3=LengthLinePolyList(Polygons);
    if(len3==len2) break;
    len2=len3;
   }
  AveragedNormals(Polygons);
  return len1-len2;
}


@ For the polygon reduction we must find quickly the polygons with a common vertex.
We do this by insertion of the polygons into the octal tree of points. The location of a point
in the octal tree needs only $\propto N\log N$ operations for  $N$ points. 

@<Insert the polygons into the octal tree@>=
  plst=Polygons;
  while(plst) {
    for(i=0; i<plst->pno; i++) 
      InsertPolyInOctTree(tree,plst,plst->points[i]); 
    plst=plst->next;
   } 


@ When walk recursive along the octal tree and look for a vertex that
can be removed. We need at least a point that is member of more than
three polygones.

@<Search the octal tree for removable verticies@>=
void ReducePolygons(double tol, PointOctTree *root,PointOctTree *tree)
{ int i;
 
  if(!tree) return;
  for(i=0; i<8; i++)
    if(tree->leafs[i]) ReducePolygons(tol, root, tree->leafs[i]);
  if(tree->polyNo>=3) {
    @<Try to reduce the polygons at the current point of the tree@>@; 
   }
}


@ For an easy detection of the outer polygon the polygon points gets rotated
until the inner point is the second point of the polygon.
@<Rotate an integer array left@>=
void RotateIntegersLeft(int *arr, int n)
{ int first; 
  int i, n1;

  n1=n-1;
  first=arr[0];
  for(i=0; i<n1; i++)
    arr[i]=arr[i+1];
  arr[n1]=first;
}

@ @<Rotate an integer array right@>=
void RotateIntegersRight(int *arr, int n)
{ int first; 
  int i, n1;

  n1=n-1;
  first=arr[n1];
  for(i=n-1; i>0; i--)
    arr[i]=arr[i-1];
  arr[0]=first;
}


@ @<Reverse an integer array@>=
void ReverseIntegers(int *arr, int n)
{ int i, tmp,n2;
  
  n2=n/2;
  for(i=0; i<n2; i++) {
    tmp=arr[i];
    arr[i]=arr[n-1-i];
    arr[n-1-i]=tmp;
   }  
}

@ @<Rotate 2d points right@>=
void RotatePoint2DRight(Point2D *pnts, int n)
{ Point2D p; 
  int i, n1;

  n1=n-1;
  p=pnts[n1]; 
  for(i=n-1; i>0; i--) 
    pnts[i]=pnts[i-1];   
  pnts[0]=p; 
}

@ @<Normalize 2d vector@>=
void Normalize2D(Point2D *p)
{ double len;
  
  len=sqrt((p->x)*(p->x)+(p->y)*(p->y));
  if(len>0.0) {
    len=1.0/len;
    (p->x)*=len;
    (p->y)*=len; 
   }
}


@ Distance point |p| to line |p1| parallel to |n|.
@<Distance of a point to a line in 3d@>=
double DistancePointToLine3D(int i,int i1 , int i2)
{ Point3D *p,*p1,n;
  Point3D dp,cp;
  double d;
  
  p=PointPool+i; @+ p1=PointPool + i1; @+ n=PointPool[i2];
  n.x -= p1->x; @+ n.y -= p1->y; @+ n.z -= p1->z; 
  dp.x=p->x-p1->x;
  dp.y=p->y-p1->y;
  dp.z=p->z-p1->z;
  Cross(&cp,&dp,&n);
  d=Dot(&n,&n);
  return sqrt(Dot(&cp,&cp)/d); 
}

@ 
@<Side of line test@>=
#define LeftSideLine   (1)
#define RightSideLine  (-1)
#define Collinear (0)
int SideOfLine2D(Point2D *p, Point2D *p1, Point2D *p2)
{ Point2D u,v;
  double test;

  u.x=p2->x-p1->x;
  u.y=p2->y-p1->y;
  v.x=p->x-p2->y;
  v.y=p->y-p2->y;
  Normalize2D(&u);
  Normalize2D(&v);
  test=u.x*v.y-u.y*v.x;
  if(test>MachineEpsilon) 
    return LeftSideLine;
  if(test<-MachineEpsilon)
    return RightSideLine;
  return Collinear;
}
               
@ @<Test a 2d point again the 2d polygon@>=
int PointInPolygon2D(Point2D *pnew,Point2D *p, int np)
{ int i,inpoly,test,all;
  
  inpoly=SideOfLine2D(pnew,p+np-1,p);
  for(i=0; i<np-1; i++) {
     test=SideOfLine2D(pnew,p+i,p+i+1);
     if(test==inpoly) all=GL_TRUE;
     if(!all) return all;
    }
  return all;
}

@ @<Tessellate the outer polygon@>=
LinePolyList *TessPolygon3D(int *poly, int pno,
                Point3D *planen,
                double r, double g, double b)
{ Point3D tnormal;
  Point3D n1,n2,*p,*p1,*p2,pc;
  Point2D *p2d,test; 
  int i,found,imax,tri[3],sameDirection;  
  LinePolyList *plst,*lst;

  plst=NULL;
  p2d=(Point2D *)calloc(pno,sizeof(Point2D));
  @<Calculate the vectors in the plane@>@;
  @<Project the 3d points to the plane $n_\, x+n_y\, y + n_z\, z+d=0$@>@;
  while(pno>3) {
    for(imax=0;imax<pno; imax++) {
      @<Construct a triangle from the point at |imax|@>@;
      if(PointInPolygon2D(&test,p2d,pno)) {
        found=GL_TRUE;
        break;
       }
     }
    if(found) 
      plst=PrependLinePolyList(plst,Polygon3D,tri,3,r,g,b); 
    for(i=imax+1; i<pno; i++) { 
      RotateIntegersRight(poly,pno);
      RotatePoint2DRight(p2d,pno);
     }      
    pno--; 
   }
  plst=PrependLinePolyList(plst,Polygon3D,poly,pno,r,g,b);
  @<Test the normal of the newly generated polygons@>@;
  if(!sameDirection) {
    RemoveLinePolyList(plst);
    plst=NULL;
   }
  free(p2d);
  return plst;
}

@ @<Calculate the vectors in the plane@>=
  p1=PointPool + poly[0]; @+ p2= PointPool + poly[1];
  n1.x=p1->x-p2->x;
  n1.y=p1->y-p2->y;
  n1.z=p1->z-p2->z;
  p1=PointPool + poly[2]; 
  n2.x=p2->x-p1->x;
  n2.y=p2->y-p1->y;
  n2.z=p2->z-p1->z;
  n1.x=0.5*(n1.x+n2.x);
  n1.y=0.5*(n1.y+n2.y);
  n1.z=0.5*(n1.z+n2.z);
  Cross(&n2,planen,&n1);
  GramSchmidt(planen,&n1,&n2);

@ @<Project the 3d points to the plane $n_\, x+n_y\, y + n_z\, z+d=0$@>=
  for(i=0; i<pno; i++) {
    p=PointPool+poly[i];
    p2d[i].x=Dot(p,&n1);
    p2d[i].y=Dot(p,&n2);
   }  


@ The new polygon may be not convex. So we seach for points on the
  convex hull of the polygon and remove this points first. |test| is the projection
  of the midpoint of the third line.

@<Construct a triangle from the point at |imax|@>=
  tri[0]=poly[(imax-1)<0 ? pno-1 :imax-1]; 
  tri[1]=poly[imax]; 
  tri[2]=poly[(imax+1)==pno ? 0 : imax+1];
  p1=PointPool+tri[0];
  p2=PointPool+tri[2];
  pc.x=0.5*(p1->x+p2->x);
  pc.y=0.5*(p1->y+p2->y);
  pc.z=0.5*(p1->z+p2->z);
  test.x=Dot(&pc,&n1);
  test.y=Dot(&pc,&n2);
 
@ To avoid artefacts in the polygon reduction we must check that every
  normal of the new polygons point in the same direction as the original
  plane.

@<Test the normal of the newly generated polygons@>=
  lst=plst;
  sameDirection=GL_TRUE;
  while(lst) {
    SurfaceNormal(&tnormal,
      PointPool+lst->points[0],
      PointPool+lst->points[1],
      PointPool+lst->points[2]);
    sameDirection=sameDirection && (Dot(&tnormal,planen)>0.25);
    lst=lst->next;
   }
  


@ For the sorting process we need a fucntion that exchange two pointers
to polygons.
@<Swap polygon pointers@>=
void SwapPolyPtr(LinePolyList **p1,LinePolyList **p2)
{ LinePolyList *tmp;
  
  tmp=*p1;
  *p1=*p2;
  *p2=tmp;
}

@ Search the adjacent polygon for polygon |j| from the data
  in |tree|.
@<Order the polygones at a single vertex@>=
int InsertAdjacentPolygon(PointOctTree *tree, int j)
{ int k,npoly;
  
  npoly=tree->polyNo; 
  k=j+1;
  while(k<npoly) {
    if(PolygonPoint(tree,j-1,2)==PolygonPoint(tree,k,0)) {
      SwapPolyPtr(tree->vpoly + j,tree->vpoly +k);
      return GL_TRUE;
     }
    k++;
   }
  return GL_FALSE;
}
 

@ We calculate an averaged plane equation 
$a\,x+b\,y+c\,z+d==0$ for the points of the outer polygon.

@<Calcluate an approximate plane for a polygon@>=
void FindPlaneEquation(Point3D *pn, double *d,
              int *poly, int n)
{ Point3D cntr,*p;
  Point3D nvect,v;
  double nn;
  int i;

  cntr.x=cntr.y=cntr.z=0.0;
  for(i=0; i<n; i++) {
     p=PointPool+poly[i];
     cntr.x+=p->x;
     cntr.y+=p->y;
     cntr.z+=p->z;
   }
  cntr.x/=n; @+
  cntr.y/=n; @+
  cntr.z/=n;
  nvect.x=nvect.y=nvect.z=0.0;
  for(i=1; i<n-1; i++) {
    SurfaceNormal(&v,PointPool+poly[i-1],PointPool+poly[i],PointPool+poly[i+1]);
    nvect.x+=v.x;
    nvect.y+=v.y;
    nvect.z+=v.z;
   } 
  SurfaceNormal(&v,PointPool+poly[n-2],PointPool+poly[n-1],PointPool+poly[0]);
  nvect.x+=v.x;
  nvect.y+=v.y;
  nvect.z+=v.z;
  nn=Norm(&nvect);
  if(nn>0.0) {
    nn=1.0/nn;
    nvect.x*=nn;
    nvect.y*=nn;
    nvect.z*=nn;
   }
  *d=-Dot(&nvect,&cntr);
  pn->x=nvect.x;
  pn->y=nvect.y;
  pn->z=nvect.z;
}


@ |center| is the vertex for the possible removal, |npoly| is the number
of polygons with this common vertex.

@d PolygonPoint(t,n,k) ((t->vpoly[(n)])->points[(k)])
@d PolygonPoints(t,n)  ((t->vpoly[(n)])->points) 
@d PolygonPointNo(t,n) ((t->vpoly[(n)])->pno)

@<Try to reduce the polygons at the current point of the tree@>=
{ int center,npoly,j,k;
  int closed,adjacent=GL_TRUE;
  int colin=GL_FALSE; 

  center=tree->point;
  npoly=tree->polyNo;
  @<Order the polygons and bring the |center| to the second position@>@;
  @<Sort the polygones at the vertex@>@;
  if((closed || colin )&& adjacent) {
    @<Find the new plane formed by outer points@>@;
   }
}

@ @<Order the polygons and bring the |center| to the second position@>=
  for(j=0; j<npoly; j++) {
    for(k=0; k<PolygonPointNo(tree,j); k++) {
      if(PolygonPoint(tree,j,1)==center) break;
      RotateIntegersLeft(PolygonPoints(tree,j),PolygonPointNo(tree,j));
     }
    adjacent=adjacent && (PolygonPoint(tree,j,1)==center); 
   }

@ We sort the polygones so that polygones with a common edge
  are stored in adjacent array locations.
  The |closed| variable is used to indicate when the encompassing
  polygons are not closed. The |adjacent| variable looks for cases where
  the triangle sequence is not closed. The |InsertAdjacentPolygon()| function
  returns |GL_FALSE| in this case.
@<Sort the polygones at the vertex@>=
for(j=1; j<npoly && adjacent; j++) {
   if(PolygonPoint(tree,j-1,2)!=PolygonPoint(tree,j,0)) {
     adjacent=adjacent && InsertAdjacentPolygon(tree,j);
    }
  }
closed=PolygonPoint(tree,0,0)==PolygonPoint(tree,npoly-1,2);
if(!closed) 
  colin=DistancePointToLine3D(center,PolygonPoint(tree,0,0),PolygonPoint(tree,npoly-1,2))<tol;


@ When we remove a boundary point(|colin=GL_TRUE|) the 
  (not a closed sequence of polygons)
  we have to add the last point of the 
  last polygon to the points of the
  new polygons.

@<Find the new plane formed by outer points@>=
{ double d,dist;
  double envdist;
  Point3D *p,planeNormal;
  int *newpoly;
  int ppNo;
  LinePolyList *newPolygons, *plst;
 
  p=PointPool+center;
  ppNo=npoly;
  if(!colin) {
    newpoly=(int *)calloc(ppNo,sizeof(int));
    for(j=0; j<ppNo; j++)
      newpoly[j]=PolygonPoint(tree,j,0);
   }
  else { /*  add the last point of the triangle */
    ppNo++;
    newpoly=(int *)calloc(ppNo,sizeof(int));
    for(j=0; j<npoly; j++)
      newpoly[j]=PolygonPoint(tree,j,0);
    newpoly[npoly]=PolygonPoint(tree,npoly-1,2);
   }
  @<Make the plane equation@>@;
  if(dist<=tol) {
     newPolygons=TessPolygon3D(newpoly, ppNo, &planeNormal,1.0,1.0,1.0);
     if(newPolygons) {
       @<Update the octtree and the global polygon list with the new polygons@>@;
       @<Remove the old polygons from the octal tree@>@;
       @<Delete the old polygons form the global polygon list@>@;
       free(tree->vpoly);
       tree->vpoly=NULL;
       tree->polyNo=0;
     }
   }
  free(newpoly); 
 }

@ When the points for the new polygon are collected the polygon
get the wrong orientation. We correct this by a |ReverseIntegers| call. 
The distance of the averaged plane to the center point as well as the distance
of the points in the new polygon are used to calculate the |dist| value.

@<Make the plane equation@>=
ReverseIntegers(newpoly,ppNo);
FindPlaneEquation(&planeNormal,&d,newpoly,ppNo);
dist=fabs(Dot(&planeNormal,p)+d);
for(envdist=0.0,j=0; j<ppNo; j++)
  envdist+=fabs(Dot(&planeNormal,PointPool+newpoly[j])+d);
envdist/=ppNo;
dist=dist+envdist;


@ @<Update the octtree and the global polygon list with the new polygons@>=
plst=newPolygons;
while(plst) {
  for(j=0; j<plst->pno; j++) 
    InsertPolyInOctTree(root,plst,plst->points[j]); 
  plst=plst->next;
 }
Polygons=JoinLinePolyList(newPolygons,Polygons);

@ @<Remove the old polygons from the octal tree@>=
for(j=0; j<npoly; j++) {
   RemovePolyFromOctTree(root,tree->vpoly[j],PolygonPoint(tree,j,0));
   RemovePolyFromOctTree(root,tree->vpoly[j],PolygonPoint(tree,j,2));
  }

@ @<Delete the old polygons form the global polygon list@>=
for(j=0; j<npoly; j++) 
  Polygons=DeleteSinglePolygon(Polygons,tree->vpoly[j]);

@ @<Print polygon information@>=
  if(closed) {
    for(j=0; j<npoly; j++){
      printf("%d ( ",center); 
      for(k=0; k<PolygonPointNo(tree,j); k++)
         printf(" %d ",PolygonPoint(tree,j,k));
      printf(")\n");
     }
    }

@ The global values |PolyReduceFactor| and |PolyReduceIterations| used to offer a command
line interface to the polygon reduction.
@<Global values@>=
double PolyReduceFactor=0.0;
int PolyReduceIterations=0;

@* Quaternions.
The quaternions are used to represent 3d rotations in angle/axes form
@<Data structure for Quaternion@>=
typedef struct Quaternion {
                  double q0,q1,q2,q3;
                 } Quaternion;

@ @<Quaternion utilities@>=
@<Create a Quaternion from a rotation@>@;
@<Extract rotation from Quaternion@>@;
@<Multiplication of two Quaternions@>@;
@<Inverse Quaternion@>@;
@<Rotation of $v$ by the quaternion |q|@>@;

@ The Quaternion $q$ represent a angle/axes rotation
if $q=(\cos \theta/2,{\vec n}\sin \theta/2)$. $\vec n$ is
the unit vector along the rotation axes, and $\theta$ the
rotation angle.
@<Create a Quaternion from a rotation@>=
Quaternion *MakeQuaternion(Quaternion *q, double theta,Point3D *v)
{ double st,ct;
  double vn;

  vn=Norm(v);
  if(vn!=0.0) {
    vn=1.0/vn;
    theta*=0.5;
    st=sin(theta);
    ct=cos(theta);
    vn*=st;
    q->q0=ct;
    q->q1=v->x*vn;
    q->q2=v->y*vn;
    q->q3=v->z*vn;
    return q;
   }
  return NULL;
}

@ The inverse operation is to retain angle and axes from a Quaternion.
@<Extract rotation from Quaternion@>=
Point3D *GetQuaternionRotation(double *theta,Point3D *axes,Quaternion *q)
{ double st;

  *theta=acos(q->q0);
  st=sin(*theta);
  if(st!=0.0) {
   axes->x=q->q1/st;
   axes->y=q->q2/st;
   axes->z=q->q3/st;
   *theta*=2.0;
   return axes;
  }
 return NULL;
}

@ The multiplication of two quaternions is given by
$$ q\cdot p=\pmatrix{ q_0\,p_0 -q_1\,p_1-q_2\,p_2-q_3\,p_3\cr
                      q_0\,p_1 +p_0\,q_1+q_2\,p_3-q_3\,p_2\cr
                      q_0\,p_2 +p_0\,q_2+q_3\,p_1-q_1\,p_3\cr
                      q_0\,p_3 +p_0\,q_3+q_1\,p_2-q_2\,p_1\cr}
$$
@<Multiplication of two Quaternions@>=
Quaternion *QuaternionTimes(Quaternion *qp,Quaternion *q,Quaternion *p)
{
  qp->q0=p->q0*q->q0 - p->q1*q->q1 - p->q2*q->q2 - p->q3*q->q3;
  qp->q1=p->q1*q->q0 + p->q0*q->q1 + p->q3*q->q2 - p->q2*q->q3;
  qp->q2=p->q2*q->q0 - p->q3*q->q1 + p->q0*q->q2 + p->q1*q->q3;
  qp->q3=p->q3*q->q0 + p->q2*q->q1 - p->q1*q->q2 + p->q0*q->q3;
  return qp;
}

@ Inversion of an Quaternion is given by $q^{-1}=(q_0,-q_1,-q_2,-q_3)$,
so that $q^{-1}\cdot q=q\cdot q^{-1}=(1,0,0,0)$.
@<Inverse Quaternion@>=
Quaternion *InverseQuaternion(Quaternion *q)
{
  q->q1=-q->q1;
  q->q2=-q->q2;
  q->q3=-q->q3;
  return q;
}

@ The rotation of a 3d vector $v$ by a quaternion $q$ is the quadratic form
$$ q\, V\, {\bar q}= q\, V\, q^{-1}$$
with $V=(0,{\vec v})$.
@<Rotation of $v$ by the quaternion |q|@>=
void QuaternionRotate(Point3D *rp, Quaternion *q, Point3D *p)
{ Quaternion conjQ,v,result,tmp;

  v.q0=0.0; @+ v.q1=p->x; @+ v.q2=p->y; @+ v.q3=p->z;
  conjQ=*q;
  InverseQuaternion(&conjQ);
  QuaternionTimes(&result,QuaternionTimes(&tmp,q,&v),&conjQ);
  rp->x=result.q1;
  rp->y=result.q2;
  rp->z=result.q3;
}

@* Read 3Scripts.
@<Read ThreeSript files@>=
@<Threescript keywords@>@;
@<Check line for a keyword@>@;
@<$LU$ decomposition@>@;
@<$LU$ solution@>@;
@<Calculate the transformation from world to display coordinates@>@;
@<Scan ThreeScript file@>@;

@ @<Threescript keywords@>=
#define KEYWORDNO    11
#define BBOX         0
#define VPOINT       1
#define LSOURCE      2
#define POINT        3
#define LINE         4
#define POLY         5
#define AMBIENT      6
#define COLOR        7
#define SURFACECOLOR 8
#define MESH         9
#define COLORMESH   10

char *Keyword[KEYWORDNO]={"boundingbox",
              "viewpoint",
              "lightsources",
              "point",
              "line",
              "polygon",
              "ambient",
              "color",
              "surfacecolor",
              "mesh",
              "colormesh"};

@ @<Check line for a keyword@>=
int SearchKeyWord(char *cline)
{ int i;
  for(i=KEYWORDNO-1; i>-1; i--)
    if(cline==strstr(cline,Keyword[i])){
      return i;
     }
  return -1;
}


@ @d MAX_STRING (256)
@<Scan ThreeScript file@>=
int Read3Script(char *fname)
{ char cline[MAX_STRING];
  FILE *infile;
  int key,i;
  int plBuffer[2048];
  double x,y,z,red,green,blue,sred,sblue,sgreen;
  double psize;

  infile=fopen(fname,"r");
  if(!infile) return 1;
  strcpy(cline,"");
  red= green=blue=1.0; /* white */
  sred=sgreen=sblue=1.0;
  psize=0.001;
  while(!feof(infile)) {
     if(!*cline)
        fgets(cline,MAX_STRING,infile);
     key=SearchKeyWord(cline);
     if(key<0) {
        strcpy(cline,"");
        continue;
      }
     switch(key) {
       case BBOX   :
         @<Read bounding box@>@;
         break;
       case VPOINT :
         @<Read viewpoint@>@;
         break;
       case LSOURCE:
         @<Read light sources@>@;
         break;
       case POINT  :
         @<Read point@>@;
         break;
       case LINE   :
         @<Read line@>@;
         break;
       case POLY   :
         @<Read polygon@>@;
         break;
       case AMBIENT:
         @<Read ambient light@>@;
         break;
       case COLOR  :
         @<Read color@>@;
         break;
       case SURFACECOLOR :
         @<Read surface color@>@;
         break;
       case MESH :
         @<Read a \.{SurfaceGraphics}@>@;
         break;
       case COLORMESH:
         @<Read a colored \.{SurfaceGraphics}@>@;
         break;
      }
    }
  fclose(infile);
  return 0;
}

@ @<Read polygon@>=
i=0;
fgets(cline,MAX_STRING,infile);
do {
  sscanf(cline,DBL_FMT" "DBL_FMT" "DBL_FMT"\n",&x,&y,&z);
  plBuffer[i]=AddToPointPool(x,y,z);
  i++;
  fgets(cline,MAX_STRING,infile);
 }
while(SearchKeyWord(cline)<0 && !feof(infile));
Polygons=PrependLinePolyList(Polygons,Polygon3D,plBuffer,i,sred,sgreen,sblue);

@ @<Read line@>=
i=0;
fgets(cline,MAX_STRING,infile);
do {
  sscanf(cline,DBL_FMT" "DBL_FMT" "DBL_FMT"\n",&x,&y,&z);
  plBuffer[i]=AddToPointPool(x,y,z);
  i++;
  fgets(cline,MAX_STRING,infile);
 }
while(SearchKeyWord(cline)<0 && !feof(infile));
Lines=PrependLinePolyList(Lines,Line3D,plBuffer,i,red,green,blue);

@ @<Read point@>=
fscanf(infile,DBL_FMT" "DBL_FMT" "DBL_FMT"\n",&x,&y,&z);
i=AddToPointPool(x,y,z);
Points=PrependPointList(Points,i,psize,red,green,blue);
strcpy(cline,"");

@ @<Read bounding box@>=
fscanf(infile,DBL_FMT" "DBL_FMT" "DBL_FMT"\n",
  &(BoundP1.x),&(BoundP1.y),&(BoundP1.z));
fscanf(infile,DBL_FMT" "DBL_FMT" "DBL_FMT"\n",&(BoundP2.x),&(BoundP2.y),&(BoundP2.z));
strcpy(cline,"");
CenterOfScene.x=0.5*(BoundP1.x+BoundP2.x);
CenterOfScene.y=0.5*(BoundP1.y+BoundP2.y);
CenterOfScene.z=0.5*(BoundP1.z+BoundP2.z);
ScaleOfScene.x=(BoundP2.x-BoundP1.x);
ScaleOfScene.y=(BoundP2.y-BoundP1.y);
ScaleOfScene.z=(BoundP2.z-BoundP1.z);
MaxScaleOfScene=MAX3(ScaleOfScene.x,ScaleOfScene.y,ScaleOfScene.z);

@ Since the stored surface graphics have only the $z$ values
  we must calculate the $x$ and $y$ data from the bounding box.

@<Prepare the scan of meshs@>=
  c.r=sred;
  c.g=sgreen;
  c.b=sblue;
  s=cline;
  while(*s && (isspace(*s) || isalpha(*s))) s++;
  sscanf(s,"%d %d",&n,&m);
  data=(Point3D *)calloc(m*n,sizeof(Point3D));
  dx=(BoundP2.x-BoundP1.x)/(n-1);
  dy=(BoundP2.y-BoundP1.y)/(m-1);

@ @<Scan the height values of a mesh@>=
  mu=n*m;
  for(k=0; k<mu;) {
    fgets(line,MAX_STRING,infile);
    PrepareLine('%',&cutline,line);
    if(!*cutline) continue;
    sscanf(cutline,DBL_FMT"\n",&data[k].z);
    data[k].x=BoundP1.x+((int) (k/n))*dx;
    data[k++].y=BoundP1.y+((int) (k % n))*dy;
   }

@ @<Scan the color values of a mesh@>=
  mu=(n-1)*(m-1);
  for(k=0;k<mu;) {
    fgets(line,MAX_STRING,infile);
    PrepareLine('%',&cutline,line);
    if(!*cutline) continue;
    sscanf(cutline,DBL_FMT" "DBL_FMT" "DBL_FMT"\n",&colors[k].r,&colors[k].g,&colors[k].b);
    k++;
   }

@ @<Read a \.{SurfaceGraphics}@>=
{ int n,m,k,mu;
  double dx,dy;
  Point3D *data;
  char *s;
  RGBColor c;
  char line[MAX_STRING];
  char *cutline;

  @<Prepare the scan of meshs@>@;
  @<Scan the height values of a mesh@>@;
  Meshes=PrependMesh3DList(Meshes,n,m,data,&c,0,0,NULL);
  free(data);
  strcpy(cline,"");
}

@ @<Read a colored \.{SurfaceGraphics}@>=
{ int n,m,k,mu;
  double dx,dy;
  Point3D *data;
  RGBColor *colors;
  char *s;
  RGBColor c;
  char line[MAX_STRING];
  char *cutline;

  @<Prepare the scan of meshs@>@;
  colors=(RGBColor *)calloc((m-1)*(n-1),sizeof(RGBColor));
  @<Scan the height values of a mesh@>@;
  @<Scan the color values of a mesh@>@;
  Meshes=PrependMesh3DList(Meshes,n,m,data,&c,n-1,m-1,(double *)colors);
  free(data);
  free(colors);
  strcpy(cline,"");
}


@ @<Read viewpoint@>=
fscanf(infile,DBL_FMT" "DBL_FMT" "DBL_FMT"\n",
  &(ViewPoint.x),
  &(ViewPoint.y),
  &(ViewPoint.z));
strcpy(cline,"");

@ @<Read color@>=
fscanf(infile,DBL_FMT" "DBL_FMT" "DBL_FMT"\n",&red,&green,&blue);
strcpy(cline,"");

@ @<Read surface color@>=
fscanf(infile,DBL_FMT" "DBL_FMT" "DBL_FMT"\n",&sred,&sgreen,&sblue);
strcpy(cline,"");

@ The 3Script store the light source positions in display coordiantes
we have to transform the positions into world coordinates.
@ @<$LU$ decomposition@>=
int LUDecomp(int n, double a[][5], int ip[], int *ier)
{
  int nm1, k, kp1, m;
  register int i, j;
  register double t;

  *ier = 0;
  ip[n] = 1;
  if (n != 1) {
    nm1 = n-1;
    for (k = 1; k <= nm1; k++) {
      kp1 = k+1;
      m = k;
      for (i = kp1; i <= n; i++) {
	if (fabs(a[i][k]) > fabs(a[m][k]))
	  m = i;
      }
      ip[k] = m;
      t = a[m][k];
      if (m != k) {
	ip[n] = -ip[n];
	a[m][k] = a[k][k];
	a[k][k] = t;
      }
      if (t == 0.0) {   /* singular matrix */
	*ier = k;
	ip[n] = 0;
	return 1;
      }
      t = 1.0 / t;
      for (i = kp1; i <= n; i++)
	a[i][k] = -a[i][k]*t;
      for (j = kp1; j <= n; j++) {
	t = a[m][j];
	a[m][j] = a[k][j];
	a[k][j] = t;
	if (t != 0.0) {
	  for (i = kp1; i <= n; i++)
	    a[i][j] += a[i][k]*t;
	}
      }  /* of |for j| */
    }  /* of |for k| */
  }  /* of |if n<>1| */
  k = n;
  if (a[n][n] == 0.0) {
    *ier = k;
    ip[n] = 0;
  }
 return 0;
}


@ @<$LU$ solution@>=
void LUSolution(int n, double a[][5], double b[], int ip[])
{
  register int k, m, i;
  register double t;

  if (n != 1) {
    for (k = 1; k < n; k++) {
      m = ip[k];
      t = b[m];
      b[m] = b[k];
      b[k] = t;
      for (i = k+1; i <= n; i++)
	b[i] += a[i][k]*t;
    }  /* of |for k| */
    for (k = n; k >= 2; k--) {
      b[k] /= a[k][k];
      t = -b[k];
      for (i = 1; i < k; i++)
	b[i] += a[i][k]*t;
    }  /* |for k| */
  }
  b[1] /= a[1][1];
}

@ The inversion of the $4\times 4$ matrix uses a routine that uses
$1$ as first index and not $0$ so we waste a bit of memory and leaf the
zero row and column empty.

@<Calculate the transformation from world to display coordinates@>=
void Transform3ScriptLights(Point3D *viewpnt, Point3D *viewvert, Point3D *viewcntr)
{ Point3D x,y,z,vp2;
  double n;
  double m[5][5],b[5];
  int i,ip[5],iter;

  vp2.x=-0.5*viewpnt->x;
  vp2.y=-0.5*viewpnt->y;
  vp2.z=-0.5*viewpnt->z;
  z.x=viewpnt->x-viewcntr->x;
  z.y=viewpnt->y-viewcntr->y;
  z.z=viewpnt->z-viewcntr->z;
  n=Norm(&z);
  if(n!=0.0) {
    z.x/=n;
    z.y/=n;
    z.z/=n;
   }
  y=*viewvert;
  n=Norm(&y);
  if(n!=0.0) {
    y.x/=n;
    y.y/=n;
    y.z/=n;
   }
  Cross(&x,&y,&z);
  Cross(&y,&z,&x);
  m[1][1]=x.x; @+ m[1][2]=x.y; @+ m[1][3]=x.z; @+ m[1][4]=Dot(&x,&vp2);
  m[2][1]=y.x; @+ m[2][2]=y.y; @+ m[2][3]=y.z; @+ m[2][4]=Dot(&y,&vp2);
  m[3][1]=z.x; @+ m[3][2]=z.y; @+ m[3][3]=z.z; @+ m[3][4]=Dot(&z,&vp2);
  m[4][1]=0.0; @+ m[4][2]=0.0; @+ m[4][3]=0.0; @+ m[4][4]=1.0;
  if(0==LUDecomp(4,m,ip,&iter)) {
    for(i=0; i<LightNo; i++) {
      b[1]=LightPosition[i].x;
      b[2]=LightPosition[i].y;
      b[3]=LightPosition[i].z;
      b[4]=1.0;
      LUSolution(4,m,b,ip);
      LightPosition[i].x=b[1];
      LightPosition[i].y=b[2];
      LightPosition[i].z=b[3];
     }
  }
}

@ @<Read light sources@>=
{ Point3D vc={0.5,0.5,0.5};

  fgets(cline,MAX_STRING,infile);
  i=0;
  do {
    sscanf(cline,DBL_FMT" "DBL_FMT" "DBL_FMT"",
       &(LightPosition[i].x),&(LightPosition[i].y),&(LightPosition[i].z));
    fgets(cline,MAX_STRING,infile);
    sscanf(cline,DBL_FMT" "DBL_FMT" "DBL_FMT"",
       &(LightColor[i].r),&(LightColor[i].g),&(LightColor[i].b));
    fgets(cline,MAX_STRING,infile);
    LightNo++;
    i++;
    if(i>=MAX_LIGHT) break;
   }
  while (SearchKeyWord(cline)<0);
  Transform3ScriptLights(&ViewPoint,&ViewVertical,&vc);
}

@ @<Read ambient light@>=
fgets(cline,MAX_STRING,infile);
sscanf(cline,DBL_FMT" "DBL_FMT" "DBL_FMT"",& AmbientColor.r,& AmbientColor.g,& AmbientColor.b);
strcpy(cline,"");

@* OpenGL and GLUtil stuff related with the display of the object.
@d ToDegree (180.0/3.1415926)
@d ToRadian (3.1415926/180.0)
@d MVNearPlane (1.0)
@d MVFarPlane  (7.0)
@d MVViewAngle (45.0)

@<Display the data structure with OpenGL@>=
  @<Define a material with the surface color@>@;
  @<Make a cone along $p_1$ and $p_2$@>@;
  @<Make a continued cone along $p_1$ and $p_2$ to $p_3$@>@;
  @<Pass the texture data to OpenGL@>@;
  @<Sphere to draw points@>@;
  @<OpenGL output of points@>@;
  @<OpenGL output of lines and polygons@>@;
  @<Draw textured polygons@>@;
  @<OpenGL output of general meshs@>@;
  @<Outlines of polygons@>@;
  @<Find the scaling of the scene@>@;
  @<Scale to unit volume@>@;
  @<Define lights@>@;
  @<Create the object@>@;
  @<Setup view parameters@>@;
  @<Initialise the view parameters@>@;


@ @d MAX(a,b) (a>b ? a : b)
@<Initialise the view parameters@>=
void InitView(int autoplanes)
{
  glEnable(GL_DEPTH_TEST);
  glShadeModel(GL_SMOOTH);
  if(Textures) GLSetTextures(Textures);
  CreateObject();
  RecalcView(1.0,autoplanes);
}

@ @<Setup view parameters@>=
void RecalcView(double fac,int autoplanes)
{ double vr, vphi, vtheta;
  Point3D vp;
  double nearPlane,farPlane;

  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  if(autoplanes) {
    Point3D p1,p2;

    p2.x=p2.y=p2.z=0.5*sqrt(3.);
    p1.x=p1.y=p1.z=-p2.x;
    EstimateViewDepth(&nearPlane, &farPlane,
       &ViewPoint, &p1, &p2);
    nearPlane*=0.25;   
   }
  else {
    nearPlane=MVNearPlane;
    farPlane=MVFarPlane;
   }
  gluPerspective(MVViewAngle,
     1.0,
     nearPlane,farPlane);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  SphericalFromCartesian(&ViewPoint, &vr,  &vtheta, &vphi);
  vp.x=fac*vr*cos(vphi)*sin(vtheta);
  vp.y=fac*vr*sin(vphi)*sin(vtheta);
  vp.z=fac*vr*cos(vtheta);
  CenterOfScene.x=0.5*(BoundP1.x+BoundP2.x);
  CenterOfScene.y=0.5*(BoundP1.y+BoundP2.y);
  CenterOfScene.z=0.5*(BoundP1.z+BoundP2.z);
  gluLookAt(vp.x,vp.y,vp.z, /* eye point */
     0.0,0.0,0.0,
     ViewVertical.x,ViewVertical.y,ViewVertical.z);
     /* up is the $x$-axes and we use a right handed system */
  DefineLightSources(LightPosition,LightColor,LightNo,AmbientColor);
  glEnable(GL_NORMALIZE); /* this must be done to remove the distortions of scaling */
  glBlendFunc( /* the default setting is equivalent to disable blending */
    GL_SRC_ALPHA,        /* source factor */
    GL_ONE_MINUS_SRC_ALPHA); /* destination factor */
  ScalingToUnitCube(&BoundP1,&BoundP2);
  glTranslated(-CenterOfScene.x,-CenterOfScene.y,-CenterOfScene.z);

  glPushMatrix();  /* dummy push matrix, so that we can pop when the
                      view is recalculated */
}


@ When the |SmoothShading| and |WireFrame| variables are changed we
  must recalculate the list of polygones with averaged normals and/or
  as wires.

@<Create the object@>=
void CreateObject(void)
{
  if(PointPool || Meshes){
    glPushMatrix();

    if(ObjID<0)
      ObjID=glGenLists(1);
    else {
      glDeleteLists(ObjID,1);
      ObjID=glGenLists(1);
     }
    glNewList(ObjID, GL_COMPILE);
    if(Points)
      GLPrintPointList(Points);
    if(Lines)
      GLPrintLinePolyList(Lines);
    if(Polygons) {
      if(Textures && SceneTextureMap && !WireFrame)
        GLPrintTexPolyList(SceneTextureMap->type,Polygons);
      else
        GLPrintLinePolyList(Polygons);
     }
    if(PolyOutline)
  	   GLPrintOutlinePolyList(Polygons,BlackBackground? White : Black);
    if(Meshes)
      GLPrintMesh3DList(Meshes);
    if(Axis.AxisType) {
      DrawAxis(Axis.AxisType,
        & Axis.Origin,& BoundP1,& BoundP2,
        Axis.XLabel,Axis.YLabel,Axis.ZLabel,
        Axis.FontScale,Axis.NumericLabels);
    }
    glEndList();
    glPopMatrix();
   }
}

@ This is the id-number of the compiled list object if it is greater than
zero otherwise there is nothing to draw.
@<Global values@>=
int ObjID=-1;

@ @<Find the scaling of the scene@>=
double CalcScaling(Point3D *p1, Point3D *p2)
{ double is;

  ScaleOfScene.x=(p2->x-p1->x);
  ScaleOfScene.y=(p2->y-p1->y);
  ScaleOfScene.z=(p2->z-p1->z);
  MaxScaleOfScene=MAX3(ScaleOfScene.x,ScaleOfScene.y,ScaleOfScene.z);
  if(MaxScaleOfScene!=0.0)
    is=2.0/MaxScaleOfScene;
  else
    is=1.0;
  return is;
} 

@ @<Scale to unit volume@>=
void ScalingToUnitCube(Point3D *p1, Point3D *p2)
{ double is;

  is=CalcScaling(p1,p2);
  glScaled(BoxRatios.x*is,BoxRatios.y*is,BoxRatios.z*is);
}

@ @d SET4VEC(arr,col) { arr[0]=col.r;
                        arr[1]=col.g;
                        arr[2]=col.b;
                        arr[3]=1.0;}

@<Define lights@>=
void DefineLightSources(
       Point3D *lightpos,
       RGBColor *lightc,
       int lno,
       RGBColor ambient)
{ float flt[4];
  int i;

  glEnable(GL_LIGHTING);
  SET4VEC(flt,ambient);
  glLightModelfv(GL_LIGHT_MODEL_AMBIENT,flt);
  glLightModeli(GL_LIGHT_MODEL_TWO_SIDE,GL_TRUE);
  glLightModeli(GL_LIGHT_MODEL_TWO_SIDE,GL_TRUE);
  glFrontFace(GL_CCW);
  for(i=0; i<lno; i++) {
    glEnable(GL_LIGHT0+i);
    flt[0]=lightpos[i].x; @+ flt[1]=lightpos[i].y; @+ flt[2]=lightpos[i].z;
    flt[3]=1.0; /* set non zero for light attenuation */
    glLightfv(GL_LIGHT0+i,GL_POSITION,flt);
    SET4VEC(flt,lightc[i]);
    glLightfv(GL_LIGHT0+i,GL_AMBIENT,flt);
    glLightfv(GL_LIGHT0+i,GL_DIFFUSE,flt);
    glLightfv(GL_LIGHT0+i,GL_SPECULAR,flt);
    glLightf(GL_LIGHT0+i,GL_CONSTANT_ATTENUATION, 1.0f);
    glLightf(GL_LIGHT0+i,GL_LINEAR_ATTENUATION,   0.25f);
    glLightf(GL_LIGHT0+i,GL_QUADRATIC_ATTENUATION,0.0f);
   }
  for(i=lno; i<MAX_LIGHT; i++)
    glDisable(GL_LIGHT0+i);
  glEnable(GL_COLOR_MATERIAL);
  glColorMaterial(GL_FRONT,GL_DIFFUSE);
}

@ The definition of the material properties. If the material has
the inherite attribute the color is copied.
@d INHERITE_COLOR (1L)
@<Define a material with the surface color@>=
void DefineMaterial(long what, RGBColor scolor)
{ GLfloat matAmb[4]={0.35,0.35,0.35,1.0};
  GLfloat matAmbBack[4]={0.3,0.3,0.3,1.0};
  GLfloat matDiff[4]={0.60,0.60,0.60,1.0};
  GLfloat matSpec[4]={0.25,0.25,0.25,1.0};
  GLfloat matSpecBack[4]={0.1,0.1,0.1,1.0};
  GLfloat matShine=60.0;

  if(INHERITE_COLOR==(what & INHERITE_COLOR)) {
    matAmb[0]*=scolor.r;
    matAmb[1]*=scolor.g;
    matAmb[2]*=scolor.b;
    matDiff[0]*=scolor.r;
    matDiff[1]*=scolor.g;
    matDiff[2]*=scolor.b;
   }
  glMaterialfv(GL_FRONT,GL_AMBIENT,matAmb);
  glMaterialfv(GL_BACK,GL_AMBIENT,matAmbBack);
  glMaterialfv(GL_FRONT_AND_BACK,GL_DIFFUSE,matDiff);
  glMaterialfv(GL_FRONT,GL_SPECULAR,matSpec);
  glMaterialfv(GL_BACK,GL_SPECULAR,matSpecBack);
  glMaterialf(GL_FRONT_AND_BACK,GL_SHININESS,matShine);

}


@ Setup the polygones that form a sphere at |cntr| with radius
  |r| with |nphi| azimutal segments and |ntheta| polar segments.
@d PointSphereSegmentsPhi 18
@d PointSphereSegmentsTheta 9
@<Sphere to draw points@>=
#pragma argsused
void PointSphere(Point3D *cnt, double r, int nphi, int ntheta,
         float colorRed, float colorGreen, float colorBlue)
{ int i,j,count;
  double phi,theta;
  double dphi,dtheta;
  register double cp,sp,ct,st;
  register double cp1,sp1,ct1,st1;
  Point3D p0,p;


  dphi=TWO_PI/nphi;
  dtheta=PI/ntheta;

  for(j=0; j<ntheta; j++) {
    ct=cos(theta=j*dtheta);
    st=sin(theta);
    ct1=cos(theta=(j+1)*dtheta);
    st1=sin(theta);
    for(i=0,count=0; i<nphi; i++) {
      cp=cos(phi=i*dphi);
      sp=sin(phi);
      cp1=cos(phi=(i+1)*dphi);
      sp1=sin(phi);
      if((count++ & 1)) {
        p.x=cp*st; @+ p.y=sp*st; @+p.z=ct;
        p0=p;
        @<Draw left lower polygon@>@;
        @<Draw right upper polygon@>@;
       }
      else {
        p.x=cp*st1; @+ p.y=sp*st1; @+ p.z=ct1;
        p0=p;
        @<Draw left upper polygon@>@;
        @<Draw right lower polygon@>@;
      }
    }
   }
}

@ @<Draw left lower polygon@>=
      glBegin(GL_POLYGON);
      @<Set vertex and normal from |p| and |cnt|@>@;
      p.x=cp*st1; @+ p.y=sp*st1; @+p.z=ct1;
      @<Set vertex and normal from |p| and |cnt|@>@;
      p.x=cp1*st1; @+ p.y=sp1*st1;
      @<Set vertex and normal from |p| and |cnt|@>@;
      glEnd();

@ @<Draw right upper polygon@>=
      glBegin(GL_POLYGON);
      @<Set vertex and normal from |p| and |cnt|@>@;
      p.x=cp1*st; @+ p.y=sp1*st; @+ p.z=ct;
      @<Set vertex and normal from |p| and |cnt|@>@;
      p=p0;
      @<Set vertex and normal from |p| and |cnt|@>@;
      glEnd();

@ @<Draw left upper polygon@>=
    glBegin(GL_POLYGON);
    @<Set vertex and normal from |p| and |cnt|@>@;
        p.x=cp1*st1; @+ p.y=sp1*st1; @+ p.z=ct1;
    @<Set vertex and normal from |p| and |cnt|@>@;
        p.x=cp1*st; @+ p.y=sp1*st; @+ p.z=ct;
    @<Set vertex and normal from |p| and |cnt|@>@;
    glEnd();

@ @<Draw right lower polygon@>=
    glBegin(GL_POLYGON);
    @<Set vertex and normal from |p| and |cnt|@>@;
    p.x=cp*st; @+ p.y=sp*st; @+ p.z=ct;
    @<Set vertex and normal from |p| and |cnt|@>@;
    p=p0;
    @<Set vertex and normal from |p| and |cnt|@>@;
    glEnd();

@ @<Set vertex and normal from |p| and |cnt|@>=
      glNormal3d(p.x,p.y,p.z);
      glVertex3d(r*p.x+cnt->x,r*p.y+cnt->y,r*p.z+cnt->z);

@ @<OpenGL output of points@>=
void GLPrintPointList(PointList *lst)
{
  Point3D *p;

  if(0.0>=PointSphereSize) {
    glDisable(GL_LIGHTING);
    while(lst) {
      p=PointPool + lst->point;
      glBegin(GL_POINTS);
      glColor3dv((double *) &(lst->color));
      glVertex3dv((double *) p);
      glEnd();
      lst=lst->next;
     }
   glEnable(GL_LIGHTING);
  }
 else {
   while(lst) {
     p=PointPool + lst->point;
     DefineMaterial(INHERITE_COLOR,lst->color);
     PointSphere(p,lst->size*PointSphereSize,
           PointSphereSegmentsPhi,
           PointSphereSegmentsTheta,
           lst->color.r,
           lst->color.g,
           lst->color.b
         );
     lst=lst->next;
   }
 }
}

@ @<OpenGL output of lines and polygons@>=
void GLPrintLinePolyList(LinePolyList *lst)
{ int i,thisI;
  int j1,j2,j3;
  Point3D p,normal;
  RGBColor lc;

  while(lst) {
    switch(lst->what) {
      case Polygon3D :
        if(!WireFrame)
          DefineMaterial(INHERITE_COLOR,lst->color);
        else {
          lc.r=lc.g=lc.b=LineColor;
          DefineMaterial(INHERITE_COLOR,lst->color);
         }
        glPolygonMode(GL_FRONT_AND_BACK,(WireFrame ? GL_LINE :GL_FILL));
        glBegin(GL_POLYGON);
        for(i=0; i<lst->pno; i++) {
          thisI=lst->points[i];
          @<Set vertex |thisI| of the polygon with an optional normal@>@;
         }
        glEnd();
      break;
    case Line3D :
      if(fabs(LineTubeSize)>MachineEpsilon) {
	     glPolygonMode(GL_FRONT_AND_BACK,WireFrame ? GL_LINE : GL_FILL);
        @<Draw lines as tubes@>@;
       }
      else
         @<Draw lines as lines@>@;
      break;
    }
    lst=lst->next;
   }
}

@ @<Set vertex |thisI| of the polygon with an optional normal@>=
 if(NormalPool[thisI] && SmoothShading)
   glNormal3dv((GLdouble *) *(NormalPool+thisI));
 else {
   @<Cyclic index |j1|, |j2| and |j3|@>@;
   if(SurfaceNormal(&normal,PointPool+j1,PointPool+j2,PointPool+j3))
     glNormal3dv((GLdouble *) &normal);
  }
 glVertex3dv((GLdouble *) (PointPool+thisI));

@ @<Draw lines as tubes@>=
{
  DefineMaterial(INHERITE_COLOR,lst->color);
  if(2==lst->pno)
    MakeCone(PointPool+lst->points[0],
         PointPool+lst->points[1],
         LineTubeSize,TubeSegments);
  else {
    for(i=0; i<lst->pno-2; i++)
      MakeConeContinued(
        PointPool+lst->points[i],
         PointPool+lst->points[i+1],
         PointPool+lst->points[i+2],
        LineTubeSize,TubeSegments);
    i=lst->pno-2;
    if(lst->points[0]==lst->points[i+1]) { /* closed curve */
      MakeConeContinued(
        PointPool+lst->points[i],
        PointPool+lst->points[0],
        PointPool+lst->points[1],
        LineTubeSize,TubeSegments);
    }
   else
     MakeCone(PointPool+lst->points[i],
         PointPool+lst->points[i+1],
         LineTubeSize,TubeSegments);
  }
}

@ @<Draw lines as lines@>=
{
  glBegin(lst->pno > 2 ? GL_LINE_STRIP : GL_LINES);
  for(i=0; i<lst->pno; i++) {
    p=PointPool[lst->points[i]];
    glVertex3d(p.x,p.y,p.z);
   }
  glEnd();
}


@ Draw the polygons of the scene with textures.
@<Draw textured polygons@>=
void GLPrintTexPolyList(int texMapType,LinePolyList *lst)
{ int i,thisI;
  int j1,j2,j3;
  Point3D normal,*tp;
  register double scaleS,scaleT;

  glEnable(GL_TEXTURE_2D);
  scaleS=SceneTextureMap->scaleS;
  scaleT=SceneTextureMap->scaleT;
  if((GL_RGBA==TextureType(SceneTextureMap->tex))||
     (GL_LUMINANCE_ALPHA==TextureType(SceneTextureMap->tex)))
    glEnable(GL_BLEND);
  glBindTexture(GL_TEXTURE_2D,SceneTextureID);
  glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
  while(lst) {
    if(TEXTURE_MAP_PLANAR==texMapType)
      @<Write a single textured polygon with plane texture@>@;
    else
      @<Resolve the mapping to $\phi=2\pi$ and write the textured polygon@>@;
    lst=lst->next;
   }
  if((GL_RGBA==TextureType(SceneTextureMap->tex)) ||
     (GL_LUMINANCE_ALPHA==TextureType(SceneTextureMap->tex)))
    glDisable(GL_BLEND);
  glDisable(GL_TEXTURE_2D);
}

@ @<Write a single textured polygon with plane texture@>=
{
 glBegin(GL_POLYGON);
 for(i=0; i<lst->pno; i++) {
   thisI=lst->points[i];
   tp=lst->pTexturePoints+i;
   glTexCoord2d(scaleS*tp->x,scaleT*tp->y);
   @<Set vertex |thisI| of the polygon with an optional normal@>@;
  }
 glEnd();
}

@ For all cyclic maping in $y$ direction we have the problem
  that $\phi=2\pi$ maps to $0$ instead of a mapping to one. The result is
  that the texture is repeated in the last part of the mapping because we flip
  in the coordinates from nearly on to zero instead to one. To resolve
  this problem the quadrants where the linear transformed polygon points
  located are stored in the polygon structure. When the polygon extends over
  the first and the fourth quadrant we use the fact that we repeat
  the texture in $x$ and $y$ direction and add one to the $x$ coordinate
  of the texture points in the first quadrant.

@d CrossXPlusAxis(p) (((p->pTexQuadrants & InQuadrant1)==InQuadrant1) &&
                      ((p->pTexQuadrants & InQuadrant4)==InQuadrant4))


@<Resolve the mapping to $\phi=2\pi$ and write the textured polygon@>=
{
  if(CrossXPlusAxis(lst)) {
    glBegin(GL_POLYGON);
    for(i=0; i<lst->pno; i++) {
      thisI=lst->points[i];
      tp=lst->pTexturePoints+i;
      glTexCoord2d(scaleS*(fabs(tp->x)<0.75 ? 1.0+tp->x : tp->x),scaleT*tp->y);
      @<Set vertex |thisI| of the polygon with an optional normal@>@;
     }
    glEnd();
   }
  else
    @<Write a single textured polygon with plane texture@>@;

}

@ @<Outlines of polygons@>=
void GLPrintOutlinePolyList(LinePolyList *lst,RGBColor c)
{ int i;
  Point3D p;

  glDisable(GL_LIGHTING);

  glLineWidth(2.0f);
  glColor3d(c.r,c.g,c.b);
  glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
  while(lst) {
    glBegin(GL_POLYGON);
    for(i=0; i<lst->pno; i++) {
      p=PointPool[lst->points[i]];
      glVertex3d( p.x, p.y, p.z);
     }
    glEnd();
    lst=lst->next;
   }
  glLineWidth(1.0f);
  glEnable(GL_LIGHTING);
}

@ Write the general meshes.
@<OpenGL output of general meshs@>=
void GLPrintMesh3DList(Mesh3DList *lst)
{
  DefineMaterial(INHERITE_COLOR,lst->mColor);
  if(!SmoothShading)  glShadeModel(GL_FLAT);
  glPolygonMode(GL_FRONT_AND_BACK,WireFrame ? GL_LINE : GL_FILL);
  while(lst) {
    glPushAttrib(GL_ALL_ATTRIB_BITS);
    if(lst->mTexture && lst->mTexture->tex)
      @<Draw a textured mesh with OpenGL@>@;
    else if(lst->mpolyColors)
      @<Draw a single colored mesh with OpenGL@>@;
    else
      @<Draw a single mesh with OpenGL@>@;
    glPopAttrib();  
    lst=lst->next;
   }
  if(!SmoothShading) glShadeModel(GL_SMOOTH);

}

@ Draw the polygon from the mesh data.
@d MeshSmoothPoint(i,j) glNormal3dv((GLdouble *)MeshNormalPtr(lst,i,j));
                          glVertex3dv((GLdouble *)MeshCoordPtr(lst,i,j));

@d MeshSmoothTexPoint(i,j) glNormal3dv((GLdouble *)MeshNormalPtr(lst,i,j));
                           tp=MeshTexCoordPtr(lst,i,j);
                           glTexCoord2d(scaleS*tp->x,scaleT*tp->y);
                           glVertex3dv((GLdouble *)MeshCoordPtr(lst,i,j));

@<Draw a mesh polygon@>=
  glBegin(GL_QUADS);
    MeshSmoothPoint(i,j)@;
    MeshSmoothPoint(i+1,j)@;
    MeshSmoothPoint(i+1,j+1)@;
    MeshSmoothPoint(i,j+1)@;
  glEnd();

@ @<Draw a textured mesh polygon@>=
  glBegin(GL_QUADS);
    MeshSmoothTexPoint(i,j)@;
    MeshSmoothTexPoint(i+1,j)@;
    MeshSmoothTexPoint(i+1,j+1)@;
    MeshSmoothTexPoint(i,j+1)@;
  glEnd();


@ @<Draw a single mesh with OpenGL@>=
{ register int i,j;
  int n=lst->dimU-1,m=lst->dimV-1;
  
  glColor3d(1.,1.,1.);
  for(i=0; i<n; i++) {
    for(j=0; j<m; j++){
      @<Draw a mesh polygon@>@;
     }
   }
}

@ @<Draw a single colored mesh with OpenGL@>=
{ register int i,j;
  int n=lst->dimU-1,m=lst->dimV-1;

  for(i=0; i<n; i++) {
    for(j=0; j<m; j++){
      glColorMaterial(GL_FRONT_AND_BACK,GL_DIFFUSE);
      glColor3dv((double *)MeshColorPtr(lst,i,j));
      @<Draw a mesh polygon@>@;
     }
   }
}

@ @<Draw a textured mesh with OpenGL@>=
{ register int i,j;
  register double scaleS,scaleT;
  int n=lst->dimU-1,m=lst->dimV-1;
  Point3D *tp;

  scaleS=lst->mTexture->scaleS;
  scaleT=lst->mTexture->scaleT;
  glEnable(GL_TEXTURE_2D);
  if((GL_RGBA==MeshTextureType(lst)) || (GL_LUMINANCE_ALPHA==MeshTextureType(lst)))
    glEnable(GL_BLEND);
  glBindTexture(GL_TEXTURE_2D,MeshTextureID(lst));
  for(i=0; i<n; i++) {
    for(j=0; j<m; j++){
      @<Draw a textured mesh polygon@>@;
     }
   }
  if((GL_RGBA==MeshTextureType(lst))|| (GL_LUMINANCE_ALPHA==MeshTextureType(lst)))
    glDisable(GL_BLEND);
  glDisable(GL_TEXTURE_2D);
}


@ @<Pass the texture data to OpenGL@>=
void GLSetTextures(TextureList *lst)
{ GLuint tname;

  if(!lst) return;
  glPixelStorei(GL_UNPACK_ALIGNMENT,1);
  while(lst) {
    if(!glIsTexture(TextureGLName(lst))) {
      glGenTextures(1,&tname);
      TextureGLName(lst)=tname; /* store OpenGLs texture number */
      glBindTexture(GL_TEXTURE_2D,tname);
      glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
      glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
      glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
      glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
      glTexImage2D(GL_TEXTURE_2D,
        0, /* level */
        TextureType(lst),
        TextureWidth(lst),TextureHeight(lst),
        0, /* border */
        TextureType(lst),
        GL_UNSIGNED_BYTE,
        TextureData(lst));
      }
    lst=lst->next;
   }
}

@* Write smooth, shaded PostScript.

@<Write PostScript@>=
@<Output the PostScript header@>@;
@<Write the feed back buffer as PostScript@>@;
@<Sort the feedback buffer@>@;
@<Top level function to write PostScript@>@;

@ The output as smooth encapsulate PostScript base on M. Kilgards
  \.{rendereps} program. It uses the feed back mechanism of OpenGL to
  generate resolution independ PostScript.

@<Top level function to write PostScript@>=
void WritePostScript(char *psfilename)
 { GLfloat *buffer;
   GLenum errCode;
   long int buffsize;
   long int truebsize;
   long int buffac=64;
   GLint retval;
   FILE *psfile;
   void MVDisplay(void);

   buffsize=buffac*MAX(PoolSize,4096);
   buffer=(GLfloat *) calloc(buffsize,sizeof(GLfloat));
   do {
     if(!buffer) return;
     glFeedbackBuffer(buffsize,GL_3D_COLOR,buffer);
     (void) glRenderMode(GL_FEEDBACK);
     DoPSOutput=GL_TRUE;
     MVDisplay(); /* Redraw the scene */
     DoPSOutput=GL_FALSE;
     retval=glRenderMode(GL_RENDER);
     if(GL_NO_ERROR!=(errCode=glGetError())) {
       const GLubyte *errStr;
       free(buffer);
       errStr=gluErrorString(errCode);
       fprintf(stderr,"OpenGL Error :: %s\n",errStr);
       return;
      }
     if(retval>0)
       truebsize=retval;
     else {
       free(buffer);
       buffac*=2;
       buffsize=buffac*MAX(PoolSize,4096);
       buffer=(GLfloat *) calloc(buffsize,sizeof(GLfloat));
      }
    } 
   while(retval<0);
   if(psfilename) {
#if MACINTOSH_MATHLINK
  psfile=MacCreateFile(psfilename,'TEXT','gsVR');
#else  
  psfile=fopen(psfilename,"w");
#endif
    if(psfile) {
       WritePSHeader(psfile);
       if(!WireFrame)
         SortedPSWrite(psfile,truebsize,buffer);
       else
         @<Unsorted feedback@>@;
       fprintf(psfile,"\nshowpage\n");
       fclose(psfile);
      } 
    }
   free(buffer);
 }

@ @<Unsorted feedback@>=
{ GLfloat *loc,*end;
  loc=buffer;
  end=buffer+truebsize;
  while(loc<end) {
    loc=WritePSPrimitives(psfile,loc);
   } 
}

@*1 Sort the feedback buffer.
@<Sort the feedback buffer@>=
@<Compare the depth of two entries in the feedback buffer@>@;
@<Sort the primitives and write them out@>

  
@ The depth index structure for sorting of the PostScript polygons.
@<Data structures@>+=
typedef struct DepthIndex {
   GLfloat *ptr;
   GLfloat depth;
  } DepthIndex;

@ The compare function for |qsort|.
@<Compare the depth of two entries in the feedback buffer@>=
static int compfeedbackbuff(const void *a, const void *b)
{ DepthIndex *p1 = (DepthIndex *) a;
  DepthIndex *p2 = (DepthIndex *) b;
  GLfloat diff = p2->depth - p1->depth;

  if (diff > 0.0)
    return 1;
  else if (diff < 0.0)
    return -1;
  else
    return 0;

}

@ @<Sort the primitives and write them out@>=
void
SortedPSWrite(FILE * file, GLint size, GLfloat * buffer)
{
  int token;
  GLfloat *loc, *end;
  Feedback3DColor *vertex;
  GLfloat depthSum;
  int nprimitives, item;
  DepthIndex *prims;
  int nvertices, i;

  end = buffer + size;
  @<Count primitives@>
  @<Create the |qsort| input@>@;
  assert(item == nprimitives);
  @<Sort primitives back to front@>@;
  /* Emit the Encapsulated PostScript for the primitives in
     back to front order. */
  for (item = 0; item < nprimitives; item++) {
    (void) WritePSPrimitives(file, prims[item].ptr);
  }

  free(prims);
}


@ @<Count primitives@>=
  nprimitives = 0;
  loc = buffer;
  while (loc < end) {
    token = *loc;
    loc++;
    switch (token) {
    case GL_LINE_TOKEN:
    case GL_LINE_RESET_TOKEN:
      loc += 14;
      nprimitives++;
      break;
    case GL_POLYGON_TOKEN:
      nvertices = *loc;
      loc++;
      loc += (7 * nvertices);
      nprimitives++;
      break;
    case GL_POINT_TOKEN:
      loc += 7;
      nprimitives++;
      break;
    default:
      /* XXX Left as an excersie to the reader. */
      printf("Incomplete implementation.  Unexpected token (%d).\n",
        token);
    }
  }

@ To use the |qsort| function we need a single array of
  pointers to the primitives and the averaged depth of the
  primitive. Allocate an array of pointers that will point back at
  primitives in the feedback buffer.  There will be one
  entry per primitive.  This array is also where we keep the
  primitive's average depth.  There is one entry per
  primitive  in the feedback buffer.
  
@<Create the |qsort| input@>=
  prims = (DepthIndex *) malloc(sizeof(DepthIndex) * nprimitives);

  item = 0;
  loc = buffer;
  while (loc < end) {
    prims[item].ptr = loc;  /* Save this primitive's location. */
    token = *loc;
    loc++;
    switch (token) {
    case GL_LINE_TOKEN:
    case GL_LINE_RESET_TOKEN:
      vertex = (Feedback3DColor *) loc;
      depthSum = vertex[0].z + vertex[1].z;
      prims[item].depth = depthSum / 2.0;
      loc += 14;
      break;
    case GL_POLYGON_TOKEN:
      nvertices = *loc;
      loc++;
      vertex = (Feedback3DColor *) loc;
      depthSum = vertex[0].z;
      for (i = 1; i < nvertices; i++) {
        depthSum += vertex[i].z;
      }
      prims[item].depth = depthSum / nvertices;
      loc += (7 * nvertices);
      break;
    case GL_POINT_TOKEN:
      vertex = (Feedback3DColor *) loc;
      prims[item].depth = vertex[0].z;
      loc += 7;
      break;
    default:
      assert(1);
    }
    item++;
  }

@ Understand that sorting by a primitives average depth
  doesn't allow us to disambiguate some cases like self
  intersecting polygons.  Handling these cases would require
  breaking up the primitives.  That's too involved for this
  example.  Sorting by depth is good enough for lots of
  applications.

@<Sort primitives back to front@>=
qsort(prims, nprimitives, sizeof(DepthIndex), compfeedbackbuff);

@ Write the PostScript header with macros and bounding box.
@d EPS_GOURAUD_THRESHOLD 0.1

@<Output the PostScript header@>=
void WritePSHeader(FILE *file)
 {
  GLfloat clearColor[4], viewport[4];
  GLfloat lineWidth;
  int i;

  /* Read back a bunch of OpenGL state to help make the EPS
     consistent with the OpenGL clear color, line width, point
     size, and viewport. */
  glGetFloatv(GL_VIEWPORT, viewport);
  glGetFloatv(GL_COLOR_CLEAR_VALUE, clearColor);
  glGetFloatv(GL_LINE_WIDTH, &lineWidth);
  glGetFloatv(GL_POINT_SIZE, &pointSize);

  /* Emit EPS header. */
  fputs("%!PS-Adobe-2.0 EPSF-2.0\n", file);
  /* Notice \%\% for a single \% in the |fprintf| calls. */
  fprintf(file, "%%%%Creator: %s %s %s (using OpenGL feedback)\n",@|
	  BANNER,VERSION,ARCH);
  fprintf(file, "%%%%BoundingBox: %g %g %g %g\n",@|
    viewport[0], viewport[1], viewport[2], viewport[3]);
  fputs("%%EndComments\n", file);
  fputs("\n", file);
  fputs("gsave\n", file);
  fputs("\n", file);

  /* Output Frederic Delhoume's "gouraudtriangle" PostScript
     fragment. */
  fputs("% the gouraudtriangle PostScript fragement below is free\n", file);
  fputs("% written by Frederic Delhoume (delhoume@@ilog.fr)\n", file);
  fprintf(file, "/threshold %g def\n", EPS_GOURAUD_THRESHOLD);
  for (i = 0; gouraudtriangleEPS[i]; i++) {
    fprintf(file, "%s\n", gouraudtriangleEPS[i]);
  }

  fprintf(file, "\n%g setlinewidth\n", lineWidth);

  /* Clear the background like OpenGL had it. */
  fprintf(file, "%g %g %g setrgbcolor\n",
    clearColor[0], clearColor[1], clearColor[2]);
  fprintf(file, "%g %g %g %g rectfill\n\n",
    viewport[0], viewport[1], viewport[2], viewport[3]);

 }
@ OpenGL feedback vertex format
@<Data structures@>+=    
typedef struct Feedback3DColor {
   GLfloat x;
   GLfloat y;
   GLfloat z;
   GLfloat red;
   GLfloat green;
   GLfloat blue;
   GLfloat alpha;
  } Feedback3DColor;


@ @<Global values@>=
GLfloat pointSize;
GLint DoPSOutput=GL_FALSE;
   
static char *gouraudtriangleEPS[] =
{
  "/bd{bind def}bind def /triangle { aload pop   setrgbcolor  aload pop 5 3",
  "roll 4 2 roll 3 2 roll exch moveto lineto lineto closepath fill } bd",
  "/computediff1 { 2 copy sub abs threshold ge {pop pop pop true} { exch 2",
  "index sub abs threshold ge { pop pop true} { sub abs threshold ge } ifelse",
  "} ifelse } bd /computediff3 { 3 copy 0 get 3 1 roll 0 get 3 1 roll 0 get",
  "computediff1 {true} { 3 copy 1 get 3 1 roll 1 get 3 1 roll 1 get",
  "computediff1 {true} { 3 copy 2 get 3 1 roll  2 get 3 1 roll 2 get",
  "computediff1 } ifelse } ifelse } bd /middlecolor { aload pop 4 -1 roll",
  "aload pop 4 -1 roll add 2 div 5 1 roll 3 -1 roll add 2 div 3 1 roll add 2",
  "div 3 1 roll exch 3 array astore } bd /gouraudtriangle { computediff3 { 4",
  "-1 roll aload 7 1 roll 6 -1 roll pop 3 -1 roll pop add 2 div 3 1 roll add",
  "2 div exch 3 -1 roll aload 7 1 roll exch pop 4 -1 roll pop add 2 div 3 1",
  "roll add 2 div exch 3 -1 roll aload 7 1 roll pop 3 -1 roll pop add 2 div 3",
  "1 roll add 2 div exch 7 3 roll 10 -3 roll dup 3 index middlecolor 4 1 roll",
  "2 copy middlecolor 4 1 roll 3 copy pop middlecolor 4 1 roll 13 -1 roll",
  "aload pop 17 index 6 index 15 index 19 index 6 index 17 index 6 array",
  "astore 10 index 10 index 14 index gouraudtriangle 17 index 5 index 17",
  "index 19 index 5 index 19 index 6 array astore 10 index 9 index 13 index",
  "gouraudtriangle 13 index 16 index 5 index 15 index 18 index 5 index 6",
  "array astore 12 index 12 index 9 index gouraudtriangle 17 index 16 index",
  "15 index 19 index 18 index 17 index 6 array astore 10 index 12 index 14",
  "index gouraudtriangle 18 {pop} repeat } { aload pop 5 3 roll aload pop 7 3",
  "roll aload pop 9 3 roll 4 index 6 index 4 index add add 3 div 10 1 roll 7",
  "index 5 index 3 index add add 3 div 10 1 roll 6 index 4 index 2 index add",
  "add 3 div 10 1 roll 9 {pop} repeat 3 array astore triangle } ifelse } bd",
  NULL
};

@ Write the primitives fromt the feed back buffer |loc| to file
  |psfile|.
@d EPS_SMOOTH_LINE_FACTOR 0.06  /* Lower for better smooth lines. */

@<Write the feed back buffer as PostScript@>=
GLfloat *WritePSPrimitives(FILE * file, GLfloat * loc)
{
  int token;
  int nvertices, i;
  GLfloat red, green, blue;
  int smooth;
  GLfloat dx, dy, dr, dg, db, absR, absG, absB, colormax;
  int steps;
  Feedback3DColor *vertex;
  GLfloat xstep, ystep, rstep, gstep, bstep;
  GLfloat xnext, ynext, rnext, gnext, bnext, distance;

  token = *loc;
  loc++;
  switch (token) {
    case GL_LINE_RESET_TOKEN:
    case GL_LINE_TOKEN:
      @<Write line token as PostScript@>@;
      break;
    case GL_POLYGON_TOKEN:
      @<Write polygon token as PostScript@>@;
      break;
    case GL_POINT_TOKEN:
      @<Write point token as PostScript@>@;
      break;
    default:
      /* XXX Left as an excersie to the reader. */
      fprintf(stderr,
	 "Incomplete implementation.  Unexpected token (%d).\n", token);
      break;
  }
  return loc;
}

@ @<Write line token as PostScript@>=
    vertex = (Feedback3DColor *) loc;

    dr = vertex[1].red - vertex[0].red;
    dg = vertex[1].green - vertex[0].green;
    db = vertex[1].blue - vertex[0].blue;

    if (dr != 0 || dg != 0 || db != 0) {
      /* Smooth shaded line. */
      dx = vertex[1].x - vertex[0].x;
      dy = vertex[1].y - vertex[0].y;
      distance = sqrt(dx * dx + dy * dy);

      absR = fabs(dr);
      absG = fabs(dg);
      absB = fabs(db);

      colormax = MAX(absR, MAX(absG, absB));
      steps = MAX(1.0, colormax * distance * EPS_SMOOTH_LINE_FACTOR);

      xstep = dx / steps;
      ystep = dy / steps;

      rstep = dr / steps;
      gstep = dg / steps;
      bstep = db / steps;

      xnext = vertex[0].x;
      ynext = vertex[0].y;
      rnext = vertex[0].red;
      gnext = vertex[0].green;
      bnext = vertex[0].blue;

      /* Back up half a step; we want the end points to be
         exactly the their endpoint colors. */
      xnext -= xstep / 2.0;
      ynext -= ystep / 2.0;
      rnext -= rstep / 2.0;
      gnext -= gstep / 2.0;
      bnext -= bstep / 2.0;
    } else {
      /* Single color line. */
      steps = 0;
    }

    fprintf(file, "%g %g %g setrgbcolor\n",
      vertex[0].red, vertex[0].green, vertex[0].blue);
    fprintf(file, "%g %g moveto\n", vertex[0].x, vertex[0].y);

    for (i = 0; i < steps; i++) {
      xnext += xstep;
      ynext += ystep;
      rnext += rstep;
      gnext += gstep;
      bnext += bstep;
      fprintf(file, "%g %g lineto stroke\n", xnext, ynext);
      fprintf(file, "%g %g %g setrgbcolor\n", rnext, gnext, bnext);
      fprintf(file, "%g %g moveto\n", xnext, ynext);
    }
    fprintf(file, "%g %g lineto stroke\n", vertex[1].x, vertex[1].y);

    loc += 14;          /* Each vertex element in the feedback
                           buffer is 7 GLfloats. */

@ @<Write polygon token as PostScript@>=
    nvertices = *loc;
    loc++;

    vertex = (Feedback3DColor *) loc;

    if (nvertices > 0) {
      red = vertex[0].red;
      green = vertex[0].green;
      blue = vertex[0].blue;
      smooth = GL_FALSE;
      for (i = 1; i < nvertices; i++) {
        if (red != vertex[i].red || green != vertex[i].green || blue != vertex[i].blue) {
          smooth = GL_TRUE;
          break;
        }
      }
      if (smooth) {
        /* Smooth shaded polygon; varying colors at vertices. */
        /* Break polygon into "nvertices-2" triangle fans. */
        for (i = 0; i < nvertices - 2; i++) {
          fprintf(file, "[%g %g %g %g %g %g]",
            vertex[0].x, vertex[i + 1].x, vertex[i + 2].x,
            vertex[0].y, vertex[i + 1].y, vertex[i + 2].y);
          fprintf(file, " [%g %g %g] [%g %g %g] [%g %g %g] gouraudtriangle\n",
            vertex[0].red, vertex[0].green, vertex[0].blue,
            vertex[i + 1].red, vertex[i + 1].green, vertex[i + 1].blue,
            vertex[i + 2].red, vertex[i + 2].green, vertex[i + 2].blue);
        }
      } else {
        /* Flat shaded polygon; all vertex colors the same. */
        fprintf(file, "newpath\n");
        fprintf(file, "%g %g %g setrgbcolor\n", red, green, blue);

        /* Draw a filled triangle. */
        fprintf(file, "%g %g moveto\n", vertex[0].x, vertex[0].y);
        for (i = 1; i < nvertices; i++) {
          fprintf(file, "%g %g lineto\n", vertex[i].x, vertex[i].y);
        }
        fprintf(file, "closepath fill\n\n");
      }
    }
    loc += nvertices * 7;  /* Each vertex element in the
                              feedback buffer is 7 GLfloats. */


@ @<Write point token as PostScript@>=
    vertex = (Feedback3DColor *) loc;
    fprintf(file, "%g %g %g setrgbcolor\n", vertex[0].red, vertex[0].green, vertex[0].blue);
    fprintf(file, "%g %g %g 0 360 arc fill\n\n", vertex[0].x, vertex[0].y, pointSize / 2.0);
    loc += 7;           /* Each vertex element in the feedback
                           buffer is 7 GLfloats. */


@* POVray output.
@<Write POVray file@>=
  @<Write coordinates for POVray@>@;
  @<Check if the color |c| is stored in |colors|@>@;
  @<Make table of polygon colors in the scene@>@;
  @<Check for white surface color@>@;
  @<Write color of polygons@>@;
  @<Write the color declarations to the POVray file@>@;
  @<Check if normals exist for a polygon@>@;
  @<Write a single flat triangle for POVray@>@;
  @<Write a single triangle for POVray@>@;
  @<Write the rotation of the trackball@>@;
  @<Make a cone for POVray along $p_1$ and $p_2$@>@;
  @<Make a continued cone for POVray along $p_1$ and $p_2$ to $p_3$@>@;
  @<Write the points into the POVray file@>@;
  @<Write POV lines@>@;
  @<Write triangle list@>@;
  @<Write textured triangle list@>@;
  @<Write the list of meshes to POVray@>@;
  @<Scale to original coordinates@>@;
  @<Write light source@>@;
  @<Write POVray header@>@;
  @<Save the data as POVray file@>@;

@ @<Scale to original coordinates@>=
void ScaleToWorld(Point3D *pw, Point3D *p)
{
  pw->x=CenterOfScene.x+MaxScaleOfScene* p->x;
  pw->y=CenterOfScene.y+MaxScaleOfScene* p->y;
  pw->z=CenterOfScene.z+MaxScaleOfScene* p->z;
}

@ @<Write coordinates for POVray@>=
void WritePOVVector(FILE *f,char *pre, Point3D *p,char *post)
{
  fprintf(f,"%s<"DBL_FMT", "DBL_FMT", "DBL_FMT">%s",pre,p->x,p->y,p->z,post);
}

@ @<Write light source@>=
void WriteLights(FILE *f,Point3D *lightp, RGBColor *lcolor, int n,int shaddow)
{ Point3D ls;
  int i;

  for (i=0; i<n; i++){
    ScaleToWorld(&ls,lightp+i);
    WritePOVVector(f,"light_source {\n\t",&ls,"\n");
    WritePOVVector(f,"\tcolor rgb ",(Point3D *)(lcolor+i),"\n");
    if(!shaddow) fprintf(f,"\tshadowless\n");
    fprintf(f,"}\n\n");
   }
}

@ @<Write the rotation of the trackball@>=
void POVTrackballPosition(FILE *f)
{ char mstr[256];
  Point3D p1;

  p1.x=-CenterOfScene.x;
  p1.y=-CenterOfScene.y;
  p1.z=-CenterOfScene.z;
  WritePOVVector(f,"\ttranslate ",&p1,"\n");
  sprintf(mstr,"\trotate "DBL_FMT"*",ToDegree*TrackAngle);
  WritePOVVector(f,mstr,&TrackAxis,"\n");
  WritePOVVector(f,"\ttranslate ",&CenterOfScene,"\n");
}

@ @<Write the points into the POVray file@>=
void WritePOVPoints(FILE *f, PointList *lst)
{
  fprintf(f,"/* Begin Points */\n\n union {\n");
  while(lst) {
    fprintf(f,"\tsphere {\n");
    WritePOVVector(f,"\t",PointPool + lst->point," ");
    fprintf(f,DBL_FMT" \n\t}\n",PointSphereSize*lst->size);
    lst=lst->next;
   }
  if(TrackAngle!=0.0)
    POVTrackballPosition(f);
  fprintf(f,"}\n/* End of Points */\n");

}

@ @<Check if normals exist for a polygon@>=
int CheckNormals(int *points, int no)
{ int res,i;

  res=NULL != NormalPool[points[0]];
  for(i=1; i<no && res; i++)
    res = res && (NULL != NormalPool[points[i]]);
  return res;
}

@ For an efficient color processing we scan the polygons
  for different colors.
@<Make table of polygon colors in the scene@>=
RGBColor **PolyColorTable(int *cno, LinePolyList *lst)
{ RGBColor  **cptr;
  int i,polyno,cindex;
  
  polyno=LengthLinePolyList(lst);
  cptr=(RGBColor **)calloc(polyno,sizeof(RGBColor *));
  for(i=0; i<polyno; i++)
    cptr[i]=NULL;
  *cno=1;
  cptr[0]=&(lst->color);
  lst->aux1=0;
  lst=lst->next;
  while(lst) {
    cindex=InColorArray(&(lst->color),cptr,*cno);
    if(cindex<0) {
      cptr[cindex=(*cno)]=&(lst->color);
      (*cno)++;
     }
    lst->aux1=cindex;
    lst=lst->next;
   }
  return cptr;
}

@ @<Check if the color |c| is stored in |colors|@>=
int InColorArray(RGBColor *c, RGBColor **colors, int cno)
{  int i;

  for(i=0; i<cno; i++) {
    if(fabs(c->r-colors[i]->r) <TINY &&
       fabs(c->g-colors[i]->g) <TINY &&
       fabs(c->b-colors[i]->b) <TINY) return i;
   }
  return -1;
}

@ @<Write the color declarations to the POVray file@>=
void WritePOVColorTab(FILE *f, RGBColor **colors, int cno)
{ int i;

  fprintf(f,"\n/* Color table */\n");
  for(i=0; i<cno; i++)
    fprintf(f,"#declare  MVColor%d = rgb <"DBL_FMT", "DBL_FMT", "DBL_FMT">;\n",
	    i,colors[i]->r,colors[i]->g,colors[i]->b);
  fprintf(f,"/* End color table */\n\n");
}

@ @<Check for white surface color@>=
int WhiteSurface(RGBColor *c)
{
  return (fabs(1.0- c->r) <TINY) && (fabs(1.0- c->g) <TINY) && (fabs(1.0- c->b) <TINY);
}

@ @<Write triangle list@>=
void WritePOVTriangles(FILE *f, LinePolyList *polys, int smooth, int colorNo)
{ int i,j, thisI;
  Point3D *p;
  int isSmooth;
  LinePolyList *lst;

  fprintf(f,"/* Begin polygones */\n\n");
  for(j=0; j<colorNo; j++) { /* for every color we scan the polygon list */
    lst=polys;
    fprintf(f,"object {\n");
    fprintf(f,"mesh {\n");
    while(lst) {
      if(j!=lst->aux1) {  /* skip this polygon */
	    lst=lst->next;
       continue;
       }
      @<Write the triangle@>@;
      lst=lst->next;
     }
    fprintf(f,"}\n"); /* close the mesh{} */
    fprintf(f,"texture {\n"@|
	         "\t  pigment { MVColor%d }\n"@|
	         "\t  finish { DefaultFinish }"@|
	         "\t}\n",j);
    if(TrackAngle!=0.0)
      POVTrackballPosition(f);
    fprintf(f,"}\n"); /* close the object */
   }
  fprintf(f,"\n/* End polygones  */\n");
}

@ @<Write textured triangle list@>=
void WriteTexPOVTriangles(FILE *f, LinePolyList *polys, int smooth,
     const char *pTexPrefix)
{ int i, thisI;
  Point3D *p,*t,*axis,*scale;
  double angle,scS,scT;
  int isSmooth;
  LinePolyList *lst;
  int tmapType;

  static int texFileCount=1;

  if(!*TextureFile(SceneTextureMap->tex))
    @<Save the texture data of the scene to a PNG file@>@;
  tmapType=SceneTextureMap->type;
  t=SceneTextureMap->translate;
  axis=SceneTextureMap->axis;
  angle=SceneTextureMap->angle;
  scale=SceneTextureMap->scale;
  scS=SceneTextureMap->scaleS;
  scT=SceneTextureMap->scaleT;
  fprintf(f,"/* Begin polygones */\n\n");
  lst=polys;
  fprintf(f,"object {\n");
  fprintf(f,"mesh {\n");
  while(lst) {
    @<Write the triangle@>@;
    lst=lst->next;
   }
  fprintf(f,"}\n"); /* close the mesh{} */
  @<Bring the polygones to the mapping area@>@;
  fprintf(f,"texture {\n"@|
    "\t  pigment {\n"@|
    "\t    image_map {\n"@|
    "\t       png \"%s\"\n",TextureFile(SceneTextureMap->tex));
  @<Translate the texture mapping to POVRay@>@;
  fprintf(f,"\t      }\n");
  @<Transform the texture mapping for POVRay@>@;
  fprintf(f,
    "\t   }\n"@|
    "\t  finish { DefaultFinish }"@|
    "\t}\n");
  @<Revert the polygone transformation from the mapping area@>@;
  if(TrackAngle!=0.0)
    POVTrackballPosition(f);
  fprintf(f,"}\n"); /* close the object */
  fprintf(f,"\n/* End polygones  */\n");
}

@ @<Bring the polygones to the mapping area@>=
if(t)
  fprintf(f,"\t translate <"DBL_FMT", "DBL_FMT", "DBL_FMT">\n",t->x,t->y,t->z);
if(axis && angle!=0.0)
  fprintf(f,"\t rotate "DBL_FMT"*<"DBL_FMT", "DBL_FMT", "DBL_FMT">\n",
    ToDegree*angle,
    axis->x,axis->y,axis->z);
if(scale)
  fprintf(f,"\t scale <"DBL_FMT","DBL_FMT","DBL_FMT">\n",scale->x,scale->y,scale->z);

@ @<Revert the polygone transformation from the mapping area@>=
if(scale)
  fprintf(f,"\t scale <"DBL_FMT","DBL_FMT","DBL_FMT">\n",1.0/scale->x,1.0/scale->y,1.0/scale->z);
if(axis && angle!=0.0)
  fprintf(f,"\t rotate "DBL_FMT"*<"DBL_FMT", "DBL_FMT", "DBL_FMT">\n",
    -ToDegree*angle,
    axis->x,axis->y,axis->z);
if(t)
  fprintf(f,"\t translate <"DBL_FMT", "DBL_FMT", "DBL_FMT">\n",-t->x,-t->y,-t->z);


@ @<Translate the texture mapping to POVRay@>=
switch(tmapType) {
  case TEXTURE_MAP_PLANAR:
    fprintf(f,"\t       map_type 0\n");
    break;
  case TEXTURE_MAP_CYLINDRICAL:
    fprintf(f,"\t       map_type 2\n");
    break;
  case TEXTURE_MAP_SPHERICAL:
    fprintf(f,"\t       map_type 1\n");
    break;
  case TEXTURE_MAP_TORUS:
    fprintf(f,"\t       map_type 5\n");
    break;
  default:
     fprintf(f,"#warning \"MathGL3d::Unsupported mapping.\\n\"\n");
     fprintf(f,"\t       map_type 0\n");
   break;
 }
fprintf(f,"\t       interpolate 2\n");

@ @<Add the planar scaling of the texture@>=
fprintf(f,"\t     scale <"DBL_FMT", "DBL_FMT", 1>\n",
  scS>0.0 ? 1.0/scS: 1.0,
  scT>0.0 ? 1.0/scT:1.0);

@  @<Transform the texture mapping for POVRay@>=
switch(tmapType) {
  case TEXTURE_MAP_PLANAR:
    @<Add the planar scaling of the texture@>@;
    break;
  case TEXTURE_MAP_CYLINDRICAL:
  case TEXTURE_MAP_SPHERICAL:
  case TEXTURE_MAP_TORUS:
    if(scS!=1.0 || scT!=1.0)
      fprintf(f,
        "#warning \"MathGL3d::Texture scaling for spherical, "
        "cylindrical and torus mapping not possible.\\n\"\n");
    fprintf(f,"\t    scale < -1, 1, 1>\n"); /* reverse the rows of the bitmap */
    fprintf(f,"\t    rotate 90*x\n");
    fprintf(f,"\t    rotate 180*z\n");
    break;
}

@ @<Write the triangle@>=
  isSmooth=smooth && CheckNormals(lst->points, lst->pno);
  if(lst->pno>=3) { /* allow only polygons with more than two points */
    fprintf(f,"%s {\n",isSmooth ? "smooth_triangle" : "triangle");
    for(i=0; i<lst->pno; i++) {
      p=PointPool+ (thisI=lst->points[i]);
      WritePOVVector(f,"\t",p,"");
      if(NormalPool[thisI] && isSmooth)
        WritePOVVector(f,", ", NormalPool[thisI],"");
        fprintf(f,"%s",i==lst->pno-1 ? "\n" : ",\n");
       }
     fprintf(f,"}\n");
   }

@ The last two arguments of |WritePOVSmoothTriangle| and |WritePOVFlatTriangle|
are pointers to counts for a mesh number and a color number. The arguments
are introduced to use the functions for writing the |Mesh3DList| objects and
the triangles of the tubes arround lines. If |mcount| or |c| are |NULL| no
texture reference is written.

@<Write a single triangle for POVray@>=
void WritePOVSmoothTriangle(FILE *f,
       Point3D *p1, Point3D *p2, Point3D *p3,
       Point3D *n1, Point3D *n2, Point3D *n3,int *mcount,int *c)
{
  if(n1 && n2 && n3) {
    fprintf(f,"\tsmooth_triangle {\n");
    WritePOVVector(f,"\t",p1,", "); @+ WritePOVVector(f,"",n1,",\n");
    WritePOVVector(f,"\t",p2,", "); @+ WritePOVVector(f,"",n2,",\n");
    WritePOVVector(f,"\t",p3,", "); @+ WritePOVVector(f,"",n3,"\n");
    @<Write the optional color@>@;
    fprintf(f,"\t}\n");
   }
  else
    WritePOVFlatTriangle(f,p1,p2,p3,mcount,c);
}

@ @<Write a single flat triangle for POVray@>=
void WritePOVFlatTriangle(FILE *f,
       Point3D *p1, Point3D *p2, Point3D *p3,int *mcount, int *c)
{
  fprintf(f,"\ttriangle {\n");
  WritePOVVector(f,"\t",p1,",\n");
  WritePOVVector(f,"\t",p2,",\n");
  WritePOVVector(f,"\t",p3,"\n");
  @<Write the optional color@>@;
  fprintf(f,"\t}\n");
}

@ @<Write the optional color@>=
if(mcount && c)
  fprintf(f,"\ttexture { Mesh%dColor%d}\n",*mcount,*c);

@ @<Write the list of meshes to POVray@>=
void WritePOVMeshes(FILE *f, Mesh3DList *lst, int smooth,
     const char *mTexPrefix)
{ int ord=1;
  Mesh3DList *head=lst;

  fprintf(f,"/* Begin Meshes */\n\n");
  while(lst) {
    @<Write |Mesh3DList| entry for POVRay@>@;
    ord++;
    lst=lst->next;
   }
  ord=1;
  lst=head;
  while(lst) {
    if((!MeshTextureQ(lst) || lst->mTexture->type>=TEXTURE_MAP_MESH_ST) )
      @<Write default mesh texture@>@;
    else
      @<Write the texture map of a mesh@>@;
    ord++;
    lst=lst->next;
   }
  fprintf(f,"/* End Meshes */\n");
}

@ @<Write default mesh texture@>=
{
  fprintf(f,"\n"@|
    "object {\n"@|
    "\tGeneralMesh%d\n"@|
    "\ttexture{\n"@|
    "\t\tpigment {rgb <"DBL_FMT","DBL_FMT","DBL_FMT"> }\n"@|
    "\t\tfinish { DefaultFinish }\n"@|
    "\t}\n}\n",ord,lst->mColor.r,lst->mColor.g,lst->mColor.b);
}

@ @<Write the texture map of a mesh@>=
{
  Point3D *t,*axis,*scale;
  double angle,scS,scT;
  int tmapType;
  Mesh3DList *mlst=lst;
  static int texFileCount=1;

  if(!*MeshTextureFile(mlst))
    @<Save the mesh texture to a PNG file@>@;
  tmapType=lst->mTexture->type;
  t=lst->mTexture->translate;
  axis=lst->mTexture->axis;
  angle=lst->mTexture->angle;
  scale=lst->mTexture->scale;
  scS=lst->mTexture->scaleS;
  scT=lst->mTexture->scaleT;

  fprintf(f,"\nobject {\n\tGeneralMesh%d\n",ord);
  @<Bring the polygones to the mapping area@>@;
  fprintf(f,"\ttexture{\n\t\tpigment {\n");
  fprintf(f,"\t    image_map {\n"@|
    "\t       png \"%s\"\n",TextureFile(lst->mTexture->tex));
  @<Translate the texture mapping to POVRay@>@;
  fprintf(f,"\t      }\n");
  @<Transform the texture mapping for POVRay@>@;
  fprintf(f,"}\n\t\tfinish { DefaultFinish }\n\t}\n");
  @<Revert the polygone transformation from the mapping area@>@;
  fprintf(f,"}\n");
}

@ Since POVRay support only declared texture directives in the triangles of
  a mesh we declare the colors first if the |Mesh3DList| has colors.
  The |WritePOVSmoothTriangle| and |WritePOVFlatTriangle| will than
  refer to the symbolic names of the textures.

@d POVMeshCount (haveColors ? &ord : NULL)
@d POVMeshColor  (haveColors ? &k   : NULL)
@<Write |Mesh3DList| entry for POVRay@>=
{
  int n,m,i,j,k,haveColors=GL_FALSE;
  RGBColor *c;

  if(MeshTextureQ(lst) && lst->mTexture->type>=TEXTURE_MAP_MESH_ST)
    fprintf(f,"#warning \"MathGL3d::Mesh texture map not supported.\\n\"\n");
  n=lst->dimU-1;
  m=lst->dimV-1;
  if(lst->mpolyColors && !MeshTextureQ(lst)) {
    @<Declare the colors in the mesh@>@;
    haveColors=GL_TRUE;
   }
  fprintf(f,"#declare  GeneralMesh%d= mesh {\n",ord);
  if(smooth) {
    @<Write smooth triangles from the mesh data@>@;
   }
  else {
    @<Write flat triangles from the mesh data@>@;
   }
  fprintf(f,"}\n");
 }

@ @<Declare the colors in the mesh@>=
for(k=i=0; i<n; i++)
  for(j=0; j<m; j++) {
    c=MeshColorPtr(lst,i,j);
    fprintf(f,"#declare Mesh%dColor%d=texture {\n"@|
            "\t pigment { color rgb <"DBL_FMT", "DBL_FMT", "DBL_FMT">}\n"@|
            "\t finish { DefaultFinish }\n"@|
            "\t}\n",ord,k++,c->r,c->g,c->b);
   }

@ Since POVRay 3.1 does not allow degenerated triangles only nondegenerated
triangles with are written.
@d TrueMeshTriangle1(lst,i,j) (MeshIndex(lst,i+1,j)!=MeshIndex(lst,i,j) &&
                                 MeshIndex(lst,i+1,j)!=MeshIndex(lst,i,j+1) &&
                                 MeshIndex(lst,i,j)!=MeshIndex(lst,i,j+1))

@d TrueMeshTriangle2(lst,i,j) (MeshIndex(lst,i+1,j)!=MeshIndex(lst,i,j+1) &&
                                 MeshIndex(lst,i+1,j)!=MeshIndex(lst,i+1,j+1) &&
                                 MeshIndex(lst,i,j+1)!=MeshIndex(lst,i+1,j+1))

 @<Write smooth triangles from the mesh data@>=
for(k=i=0; i<n; i++)
  for(j=0; j<m; j++) {
    if(TrueMeshTriangle1(lst,i,j))
      WritePOVSmoothTriangle(f,
        MeshCoordPtr(lst,i+1,j),
        MeshCoordPtr(lst,i,j),
        MeshCoordPtr(lst,i,j+1),
        MeshNormalPtr(lst,i+1,j),
        MeshNormalPtr(lst,i,j),
        MeshNormalPtr(lst,i,j+1),POVMeshCount,POVMeshColor);
    if(TrueMeshTriangle2(lst,i,j))
      WritePOVSmoothTriangle(f,
        MeshCoordPtr(lst,i+1,j),
        MeshCoordPtr(lst,i,j+1),
        MeshCoordPtr(lst,i+1,j+1),
        MeshNormalPtr(lst,i+1,j),
        MeshNormalPtr(lst,i,j+1),
        MeshNormalPtr(lst,i+1,j+1),POVMeshCount,POVMeshColor);
    k++;
   }

@ @<Write flat triangles from the mesh data@>=
for(k=i=0; i<n; i++)
  for(j=0; j<m; j++) {
    if(TrueMeshTriangle1(lst,i,j))
      WritePOVFlatTriangle(f,
        MeshCoordPtr(lst,i+1,j),
        MeshCoordPtr(lst,i,j),
        MeshCoordPtr(lst,i,j+1),POVMeshCount,POVMeshColor);
    if(TrueMeshTriangle2(lst,i,j))
      WritePOVFlatTriangle(f,
        MeshCoordPtr(lst,i+1,j),
        MeshCoordPtr(lst,i,j+1),
        MeshCoordPtr(lst,i+1,j+1),POVMeshCount,POVMeshColor);
    k++;
   }

@ @<Make a cone for POVray along $p_1$ and $p_2$@>=
void MakePOVCone(FILE *f,Point3D *p1, Point3D *p2, double r, int n)
{ Point3D v1,v2,v3,vn[4],p[4];
  double norm;
  double dphi;
  int i;

  v1.x=p2->x-p1->x;
  v1.y=p2->y-p1->y;
  v1.z=p2->z-p1->z;
  norm=Norm(&v1);
  v1.x/=norm; @+  v1.y/=norm; @+ v1.z/=norm;
  OrthogonalSet(&v1,&v2,&v3);

  v1.x=p2->x-p1->x;
  v1.y=p2->y-p1->y;
  v1.z=p2->z-p1->z;

  dphi=TWO_PI/n;
  ConePoint(r,0.0,&v2,&v3, p);
  vn[0]=vn[1]=*p;
  IncPoint3D(p[0],(*p1))@;
  AddPoint3D(p[1],p[0],v1)@;
  for(i=1; i<=n; i++) {
      ConePoint(r,i*dphi,&v2,&v3,p+2);
      vn[2]=p[2];
      IncPoint3D(p[2],(*p1))@;
      WritePOVSmoothTriangle(f,p,p+1,p+2,vn,vn+1,vn+2,NULL,NULL);
      AddPoint3D(p[3],p[2],v1)@;
      vn[3]=vn[2];
      WritePOVSmoothTriangle(f,p+2,p+1,p+3,vn+2,vn+1,vn+3,NULL,NULL);
      p[0]=p[2]; @+ vn[0]=vn[2];
      p[1]=p[3]; @+ vn[1]=vn[3];
    }
}

@ @<Make a continued cone for POVray along $p_1$ and $p_2$ to $p_3$@>=
void MakePOVConeContinued(FILE *f,Point3D *p1, Point3D *p2, Point3D *p3,
               double r, int n)
{ Point3D v1,v2,v3,u1,u2,u3,vn[4],p[4];
  double norm;
  double dphi;
  int i;

  v1.x=p2->x-p1->x; @+ v1.y=p2->y-p1->y; @+ v1.z=p2->z-p1->z;
  norm=Norm(&v1);
  v1.x/=norm; @+  v1.y/=norm; @+ v1.z/=norm;
  OrthogonalSet(&v1,&v2,&v3);
  u1.x=p3->x-p2->x;@+  u1.y=p3->y-p2->y; @+  u1.z=p3->z-p2->z;
  norm=Norm(&u1);
  u1.x/=norm; @+  u1.y/=norm; @+ u1.z/=norm;
  @<Skip coninuation in POVray if the angle between the vectors is to large@>@;
  u2=v2; @+  u3=v3;
  GramSchmidt(&u1,&u2,&u3);
  dphi=TWO_PI/n;
  ConePoint(r,0.0,&v2,&v3, p);
  vn[0]=*p;
  IncPoint3D(p[0],(*p1))@;
  ConePoint(r,0.0,&u2,&u3,p+1);
  vn[1]=p[1];
  IncPoint3D(p[1],(*p2))
  for(i=1; i<=n; i++) {
    ConePoint(r,i*dphi,&v2,&v3,p+2);
    vn[2]=p[2];
    IncPoint3D(p[2],(*p1))@;
    WritePOVSmoothTriangle(f,p,p+1,p+2,vn,vn+1,vn+2,NULL,NULL);
    ConePoint(r,i*dphi,&u2,&u3,p+3);
    vn[3]=p[3];
    IncPoint3D(p[3],(*p2)) @;
    WritePOVSmoothTriangle(f,p+2,p+1,p+3,vn+2,vn+1,vn+3,NULL,NULL);
    p[0]=p[2]; @+ vn[0]=vn[2];
    p[1]=p[3]; @+ vn[1]=vn[3];

   }
}

@ @<Skip coninuation in POVray if the angle between the vectors is to large@>=
  if(Dot(&u1,&v1)<CosSkipCont) {
    MakePOVCone(f,p1,p2,r,n);
    MakePOVCone(f,p2,p3,r,n);
    return;
   }

@ @<Write POV lines@>=
void WritePOVLines(FILE *f, LinePolyList *lst)
{ int i,cnt;

  fprintf(f,"/* Begin lines */\n");
  if(fabs(LineTubeSize)>MachineEpsilon) {
    cnt=1;
    while(lst) {
      fprintf(f,"/* Line %d */\n",cnt);
      fprintf(f,"mesh {\n");
      @<Draw lines for POVray as tubes@>@;
      fprintf(f,"texture {\n"@|
        "\t pigment { color rgb <"DBL_FMT", "DBL_FMT", "DBL_FMT">}\n"@|
        "\t finish { DefaultFinish }\n"@|
        "\t}\n",lst->color.r,lst->color.g,lst->color.b);
      if(TrackAngle!=0.0)
        POVTrackballPosition(f);
      fprintf(f,"}\n/* End of Line %d*/\n",cnt++);
      lst=lst->next;
     }
   }
  else
    fprintf(f,"// Line output skiped due to zero LineTubeSize\n");
  fprintf(f,"/* End lines */");
}

@ @<Draw lines for POVray as tubes@>=
{ if(2==lst->pno)
    MakePOVCone(f,PointPool+lst->points[0],
         PointPool+lst->points[1],
         LineTubeSize,TubeSegments);
  else {
    for(i=0; i<lst->pno-2; i++)
      MakePOVConeContinued(f,
        PointPool+lst->points[i],
    PointPool+lst->points[i+1],
    PointPool+lst->points[i+2],
    LineTubeSize,TubeSegments);
    i=lst->pno-2;
    if(lst->points[0]==lst->points[i+1]) { /* closed curve */
      MakePOVConeContinued(f,
        PointPool+lst->points[i],
    PointPool+lst->points[0],
    PointPool+lst->points[1],
    LineTubeSize,TubeSegments);
    }
   else
     MakePOVCone(f,PointPool+lst->points[i],
         PointPool+lst->points[i+1],
         LineTubeSize,TubeSegments);
  }
}

@ @<Write color of polygons@>=
void WritePOVColor(FILE *f,
		   RGBColor *c)
{ fprintf(f,"texture {"@|
                "pigment { color <"DBL_FMT", "DBL_FMT", "DBL_FMT">}"@|
                "finish { DefaultFinish }"@|
              "}\n",c->r,c->g,c->b);
}  

@ @d Camera 2.33
 @<Write POVray header@>=
void WritePOVProlog(FILE *f, const char *povname)
{ Point3D vp,p;
#if 0
  Point3D addLight[8]={{2,2,2},{-2,2,2},{-2,-2,2},{2,-2,2},
                       {2,2,-2},{-2,2,-2},{-2,-2,-2},{2,-2,-2}};
  RGBColor addLColor[8]={{0.25,0.25,0.25},
                         {0.25,0.25,0.25},{0.25,0.25,0.25},{0.25,0.25,0.25},
                        {0.1,0.1,0.1},{0.1,0.1,0.1},{0.1,0.1,0.1},{0.1,0.1,0.1}};
#endif
  fprintf(f,"//**********************************************\n"@|
        "//  File was created by " BANNER "\n// Version " VERSION "\n"@|
        "// (c) by Jens-Peer Kuska 1997,98,99\n"@|
        "//**********************************************\n");
  fprintf(f,"// POVray 3.x input file: %s     \n",povname);
  if(*ThreeScriptName) {
    fprintf(f,"// 3Script source       : %s     \n",ThreeScriptName);
   }
  fprintf(f,"// Bounding box:\n"@|
        "// x: "DBL_FMT"  "DBL_FMT
        "\n// y: "DBL_FMT" "DBL_FMT
        "\n// z: "DBL_FMT" "DBL_FMT" \n//\n",@|
        BoundP1.x,BoundP2.x,BoundP1.y,BoundP2.y,BoundP1.z,BoundP2.z);
  fprintf(f,"// Unique Points: %d\n",PoolSize);
  fprintf(f,"// Line         : %ld\n",LengthLinePolyList(Lines));
  fprintf(f,"// Polygons     : %ld\n",LengthLinePolyList(Polygons));
  fprintf(f,"// Meshes       : %ld\n",LengthMesh3DList(Meshes));

  fprintf(f,"// end of header *******************************\n\n");
  fprintf(f,"#declare DefaultFinish=finish { phong 0.8 ambient 0.4}\n");
  fprintf(f,"#default {"@|
                    "texture {"@|
                     "pigment { color <1, 1, 1>}"@|
                       "finish { DefaultFinish }"@|
                      "}}\n");
  if(AmbientColor.r>0.0 || AmbientColor.g>0.0 || AmbientColor.r>0.0)
    fprintf(f,"global_settings { ambient_light color rgb <"
               DBL_FMT", "DBL_FMT", "DBL_FMT">}\n\n",
        AmbientColor.r,AmbientColor.g,AmbientColor.b);
  ScaleToWorld(&vp,&ViewPoint);
  p.x=p.z=0.0; @+ p.y=Norm(&vp);
  fprintf(f,"camera {\n");
  WritePOVVector(f,"\tlocation  ",&vp,"\n");
  WritePOVVector(f,"\tdirection ",&p,"\n");
  p.x=p.y=0.0; @+ p.z=0.5*Camera*MaxScaleOfScene;
  WritePOVVector(f,"\tup        ",&p,"\n");
  p.x=0.5*Camera*MaxScaleOfScene; @+ p.y=p.z=0.0;
    /* make a right hand coordiante system */
  WritePOVVector(f,"\tright     ",&p,"\n");
  WritePOVVector(f,"\tsky       ",&ZAxis,"\n");
  WritePOVVector(f,"\tlook_at   ",&CenterOfScene,"\n }\n\n");
  WriteLights(f,LightPosition,LightColor,LightNo,GL_FALSE);
#if 0
  WriteLights(f,addLight,addLColor,8,GL_TRUE);
#endif
  fprintf(f,"/* Graphics data begin */\n");
}


@ @<Save the data as POVray file@>=
int WritePOVray(const char *povout, int smooth,
      const char *pTexPrefix,const char *mTexPrefix)
{ FILE *f;
  RGBColor **ctab;
  int cno;
#if MACINTOSH_MATHLINK
  f=MacCreateFile(povout,'TEXT','POV3');
#else  
  f=fopen(povout,"w");
#endif  
  if(!f) return 1;
  WritePOVProlog(f,povout);
  if(Polygons){
    ctab=PolyColorTable(&cno,Polygons);
    WritePOVColorTab(f,ctab,cno);
    free(ctab);
   }
  if(Points && (0.0<PointSphereSize))
    WritePOVPoints(f,Points);
  if(Lines)
    WritePOVLines(f,Lines);
  if(Polygons) {
    if(!SceneTextureMap)
      WritePOVTriangles(f,Polygons,smooth,cno);
    else
      WriteTexPOVTriangles(f,Polygons,smooth,pTexPrefix);
   }
  if(Meshes)
    WritePOVMeshes(f,Meshes,smooth,mTexPrefix);
  fclose(f);
  return 0;
}

@* QuickDraw 3D Metafiles.
@<Write Apple QuickDraw 3D ASCII files@>=
  @<Write the QuickDraw normal for |p|@>@;
  @<Write the flipped QuickDraw normal for |p|@>@;  
  @<Write the color and the normal for |p|@>@;
  @<Make a QuickDraw cone along $p_1$ and $p_2$@>@;
  @<Make a QuickDraw continued cone along $p_1$ and $p_2$ to $p_3$@>@;
  @<Write the light sources for QuickDraw@>@;
  @<Write the camera position for QuickDraw@>@;
  @<Write the QuickDraw points@>@;
  @<Write QuickDraw lines@>@;
  @<Write QuickDraw polygon@>@;
  @<Write a QuickDraw mesh@>@;
  @<Save the data as QuickDraw 3D file@>@;

@ @<Write the QuickDraw normal for |p|@>=
void QDNormal(FILE *f,Point3D *p)
{
  fprintf(f,"Container (\n"@|
    "\t AttributeSet()\n"@|
    "\t Normal ( "DBL_FMT" "DBL_FMT" "DBL_FMT" )\n)\n",p->x,p->y,p->z);
}

@ @<Write the flipped QuickDraw normal for |p|@>=
void QDNegNormal(FILE *f,Point3D *p)
{
  fprintf(f,"Container (\n"@|
    "\t AttributeSet()\n"@|
    "\t Normal ( "DBL_FMT" "DBL_FMT" "DBL_FMT" )\n)\n",-(p->x),-(p->y),-(p->z));
}

@ @<Write the color and the normal for |p|@>=
void QDNormalColor(FILE *f,Point3D *p, RGBColor *c)
{
  fprintf(f,
    "Container (\n"@|
    "\t AttributeSet()\n"@|
    "\t Normal ( "DBL_FMT" "DBL_FMT" "DBL_FMT" )\n"
    "\t DiffuseColor( "DBL_FMT" "DBL_FMT" "DBL_FMT")\n"
    ")\n",p->x,p->y,p->z,c->r,c->g,c->b);
}

@ @<Write the color for QuickDraw@>=
  fprintf(f,"Container (\n"@|
          "\tAttributeSet()\n"@|
          "\tDiffuseColor( "DBL_FMT" "DBL_FMT" "DBL_FMT")\n)\n)",
          lst->color.r,lst->color.g,lst->color.b);

@ @<Begin QuickDraw triangle strip@>=
fprintf(f,"Container (\n  TriGrid (\n    %d  2\n",n+1);

@ @<Write the initial vertex pair@>=
  fprintf(f,"  "DBL_FMT" "DBL_FMT" "DBL_FMT"  "DBL_FMT" "DBL_FMT" "DBL_FMT"\n",
    p->x,p->y,p->z,
    p[1].x,p[1].y,p[1].z);

@ @<Write the remainig vertex pairs@>=
    fprintf(f,"  "DBL_FMT" "DBL_FMT" "DBL_FMT"  "DBL_FMT" "DBL_FMT" "DBL_FMT"\n",
      p[2].x,p[2].y,p[2].z,
      p[3].x,p[3].y,p[3].z);

@ @<Close the QuickDraw triangle strip@>=
fprintf(f,")\n");

@ @<Write the QuickDraw cone normals@>=
    fprintf(f,"Container (\n  VertexAttributeSetList ( %d Exclude 0)\n",2*(n+1));
      for(i=0; i<=n; i++) {
        QDNormalColor(f,normals+i,c);
        QDNormalColor(f,normals+i,c);
       }
    fprintf(f,")\n");
    fprintf(f,")\n");

@ @<Write the QuickDraw continued cone normals@>=
    fprintf(f,"Container (\n  VertexAttributeSetList ( %d Exclude 0)\n",2*(n+1));
      for(i=0; i<=n; i++) {
        QDNormalColor(f,normals1+i,c);
        QDNormalColor(f,normals2+i,c);
       }
    fprintf(f,")\n");
    fprintf(f,")\n");


@ @<Make a QuickDraw cone along $p_1$ and $p_2$@>=
void MakeQDCone(FILE *f,Point3D *p1, Point3D *p2,RGBColor *c, double r, int n)
{ Point3D v1,v2,v3,vn,p[4],testn;
  double norm;
  double dphi;
  int i,interchange;
  Point3D *normals;

  v1.x=p2->x-p1->x;
  v1.y=p2->y-p1->y;
  v1.z=p2->z-p1->z;
  norm=Norm(&v1);
  v1.x/=norm; @+  v1.y/=norm; @+ v1.z/=norm;
  OrthogonalSet(&v1,&v2,&v3);

  v1.x=p2->x-p1->x;
  v1.y=p2->y-p1->y;
  v1.z=p2->z-p1->z;
  dphi=TWO_PI/n;
  @<Test triangle orientation@>@;
  ConePoint(r,0.0,&v2,&v3, p);
  normals=(Point3D *)calloc(n+1,sizeof(Point3D));
  vn=*p;
  normals[0].x=-p->x; @+ normals[0].y=-p->y; @+ normals[0].z=-p->z;
  IncPoint3D(p[0],(*p1))@;
  AddPoint3D(p[1],p[0],v1)@;
  @<Begin QuickDraw triangle strip@>@;
  @<Write the initial vertex pair@>@;
  for(i=1; i<=n; i++) {
    ConePoint(r,i*dphi,&v2,&v3,p+2);
    vn=p[2];
    IncPoint3D(p[2],(*p1))@;
    AddPoint3D(p[3],p[2],v1)@;
    normals[i].x=-vn.x; @+
    normals[i].y=-vn.y; @+
    normals[i].z=-vn.z; @+
    @<Write the remainig vertex pairs@>@;
   }
  @<Close the QuickDraw triangle strip@>@;
  @<Write the QuickDraw cone normals@>@;
  free(normals);
}


@ @<Make a QuickDraw continued cone along $p_1$ and $p_2$ to $p_3$@>=
void MakeQDConeContinued(FILE *f,Point3D *p1, Point3D *p2, Point3D *p3,
               RGBColor *c,
               double r, int n)
{ Point3D v1,v2,v3,u1,u2,u3,p[4];
  Point3D testn;
  double norm;
  double dphi;
  int i,interchange;
  Point3D *normals1,*normals2;

  @<Prepare the local frame from |p1|, |p2| and |p3|@>@;
  @<Skip continuation for QuickDraw@>@;
  normals1=(Point3D *)calloc(n+1,sizeof(Point3D));
  normals2=(Point3D *)calloc(n+1,sizeof(Point3D));

  u2=v2; @+  u3=v3;
  GramSchmidt(&u1,&u2,&u3);
  dphi=TWO_PI/n;
  @<Check the orientation of the triangle strips@>@;
  ConePoint(r,0.0,&v2,&v3, p);
  normals1[0].x=-p->x; @+ normals1[0].y=-p->y; @+ normals1[0].z=-p->z;
  IncPoint3D(p[0],(*p1))@;
  ConePoint(r,0.0,&u2,&u3,p+1);
  normals2[0].x=-p[1].x; @+ normals2[0].y=-p[1].y; @+ normals2[0].z=-p[1].z;  
  IncPoint3D(p[1],(*p2))
  @<Begin QuickDraw triangle strip@>@;
  @<Write the initial vertex pair@>@;
  for(i=1; i<=n; i++) {
    ConePoint(r,i*dphi,&v2,&v3,p+2);
    normals1[i].x=-p[2].x;
    normals1[i].y=-p[2].y;
    normals1[i].z=-p[2].z;
    IncPoint3D(p[2],(*p1))@;
    ConePoint(r,i*dphi,&u2,&u3,p+3);
    normals2[i].x=-p[3].x;
    normals2[i].y=-p[3].y;
    normals2[i].z=-p[3].z;
    IncPoint3D(p[3],(*p2));
    @<Write the remainig vertex pairs@>@;
    }
  @<Close the QuickDraw triangle strip@>@;
  @<Write the QuickDraw continued cone normals@>@;
  free(normals1);
  free(normals2);
}

@ @<Skip continuation for QuickDraw@>=
  if(Dot(&u1,&v1)<CosSkipCont) {
    MakeQDCone(f,p1,p2,c,r,n);
    return;
   }


@ @<Write QuickDraw line and polygon coordinates@>=
  for(i=0; i<lst->pno; i++) {
    p=PointPool+lst->points[i];
    fprintf(f,"\t "DBL_FMT" "DBL_FMT" "DBL_FMT"\n",p->x,p->y,p->z);
   }


@ @<Write QuickDraw lines@>=
LinePolyList *WriteQDLine(FILE *f,LinePolyList *lst)
{ Point3D *p;
  int i;

  if(fabs(LineTubeSize)<MachineEpsilon) {
    fprintf(f,"Container (\n");
    if(lst->pno>2) {
      fprintf(f,"PolyLine(\n  %d\n",lst->pno);
      @<Write QuickDraw line and polygon coordinates@>@;
      fprintf(f,")\n");
     }
    else {
      fprintf(f,"Line (\n");
      @<Write QuickDraw line and polygon coordinates@>@;
      fprintf(f,")\n");
     }
    @<Write the color for QuickDraw@>@;
   }
  else {
    @<Draw tubes for the lines@>@;
   }
  return lst->next;
}

@  @<Draw tubes for the lines@>=
{
  if(2==lst->pno)
    MakeQDCone(f,PointPool+lst->points[0],
         PointPool+lst->points[1],
         &lst->color,LineTubeSize,TubeSegments);
  else {
    for(i=0; i<lst->pno-2; i++)
      MakeQDConeContinued(f,
        PointPool+lst->points[i],
         PointPool+lst->points[i+1],
         PointPool+lst->points[i+2],
         &lst->color,
        LineTubeSize,TubeSegments);
    i=lst->pno-2;
    if(lst->points[0]==lst->points[i+1]) { /* closed curve */
      MakeQDConeContinued(f,
        PointPool+lst->points[i],
        PointPool+lst->points[0],
        PointPool+lst->points[1],
        &lst->color,
        LineTubeSize,TubeSegments);
    }
   else
     MakeQDCone(f,PointPool+lst->points[i],
         PointPool+lst->points[i+1],
         &lst->color,
         LineTubeSize,TubeSegments);

  }
}

@ @<Write QuickDraw polygon@>=
LinePolyList *WriteQDPolygon(FILE *f,LinePolyList *lst)
{ int i;
  Point3D *p;

  fprintf(f,"Container (\n"@|
            "  Polygon (\n"@|
            "\t %d\n",lst->pno);
  @<Write QuickDraw line and polygon coordinates@>@;
  fprintf(f,"  )\n");
  if(SmoothShading) {
    fprintf(f,"Container (\n  VertexAttributeSetList ( %d Exclude 0)\n",lst->pno);
      for(i=0; i<lst->pno; i++) {
        p=NormalPool[lst->points[i]];
        QDNegNormal(f,p);
       }
    fprintf(f,")\n");
   }
  @<Write the color for QuickDraw@>@;
  return lst->next;
}

@ @<Write a QuickDraw mesh@>=
Mesh3DList *WriteQDMesh(FILE *f, Mesh3DList *lst)
{ int i,j,mu;
  Point3D *p;
  RGBColor *c;

  mu=lst->dimU*lst->dimV;
  fprintf(f,"Container (\n");
  fprintf(f,"TriGrid (\n %d\n %d\n",lst->dimU,lst->dimV);
  for(i=0; i<lst->dimU; i++)
    for(j=0; j<lst->dimV; j++) {
    p=MeshCoordPtr(lst,i,j);
    fprintf(f,"\t"DBL_FMT" "DBL_FMT" "DBL_FMT"\n",p->x,p->y,p->z);
   }
  fprintf(f,")\n"); /* close the TriGrid */
  @<Write the normals per mesh vertex@>@;
  @<Write the colors per mesh face for QuickDraw@>@;
  fprintf(f,")\n");
  return lst->next;
}

@ @<Write the normals per mesh vertex@>=
  if(SmoothShading) {
    fprintf(f,"Container ( VertexAttributeSetList ( %d Exclude 0)\n",mu);
    for(i=0; i<lst->dimU; i++)
      for(j=0; j<lst->dimV; j++) {
        p=MeshNormalPtr(lst,i,j);
        QDNegNormal(f,p);
     }
    fprintf(f,")\n");
   }

@ @<Write the colors per mesh face for QuickDraw@>=
  if(MESH_FACE_COLOR==(lst->attrib & MESH_FACE_COLOR)) {
    mu=(lst->dimU-1)*(lst->dimV-1);
    fprintf(f,"Container ( FaceAttributeSetList ( %d Exclude 0)\n",2*mu);
    for(i=0; i<lst->dimU-1; i++)
      for(j=0; j<lst->dimV-1; j++){
        c=MeshColorPtr(lst,i,j);
        fprintf(f,"Container (\n"
                     "AttributeSet()\n"
                     "DiffuseColor( "DBL_FMT" "DBL_FMT" "DBL_FMT" )\n"
                   ")\n",c->r,c->g,c->b);
        fprintf(f,"Container (\n"
                     "AttributeSet()\n"
                     "DiffuseColor( "DBL_FMT" "DBL_FMT" "DBL_FMT" )\n"
                   ")\n",c->r,c->g,c->b);
       }
    fprintf(f,")\n");
   }


@ @<Write the QuickDraw points@>=
PointList *WriteQDPoint(FILE *f,PointList *lst)
{ Point3D *p;
  double sz;
  p=PointPool + lst->point;
  if(0==PointSphereSize)
    fprintf(f,"Point ("DBL_FMT" "DBL_FMT" "DBL_FMT")\n",p->x,p->y,p->z);
  else {
    sz=lst->size*PointSphereSize;
    fprintf(f,"Ellipsoid (\n"
                 ""DBL_FMT"  0   0\n"
                 " 0  "DBL_FMT"  0\n"
                 " 0   0  "DBL_FMT"\n"
                 " "DBL_FMT" "DBL_FMT" "DBL_FMT"\n0\n1\n0\n1\n)\n",
                 sz,sz,sz,
                 p->x,p->y,p->z);
   }
  return lst->next;
}

@ @<Write the header to |qdfile|@>=
fprintf(qdfile,
  "3DMetafile ( 1 5 Stream Label0>)\n"
  "CString (\"Created by MathGL3d (c) Jens-Peer Kuska 1997,98,99\")\n");

@ @<Write the camera position for QuickDraw@>=
void WriteQDCamera(FILE *f,Point3D *viewpoint)
{
  Point3D vp;
  Point3D u1,u2,u3;
  double nrm;

  ScaleToWorld(&vp,viewpoint);
  vp.x=CenterOfScene.x-vp.x;
  vp.y=CenterOfScene.y-vp.y;
  vp.z=CenterOfScene.z-vp.z;
  u3=vp;
  nrm=Norm(&u3);
  u3.x/=nrm; @+ u3.y/=nrm; u3.z/=nrm;
  u1.x=1.0; @+ u1.y=u1.z=0.0;
  u2.x=0.0; @+ u2.y=1.0; @+ u2.z=0.0;
  GramSchmidt(&u3,&u1,&u2);
  fprintf(f,"Container(\n  ViewHints()\n  Container (\n");
  fprintf(f,"  ViewAngleAspectCamera (\n    "DBL_FMT" 1\n   )\n",MVViewAngle);
  fprintf(f,"  CameraPlacement (\n"@|
            "    "DBL_FMT" "DBL_FMT" "DBL_FMT"\n"@|
            "    "DBL_FMT" "DBL_FMT" "DBL_FMT"\n"@|
            "    0 0 1)\n",-vp.x,-vp.y,-vp.z,
                                   CenterOfScene.x,
                                   CenterOfScene.y,
                                   CenterOfScene.z);
  fprintf(f,"  CameraViewPort(\n"@|
            "    -0.5 0.5\n"@|
            "    1.0\n"@|
            "    1.0\n"@|
            "   )\n");
  fprintf(f,")\n)\n");
}

@ @<Write the light sources for QuickDraw@>=
void WriteQDLights(FILE *f,Point3D *lightp, RGBColor *lcolor, int n)
{ Point3D ls;
  double nls;
  int i;

  fprintf(f,"Container (\n"
            "  ViewHints()\n"
            "  Container (\n"
            "    InteractiveRenderer()\n"
            "   )\n");
  for (i=0; i<n; i++){
    ScaleToWorld(&ls,lightp+i);
    ls.x-=CenterOfScene.x;
    ls.y-=CenterOfScene.y;
    ls.z-=CenterOfScene.z;
    nls=Norm(&ls);
    if(nls>0.0) {
      ls.x/=nls;
      ls.y/=nls;
      ls.z/=nls;
     }
    fprintf(f,"Container (\n"@|
              "  DirectionalLight (\n"@|
              "    "DBL_FMT" "DBL_FMT" "DBL_FMT"\n"@|
              "    False\n"@|
              "   )\n",
              ls.x,ls.y,ls.z);
    fprintf(f,"  Light (\n"@|
              "    True\n    1.0\n"@|
              "    "DBL_FMT" "DBL_FMT" "DBL_FMT"\n   )\n )\n",@|
              lcolor[i].r,lcolor[i].g,lcolor[i].b);
   }
  fprintf(f,"Container (\n"@|
            "  AmbientLight()\n"@|
            "  Light(\n"@|
            "    True\n"@|
            "    1.0\n"@|
            "    "DBL_FMT" "DBL_FMT" "DBL_FMT"\n"@|
            "   )\n"@|
            " )\n",AmbientColor.r,AmbientColor.g,AmbientColor.b);
  fprintf(f,"ImageClearColor ( 1\n"@|
            "  %s\n )\n",BlackBackground ? "0 0 0" : "0.8 0.8 0.8");
  fprintf(f,")\n");
}


@ @<Save the data as QuickDraw 3D file@>=
int Write3DMF(const char *fname,int WriteLight,int WriteView)
{ FILE *qdfile;
  PointList *pplst=Points;
  LinePolyList *llst=Lines;
  LinePolyList *plst=Polygons;
  Mesh3DList *mlst=Meshes;
#if MACINTOSH_MATHLINK
  qdfile=MacCreateFile(fname,'3DMF','ttxt');
#else  
  qdfile=fopen(fname,"w");
#endif
  if (!qdfile) return 1;
  @<Write the header to |qdfile|@>@;
  if(WriteLight) WriteQDLights(qdfile,LightPosition,LightColor,LightNo);
  fprintf(qdfile,"BeginGroup( DisplayGroup() )\n");
  fprintf(qdfile,"# Points in scene\n");
  while(pplst) pplst=WriteQDPoint(qdfile,pplst);
  fprintf(qdfile,"# Polygons in scene\n");
  while(plst) plst=WriteQDPolygon(qdfile,plst);
  fprintf(qdfile,"# Lines in scene\n");
  while(llst) llst=WriteQDLine(qdfile,llst);
  fprintf(qdfile,"# Meshes in scene\n");
  while(mlst) mlst=WriteQDMesh(qdfile,mlst);
  fprintf(qdfile,"EndGroup()\n");
  if(WriteView) WriteQDCamera(qdfile,&ViewPoint);
  fclose(qdfile);
  return 0;
}

@* VRML 2.0 output.
@<Write Virtual Reality files@>=
@<Calculate the camera orientation@>@;
@<Write VRML material with |*c|@>@;
@<Save the points in VRML format@>@;
@<Make a VRML cone along $p_1$ and $p_2$@>@;
@<Make a VRML continued cone along $p_1$ and $p_2$ to $p_3$@>@;
@<Save the lines in VRML format@>@;
@<Make thick lines in VRML format without extrusion@>@;
@<Save the polygons in VRML format@>@;
@<Write the meshes in VRML format@>@;
@<Save the scene as VRML file@>@;

@ @<Save the points in VRML format@>=
void WriteVRPoints(FILE *f, PointList *plst)
{ PointList *lst;
  Point3D *p;

  if(0.0==PointSphereSize)
    @<Write the points as \.{PointSet}@>@;
  else
    @<Write the points as VRML spheres@>@;
  fprintf(f," }\n");
}

@ @<Write the points as \.{PointSet}@>=
{
  lst=plst;
  fprintf(f,"DEF MGL_POINTS Shape {\n");
  fprintf(f,
    " geometry PointSet {\n"@|
    "   coord Coordinate {\n"
    "     point [\n");
  while(lst) {
    p=PointPool+lst->point;
    fprintf(f,"     "DBL_FMT" "DBL_FMT" "DBL_FMT"%s\n",p->x,p->y,p->z,(lst->next ? ",":""));
    lst=lst->next;
   }
  lst=plst;
  fprintf(f,
    "     ]\n"@|
    "   }\n"@|
    "   color Color {\n"@|
    "     color [\n"@|);
  while(lst) {
    fprintf(f,"     "DBL_FMT" "DBL_FMT" "DBL_FMT"\n",lst->color.r,lst->color.g,lst->color.b);
    lst=lst->next;
   }
  fprintf(f,
    "      ]\n"@|
    "   }\n"@|
    " }\n");
}

@ @<Write VRML material with |lst->color|@>=
    WriteVRMaterial(f,&lst->color);

@ @<Write VRML material with |*c|@>=
void WriteVRMaterial(FILE *f, RGBColor *c)
{
    fprintf(f,
      "  appearance Appearance {\n"@|
      "    material Material{\n"@|
      "      diffuseColor "DBL_FMT" "DBL_FMT" "DBL_FMT"\n"@|
      "      ambientIntensity 0.0\n"@|
      "      specularColor 0.0 0.0 0.0\n"@|
      "      emissiveColor 0.0 0.0 0.0\n"@|
      "      shininess 0.2\n"@|
      "      transparency 0.0\n"@|
      "     }\n"@|
      "   }\n",c->r,c->g,c->b);
}

@ @<Write the points as VRML spheres@>=
{ double sz;

  lst=plst;
  fprintf(f,
    " Group {\n"
    "   children [\n");
  while(lst) {
    p=PointPool +lst->point;
    sz=lst->size*PointSphereSize;
    fprintf(f,
      "  Transform {\n");
    fprintf(f,
      "    children Shape {\n");
    @<Write VRML material with |lst->color|@>@;
    fprintf(f,
      "  geometry Sphere {\n"@|
      "     radius "DBL_FMT"\n"@|
      "    }\n"@|
      "}\n",sz);
    fprintf(f,"    translation "DBL_FMT" "DBL_FMT" "DBL_FMT"\n",p->x,p->y,p->z);
    fprintf(f,
      "   }\n");
    lst=lst->next;
   }
  fprintf(f,"  ]\n");
}

@ @<Make a VRML cone along $p_1$ and $p_2$@>=
void MakeVRCone(FILE *f,Point3D *p1, Point3D *p2,RGBColor *c, double r, int n)
{ Point3D v1,v2,v3,p[4],testn;
  double norm;
  double dphi;
  int i,interchange;

  v1.x=p2->x-p1->x;
  v1.y=p2->y-p1->y;
  v1.z=p2->z-p1->z;
  norm=Norm(&v1);
  v1.x/=norm; @+  v1.y/=norm; @+ v1.z/=norm;
  OrthogonalSet(&v1,&v2,&v3);

  v1.x=p2->x-p1->x;
  v1.y=p2->y-p1->y;
  v1.z=p2->z-p1->z;
  dphi=TWO_PI/n;
  @<Test triangle orientation@>@;
  ConePoint(r,0.0,&v2,&v3, p);
  IncPoint3D(p[0],(*p1))@;
  AddPoint3D(p[1],p[0],v1)@;
  @<Begin VR cone segment@>@;
  @<Write VR initial vertex pair@>@;
  for(i=1; i<=n; i++) {
    ConePoint(r,i*dphi,&v2,&v3,p+2);
    IncPoint3D(p[2],(*p1))@;
    AddPoint3D(p[3],p[2],v1)@;
    @<Write VR remainig vertex pair@>@;
   }
  @<Write the VR face coordinates of the cone segment@>@;
  @<End the VR cone segment@>@;
}


@ @<Make a VRML continued cone along $p_1$ and $p_2$ to $p_3$@>=
void MakeVRConeContinued(FILE *f,Point3D *p1, Point3D *p2, Point3D *p3,
               RGBColor *c,
               double r, int n)
{ Point3D v1,v2,v3,u1,u2,u3,p[4];
  Point3D testn;
  double norm;
  double dphi;
  int i,interchange;

  @<Prepare the local frame from |p1|, |p2| and |p3|@>@;
  @<Skip continuation for VRML@>@;

  u2=v2; @+  u3=v3;
  GramSchmidt(&u1,&u2,&u3);
  dphi=TWO_PI/n;
  @<Check the orientation of the triangle strips@>@;
  ConePoint(r,0.0,&v2,&v3, p);
  IncPoint3D(p[0],(*p1))@;
  ConePoint(r,0.0,&u2,&u3,p+1);
  IncPoint3D(p[1],(*p2))
  @<Begin VR cone segment@>@;
  @<Write VR initial vertex pair@>@;
  for(i=1; i<=n; i++) {
    ConePoint(r,i*dphi,&v2,&v3,p+2);
    IncPoint3D(p[2],(*p1))@;
    ConePoint(r,i*dphi,&u2,&u3,p+3);
    IncPoint3D(p[3],(*p2));
    @<Write VR remainig vertex pair@>@;
    }
  @<Write the VR face coordinates of the cone segment@>@;
  @<End the VR cone segment@>@;
}

@ @<Skip continuation for VRML@>=
  if(Dot(&u1,&v1)<CosSkipCont) {
    MakeVRCone(f,p1,p2,c,r,n);
    return;
   }

@ @<Begin VR cone segment@>=
fprintf(f,"Shape {\n");
WriteVRMaterial(f,c);
fprintf(f,
  "  geometry IndexedFaceSet {\n"
  "    coord Coordinate {\n"
  "      point [\n");

@ @<End the VR cone segment@>=
fprintf(f,
  "    creaseAngle "DBL_FMT"\n"
  "   }\n"
  " }\n",2.0*dphi);

@ @<Write VR initial vertex pair@>=
fprintf(f,
  "      "DBL_FMT" "DBL_FMT" "DBL_FMT", "DBL_FMT" "DBL_FMT" "DBL_FMT",\n",
  p->x,p->y,p->z,p[1].x,p[1].y,p[1].z);

@ @<Write VR remainig vertex pair@>=
fprintf(f,
  "      "DBL_FMT" "DBL_FMT" "DBL_FMT", "DBL_FMT" "DBL_FMT" "DBL_FMT",\n",
  p[2].x,p[2].y,p[2].z,p[3].x,p[3].y,p[3].z);


@ @<Write the VR face coordinates of the cone segment@>=
fprintf(f,
  "       ]\n" /* Close the \.{point} entry*/
  "     }\n"   /* Close the \.{coord Coordinate} entry*/
  "    coordIndex [\n");
for(i=0; i<2*n; i+=2)
  fprintf(f,
    "     %d %d %d %d -1,\n",i,i+1,i+3,i+2);
fprintf(f,  "     ]\n");

@ @<Save the lines in VRML format@>=
LinePolyList *WriteVRLines(FILE *f,int *count,LinePolyList *lst)
{ int i;
  Point3D *p;
  fprintf(f,"DEF MGL_LINE%d Shape {\n",*count);
  if(fabs(LineTubeSize)>MachineEpsilon)
    @<Write simple VRML lines@>@;
  else
    @<Write lines as VRML extrusions@>@;
  fprintf(f,"}\n");
  (*count)++;
  return lst->next;
}

@ @<Write VR line coordinates@>=
for(i=0; i<lst->pno; i++){
  p=PointPool+lst->points[i];
  fprintf(f,"      "DBL_FMT" "DBL_FMT" "DBL_FMT"%s",p->x,p->y,p->z,n==i ? "\n":",\n");
 }

@ @<Write simple VRML lines@>=
{ int n=lst->pno-1;
  fprintf(f,"  geometry IndexedLineSet {\n");
  fprintf(f,"    coord Coordinate {\n"
            "      point [\n");
  @<Write VR line coordinates@>@;
  fprintf(f,"       ]\n"
            "     }\n");
  fprintf(f,"   coordIndex [\n");
  for(i=0; i<lst->pno; i++)
    fprintf(f," %d\n",i);
  fprintf(f,"    ]\n");
  fprintf(f,"   }\n");
}

@ @<Write lines as VRML extrusions@>=
{ double dphi;
  double r;
  int n=lst->pno-1;

  r=LineTubeSize;
  dphi=TWO_PI/TubeSegments;
  @<Write VRML material with |lst->color|@>@;
  fprintf(f,"  geometry Extrusion {\n");
  fprintf(f,"    crossSection [\n");
  for(i=0; i<=TubeSegments; i++)
    fprintf(f,"     "DBL_FMT" "DBL_FMT"%s",
      r*cos(i*dphi),r*sin(i*dphi),i==TubeSegments ?"\n":",\n");
  fprintf(f,"     ]\n");
  fprintf(f,"    spine [\n");
  @<Write VR line coordinates@>@;
  fprintf(f,"     ]\n");
  fprintf(f,"    beginCap FALSE\n"
            "    endCap FALSE\n"
            "    solid FALSE\n");
  fprintf(f,"    creaseAngle "DBL_FMT"\n",2.0*dphi);
  fprintf(f,"   }\n");
}


@ @<Make thick lines in VRML format without extrusion@>=
LinePolyList *WriteNoExtrudedVRLines(FILE *f,int *count,LinePolyList *lst)
{ int i;

  fprintf(f,"DEF MGL_NOEEXTLN%d Group {\n",*count);
  fprintf(f,"  children [\n");
  @<Save the tube pices as VRML indexed face sets@>@;
  fprintf(f,"   ]\n""}\n");
  (*count)++;
  return lst->next;
}

@ @<Save the tube pices as VRML indexed face sets@>=
{
  if(2==lst->pno)
    MakeVRCone(f,PointPool+lst->points[0],
         PointPool+lst->points[1],
         &lst->color,LineTubeSize,TubeSegments);
  else {
    for(i=0; i<lst->pno-2; i++)
      MakeVRConeContinued(f,
        PointPool+lst->points[i],
         PointPool+lst->points[i+1],
         PointPool+lst->points[i+2],
         &lst->color,
        LineTubeSize,TubeSegments);
    i=lst->pno-2;
    if(lst->points[0]==lst->points[i+1]) { /* closed curve */
      MakeVRConeContinued(f,
        PointPool+lst->points[i],
        PointPool+lst->points[0],
        PointPool+lst->points[1],
        &lst->color,
        LineTubeSize,TubeSegments);
    }
   else
     MakeVRCone(f,PointPool+lst->points[i],
         PointPool+lst->points[i+1],
         &lst->color,
         LineTubeSize,TubeSegments);

  }
}


@ @<Save the polygons in VRML format@>=
void WriteVRPolygons(FILE *f,const char *pTexPrefix,LinePolyList *plst)
{ int i;
  LinePolyList *lst;
  RGBColor **ctab;
  int cno;
  static int texFileCount=1;

  ctab=PolyColorTable(&cno,plst);
  fprintf(f,
    "DEF MGL_POLYGONS Shape {\n"@|
    "  appearance Appearance {\n"@|
    "    material Material{\n"@|
    "      diffuseColor 1.0 1.0 1.0\n"@|
    "      ambientIntensity 0.0\n"@|
    "      specularColor 0.0 0.0 0.0\n"@|
    "      emissiveColor 0.0 0.0 0.0\n"@|
    "      shininess 0.2\n"@|
    "      transparency 0.0\n"@|
    "     }\n");
  if(SceneTextureMap)
    @<Write the texture of the scene@>@;
  fprintf(f,"   }\n");
  if(!SceneTextureMap)
    @<Write the polygons with direct usage of the indexed point set@>@;
  else
    @<Expand the indexed point set of the polygons@>@;
  fprintf(f," }\n");
  free(ctab);
}

@ @<Write the polygons with direct usage of the indexed point set@>=
{
  fprintf(f,
    "  geometry IndexedFaceSet {\n"@|
    "    solid FALSE\n"@|
    "    coord Coordinate {\n");
  @<Write the points of an indexed face set@>@;
  fprintf(f,"     }\n");
  @<Write the coordinates of the face set@>@;
  @<Write optional vertex normals@>@;
  @<Write the polygon color table@>@;
  fprintf(f,"}\n");
}

@ @<Expand the indexed point set of the polygons@>=
{ int i,pcount;
  LinePolyList *polys;
  Point3D *p,*tp;

  fprintf(f,
    "  geometry IndexedFaceSet {\n"@|
    "    solid FALSE\n"@|
    "    coord Coordinate {\n");
  @<Expand the polygon points of the scene@>@;
  @<Write the expanded face indicies@>@;
  @<Optional write the expanded vertex normals@>@;
  @<Write the texture coordinates of the scene@>@;
  fprintf(f,"   }\n");
}

@ @d VRLastPoint(i,lst) ((NULL==lst->next) && ((i)==lst->pno-1))
@<Expand the polygon points of the scene@>=
polys=plst;
fprintf(f,"  point [");
while(polys) {
  for(i=0; i<polys->pno; i++) {
    p=PointPool+polys->points[i];
    fprintf(f," "DBL_FMT" "DBL_FMT" "DBL_FMT" %s\n",p->x,p->y,p->z,
              VRLastPoint(i,polys) ? "" : ",");
   }
  polys=polys->next;
 }
fprintf(f,"   ]\n       }\n");

@ @<Write the expanded face indicies@>=
polys=plst;
fprintf(f,"  coordIndex [\n");
pcount=0;
while(polys) {
  for(i=0; i<polys->pno; i++)
    fprintf(f,"%d, ",pcount++);
  fprintf(f," -1,\n");
  polys=polys->next;
 }
fprintf(f,"    ]\n");

@ @<Optional write the expanded vertex normals@>=
if(SmoothShading) {
  fprintf(f,
    "  normalPerVertex TRUE\n"@|
    "  normal Normal {\n"@|
    "    vector [\n");
  polys=plst;
  while(polys) {
    for(i=0; i<polys->pno;i++) {
      p=NormalPool[polys->points[i]];
      if(p)
        fprintf(f,"\t "DBL_FMT" "DBL_FMT" "DBL_FMT"\n",p->x,p->y,p->z);
      else
        fprintf(f,"\t 0 0 0\n");
     }
    polys=polys->next;
   }
  fprintf(f,
    "     ]\n"@|
    "   }\n");
}


@ @<Write the texture coordinates of the scene@>=
fprintf(f," texCoord TextureCoordinate {\n");
fprintf(f,"   point [\n");
polys=plst;
while(polys) {
  if(CrossXPlusAxis(polys)) {
    for(i=0; i<polys->pno; i++) {
      tp=polys->pTexturePoints+i;
      fprintf(f," "DBL_FMT" "DBL_FMT" %s\n",
        (fabs(tp->x)<0.5 ? 1.0+tp->x : tp->x),tp->y,
        VRLastPoint(i,polys) ? "" : ",");
     }
   }
  else
    for(i=0; i<polys->pno; i++) {
      tp=polys->pTexturePoints+i;
      fprintf(f," "DBL_FMT" "DBL_FMT" %s\n",tp->x,tp->y,VRLastPoint(i,polys) ? "" : ",");
     }
  polys=polys->next;
 }
fprintf(f,"    ]\n   }\n");

@ @<Write the texture of the scene@>=
{
    if(!*TextureFile(SceneTextureMap->tex))
      @<Save the texture data of the scene to a PNG file@>@;
    fprintf(f,
      "texture ImageTexture {\n"@|
      "  url \"%s\"\n"@|
      "  repeatS TRUE\n"@|
      "  repeatT TRUE\n"@|
      " }\n",TextureFile(SceneTextureMap->tex));
    fprintf(f,
      "textureTransform TextureTransform {\n"@|
      "  scale "DBL_FMT" "DBL_FMT"\n"@|
      " }\n",SceneTextureMap->scaleS,SceneTextureMap->scaleT);
}

@ @<Save the texture data of the scene to a PNG file@>=
{
   sprintf(TextureFile(SceneTextureMap->tex),
     "%stex%d.png",pTexPrefix,texFileCount++);
   PNGSaveBitmap(
     TextureFile(SceneTextureMap->tex),
     TextureWidth(SceneTextureMap->tex),
     TextureHeight(SceneTextureMap->tex),
     TextureType(SceneTextureMap->tex),
     TextureData(SceneTextureMap->tex),GL_FALSE,1.0);
}

@ @<Write the points of an indexed face set@>=
fprintf(f,
  "      point [\n");
for(i=0; i<PoolSize; i++)
  fprintf(f,"\t"DBL_FMT" "DBL_FMT" "DBL_FMT",\n",
    PointPool[i].x,PointPool[i].y,PointPool[i].z);
fprintf(f,
  "       ]\n");

@ @<Write the coordinates of the face set@>=
fprintf(f,
  " coordIndex [\n");
lst=plst;
while(lst) {
  fprintf(f,"\t");
  for(i=0; i<lst->pno; i++)
    fprintf(f,"%d ",lst->points[i]);
  fprintf(f,"-1,\n");
  lst=lst->next;
 }
fprintf(f,
  "  ]\n");


@ @<Write optional vertex normals@>=
if(SmoothShading) {
  Point3D *p;

  fprintf(f,
    "  normalPerVertex TRUE\n"@|
    "  normal Normal {\n"@|
    "    vector [\n");
  for(i=0; i<PoolSize;i++) {
    p=NormalPool[i];
    if(p)
      fprintf(f,"\t "DBL_FMT" "DBL_FMT" "DBL_FMT"\n",p->x,p->y,p->z);
    else
      fprintf(f,"\t 0 0 0\n");
   }
  fprintf(f,
    "     ]\n"@|
    "   }\n");
}


@ @<Write the polygon color table@>=
{
  fprintf(f,
    "colorPerVertex FALSE\n"@|
    " color Color {\n"@|
    "  color [\n");
  for(i=0; i<cno; i++)
    fprintf(f,"    "DBL_FMT" "DBL_FMT" "DBL_FMT"\n",ctab[i]->r,ctab[i]->g,ctab[i]->b);
  fprintf(f,
    "   ]\n"@|
    " }\n");
  lst=plst;
  fprintf(f,
    "colorIndex [\n");
  while(lst) {
    fprintf(f," %d,\n",lst->aux1);
    lst=lst->next;
   }
  fprintf(f,
    " ]\n");
}

@ @<Write the meshes in VRML format@>=
Mesh3DList *WriteVRMesh(FILE *f,const char *mTexPrefix,
                        int *count, Mesh3DList *mlst)
{ static int texFileCount=1;

  fprintf(f,
    "DEF MGL_MESH%d Shape {\n",*count);
  fprintf(f,
    "  appearance Appearance {\n"@|
    "    material Material{\n"@|
    "      diffuseColor "DBL_FMT" "DBL_FMT" "DBL_FMT"\n"@|
    "      ambientIntensity 0.0\n"@|
    "      specularColor 0.0 0.0 0.0\n"@|
    "      emissiveColor 0.0 0.0 0.0\n"@|
    "      shininess 0.2\n"@|
    "      transparency 0.0\n"@|
    "     }\n",mlst->mColor.r,mlst->mColor.g,mlst->mColor.b);
    @<Write the texture of a mesh@>@;
    fprintf(f,
      "   }\n");
    fprintf(f,
    "  geometry IndexedFaceSet {\n"@|
    "    solid FALSE\n"@|
    "    coord Coordinate {\n");
  @<Write the points of the mesh |mlst|@>@;
  fprintf(f,
    "     }\n");
  @<Write the VR mesh faces@>@;
  @<Write the optional VR mesh normals@>@;
  @<Write the VR mesh color table@>@;
  @<Write the VR mesh texture coordinates@>@;
  fprintf(f,
    "   }\n"@|
    " }\n");
  (*count)++;
  return mlst->next;
}

@ @<Write the texture of a mesh@>=
{
  if(MeshTextureQ(mlst)) {
    if(!*MeshTextureFile(mlst))
      @<Save the mesh texture to a PNG file@>@;
    fprintf(f,
      "texture ImageTexture {\n"@|
      "  url \"%s\"\n"@|
      "  repeatS TRUE\n"@|
      "  repeatT TRUE\n"@|
      " }\n",MeshTextureFile(mlst));
    fprintf(f,
      "textureTransform TextureTransform {\n"@|
      "  scale "DBL_FMT" "DBL_FMT"\n"@|
      " }\n",mlst->mTexture->scaleS,mlst->mTexture->scaleT);
   }
}

@ @<Save the mesh texture to a PNG file@>=
{
   sprintf(MeshTextureFile(mlst),"%stex%d.png",mTexPrefix,texFileCount++);
   PNGSaveBitmap(
     MeshTextureFile(mlst),
     TextureWidth(mlst->mTexture->tex),
     TextureHeight(mlst->mTexture->tex),
     TextureType(mlst->mTexture->tex),
     TextureData(mlst->mTexture->tex),GL_FALSE,1.0);
}

@ @<Write the points of the mesh |mlst|@>=
{ int i,j;
  int n,m;
  Point3D *p;

  n=mlst->dimU;
  m=mlst->dimV;
  fprintf(f,
    "  point [\n");
  for(i=0; i<n; i++)
    for(j=0; j<m; j++) {
      p=MeshCoordPtr(mlst,i,j);
      fprintf(f,DBL_FMT" "DBL_FMT" "DBL_FMT"\n",p->x,p->y,p->z);
     }
 fprintf(f,
   "   ]\n");
}

@ @<Write the VR mesh faces@>=
{ int i,j;
  int n,m;

  n=mlst->dimU-1;
  m=mlst->dimV-1;
  fprintf(f,"  coordIndex [\n");
  for(i=0; i<n; i++)
    for(j=0; j<m; j++) {
      fprintf(f,"    %d %d %d %d -1\n",
        MeshIndexExpanded(mlst,i,j),
        MeshIndexExpanded(mlst,i+1,j),
        MeshIndexExpanded(mlst,i+1,j+1),
        MeshIndexExpanded(mlst,i,j+1));
       }
  fprintf(f,"   ]\n");
}

@ @<Write the optional VR mesh normals@>=
if(SmoothShading) {
  register Point3D *p;
  register int i,j;
  register int n,m;

  n=mlst->dimU;
  m=mlst->dimV;
  fprintf(f,
    "  normalPerVertex TRUE\n"@|
    "  normal Normal {\n"@|
    "    vector [\n");
  for(i=0; i<n;i++)
    for(j=0; j<m; j++) {
      p=MeshNormalPtr(mlst,i,j);
      fprintf(f,"\t "DBL_FMT" "DBL_FMT" "DBL_FMT"\n",p->x,p->y,p->z);
   }
  fprintf(f,
    "     ]\n"@|
    "   }\n");
}

@ @<Write the VR mesh color table@>=
if(mlst->mpolyColors) {
  register int i,j;
  register int n,m;
  RGBColor *c;

  n=mlst->dimU;
  m=mlst->dimV;
  fprintf(f,
    "colorPerVertex %s\n"@|
    " color Color {\n"@|
    "  color [\n",
    VRBool(MESH_VERTEX_COLOR==(mlst->attrib & MESH_VERTEX_COLOR)));
  for(i=0; i<n; i++)
    for(j=0; j<m; j++) {
      c=MeshColorPtr(mlst,i,j);
      fprintf(f,"    "DBL_FMT" "DBL_FMT" "DBL_FMT"\n",c->r,c->g,c->b);
     }
  fprintf(f,
    "   ]\n"@|
    " }\n");
}

@ @<Write the VR mesh texture coordinates@>=
if (MeshTextureQ(mlst)) {
  int i,j;
  int n,m;
  Point3D *p;

  n=mlst->dimU;
  m=mlst->dimV;
  fprintf(f,
    "texCoord TextureCoordinate {\n"@|
    "  point [\n");
  for(i=0; i<n; i++)
    for(j=0; j<m; j++) {
      p=MeshTexCoordPtr(mlst,i,j);
      fprintf(f," "DBL_FMT" "DBL_FMT" %s\n",p->x,p->y,i==(n-1) ? ",": "");
     }
  fprintf(f,"   ]\n"@|
    " }\n");
 }

@ The top level function to write VRML 2.0 files.
|mTexPrefix| and |pTeXPrefix| are the first characters used to save
the texture bitmaps.
@d VRBool(t) (t? "TRUE" : "FALSE")
@<Save the scene as VRML file@>=
int WriteVRML(char *fname, int headlight,int useextrusion,
    const char *pTexPrefix,const char *mTexPrefix)
{ FILE *vrfile;
  PointList *pplst=Points;
  LinePolyList *llst=Lines;
  LinePolyList *plst=Polygons;
  Mesh3DList *mlst=Meshes;
  int count;

  vrfile=fopen(fname,"w");
  if(!vrfile) return 1;
  @<Write the VRML header@>@;
  @<Write the VR view point of the scene@>@;
  @<Write the VRML light sources@>@;
  fprintf(vrfile,"Group {\n");
  fprintf(vrfile,"  children [\n");
  if(pplst) WriteVRPoints(vrfile,pplst);
  count=0;
  if(useextrusion || fabs(LineTubeSize)>MachineEpsilon)
    while(llst) llst=WriteVRLines(vrfile,&count,llst);
  else
    while(llst) llst=WriteNoExtrudedVRLines(vrfile,&count,llst);
  if(plst) WriteVRPolygons(vrfile,pTexPrefix,plst);
  count=0;
  while(mlst) mlst=WriteVRMesh(vrfile,mTexPrefix,&count,mlst);
  fprintf(vrfile,"  ]\n");
  fprintf(vrfile,"}");
  if (!vrfile) return 1;
  fclose(vrfile);
  return 0;
}

@  @<Calculate the camera orientation@>=
void VROrientation(Point3D *orient, double *angle,
        Point3D *viewpoint, Point3D *lookat, Point3D *up)
{ Point3D vp,vert,zero;
  double d;
  Quaternion qRotMajor,qRotMinor;
  Quaternion qtmp;

  @<Normalize the vector to the view point@>@;
  @<Make the vector of the vertical view direction@>@;
  Cross(orient,&vp,&ZAxis);
  d=Norm(orient);
  if(d<TINY) {
    if(orient->z>0.0)
      MakeQuaternion(&qRotMajor,0.5*PI,&YAxis);
    else {
      zero.x=zero.y=zero.z=0.0;
      MakeQuaternion(&qRotMajor,0.5*PI,&zero);
     } 
   }
  else {
    *angle=asin(Dot(orient,orient));
    orient->x/=d;
    orient->y/=d;
    orient->z/=d;
    MakeQuaternion(&qRotMajor,acos(-vp.z),orient);
   }
  @<Remove the twisting in the up direction@>@;
  QuaternionTimes(&qtmp,&qRotMajor,&qRotMinor);
  GetQuaternionRotation(angle,orient,&qtmp);
}

@ @<Normalize the vector to the view point@>=
  vp.x=-(viewpoint->x-lookat->x);
  vp.y=-(viewpoint->y-lookat->y);
  vp.z=-(viewpoint->z-lookat->z);
  d=Norm(&vp);
  if(d!=0.0) {
    vp.x/=d;
    vp.y/=d;
    vp.z/=d;
   }

@ @<Make the vector of the vertical view direction@>=
  d=Dot(&vp,up);
  vert.x=up->x-d*vp.x;
  vert.y=up->y-d*vp.y;
  vert.z=up->z-d*vp.z;
  d=Norm(&vert);
  if(d!=0.0) {
    vert.x/=d;
    vert.y/=d;
    vert.z/=d;
   }

@ The native rotation of the view point yields a twisting of
the vertical view direction. We must remove this twisting.
For that task we take the $y$-axis and rotate the axis back
to the camera position. The angle between the rotated $y$-axis
and the |up| vector give the twisting that must be corrected.
@<Remove the twisting in the up direction@>=
{ 
  Point3D newY;
  double twist;

  QuaternionRotate(&newY,&qRotMajor,&YAxis);
  twist=acos(Dot(&newY,&vert));
  MakeQuaternion(&qRotMinor,twist,&ZAxis);
}

@ @<Write the VRML header@>=
fprintf(vrfile,
  "#VRML V2.0 utf8\n"@|
  "# Created with %s %s \n"@|
  "# (c) Jens-Peer Kuska 1997-99\n",@|
  BANNER,VERSION);
fprintf(vrfile,
  "##Bounding box:\n"@|
  "## x:  "DBL_FMT" "DBL_FMT"\n"@|
  "## y:  "DBL_FMT" "DBL_FMT"\n"@|
  "## z:  "DBL_FMT" "DBL_FMT"\n",
  BoundP1.x,BoundP2.x,
  BoundP1.y,BoundP2.y,
  BoundP1.z,BoundP2.z);
fprintf(vrfile,
  "WorldInfo {\n"@|
  "  title \"%s\"\n"@|
  "  info  \"%s\n%s\n%s\"\n }\n\n",@|
  "MathGL3d Output",
  "VRML 2.0 model was automatic created from a Mathematica 3D Graphic",
  "and the free OpenGL viewer for Mathematica. MathGL3d is written by Jens-Peer Kuska.",
  "see <http://www.mpae.gwdg.de/~kuska/mview3d.html> for more information.");
fprintf(vrfile,
  "NavigationInfo {\n"@|
  "  avatarSize [ "DBL_FMT" "DBL_FMT" "DBL_FMT" ]\n",
  BoundP2.x-BoundP1.x,
  BoundP2.y-BoundP1.y,
  BoundP2.z-BoundP1.z);
fprintf(vrfile,"  headlight %s\n",VRBool(headlight));
fprintf(vrfile,"  speed 1.0\n");
fprintf(vrfile,"  type [\"EXAMINE\" \"WALK\" \"FLY\"]\n");
fprintf(vrfile,"  visibilityLimit 0.0\n");
fprintf(vrfile," }\n");

@ @<Write the VR view point of the scene@>=
{ Point3D vp,orient;
  double r,th,phi,alpha;
  double fac=5.0;


  ScaleToWorld(&vp,&ViewPoint);
  SphericalFromCartesian(&vp,&r,&th,&phi);
  VROrientation(&orient,&alpha,&vp,&CenterOfScene,&ViewVertical);
  fprintf(vrfile,
    " Viewpoint {\n"
    "      fieldOfView "DBL_FMT"\n"
    "      position "DBL_FMT" "DBL_FMT" "DBL_FMT"\n"
    "      orientation "DBL_FMT" "DBL_FMT" "DBL_FMT" "DBL_FMT"\n"
    "      description \"DefaultViewpoint\"\n"
    "     }\n",
  PI*MVViewAngle/180.,
  CenterOfScene.x+vp.x,CenterOfScene.y+vp.y,CenterOfScene.z+vp.z,
  orient.x,orient.y,orient.z,alpha);
  fprintf(vrfile,
    "Viewpoint {\n"
    "  position "DBL_FMT" "DBL_FMT" "DBL_FMT"\n"
    "  description \"Top View\""
    " }\n",
    CenterOfScene.x,
    CenterOfScene.y,
    CenterOfScene.z+fac*(BoundP2.z-BoundP1.z)
   );
  fprintf(vrfile,
    "Viewpoint {\n"
    "  position "DBL_FMT" "DBL_FMT" "DBL_FMT"\n"
    "  orientation 1 0 0 "DBL_FMT"\n"
    "  description \"Bottom View\""
    " }\n",
    CenterOfScene.x,
    CenterOfScene.y,
    CenterOfScene.z-fac*(BoundP2.z-BoundP1.z),
    PI
   );
  fprintf(vrfile,
    "Viewpoint {\n"
    "  position "DBL_FMT" "DBL_FMT" "DBL_FMT"\n"
    "  orientation 1 0 0 "DBL_FMT"\n"
    "  description \"Front View\""
    " }\n",
    CenterOfScene.x,
    CenterOfScene.y-fac*(BoundP2.y-BoundP1.y),
    CenterOfScene.z,
    0.5*PI
   );
  fprintf(vrfile,
    "Viewpoint {\n"
    "  position "DBL_FMT" "DBL_FMT" "DBL_FMT"\n"
    "  orientation 1 0 0 "DBL_FMT"\n"
    "  description \"Backface View\""
    " }\n",
    CenterOfScene.x,
    CenterOfScene.y+fac*(BoundP2.y-BoundP1.y),
    CenterOfScene.z,
    -0.5*PI
   );

}

@ @<Write the VRML light sources@>=
{ int i;
  Point3D lp;

  for(i=0; i<LightNo; i++) {
    ScaleToWorld(&lp,LightPosition+i);

    fprintf(vrfile,
      "PointLight {\n"@|
      "  on TRUE\n"@|
      "  intensity 1\n"@|
      "  ambientIntensity 0\n");
    fprintf(vrfile,
      "  color "DBL_FMT" "DBL_FMT" "DBL_FMT"\n"@|
      "  location "DBL_FMT" "DBL_FMT" "DBL_FMT"\n",
      LightColor[i].r,LightColor[i].g,LightColor[i].b,
      lp.x,lp.y,lp.z);
    fprintf(vrfile,
      "  radius "DBL_FMT"\n"@|
      "  attenuation 1 0 0\n"@|
      " }\n");
   }
}

@* AutoCAD DXF files.

@<Stuff to write a DXF file@>=
@<Write a 3d face@>@;
@<Check the ordering of the tetragons@>@;
@<Write a triangle to the DXF file@>@;
@<Write a tetragon to the DXF file@>@;
@<Write a sphere at |p| into the DXF file@>@;
@<Write the points to the DXF file@>@;
@<Make a cone for the DXF file@>@;
@<Make a continued cone for the DXF output@>@;
@<Write the list of meshes to the DXF file@>@;
@<Write the polygon list@>@;
@<Write the line list as covered lines to the DXF file@>@;
@<Write the DXF file@>@;


@ @<Write the DXF file@>=
int  WriteDXF(char *dxfname)
{ FILE *dxffile;

  dxffile=fopen(dxfname,"w");
  if(dxffile) {
    @<Write the DXF header@>@;
    @<Start the Entities section@>@;

    if(Meshes)
      WriteDXFMeshs(dxffile,MESH_LAYER,4,Meshes);
    if(Polygons)
      WriteDXFPolys(dxffile,POLY_LAYER,1,Polygons);
    if(Lines && fabs(LineTubeSize)>MachineEpsilon)
      WriteDXFLines(dxffile,LINE_LAYER,2,Lines);
    if(Points && PointSphereSize>0.0)
      WriteDXFPoints(dxffile,POINT_LAYER,3,Points);
    @<Close the Entities section@>@;
    @<End of DXF file@>@;
    fclose(dxffile);
    return 0;
   }
  return 1;
}

@ The header section contains general information about the
  drawing, these are only relevant when creating
  specialised DXF files for AutoCAD. We will write a header comment
  and a empty header section. We will define three layers for
  polygons (layer 1), polygons created from lines (layer 2) and
  polygons created from points (layer 3).
@d POLY_LAYER  1
@d LINE_LAYER  2
@d POINT_LAYER 3
@d MESH_LAYER  4

@<Write the DXF header@>=
  fprintf(dxffile,"999\n"@|
    "DXF created from MathGL3d "VERSION @|
    "\n0\n"@|
    "SECTION\n2\n"@|
    "HEADER\n0\nENDSEC\n");
  /* Create 3 layers */
  fprintf(dxffile,"0\nSECTION\n2\nTABLES\n0\n"@|
                  "TABLE\n3\n"@|
                  "LAYER\n0\n"@|
                  "LAYER\n2\n1\n0\n"@|
                  "LAYER\n2\n2\n0\n"@|
                  "LAYER\n2\n3\n0\n"@|
                  "ENDTAB\n0\nENDSEC\n");
  /* Empty blocks section */
  fprintf(dxffile,"0\nSECTION\n2\nBLOCKS\n0\nENDSEC\n");

@ @<End of DXF file@>=fprintf(dxffile,"0\nEOF\n");

@ @<Start the Entities section@>=
fprintf(dxffile,"0\nSECTION\n2\nENTITIES\n");

@ @<Close the Entities section@>=
fprintf(dxffile,"0\nENDSEC\n");

@ @<Write a 3d face@>=
void WriteDXF3dFace(FILE *f, int layer,
        int color, int *points, int pno)
{ int i,k;

  fprintf(f,"0\n3DFACE\n8\n%d\n",layer);
  fprintf(f,"62\n%d\n",color);
  for(i=0; i<pno; i++) {
    k=1;
    fprintf(f,"%d\n"DBL_FMT"\n",i+10*(k++),PointPool[points[i]].x);
    fprintf(f,"%d\n"DBL_FMT"\n",i+10*(k++),PointPool[points[i]].y);
    fprintf(f,"%d\n"DBL_FMT"\n",i+10*(k++),PointPool[points[i]].z);
   }
}

@ DXF files need the repeated third point of a triangle.
@<Write a triangle to the DXF file@>=
void WriteDXFTriangle(FILE *f, int layer,
        int color, Point3D *p1, Point3D *p2, Point3D *p3)
{
  fprintf(f,"0\n3DFACE\n8\n%d\n",layer);
  fprintf(f,"62\n%d\n",color);
  fprintf(f,"%d\n"DBL_FMT"\n%d\n"DBL_FMT"\n%d\n"DBL_FMT"\n",@|
    10,p1->x,20,p1->y,30,p1->z);
  fprintf(f,"%d\n"DBL_FMT"\n%d\n"DBL_FMT"\n%d\n"DBL_FMT"\n",@|
    11,p2->x,21,p2->y,31,p2->z);
  fprintf(f,"%d\n"DBL_FMT"\n%d\n"DBL_FMT"\n%d\n"DBL_FMT"\n",@|
    12,p3->x,22,p3->y,32,p3->z);
  fprintf(f,"%d\n"DBL_FMT"\n%d\n"DBL_FMT"\n%d\n"DBL_FMT"\n",@|
    13,p1->x,23,p1->y,33,p1->z);
}

@ The polygons created by |MakeDXFCone| and |MakeDXFConeContinued| are
  not correctly oriented. For OpenGL and POVRay this doesn't
  matter because the surface normals are explicit given, for DXF files
  we must check the correct orientation.
@<Check the ordering of the tetragons@>=
int CheckTubeTetra(Point3D *p1,Point3D *p2, Point3D *p3, Point3D *p4,
                   Point3D *v1,Point3D *v2, Point3D *v3, Point3D *v4)
{ Point3D n;
  Point3D nn1,nn2;

  n.x=0.25*(v1->x+v2->x+v3->x+v4->x);
  n.y=0.25*(v1->y+v2->y+v3->y+v4->y);
  n.z=0.25*(v1->z+v2->z+v3->z+v4->z);
  SurfaceNormal(&nn1,p4,p1,p2);
  SurfaceNormal(&nn2,p2,p3,p4);
  nn1.x+=nn2.x; @+ nn1.y=nn2.y; @+ nn1.z=nn2.z;
  if(Dot(&nn1,&n)<0) return GL_FALSE;
  return GL_TRUE;
}

@ DXF files can store tetragons, the points must not lie in a plane
@<Write a tetragon to the DXF file@>=
void WriteDXFTetra(FILE *f, int layer,
        int color, Point3D *p1, Point3D *p2, Point3D *p3, Point3D *p4)
{
  fprintf(f,"0\n3DFACE\n8\n%d\n",layer);
  fprintf(f,"62\n%d\n",color);
  fprintf(f,"%d\n"DBL_FMT"\n%d\n"DBL_FMT"\n%d\n"DBL_FMT"\n",@|
    10,p1->x,20,p1->y,30,p1->z);
  fprintf(f,"%d\n"DBL_FMT"\n%d\n"DBL_FMT"\n%d\n"DBL_FMT"\n",@|
    11,p2->x,21,p2->y,31,p2->z);
  fprintf(f,"%d\n"DBL_FMT"\n%d\n"DBL_FMT"\n%d\n"DBL_FMT"\n",@|
    12,p3->x,22,p3->y,32,p3->z);
  fprintf(f,"%d\n"DBL_FMT"\n%d\n"DBL_FMT"\n%d\n"DBL_FMT"\n",@|
    13,p4->x,23,p4->y,33,p4->z);
}

@ @<Write the list of meshes to the DXF file@>=
void WriteDXFMeshs(FILE *f, int layer, int color, Mesh3DList *lst)
{
  while(lst) {
    @<Write the DXF data for a single mesh@>@;
    lst=lst->next;
   }
}

@ @<Write the DXF data for a single mesh@>=
{ int i,j,n,m;

  n=lst->dimU-1;
  m=lst->dimV-1;
  for(i=0; i<n; i++)
    for(j=0; j<m; j++)
      WriteDXFTetra(f,layer,color,
        MeshCoordPtr(lst,i,j),
        MeshCoordPtr(lst,i+1,j),
        MeshCoordPtr(lst,i+1,j+1),
        MeshCoordPtr(lst,i,j+1));
}


@ @<Write the polygon list@>=
void WriteDXFPolys(FILE *f, int layer, int color, LinePolyList *lst)
{
  fprintf(f,"999\nPolygons\n");
  while(lst) {
    if(3==lst->pno)
      WriteDXFTriangle(f,layer,color,
        PointPool+lst->points[0],
        PointPool+lst->points[1],
        PointPool+lst->points[2]);
    else
      WriteDXF3dFace(f,layer,color,lst->points,lst->pno);
    lst=lst->next;
   }
}

@ @<Make a cone for the DXF file@>=
void MakeDXFCone(FILE *f,int layer, int color,
                 Point3D *p1, Point3D *p2, double r, int n)
{ Point3D v1,v2,v3,vn[4],p[4];
  double norm;
  double dphi;
  int i;

  v1.x=p2->x-p1->x;
  v1.y=p2->y-p1->y;
  v1.z=p2->z-p1->z;
  norm=Norm(&v1);
  v1.x/=norm; @+  v1.y/=norm; @+ v1.z/=norm;
  OrthogonalSet(&v1,&v2,&v3);

  v1.x=p2->x-p1->x;
  v1.y=p2->y-p1->y;
  v1.z=p2->z-p1->z;

  dphi=TWO_PI/n;
  ConePoint(r,0.0,&v2,&v3, p);
  vn[0]=vn[1]=*p;
  IncPoint3D(p[0],(*p1))@;
  AddPoint3D(p[1],p[0],v1)@;
  for(i=1; i<=n; i++) {
    ConePoint(r,i*dphi,&v2,&v3,p+2);
    vn[2]=p[2];
    IncPoint3D(p[2],(*p1))@;
    AddPoint3D(p[3],p[2],v1)@;
    vn[3]=vn[2];
    @<Write an oriented tetragon to the DXF file@>@;
    p[0]=p[2]; @+ vn[0]=vn[2];
    p[1]=p[3]; @+ vn[1]=vn[3];
   }
}

@ @<Write an oriented tetragon to the DXF file@>=
    if(CheckTubeTetra(p,p+1,p+3,p+2,vn,vn+1,vn+3,vn+2))
      WriteDXFTetra(f,layer,color,p,p+1,p+3,p+2);
    else
      WriteDXFTetra(f,layer,color,p+2,p+3,p+1,p);

@ @<Make a continued cone for the DXF output@>=
void MakeDXFConeContinued(FILE *f,int layer, int color,
               Point3D *p1, Point3D *p2, Point3D *p3,
               double r, int n)
{ Point3D v1,v2,v3,u1,u2,u3,vn[4],p[4];
  double norm;
  double dphi;
  int i;

  v1.x=p2->x-p1->x; @+ v1.y=p2->y-p1->y; @+ v1.z=p2->z-p1->z;
  norm=Norm(&v1);
  v1.x/=norm; @+  v1.y/=norm; @+ v1.z/=norm;
  OrthogonalSet(&v1,&v2,&v3);
  u1.x=p3->x-p2->x;@+  u1.y=p3->y-p2->y; @+  u1.z=p3->z-p2->z;
  norm=Norm(&u1);
  u1.x/=norm; @+  u1.y/=norm; @+ u1.z/=norm;
  @<Skip coninuation in DXF output@>@;
  u2=v2; @+  u3=v3;
  GramSchmidt(&u1,&u2,&u3);
  dphi=TWO_PI/n;
  ConePoint(r,0.0,&v2,&v3, p);
  vn[0]=*p;
  IncPoint3D(p[0],(*p1))@;
  ConePoint(r,0.0,&u2,&u3,p+1);
  vn[1]=p[1];
  IncPoint3D(p[1],(*p2))
  for(i=1; i<=n; i++) {
    ConePoint(r,i*dphi,&v2,&v3,p+2);
    vn[2]=p[2];
    IncPoint3D(p[2],(*p1))@;
    ConePoint(r,i*dphi,&u2,&u3,p+3);
    vn[3]=p[3];
    IncPoint3D(p[3],(*p2)) @;
    @<Write an oriented tetragon to the DXF file@>@;
    p[0]=p[2]; @+ vn[0]=vn[2];
    p[1]=p[3]; @+ vn[1]=vn[3];
   }
}

@ @<Skip coninuation in DXF output@>=
  if(Dot(&u1,&v1)<CosSkipCont) {
    MakeDXFCone(f,layer,color,p1,p2,r,n);
    MakeDXFCone(f,layer,color,p2,p3,r,n);
    return;
   }

@ @<Write the line list as covered lines to the DXF file@>=
void WriteDXFLines(FILE *f, int layer, int color, LinePolyList *lst)
{ int i;
  fprintf(f,"999\nCovered lines\n");
  while(lst) {
    @<Draw lines in the DXF file as tubes@>@;
    lst=lst->next;
   }
}

@ @<Draw lines in the DXF file as tubes@>=
{ if(2==lst->pno)
    MakeDXFCone(f,layer,color,PointPool+lst->points[0],
         PointPool+lst->points[1],
         LineTubeSize,TubeSegments);
  else {
    for(i=0; i<lst->pno-2; i++)
      MakeDXFConeContinued(f,layer,color,
        PointPool+lst->points[i],
    PointPool+lst->points[i+1],
    PointPool+lst->points[i+2],
    LineTubeSize,TubeSegments);
    i=lst->pno-2;
    if(lst->points[0]==lst->points[i+1]) { /* closed curve */
      MakeDXFConeContinued(f,layer,color,
        PointPool+lst->points[i],
    PointPool+lst->points[0],
    PointPool+lst->points[1],
    LineTubeSize,TubeSegments);
    }
   else
     MakeDXFCone(f,layer,color,PointPool+lst->points[i],
         PointPool+lst->points[i+1],
         LineTubeSize,TubeSegments);
  }
}

@ @<Write the points to the DXF file@>=
void WriteDXFPoints(FILE *dxffile,int layer,int color,PointList *lst)
{
  fprintf(dxffile,"999\nPoints\n");
  while(lst) {
    MakeDXFSphere(dxffile, layer, color,PointPool+(lst->point),
           lst->size*PointSphereSize,
           PointSphereSegmentsPhi,
           PointSphereSegmentsTheta);
    lst=lst->next;
   }

}

@ @<Write a sphere at |p| into the DXF file@>=
void MakeDXFSphere(FILE *dxffile,
       int layer, int color, Point3D *pnt,
       double r, int nphi, int nth)
{ double dth,dp;
  int i, j;
  double cp,cp1,st,st1,sp,sp1,ct,ct1,phi,th;
  Point3D p,p1,p2,p3;

  dp=TWO_PI/nphi;
  dth=PI/nth;
  for(i=0; i<nphi; i++) {
    cp=cos(phi=i*dp);
    sp=sin(phi);
    cp1=cos(phi=(i+1)*dp);
    sp1=sin(phi);
    for(j=0; j<nth; j++) {
      ct=r*cos(th=(j+1)*dth);
      st=r*sin(th);
      ct1=r*cos(th=j*dth);
      st1=r*sin(th);
      p.x=p1.x=p2.x=p3.x=pnt->x;
      p.y=p1.y=p2.y=p3.y=pnt->y;
      p.z=p1.z=p2.z=p3.z=pnt->z;
      p.x+=cp*st;    @+ p.y+=sp*st;    @+ p.z+=ct;
      p1.x+=cp1*st;  @+ p1.y+=sp1*st;  @+ p1.z+=ct;
      p2.x+=cp1*st1; @+ p2.y+=sp1*st1; @+ p2.z+=ct1;
      p3.x+=cp*st1;  @+ p3.y+=sp*st1;  @+ p3.z+=ct1;
      WriteDXFTetra(dxffile,layer,color,&p,&p1,&p2,&p3);
    }
   }
}

@ The DXF file reader is rather primitive. I had testen it with the
  DXF files created by \.{mathview3d} itself, by the DXF files created
  with \Math and with some common DXF files from \.{http://www.3dcafe.com}.
@<Stuff to read a DXF file@>=
@<Remove spaces@>@;
@<Read a DXF file@>@;

@ |RemoveSpaces| will remove all space characters at the beginning and the
end of a |line|. Additionaly the MS-DOS like carrige return is removed.
@<Remove spaces@>=
char *RemoveSpaces(char *line)
{ int i,n;
  
  n=strlen(line);
  for(i=0; i<=n; i++) {
     if(10==line[i]) line[i]='\0';
     else if(13==line[i]) line[i]='\0';
    } 
  @<Kill leading spaces from |line|@>@;
  return line;
}  

@ @<Kill leading spaces from |line|@>=
  while(*line && (isspace(*line) || *line=='\10' || *line=='\13')) 
    memmove(line,line+1,strlen(line));
  while(*line && isspace(line[strlen(line)])) 
    line[strlen(line)]='\0';

@ The scanner for the DXF file.
@d DXF_LINESIZE 1024
@d DXFGetLine(l) {do {
                    fgets(l,DXF_LINESIZE,dxf);
                    RemoveSpaces(l); 
                   } while(!*l && !feof(dxf)); 
                 }
                 
@d DXFGetInteger(i,l) {do {
                         fgets(l,DXF_LINESIZE,dxf);
                         RemoveSpaces(l);
                        } while (!*l && !feof(dxf));  
                       i=atoi(line);
                      } 
@d DXFGetDouble(d,l) { do {
                         fgets(l,DXF_LINESIZE,dxf);
                         RemoveSpaces(l);
                        } while (!*l && !feof(dxf)); 
                   d=atof(line);
                  } 


@d DXFEndQ(line)      strstr(line,"EOF")
@d DXFEntitiesQ(line) strstr(line,"ENTITIES")
@d DXFPointQ(line)    strstr(line,"POINT")
@d DXFPolyLineQ(line) strstr(line,"POLYLINE")
@d DXFVertexQ(line)   strstr(line,"VERTEX")
@d DXF3DFaceQ(line)   strstr(line,"3DFACE")
@d DXFEndSeqQ(line)   strstr(line,"SEQEND")
@d DXFUpdateBBox(x,y,z) { if((x)<xMin) xMin=(x);
                          if((x)>xMax) xMax=(x);
                          if((y)<yMin) yMin=(y);
                          if((y)>yMax) yMax=(y);
                          if((z)<zMin) zMin=(z);
                          if((z)>zMax) zMax=(z);
                        }
@d DXFNone      (0)
@d DXFPoint     (2)
@d DXFLine3D    (4)
@d DXFPoly3D    (8)

@<Read a DXF file@>=
int ReadDXF(char *dxfname)
{ FILE *dxf;
  static char line[DXF_LINESIZE];
  static char dxftoken[DXF_LINESIZE];
  static char layerName[DXF_LINESIZE];
  int inEntities=GL_FALSE;
  double xCoord[10],yCoord[10],zCoord[10];
  int lbuffer[10];
  double xVertex,yVertex,zVertex;
  double xMin,yMin,zMin,xMax,yMax,zMax;
  int what,i;
  int groupCode,dxfColor,dxfLayer,pointNo,pointNo1;
  double red,green,blue;
  double psize;
  dxf=fopen(dxfname,"r");
  if(!dxf) return GL_TRUE;
  dxfLayer=dxfColor=1;
  xMin=yMin=zMin=FLT_MAX;
  xMax=yMax=zMax=-FLT_MAX;
  psize=0.001;
  red=green=blue=1.0;
  while(!feof(dxf)) {
    DXFGetLine(line)@;
    if(DXFEndQ(line)) break;
    if(DXFEntitiesQ(line)) {
      inEntities=GL_TRUE;
      continue;
     }
    if(!inEntities) continue;
    what=DXFNone;
    if(!*line) continue;
    if(isalpha(*line))
      strcpy(dxftoken,line);
    else
      strcpy(dxftoken,"");
    if(DXFPointQ(line)) @<Scan a DXF point@>@;
    if(DXFPolyLineQ(line))@<Scan a DXF line@>@;
    if(DXF3DFaceQ(line)) @<Scan a DXF polygon@>@;
    @<Put DXF primitive@>@;
   }
  BoundP1.x=xMin; @+ BoundP1.y=yMin; @+ BoundP1.z=zMin;
  BoundP2.x=xMax; @+ BoundP2.y=yMax; @+ BoundP2.z=zMax;
  @<Add light sources to the scene@>@;
  @<Add view point to the scene@>@;
  fclose(dxf);
  return GL_FALSE;
}

@ This code will look to the coordinates and update
  |pointNo| to the number of entries in the |xCoord|, |yCoord| and
  |zCoord| array.
@<Scan DXF coordinates@>=
  while(groupCode!=0) {
    if(groupCode>=10 && groupCode<19) /* $x$ coordinate */
      DXFGetDouble(xCoord[groupCode-10],line)@;
    if(groupCode>=20 && groupCode<29) /* $y$ coordinate */
      DXFGetDouble(yCoord[groupCode-20],line)@;
    if(groupCode>=30 && groupCode<39) /* $z$ coordinate */
      DXFGetDouble(zCoord[groupCode-30],line)@;
    if(groupCode>=10 && groupCode<39)
      pointNo++;
    DXFGetLine(line)@;
    if(isdigit(*line))
      groupCode=atoi(line);
    else {
      break;
     }
   }
  pointNo=(pointNo+1)/3;

@ Here the coordinates are read into |xVertex|, |yVertex| and
  |zVertex|. The point number gets updated by scanner for the
  \.{POLYLINE} directive.
@<Scan DXF vertex coordinates@>=
  { int coordFound=GL_FALSE;

    DXFGetInteger(groupCode,line)@;
    while(groupCode!=0) {
      if(groupCode>=10 && groupCode<19) /* $x$ coordinate */
        DXFGetDouble(xVertex,line)@;
      if(groupCode>=20 && groupCode<29) /* $y$ coordinate */
        DXFGetDouble(yVertex,line)@;
      if(groupCode>=30 && groupCode<39) /* $z$ coordinate */
        DXFGetDouble(zVertex,line)@;
      if(groupCode>=10 && groupCode<39) {
        coordFound=GL_TRUE;
       }
      else /* skip the next entry */
	     DXFGetLine(line)@;
      DXFGetInteger(groupCode,line)@;
     }
  }

@ We will only look for a layer and color attributes. When the code
  ends it has  updated |line| for next scanning.
@<Scan DXF attributes@>=
  do {
    DXFGetInteger(groupCode,line)@;
    if(DXFVertexQ(line)) break;
    if(8==groupCode) {
      DXFGetLine(line)@;
      if(isdigit(*line)) {
        dxfLayer=atoi(line);
	strcpy(layerName,"");
       }
      else
	strcpy(layerName,line);
      DXFGetInteger(groupCode,line)@;
     }
    if(62==groupCode) {
      DXFGetInteger(dxfColor,line)@;
     }
    if(feof(dxf)) break;
  } while (groupCode<10 || groupCode>=39 || 0==groupCode);

@ @<Scan a DXF point@>=
{
  what=DXFPoint;
  @<Scan DXF attributes@>@;
  pointNo=-1;
  @<Scan DXF coordinates@>@;
}

@ @<Scan a DXF line@>=
{
  what=DXFLine3D;
  @<Scan DXF attributes@>@;
  pointNo=0;
  do {
    if(DXFVertexQ(line)) {
      @<Scan DXF vertex coordinates@>@;
      xCoord[pointNo]=xVertex;
      yCoord[pointNo]=yVertex;
      zCoord[pointNo]=zVertex;
      pointNo++;
     }
    DXFGetLine(line);
   } while (!feof(dxf) && !DXFEndSeqQ(line));
}

@ @<Scan a DXF polygon@>=
{
  what=DXFPoly3D;
  @<Scan DXF attributes@>@;
  pointNo=-1;
  @<Scan DXF coordinates@>@;
}


@ @<Put DXF primitive@>=
switch(what) {
  case DXFNone:   break;
  case DXFPoint:
    DXFUpdateBBox(xCoord[0],yCoord[0],zCoord[0]);
    i=AddToPointPool(xCoord[0],yCoord[0],zCoord[0]);
    Points=PrependPointList(Points,i,psize,red,green,blue);
    break;
  case DXFLine3D:
    if(pointNo>0) {
      for(i=0; i<pointNo; i++) {
        DXFUpdateBBox(xCoord[i],yCoord[i],zCoord[i]);
	     lbuffer[i]=AddToPointPool(xCoord[i],yCoord[i],zCoord[i]);
       }
      Lines=PrependLinePolyList(Lines,Line3D,lbuffer,pointNo,red,green,blue);
     }
    break;
  case DXFPoly3D:
    if(pointNo>0) {
      pointNo1=pointNo-1;
      /* reduce point number for triangles */
      if(xCoord[0]==xCoord[pointNo1] &&
         yCoord[0]==yCoord[pointNo1] &&
	      zCoord[0]==zCoord[pointNo1])
	     pointNo=pointNo1;
      else if(xCoord[pointNo-2]==xCoord[pointNo1] &&
	      yCoord[pointNo-2]==yCoord[pointNo1] &&
	      zCoord[pointNo-2]==zCoord[pointNo1])
	     pointNo=pointNo1;
      for(i=0; i<pointNo; i++) {
	     DXFUpdateBBox(xCoord[i],yCoord[i],zCoord[i]);
	     lbuffer[i]=AddToPointPool(xCoord[i],yCoord[i],zCoord[i]);
       }
      Polygons=PrependLinePolyList(Polygons,Polygon3D,lbuffer,pointNo,red,green,blue);

     }
    break;
  default : fprintf(stderr,"ReadDXF::Unkonwn primitive %s found.",dxftoken);
 } 

@ @<Add light sources to the scene@>=
{
  LightNo=0;
  i=0;

  LightPosition[i].x=1.85198; @+
  LightPosition[i].y=-1.79677; @+
  LightPosition[i].z=1.44622;
  LightColor[i].r=1.0; @+
  LightColor[i].g=0.0; @+
  LightColor[i].b=0.0;
  i++;

  LightPosition[i].x=1.73331; @+
  LightPosition[i].y=-1.36661; @+
  LightPosition[i].z=2.34114;
  LightColor[i].r=0.0; @+
  LightColor[i].g=1.0; @+
  LightColor[i].b=0.0;
  i++;
 
  LightPosition[i].x=0.769322; @+
  LightPosition[i].y=-1.63254; @+
  LightPosition[i].z=2.34114;
  LightColor[i].r=0.0; @+
  LightColor[i].g=0.0; @+
  LightColor[i].b=1.0;
  i++; 
  LightNo=i;
}

@ @<Add view point to the scene@>=
{
   ViewPoint.x=1.3;
   ViewPoint.y=-2.4;
   ViewPoint.z=2.0;
}  

@* Geomview OFF files.
@<Stuff for Geomviews \.{OFF} files@>=
  @<Write Geomviews \.{OFF} files@>@;
  @<Strip Geomviews comment sign from the line@>@;
  @<Get a on comment line form \.{OFF} file@>@;     
  @<Read an \.{OFF} file into the memory@>@;
       
@ Since the \.{OFF} files use the same indexed point set as
  \.{mathview3d} it is easy to write the off files. We will only
  write polygons -- no tubes and no spheres for points.
@<Write Geomviews \.{OFF} files@>=
int  WriteOFF(char *offname)
{ FILE *off;
  int nface, i;
  LinePolyList *lst;
  
  if(!Polygons) return 1;
  off=fopen(offname,"w");
  if(!off) return 1;
  fprintf(off,"OFF\n");
  fprintf(off,"# Off file generated by MathGL3D (c) Jens-Peer Kuska\n");
  nface=LengthLinePolyList(Polygons);
  fprintf(off,"%d %d %d\n",PoolSize,nface,3*nface);
  for(i=0; i< PoolSize; i++)
    fprintf(off,DBL_FMT" "DBL_FMT" "DBL_FMT"\n",PointPool[i].x,PointPool[i].y,PointPool[i].z);
  fprintf(off,"# Faces\n");
  lst=Polygons;
  while(lst) {
    fprintf(off,"%d ",lst->pno);
    for(i=0; i<lst->pno; i++)
      fprintf(off,"%d ",lst->points[i]);
    fprintf(off,"\n");
    lst=lst->next;
   }
  fclose(off);
  return 0;
}

@ @<Strip Geomviews comment sign from the line@>=
char *StripOFFComment(char *line)
{ unsigned int i;

  for(i=0; i<strlen(line); i++) {
    if('#'==line[i] || '\n'==line[i]) { 
      line[i]='\0';
      break;
     }
   }
  @<Kill leading spaces from |line|@>@;
  return line;
}  

@ @<Get a on comment line form \.{OFF} file@>=
char * NextDataLine(FILE *f, char *line)
{
  strcpy(line,"");
  do {
    fgets(line,OFF_LINESIZE,f);
    StripOFFComment(line);
   } while (!*line && !feof(f));
  return line;
}


@ Reading the \.{OFF} files is easy as well. The only problem
  is that the off file may contain a single point more than
  once. In that case the index generated by |AddToPointPool|
  mismatches the indexes in the face list. A |pointmap| array
  is created that store how the index of the \.{OFF} file
  is mapped onto the index in the |PointPool|.
  
@d OFF_LINESIZE 1024

@<Read an \.{OFF} file into the memory@>=
int ReadOFF(char *offname)
{ char line[OFF_LINESIZE],*rest;
  FILE *off;
  int i,j,nvertex,nface,npoly;
  double xv,yv,zv;
  double xMin,xMax,yMin,yMax,zMin,zMax;
  int lbuffer[64],fail;
  int *pointmap;

  off=fopen(offname,"r");
  if(!off) return 1;
  NextDataLine(off,line);
  if(!strstr(line,"OFF")) {
    fclose(off);
    return 1;
   }
  xMin=yMin=zMin=FLT_MAX;
  xMax=yMax=zMax=-FLT_MAX;

  while(!feof(off)) {
    NextDataLine(off,line);
    rest=line;
    nvertex=ScanInt(&rest,0,&fail);
    nface=ScanInt(&rest,0,&fail);
    pointmap=(int *)calloc(nvertex,sizeof(int));
    for(i=0; i<nvertex; i++) {
      NextDataLine(off,line);
      rest=line;
      xv=ScanDouble(&rest,0.0,&fail);
      yv=ScanDouble(&rest,0.0,&fail);
      zv=ScanDouble(&rest,0.0,&fail);
      DXFUpdateBBox(xv,yv,zv);
      pointmap[i] = AddToPointPool(xv,yv,zv);
     }
    for(i=0; i<nface; i++) {
      NextDataLine(off,line);
      rest=line;
      npoly=ScanInt(&rest,0,&fail);
      for(j=0;j<npoly; j++) {
	     lbuffer[j]=ScanInt(&rest,0,&fail);
	     lbuffer[j]=pointmap[lbuffer[j]];
       }
      if(npoly)
	     Polygons=PrependLinePolyList(Polygons,Polygon3D,lbuffer,npoly,1.0,1.0,1.0);
     }
   }
  BoundP1.x=xMin; @+ BoundP1.y=yMin; @+ BoundP1.z=zMin;
  BoundP2.x=xMax; @+ BoundP2.y=yMax; @+ BoundP2.z=zMax;
  free(pointmap);
  @<Add light sources to the scene@>@;
  @<Add view point to the scene@>@;
  fclose(off);
  return 0;
}



@* \ML-Interface.

@ Templates.
@<Templates for \.{mprep}@>=
@=:Begin:@>@|
@=:Function: mvGetPoolSize  @>@|
@=:Pattern: MViewPoolSize[] @>@|
@=:Arguments: {}            @>@|
@=:ArgumentTypes: {}        @>@|
@=:ReturnType: Integer      @>@|
@=:End:@>@|

@ @<Usage for functions in the Global context@>=
@=:Evaluate:@>@|
@=  MViewPoolSize::usage="MViewPoolSize returns the pool size of mathview3d."@>@|

@ @<Templates for \.{mprep}@>+=
@=:Begin: @>@|
@=:Function: mvPutGraphics3D @>@|
@=:Pattern: MVPutGraphics3D[l_List] @>@|
@=:Arguments:{l}                    @>@|
@=:ArgumentTypes: {Manual}          @>@|
@=:ReturnType: Manual               @>@|
@=:End:@>@|

@ @<Usage for functions in the Global context@>+=
@=:Evaluate:MVPutGraphics3D::usage="MVPutGraphics3D[lst] is internal used."@>@|

@ @<Templates for \.{mprep}@>+=
@=:Begin: @>@|
@=:Function: mvClearContents @>@|
@=:Pattern: MVClear[]       @>@|
@=:Arguments: {}            @>@|
@=:ArgumentTypes: {}        @>@|
@=:ReturnType: Manual       @>@|
@=:End:@>@|

@ @<Usage for functions in the Global context@>+=
@=:Evaluate:MVClear::usage="MVClear[] clears the MathGL3d window."@>@|

@ @<Templates for \.{mprep}@>+=
@=:Begin: @>@|
@=:Function: mvReset @>@|
@=:Pattern: MVReset[]       @>@|
@=:Arguments: {}            @>@|
@=:ArgumentTypes: {}        @>@|
@=:ReturnType: Manual       @>@|
@=:End:@>@|

@ @<Usage for functions in the Global context@>+=
@=:Evaluate:MVReset::usage="MVReset[] reset the view parameter in the MathGL3d window."@>@|

@ @<Templates for \.{mprep}@>+=
@=:Begin:@>@|
@=:Function: mvShowWindow  @>@|
@=:Pattern: MVShowWindow[] @>@|
@=:Arguments: {}           @>@|
@=:ArgumentTypes: {}       @>@|
@=:ReturnType: Manual      @>@|
@=:End:@>@|

@ @<Usage for functions in the Global context@>+=
@=:Evaluate:MVShowWindow::usage=@>@|
@=   "MVShowWindow[] show the MathGL3d window if it was hidden."@>@|

@ @<Templates for \.{mprep}@>+=
@=:Begin:@>@|
@=:Function: mvHideWindow  @>@|
@=:Pattern: MVHideWindow[] @>@|
@=:Arguments: {}           @>@|
@=:ArgumentTypes: {}       @>@|
@=:ReturnType: Manual      @>@|
@=:End:@>@|

@ @<Usage for functions in the Global context@>=
@=:Evaluate:MVHideWindow::usage="MVHideWindow[] hides the MathGL3d window."@>@|

@ @<Templates for \.{mprep}@>+=
@=:Begin:@>@|
@=:Function: mvIconifyWindow  @>@|
@=:Pattern: MVIconifyWindow[] @>@|
@=:Arguments: {}           @>@|
@=:ArgumentTypes: {}       @>@|
@=:ReturnType: Manual      @>@|
@=:End:@>@|

@ @<Usage for functions in the Global context@>=
@=:Evaluate:MVIconifyWindow::usage="MVIconifyWindow[] iconifys the MathGL3d window."@>@|

@ @<Templates for \.{mprep}@>+=
@=:Begin:@>@|
@=:Function: mvPopWindow  @>@|
@=:Pattern: MVPopWindow[] @>@|
@=:Arguments: {}           @>@|
@=:ArgumentTypes: {}       @>@|
@=:ReturnType: Manual      @>@|
@=:End:@>@|

@ @<Usage for functions in the Global context@>+=
@=:Evaluate:MVPopWindow::usage=@>@|
@=   "MVPopWindow[] pops up the MathGL3d window."@>@|

@ @<Templates for \.{mprep}@>+=
@=:Begin:@>@|
@=:Function: mvPushWindow  @>@|
@=:Pattern: MVPushWindow[] @>@|
@=:Arguments: {}           @>@|
@=:ArgumentTypes: {}       @>@|
@=:ReturnType: Manual      @>@|
@=:End:@>@|

@ @<Usage for functions in the Global context@>+=
@=:Evaluate:MVPushWindow::usage=@>@|
@=   "MVPushWindow[] pushs the MathGL3d window down."@>@|


@ @<Templates for \.{mprep}@>+=
@=:Begin: @>@|
@=:Function: mvStopSpin @>@|
@=:Pattern: MVStopSpin[]       @>@|
@=:Arguments: {}            @>@|
@=:ArgumentTypes: {}        @>@|
@=:ReturnType: Manual       @>@|
@=:End:@>@|

@ @<Usage for functions in the Global context@>=
@:Evaluate:MVStopSpin::usage="MVStopSpin[] stops the spin animation of MathGL3d."@>@|

@ @<Templates for \.{mprep}@>+=
@=:Begin: @>@|
@=:Function: mvZoom             @>@|
@=:Pattern: MVZoom[zoom_Real]   @>@|
@=:Arguments: {zoom}            @>@|
@=:ArgumentTypes: {Real}        @>@|
@=:ReturnType: Manual           @>@|
@=:End:@>@|

@ @<Usage for functions in the Global context@>+=
@=:Evaluate:MVZoom::usage="MVZoom[value] zooms in (value<1) or out (value>1)."@>@|

@ @<Templates for \.{mprep}@>+=
@=:Begin: @>@|
@=:Function: mvSpin                                        @>@|
@=:Pattern: MVSpin[angle_Real,l_ /;                        @>@|
@=            VectorQ[l,Real==Head[#] &] && 3==Length[l]]  @>@|
@=:Arguments: {angle,l}                                    @>@|
@=:ArgumentTypes:{Real,RealList}                           @>@|
@=:ReturnType: Manual                                      @>@|
@=:End: @>

@ @<Templates for \.{mprep}@>+=
@=:Evaluate: MVSpin[angle_?NumericQ,{x_?NumericQ,y_NumericQ,z_NumericQ}]:= @>@|
@=             MVSpin[N[angle],N[{x,y,z}]] /. 0->0.0          @>@|

@ @<Usage for functions in the Global context@>+=
@=:Evaluate:MVSpin::usage="MVSpin[angle,axis] starts spinning of the object@>@|
@=  in the MathGL3d window around the axis {x,y,z} with angle increment angle."@>@|

@ @<Templates for \.{mprep}@>+=
@=:Begin: @>@|
@=:Function: mvReshape                                     @>@|
@=:Pattern: MVReshapeWindow[width_Integer,height_Integer]  @>@|
@=:Arguments: {width,height}                               @>@|
@=:ArgumentTypes:{Integer,Integer}                         @>@|
@=:ReturnType: Manual                                      @>@|
@=:End: @>

@ @<Usage for functions in the Global context@>+=
@=:Evaluate:MVReshapeWindow::usage="MVReshape[w,h] sets a new width w and height for @>@|
@=  the MathGL3d window."@>@|

@ @<Templates for \.{mprep}@>+=
@=:Begin: @>@|
@=:Function: mvSendBoundingBox                             @>@|
@=:Pattern: MVGetPlotRange[]                               @>@|
@=:Arguments: {}                                           @>@|
@=:ArgumentTypes:{}                                        @>@|
@=:ReturnType: Manual                                      @>@|
@=:End: @>

@ @<Usage for functions in the Global context@>+=
@=:Evaluate:MVGetPlotRange::usage="MVGetPlotRange[] returns the plot range used by MathGL3d."@>@|

@ @<Templates for \.{mprep}@>+=
@=:Begin: @>@|
@=:Function: mvSendViewPoint                               @>@|
@=:Pattern: MVGetViewPoint[]                               @>@|
@=:Arguments: {}                                           @>@|
@=:ArgumentTypes:{}                                        @>@|
@=:ReturnType: Manual                                      @>@|
@=:End: @>

@ @<Usage for functions in the Global context@>+=
@=:Evaluate:MVGetViewPoint::usage="MVGetViewPoint[] returns the view point used by MathGL3d."@>@|

@ @<Templates for \.{mprep}@>+=
@=:Begin: @>@|
@=:Function: mvSendLightSources        @>@|
@=:Pattern:   mvRawGetLightSources[]   @>@|
@=:Arguments: {}             @>@|
@=:ArgumentTypes:{}          @>@|
@=:ReturnType: Manual        @>@|
@=:End: @>

@ @<Usage for functions in the Global context@>+=
@=:Evaluate:mvRawGetLightSources::usage="mvRawGetLightSources[] is used internal by MathGL3d."@>@|

@ @<Templates for \.{mprep}@>+=
@=:Begin: @>@|
@=:Function: mlWritePOVray                        @>@|
@=:Pattern: mvRawWritePOVRay[fname_String,ptexpre_String,mtexpre_String] @>@|
@=:Arguments: {fname,ptexpre,mtexpre}             @>@|
@=:ArgumentTypes: {String,String,String}          @>@|
@=:ReturnType: Manual                             @>@|
@=:End:                                           @>@|

@ @<Usage for functions in the Global context@>+=
@=:Evaluate:mvRawWritePOVRay::usage="mvRawWritePOVRay[] is used internaly by MathGL3d."@>@|

@ @<Templates for \.{mprep}@>+=
@=:Begin: @>@|
@=:Function: mlWrite3DMF                        @>@|
@=:Pattern: mvWrite3DMF[fname_String,savelight_Integer,   @>@|
@=             saveview_Integer]                @>@|
@=:Arguments: {fname,savelight,saveview}        @>@|
@=:ArgumentTypes: {String,Integer,Integer}      @>@|
@=:ReturnType: Manual                           @>@|
@=:End:                                         @>@|

@ @<Usage for functions in the Global context@>+=
@=:Evaluate:mvWrite3DMF::usage="mvWrite3DMF[] is used internaly by MathGL3d."@>@|

@ @<Templates for \.{mprep}@>+=
@=:Begin:@>@|
@=:Function: mlWriteDXF                            @>@|
@=:Pattern: mvWriteDXF[fname_String,               @>@|
@=            ts_Real,tseg_Integer,psize_Real,tangle_Real]   @>@|
@=:Arguments: {fname,ts,tseg,psize,tangle}         @>@|
@=:ArgumentTypes: {String,Real,Integer,Real,Real}  @>@|
@=:ReturnType: Manual                              @>@|
@=:End:@>@|

@ @<Usage for functions in the Global context@>+=
@=:Evaluate:mvWriteDXF::usage="mvWriteDXF[] is used internaly by MathGL3d."@>@|

@ @<Templates for \.{mprep}@>+=
@=:Begin:@>@|
@=:Function: mlWritePostScript                     @>@|
@=:Pattern: mvWritePostScript[fname_String,wbitmap_Integer]  @>@|
@=:Arguments: {fname,wbitmap}                      @>@|
@=:ArgumentTypes: {String,Integer}                 @>@|
@=:ReturnType: Manual                              @>@|
@=:End:@>@|

@ @<Usage for functions in the Global context@>+=
@=:Evaluate:mvWritePostScript::usage=@>@|
@=  "mvWritePostScript[] is used internaly by MathGL3d."@>@|

@ @<Templates for \.{mprep}@>+=
@=:Begin:@>@|
@=:Function: mlRawWriteVRML                                @>@|
@=:Pattern: mvRawWriteVRML[fname_String,                   @>@|
@=   headl_Integer,useext_Integer,ptpre_String,mtpre_String]         @>@|
@=:Arguments: {fname,headl,useext,ptpre,mtpre}             @>@|
@=:ArgumentTypes: {String,Integer,Integer,String,String}   @>@|
@=:ReturnType: Manual                              @>@|
@=:End:@>@|

@ @<Usage for functions in the Global context@>+=
@=:Evaluate:mvRawWriteVRML::usage=@>@|
@=  "mvRawWriteVRML[] is used internaly by MathGL3d."@>@|

@ @<Templates for \.{mprep}@>+=
@=:Begin:@>@|
@=:Function: MLSendGraphics                        @>@|
@=:Pattern: MVGetGraphics3D[]                      @>@|
@=:Arguments: {}                                   @>@|
@=:ArgumentTypes: {}                               @>@|
@=:ReturnType: Manual                              @>@|
@=:End:@>@|

@ @<Usage for functions in the Global context@>+=
@=:Evaluate:MVGetGraphics3D::usage=@>@|
@=  "MVGetGraphics3D[] will return the graphics data from MathGL3d."@>@|

@ @<Templates for \.{mprep}@>+=
@=:Begin:@>@|
@=:Function: MLSendFrameBuffer                      @>@|
@=:Pattern: MVGetRasterImage[]                      @>@|
@=:Arguments: {}                                    @>@|
@=:ArgumentTypes: {}                                @>@|
@=:ReturnType: Manual                               @>@|
@=:End:@>@|

@ @<Usage for functions in the Global context@>+=
@=:Evaluate:MVGetRasterImage::usage=@>@|
@=  "MVGetRasterImage[] will return RasterArray[] image of the rendered scene."@>@|


@ @<Templates for \.{mprep}@>+=
@=:Begin:@>@|
@=:Function: MLPolygonReduce                        @>@|
@=:Pattern: mvPolygonReduce[tol_Real,iter_Integer]  @>@|
@=:Arguments: {tol,iter}                            @>@|
@=:ArgumentTypes: {Real,Integer}                    @>@|
@=:ReturnType: Integer                              @>@|
@=:End:@>@|

@ @<Usage for functions in the Global context@>+=
@=:Evaluate:mvPolygonReduce::usage=@>@|
@=  "mvPolygonReduce[tol,iter] will reduce the number of polygons in the scene."@>@|

@ @<Templates for \.{mprep}@>+=
@=:Begin:@>@|
@=:Function: MVLoad3Script                             @>@|
@=:Pattern: MVLoad3Script[fname_String]                @>@|
@=:Arguments: {fname}                              @>@|
@=:ArgumentTypes: {String}                         @>@|
@=:ReturnType: Manual                              @>@|
@=:End:@>@|

@ @<Usage for functions in the Global context@>+=
@=:Evaluate:MVLoad3Script::usage=@>@|
@=  "MVLoad3Script[tsfile] will read a ThreeScript file into the MathGL3d window."@>@|


@ @<Templates for \.{mprep}@>+=
@=:Begin:@>@|
@=:Function: MVLoadDXF                             @>@|
@=:Pattern: MVLoadDXF[fname_String]                @>@|
@=:Arguments: {fname}                              @>@|
@=:ArgumentTypes: {String}                         @>@|
@=:ReturnType: Manual                              @>@|
@=:End:@>@|

@ @<Usage for functions in the Global context@>+=
@=:Evaluate:MVLoadDXF::usage=@>@|
@=  "MVLoadDXF[dxffile] will read a DXF file into the MathGL3d window."@>@|

@ @<Templates for \.{mprep}@>+=
@=:Begin:@>@|
@=:Function: MVLoadOFF                             @>@|
@=:Pattern: MVLoadOFF[fname_String]                @>@|
@=:Arguments: {fname}                              @>@|
@=:ArgumentTypes: {String}                         @>@|
@=:ReturnType: Manual                              @>@|
@=:End:@>@|

@ @<Usage for functions in the Global context@>+=
@=:Evaluate:MVLoadOFF::usage=@>@|
@=  "MVLoadOFF[dxffile] will read a OFF file into the MathGL3d window."@>@|

@ @<Templates for \.{mprep}@>+=
@=:Begin:@>@|
@=:Function: mvWriteOFF                             @>@|
@=:Pattern: mvWriteOFF[fname_String]                @>@|
@=:Arguments: {fname}                              @>@|
@=:ArgumentTypes: {String}                         @>@|
@=:ReturnType: Manual                              @>@|
@=:End:@>@|

@ @<Usage for functions in the Global context@>+=
@=:Evaluate:mvWriteOFF::usage=@>@|
@=  "mvWriteOFF[dxffile] is used internal."@>@|

@ @<Templates for \.{mprep}@>+=
@=:Begin:@>@|
@=:Function: mlRawWritePNG                             @>@|
@=:Pattern: mvRawWritePNG[fname_String,gamma_Real,inter_Integer] @>@|
@=:Arguments: {fname,gamma,inter}                      @>@|
@=:ArgumentTypes: {String,Real,Integer}                @>@|
@=:ReturnType: Manual                                  @>@|
@=:End:@>@|

@ @<Usage for functions in the Global context@>+=
@=:Evaluate:mvRawWritePNG::usage=@>@|
@=  "mvRawWritePNG[pngfile,gm,interlace] is used internal."@>@|

@ @<Templates for \.{mprep}@>+=
@=:Begin:@>@|
@=:Function: mlRawWriteDepthBuffer                           @>@|
@=:Pattern: mvRawWriteDepthPNG[fname_String,fmt_Integer,     @>@|
@=            gamma_Real,inter_Integer,scale_Real]           @>@|
@=:Arguments: {fname,fmt,gamma,inter,scale}                  @>@|
@=:ArgumentTypes: {String,Integer,Real,Integer,Real}         @>@|
@=:ReturnType: Manual                                        @>@|
@=:End:@>@|

@ @<Usage for functions in the Global context@>+=
@=:Evaluate:mvRawWriteDepthPNG::usage=@>@|
@=   "mvRawWriteDepthPNG[pngfile,fmt,gm,interlace,scale] is used internal."@>@|

@ @<Templates for \.{mprep}@>+=
@=:Begin:@>@|
@=:Function: mlRawWriteSIRDS                               @>@|
@=:Pattern: mvRawWriteSIRDS[fname_String,                  @>@|
@=            dpiOut_Integer,trueWidth_Real,               @>@|
@=            eyeSeparation_Real,mu_Real,osample_Integer,scale_Real] @>@|
@=:Arguments: {fname,dpiOut,trueWidth,eyeSeparation,mu,osample,scale}@>@|
@=:ArgumentTypes: {String,Integer,Real,Real,Real,Integer,Real}       @>@|
@=:ReturnType: Manual                                      @>@|
@=:End:@>@|

@ @<Usage for functions in the Global context@>+=
@=:Evaluate:mvRawWriteSIRDS::usage=@>@|
@=  "mvRawWriteSIRDS[pngfile,dpi,twidth,eyes,mu] is used internal."@>@|

@ @<Templates for \.{mprep}@>+=
@=:Begin:@>@|
@=:Function: mlLoadPNGTexture                          @>@|
@=:Pattern: mvRawLoadPNGTexture[fname_String,gamma_Real]         @>@|
@=:Arguments: {fname,gamma}                            @>@|
@=:ArgumentTypes: {String,Real}                        @>@|
@=:ReturnType: Manual                                  @>@|
@=:End:@>@|

@ @<Usage for functions in the Global context@>+=
@=:Evaluate:mvRawLoadPNGTexture::usage=@>@|
@=  "mvRawLoadPNGTexture[pngfile,gm] is used internal."@>@|

@ @<Templates for \.{mprep}@>+=
@=:Begin:@>@|
@=:Function: mlGraphicsToTexture                       @>@|
@=:Pattern: mvRawPutMathTexture[clip_Integer,dispstr_String]     @>@|
@=:Arguments: {clip,dispstr}                           @>@|
@=:ArgumentTypes: {Integer,Manual}                     @>@|
@=:ReturnType: Manual                                  @>@|
@=:End:@>@|

@ @<Usage for functions in the Global context@>+=
@=:Evaluate:mvRawPutMathTexture::usage=@>@|
@=   "mvRawPutMathTexture[clip,displaystring] is used internal."@>@|

@ @<Templates for \.{mprep}@>+=
@=:Begin:@>@|
@=:Function: mlRasterToTexture                           @>@|
@=:Pattern: mvRawPutRasterTexture[                       @>@|
@=            bytec_Integer,w_Integer,h_Integer,data_]   @>@|
@=:Arguments: {bytec,w,h,data}                           @>@|
@=:ArgumentTypes: {Integer,Integer,Integer,RealList}     @>@|
@=:ReturnType: Manual                                    @>@|
@=:End:@>@|

@ @<Usage for functions in the Global context@>+=
@=:Evaluate:mvRawPutRasterTexture::usage=@>@|
@=  "mvRawPutRasterTexture[bc,w,h,l] is used internal."@>@|

@ @<Templates for \.{mprep}@>+=
@=:Begin: @>@|
@=:Function: mvSendTextureInfo                             @>@|
@=:Pattern: MVGetTextureInformation[]                      @>@|
@=:Arguments: {}                                           @>@|
@=:ArgumentTypes:{}                                        @>@|
@=:ReturnType: Manual                                      @>@|
@=:End: @>

@ @<Usage for functions in the Global context@>+=
@=:Evaluate:MVGetTextureInformation::usage=@>@|
@=  "MVGetTextureInformation[] returns the names and parameters\n@>@|
@= of the textures used by MathGL3d."@>@|

@ @<Templates for \.{mprep}@>+=
@=:Begin:@>@|
@=:Function: mlMapTexture                              @>@|
@=:Pattern: mvRawMapTexture[gid_Integer,texid_Integer, @>@|
@=            maptype_Integer,                         @>@|
@=            move_List /; 3==Length[move],            @>@|
@=            axis_List /; 3==Length[axis],            @>@|
@=            angle_Real,                              @>@|
@=            scale_List /; 3==Length[scale],          @>@|
@=            scaleU_Real,scaleV_Real                  @>@|
@=           ]                                         @>@|
@=:Arguments: {gid,texid,maptype,                      @>@|
@=   move,axis,angle,scale,scaleU,scaleV}              @>@|
@=:ArgumentTypes: {Integer,Integer,Integer,            @>@|
@=  RealList,RealList,Real,RealList,Real,Real}         @>@|
@=:ReturnType: Manual                                  @>@|
@=:End:@>@|

@ @<Usage for functions in the Global context@>+=
@=:Evaluate:mvRawMapTexture::usage=@>@|
@=  "mvRawMapTexture[gid,texid,maptype,t,rx,ra,s,su,sv] is used internal."@>@|

@ @<Templates for \.{mprep}@>+=
@=:Begin:@>@|
@=:Function: mvRotate3D                             @>@|
@=:Pattern: mvRotate3D[what_Integer,axis_?VectorQ,th_Real,cntr_?VectorQ,update_Integer] @>@|
@=:Arguments: {what,axis,th,cntr,update}                       @>@|
@=:ArgumentTypes: {Integer,RealList,Real,RealList,Integer}     @>@|
@=:ReturnType: Manual                                          @>@|
@=:End:@>@|

@ @<Templates for \.{mprep}@>+=
@=:Begin:@>@|
@=:Function: mvTranslate3D                          @>@|
@=:Pattern: mvTranslate3D[what_Integer,nx_Real,ny_Real,nz_Real,update_Integer]  @>@|
@=:Arguments: {what,nx,ny,nz,update}                     @>@|
@=:ArgumentTypes: {Integer,Real,Real,Real,Integer}          @>@|
@=:ReturnType: Manual                               @>@|
@=:End:@>@|

@ @<Usage for functions in the Global context@>+=
@=:Evaluate:mvRotate3D::usage=@>@|
@=  "mvRotate3D[] is used internal."@>@|

@ @<Templates for \.{mprep}@>=
@<Prepare \Math{} for interaction with \.{mathview3d}@>@;
@<Usage for functions in the Global context@>@;
@<Start the \.{MathView3D} package@>@;
@<Additional \Math-definitions@>@;
@<End the \.{MathView3D} package@>@;


@ @<Prepare \Math{} for interaction with \.{mathview3d}@>=
@=:Evaluate:@>@|
@=  StylePrint[StringJoin["MathGL3d installed, Version 2.2\\[NewLine]",@>@|
@=   "for ",$OperatingSystem," system ", $System,"\\[NewLine]",@>@|
@=   "\\[Copyright] by Jens-Peer Kuska 1997,98,99\\[NewLine]",@>@|
@=   "with MathLink from Wolfram Research."],"Text"];@>@|

@ Load the standard packages needed for writing 3Scripts.
@<Prepare \Math{} for interaction with \.{mathview3d}@>=
@=:Evaluate:Needs["Graphics`ThreeScript`"]@>@|

@ Since the 3Script package that comes with \Math{} does not support the
\.{SurfaceColor[]} primitive we add the definitions to write the
color directive inside a \.{SurfaceColor[]} primitive here.
The boundig box for \.{SurfaceGraphics[]} objects uses box ratios
as bounding box. We patch this also to get the true coordinate extensions.
At first let us switch to the private context of the 3Script package.

@<Prepare \Math{} for interaction with \.{mathview3d}@>+=
@=:Evaluate:Begin["Graphics`ThreeScript`Private`"]@>@|

@=:Evaluate:TS0[file_,SurfaceColor[g_RGBColor,___]]:=@>@|
@=  (WriteName[file,"surfacecolor"];@>@|
@=	 WriteTriple[file,Apply[List,g]])@>@|

@=:Evaluate:TS0[file_,SurfaceColor[g_GrayLevel,___]]:=@>@|
@=  (WriteName[file,"surfacecolor"];@>@|
@=	 WriteTriple[file,{g,g,g}])@>@|

@=:Evaluate:Clear[SurfaceBounding]@>@|

@=:Evaluate:SurfaceBounding[file_,@>@|
@=  g_List, { {xmin_,xmax_}, {ymin_,ymax_},{zmin_, zmax_}}] :=@>@|
@=  Block[{},@>@|
@=   WriteName[file, "boundingbox"] ;@>@|
@=   WriteTriple[file, {xmin, ymin, zmin}] ;@>@|
@=   WriteTriple[file, {xmax, ymax, zmax}]@>@|
@=  ]@>@|

@=:Evaluate:SurfaceBounding[file_, g_List, _Symbol] :=@>@|
@=        SurfaceBounding[file, g,PlotRange /. FullOptions[g]]@>@|


@=:Evaluate:End[]@>@|

@ Look if an \.{\$MVTexturePath} is defined.
@<Prepare \Math{} for interaction with \.{mathview3d}@>+=
@=:Evaluate:@>@|
@=  If[Head[$MVTexturePath]=!=List,@>@|
@=   $MVTexturePath={"."}@>@|
@=  ]@>@|
@=:Evaluate:@>@|
@=  $MVTexturePath::usage=@>@|
@=  "$MVTexturePath is the global list of texture directories."@>@|

@ At first we unprotect the \.{MathView3D} context to allow
  the redefinition of the functions if \.{mathview3d} is started
  a second time during one session.
@<Prepare \Math{} for interaction with \.{mathview3d}@>+=
@=:Evaluate:Unprotect["MathView3D`*"];@>@|

@ @<Start the \.{MathView3D} package@>=
@=:Evaluate:@>@|
@=   BeginPackage["MathView3D`",{"Utilities`FilterOptions`"}]@>@|

@<Usage for \Math\ functions and symbols@>@|

@=:Evaluate: Begin["`Private`"]@>@|
@=:Evaluate: SetAttributes[MVShow3D,ReadProtected]@>@|
@=:Evaluate: SetAttributes[MVWritePOVRay,ReadProtected]@>@|
@=:Evaluate: SetAttributes[MVWriteDXF,ReadProtected]@>@|
@=:Evaluate: SetAttributes[MVClose,ReadProtected]@>@|
@=:Evaluate: SetAttributes[MVCreatePalette,ReadProtected]@>@|
@=:Evaluate: SetAttributes[MVWriteEPS,ReadProtected]@>@|
@=:Evaluate: SetAttributes[MVWritePNG,ReadProtected]@>@|
@=:Evaluate: SetAttributes[MVWrite3DMF,ReadProtected]@>@|
@=:Evaluate: SetAttributes[MVWriteVRML,ReadProtected]@>@|
@=:Evaluate: SetAttributes[MVPolygonReduce,ReadProtected]@>@|
@=:Evaluate: SetAttributes[MVPutTexture,ReadProtected]@>@|
@=:Evaluate: SetAttributes[MVApplyTexture,ReadProtected]@>@|


@ @<End the \.{MathView3D} package@>=
@=:Evaluate: End[] (* Private *)@>@|

@=:Evaluate: EndPackage[]@>@|
@=:Evaluate: Protect["MathView3D`*"]@>@|

@ The function to close the link is a pure \Math-function.
@<Additional \Math-definitions@>=
@=:Evaluate:MVClose[]:= Uninstall /@@@>@|
@=  Select[Links[],StringMatchQ[First[#],"*mathview3d*"] &]@>@|

@ @<Usage for \Math\ functions and symbols@>=
@=:Evaluate: MVClose::usage="MVClose[] will uninstall the MathGL3d program."@>@|

@* {\tt MeshGraphics3D}.
  We introduce the \.{MeshGraphics3D[]} object. It us used to represent
  surfaces with points on rectangular meshes. This graphics type is created
  to use a faster drawing in OpenGL and to get a natural parametrisation
  of surfaces for texture mapping.

@ @<Usage for \Math\ functions and symbols@>=
@=:Evaluate:MeshGraphics3D::usage="MeshGraphics3D[] is a new graphics object,@>@|
@=  repesenting a rectangular mesh of points."@>@|

@  Print omly a short version of the new graphics object.
@<Additional \Math-definitions@>=
@=:Evaluate:Format[_MeshGraphics3D]:="-MeshGraphics3D-"@>@|

@ When we make the mesh for \Math{} we must take care of the
proper orientation of the polygons. We use counter clockwise order.
@<Additional \Math-definitions@>=
@=:Evaluate:makeMesh[vl_List,col_List]:=@>@|
@=   Module[{l = vl, l1 = Map[RotateLeft, vl], mesh},@>@|
@=     mesh = {l, l1, RotateLeft[l1], RotateLeft[l]};@>@|
@=     mesh = Map[Drop[#, -1]&, mesh, {1}];@>@|
@=     mesh = Map[Drop[#, -1]&, mesh, {2}];@>@|
@=     mesh=Map[@>@|
@=           Polygon[Reverse[#]] &,@>@|
@=             Transpose[@>@|
@=               Flatten[#,1] & /@@@>@|
@=                mesh@>@|
@=              ]@>@|
@=          ] //Flatten;@>@|
@=     If[col==={}, Return[mesh]];@>@|
@=     If[(Drop[Dimensions[vl],-1]-{1,1})==Dimensions[col],@>@|
@=       Transpose[{Flatten[col],mesh}]@>@|
@=      ]@>@|
@=    ]@>@|

@ Define the transformations for display the \.{MeshGraphics3D}-object inside
\Math{}. The \.{MeshGraphics3D}-object is repeated after a \.{Show[]} and
\.{Display[]} command to preserve the graphics type.
@<Additional \Math-definitions@>=
@=:Evaluate:MeshGraphics3D /:@>@|
@=   Graphics3D[MeshGraphics3D[n_,m_,data_,color_,{opts___}]]:=@>@|
@=     Graphics3D[makeMesh[data,color],{FilterOptions[Graphics3D,opts]}]@>@|
@=:Evaluate:MeshGraphics3D /:@>@|
@=   Show[m_MeshGraphics3D,opts___?OptionQ]:=(Show[Graphics3D[m],opts];m)@>@|
@=:Evaluate:Unprotect[Show];@>@|
@=:Evaluate:Show[a___,m_MeshGraphics3D,b___]:=@>@|
@=    Show[a,Graphics3D[m],b]@>@|
@=:Evaluate:Protect[Show];@>@|
@=:Evaluate:MeshGraphics3D /:@>@|
@=   Display[file_,m_MeshGraphics3D,args___]:=@>@|
@=     (Display[file,Graphics3D[m],args];m)@>@|
@=:Evaluate:MeshGraphics3D /:@>@|
@=   DisplayString[m_MeshGraphics3D,args___]:=@>@|
@=     (DisplayString[Graphics3D[m],args];m)@>@|

@=:Evaluate: Unprotect[PlotRange]@>@|

@=:Evaluate:@>@|
@=  PlotRange[MeshGraphics3D[arg__]]:=PlotRange /. Last[{arg}]@>@|

@=:Evaluate:@>@|
@=  PlotRange[ms:{_MeshGraphics3D..}]:=@>@|
@=    {Min[First[#]], Max[Last[#]]} & /@@@>@|
@=      Transpose /@@ Transpose[PlotRange /@@ ms]@>@|

@=:Evaluate: Protect[PlotRange]@>@|

@=:Evaluate:@>@|
@=  MeshGraphics3D /: FullOptions[MeshGraphics3D[arg__]]:=@>@|
@=    Module[{opt},@>@|
@=      opt=Last[{arg}];@>@|
@=      Join[@>@|
@=        opt,@>@|
@=        Select[@>@|
@=          Options[Graphics3D],@>@|
@=          FreeQ[opt,First[#]] &@>@|
@=         ]@>@|
@=       ]@>@|
@=     ]@>@|

@ The \.{ParametricPlot3D[]} function is overwritten to produce the new
\.{MeshGraphics3D} object.
@<Additional \Math-definitions@>=
@=:Evaluate:makePlotPoints[plotp_]:=		@>@|
@=   Switch[plotp,                  		@>@|
@=     Automatic, {15,15},          		@>@|
@=     _Integer, {plotp, plotp},    		@>@|
@=    {_Integer,_Integer}, plotp,   		@>@|
@=    _, {15,15}                    		@>@|
@=   ]                              		@>@|
@=:Evaluate:addDefault[fromFun_,optName_,opt_List]:=@>@|
@=   Module[{val},@>@|
@=     If[FreeQ[First /@@ opt,optName], (* Then *)@>@|
@=       val=optName /. Options[fromFun];@>@|
@=       Append[opt,optName->val], (* Else *)@>@|
@=       opt@>@|
@=      ]@>@|
@=    ]@>@|
@=:Evaluate:protected=Unprotect[ParametricPlot3D];@>@|

@ This rule is to evaluate several three dimensional functions
by a single \.{ParametricPlot3D} call. Since the combination
will be in general not a single mesh now a list of \.{MeshGraphic3D}
objects is returned.

@<Additional \Math-definitions@>=
@=:Evaluate:ParametricPlot3D[f:{{_,_,__}..},@>@|
@=            ur:{u_,u0_,u1_},vr:{v_,v0_,v1_},opts___]:=@>@|
@=     Module[{gr,ds},@>@|
@=       ds=DisplayFunction /. {opts} /. Options[ParametricPlot3D];@>@|
@=       gr=ParametricPlot3D[@>@|
@=            #,ur,vr,DisplayFunction->Identity,opts] &/@@ f;@>@|
@=       Show[@>@|
@=         Graphics3D[#,FilterOptions[Graphics3D,opts]] & /@@ gr,@>@|
@=         DisplayFunction->ds@>@|
@=        ];@>@|
@=       gr@>@|
@=      ]@>@|

@ Here is the new definition of the parametric plot.
@<Additional \Math-definitions@>=
@=:Evaluate:								@>@|
@=   ParametricPlot3D[f:{_,_,__}/; !MatrixQ[f],ur:{u_,u0_,u1_},vr:{v_,v0_,v1_},opts___]:=@>@|
@=     Module[{pltpoints,ff,colorf,cfun,i,j,comp,@>@|
@=             nu,nv,du,dv,data,cdata,prange,options={opts},mgraph},@>@|
@=       pltpoints=PlotPoints /. {opts} /. Options[ParametricPlot3D];@>@|
@=       {nu,nv}=makePlotPoints[pltpoints];@>@|
@=       If[Length[f]==3,(* Then no colors *)@>@|
@=         ff=f;@>@|
@=         colorf={},(* Else split the colors *)@>@|
@=         ff=Drop[f,-1];@>@|
@=         colorf=Last[f]@>@|
@=        ];@>@|
@=       comp=Compiled /. {opts} /. Options[ParametricPlot3D];@>@|
@=       If[comp,@>@|
@=         cfun=Compile[@>@|
@=                {{u,_Real},{v,_Real}},@>@|
@=                  Evaluate[N[ff]]],@>@|
@=         cfun=Function[{u,v},Evaluate[ff]]@>@|
@=        ];@>@|
@=	      du=(u1-u0)/(nu-1);@>@|
@=	      dv=(v1-v0)/(nv-1);@>@|
@=       Off[CompiledFunction::ccr];@>@|
@=       Off[CompiledFunction::cfex];@>@|
@=       data=Table[cfun[N[u],N[v]],@>@|
@=              {u,u0,u1+10*$MachineEpsilon,du},@>@|
@=              {v,v0,v1+10*$MachineEpsilon,dv}];@>@|
@=       data=data /. a_Complex :> Abs[a];@>@|
@=       On[CompiledFunction::ccr];@>@|
@=       On[CompiledFunction::cfex];@>@|
@=       If[colorf=!={},@>@|
@=         colorf=Function[{u,v},Evaluate[colorf]];@>@|
@=         cdata=N[Table[@>@|
@=                 colorf[N[u],N[v]],@>@|
@=                 {u,u0+du/2,u1,du},{v,v0+dv/2,v1,dv}]],@>@|
@=         cdata={}@>@|
@=        ];@>@|
@=       prange={Min[Chop[#]],Max[Chop[#]]} & /@@@>@|
@=          Transpose[Flatten[data,1]];@>@|
@=       PrependTo[options,PlotRange->prange];@>@|
@=       options=addDefault[ParametricPlot3D,ViewPoint,options];@>@|
@=       options=addDefault[ParametricPlot3D,ViewVertical,options];@>@|
@=       options=addDefault[ParametricPlot3D,ViewCenter,options];@>@|
@=       options=addDefault[ParametricPlot3D,LightSources,options];@>@|
@=       options=addDefault[ParametricPlot3D,AmbientLight,options];@>@|
@=         mgraph=MeshGraphics3D[@>@|
@=           Sequence @@@@ Drop[Dimensions[#],-1],@>@|
@=           #,cdata,options@>@|
@=          ] &[data];@>@|
@=       Show[mgraph]@>@|
@=      ]@>@|
@=:Evaluate:Protect /@@ protected;@>@|

@ The \.{SurfaceGraphics} objects are converted to \.{MeshGraphics3D} objects.
We add the $x$ and $y$ coordinates of the points to
the data of the mesh in \.{SurfaceGraphics} and make a proper \.{PlotRange}.
@<Additional \Math-definitions@>=
@=:Evaluate:surfToMesh[s_SurfaceGraphics]:=@>@|
@=   Module[{mesh=Transpose[First[s]],sopt=Last[s],@>@|
@=           u0,u1,v0,v1,nu,nv,mr,@>@|
@=           du,dv,meshopt,prange},@>@|
@=     mr=MeshRange /. sopt;@>@|
@=     If[Automatic===mr,  (* Then *)@>@|
@=       {{u0,u1},{v0,v1}}= {1,#} & /@@ Dimensions[mesh],@>@|
@=     (* Else *)@>@|
@=       {{u0,u1},{v0,v1}}=MeshRange /. sopt@>@|
@=      ];@>@|
@=     {nu,nv}=Dimensions[mesh];@>@|
@=     du=(u1-u0)/(nu-1);@>@|
@=     dv=(v1-v0)/(nv-1);@>@|
@=     mesh=MapIndexed[Append[{u0,v0}+(#2-{1,1})*{du,dv},#1] &,mesh,{2}];@>@|
@=     meshopt=sopt;    (* add the default PlotRange *)@>@|
@=     If[FreeQ[meshopt,BoxRatios], @>@|
@=       AppendTo[meshopt,BoxRatios->{1,1,1}],@>@|
@=       meshopt=meshopt /. Rule[BoxRatios,_] :> (BoxRatios->{1,1,1});@>@|         
@=       ];@>@|
@=     If[MemberQ[{Automatic,All},(PlotRange /. meshopt)],@>@|
@=       prange=Transpose[@>@|
@=                {{u0,v0,Min[#]},{u1,v1,Max[#]}} &[Flatten[First[s]]]@>@|
@=               ];@>@|
@=       meshopt=meshopt /. Rule[PlotRange,_]:>Rule[PlotRange,prange]@>@|
@=      ];@>@|
@=     If[MatchQ[s,SurfaceGraphics[_List,_List]],@>@|
@=       MeshGraphics3D[nu,nv,mesh,{},meshopt],@>@|
@=       MeshGraphics3D[nu,nv,mesh,Transpose[s[[2]]],meshopt]@>@|
@=      ]@>@|
@=    ]@>@|

@ The output file placement of the \ML{} binary is nearly unpredictable.
When we run the MathGL3d from the FrontEnd we will use the directory of the
notebook otherwise the current working directory. The \.{MakeSaveFilename[]}
function will append the directory if the filename starts with a backquote.
@<Additional \Math-definitions@>+=
@=:Evaluate:GetNotebookDirectory[] :=@>@|
@=  If[$Notebooks,@>@|
@=    GetNotebookDirectory[EvaluationNotebook[]],@>@|    
@=    Directory[] <> $PathnameSeparator@>@|
@=   ]@>@|

@=:Evaluate:GetNotebookDirectory[nb_NotebookObject] /; $Notebooks := @>@|
@=  Module[{fname},@>@|
@=    fname = "FileName" /. @>@|
@=            NotebookInformation[nb] /. @>@|   
@=            FrontEnd`FileName[dir_, ___] :>  @>@|
@=              ToFileName[ dir];  @>@|
@=    If["FileName" == fname, @>@|
@=      fname = Directory[] <> $PathnameSeparator @>@|
@=     ];@>@|
@=    fname @>@|
@=   ]@>@|

@=:Evaluate:MakeSaveFilename[str_String] := @>@| 
@=  If[StringMatchQ[str, "`*"], @>@|
@=    GetNotebookDirectory[] <> StringDrop[str, 1], @>@|
@=    str  @>@|
@=   ]@>@|
@ Convert \.{Hue[]} to Red, Green, Blue triples. This is due to
Foley, van Dam, Feiner and Hughes. ``Computer Graphics: Principles and
Practice'' Second Edition.
@<Additional \Math-definitions@>+=
@=:Evaluate:@>@|
@=   hueToRGB[h_?NumericQ,0,b_:1] /; h<0.0 :=RGBColor[b,b,b]@>@|

@=:Evaluate:@>@|
@=   hueToRGB[h_?NumericQ,s_:1,v_:1]:=@>@|
@=	Module[{hh,i,f,p,q,t},@>@|
@=	  hh=Mod[h,1.0];@>@|
@=	  If[hh<0.0, hh+=1.0];@>@|
@=        hh*=6.0;@>@|
@=        i=Floor[hh];@>@|
@=        f=hh-i;@>@|
@=        p=v*(1.0-s);@>@|
@=        q=v*(1.0-s*f);@>@|
@=        t=v*(1.0-s*(1.0-f));@>@|
@=        Switch[i,@>@|
@=	    0, RGBColor[v,t,p],@>@|
@=	    1, RGBColor[q,v,p],@>@|
@=	    2, RGBColor[p,v,t],@>@|
@=	    3, RGBColor[p,q,v],@>@|
@=	    4, RGBColor[t,p,v],@>@|
@=	    5, RGBColor[v,p,q],@>@|
@=          _, RGBColor[0,0,0]@>@|
@=	   ]@>@|
@=	 ]@>@|

@ Prepare the colors in a \.{MeshGraphics3D} for the transfer.
@<Additional \Math-definitions@>+=
@=:Evaluate: prepMeshColors[{}]:={0,0,{}}@>@|
@=:Evaluate:@>@|
@=   prepMeshColors[l_] /;@>@|
@=        MatrixQ[@>@|
@=          l,@>@|
@=          MemberQ[@>@|
@=            {SurfaceColor,RGBColor,Hue,GrayLevel},@>@|
@=            Head[#]@>@|
@=           ] &]:=@>@|
@=     Module[{trans=Dimensions[l],carr},@>@|
@=       carr=l /. SurfaceColor[c_,___]:> c;@>@|
@=       carr=carr /.@>@|
@=         {Hue[a__]:>hueToRGB[a],@>@|
@=          GrayLevel[a_]:>RGBColor[a,a,a]};@>@|
@=       AppendTo[@>@|
@=         trans,@>@|
@=         Flatten[carr /. RGBColor ->List]@>@|
@=      ]@>@|
@=     ]@>@|

@* Texture mapping.
@ The \.{DisplayString[]} function allow no options like \.{ImageSize}.
It uses the options in the graphic object and the rules for the desired
texture size must be replaced in the optional option list of the
graphics.

@<Additional \Math-definitions@>+=
@=:Evaluate:@>@|
@=  addReplaceOption[Graphics[data_],option_,newval_]:=@>@|
@=    Graphics[data,{option->newval}]@>@|
@=:Evaluate:@>@|
@=  addReplaceOption[Graphics[data_,opts__],option_,newval_] /;@>@|
@=      MemberQ[First /@@ {opts},option]:=@>@|
@=    Graphics[data,(opts /. (option -> _) :> (option->newval))]@>@|
@=:Evaluate:@>@|
@=  addReplaceOption[Graphics[data_,opts__],option_,newval_]:=@>@|
@=    Graphics[data,Append[opts,option->newval]]@>@|


@ Clear the connection between \Math{} and the OpenGL viewer.
It was original a bug that puts unwanted \.{Null} symbols in the
link. The code is keept due to its interesting solution.
@<Additional \Math-definitions@>+=
@=:Evaluate:@>@|
@=  cleanMVLink[]:=@>@|
@=    Module[{getlnk},@>@|
@=      getlnk=Part[@>@|
@=               ToExpression[@>@|
@=                 ToString[@>@|
@=	             Definition[Global`MViewPoolSize],@>@|
@=                   InputForm@>@|
@=                  ],@>@|
@=                 InputForm,@>@|
@=                 Hold@>@|
@=                ],@>@|
@=               1,2,1@>@|
@=              ];@>@|
@=      If[LinkReadyQ[getlnk],LinkRead[getlnk]]@>@|
@=     ]@>@|

@ The data of the texture are transfered by \.{MVPutTexture}.
Possible textures are PNG file names, any \Math{} graphics as well
as \.{RasterArray[]}. Every data type calls its own \CEE/-function
in the \ML{} program. The \.{MVDispalyGamma} option is only used by
PNG files and the \.{MVTextureSize} is only used by \Math{} graphics
objects to convert them to a bitmap. The default texture size is
$64\times64$. This size is supported by all OpenGL implementations.

@<Additional \Math-definitions@>+=
@=:Evaluate:Options[MVPutTexture]={@>@|
@=  MVDisplayGamma->1,@>@|
@=  MVTextureSize->Automatic,@>@|
@=  MVClipBorderColor->True};@>@|

@=:Evaluate:@>@|
@=  makeTextureSize[size_]:=@>@|
@=    Switch[size,@>@|
@=      Automatic, {64,64},@>@|
@=      _Integer, {size,size},@>@|
@=      {_Integer,_Integer}, size,@>@|
@=      _,  {32,32}@>@|
@=     ]@>@|

@=:Evaluate:MVPutTexture::noreal="MVDisplayGamma must evaluate to a real number.";@>@|

@ Load a file PNG file.
@<Additional \Math-definitions@>+=
@=:Evaluate:@>@|
@=  MVPutTexture[pngfile_String,opts___?OptionQ]:=@>@|
@=    Module[{texfile=pngfile,gamma},@>@|
@=      If[StrinMatchQ[pngfile,"*`"] || StringMatchQ[pngfile,"`*"],@>@|
@=        texfile=ExpandTextureFileName[pngfile],@>@|
@=        texfile=pngfile@>@|
@=       ];@>@|
@=      gamma=N[MVDisplayGamma /. {opts} /. Options[MVPutTexture]];@>@|
@=      If[!NumberQ[gamma],@>@|
@=        Message[MVPutTexture::noreal];@>@|
@=        gamma=1.0;@>@|
@=       ];@>@|
@=      Global`mvRawLoadPNGTexture[texfile,gamma]@>@|
@=     ]@>@|

@ An ordinary 2d graphics is converted into a portable bitmap.
The result is send as a string to MathGL3d and the OpenGL viewer will
encode the image data from this string.
@<Additional \Math-definitions@>+=
@=:Evaluate:If[$VersionNumber>3,(* Then *)@>@|
@=  makeBitmapString[gr_,tsize_]:=@>@|
@=    ExportString[gr,"PBM",ImageSize->tsize],(* Else *)@>@|
@=  makeBitmapString[gr_,tsize_]:=@>@|
@=    DisplayString[gr,"PBM",ImageSize->tsize]@>@|
@= ]@>@| 

@=:Evaluate:@>@|
@=  MVPutTexture[gr_Graphics,opts___?OptionQ]:=@>@|
@=    Module[{tsize,dstr,ggr,clip},@>@|
@=      tsize=MVTextureSize /. {opts} /. Options[MVPutTexture];@>@|
@=      tsize=makeTextureSize[tsize];@>@|
@=      clip=MVClipBorderColor /. {opts} /. Options[MVPutTexture];@>@|
@=      If[TrueQ[clip], clip=1, clip=0];@>@|
@=      ggr=addReplaceOption[@>@|
@=               addReplaceOption[gr,ImageSize,tsize],@>@|
@=               AspectRatio,@>@|
@=               tsize[[2]]/tsize[[1]]@>@|
@=              ];@>@|
@=     dstr=makeBitmapString[ggr,tsize];@>@|
@=     Global`mvRawPutMathTexture[clip,dstr]@>@|
@=    ]@>@|

@ Convert all other graphics to 2d graphics.
@<Additional \Math-definitions@>+=
@=:Evaluate:@>@|
@=  MVPutTexture[@>@|
@=    gr:(_DensityGraphics|_ContourGraphics|_SurfaceGraphics |_Graphics3D),@>@|
@=    opts___?OptionQ@>@|
@=   ]:=MVPutTexture[Graphics[gr],opts]@>@|

@=:Evaluate:@>@|
@=  MVPutTexture[gr_MeshGraphics3D,opts___?OptionQ]:=@>@|
@=    MVPutTexture[Graphics[Graphics3D[gr]],opts]@>@|

@ Send gray level arrays.
@<Additional \Math-definitions@>+=
@=:Evaluate:@>@|
@=  MVPutTexture[ra:{{GrayLevel[_]..}..},opts___]:=@>@|
@=    Global`mvRawPutRasterTexture[@>@|
@=      1,@>@|
@=      Sequence @@@@(Reverse[Dimensions[ra]]),@>@|
@=      N[Flatten[ra /. GrayLevel -> List]] /. 0-> 0.0@>@|
@=     ]@>@|

@ Send RGB arrays.
@<Additional \Math-definitions@>+=
@=:Evaluate:@>@|
@=  MVPutTexture[ra:{{RGBColor[__]..}..},opts___]:=@>@|
@=    Global`mvRawPutRasterTexture[@>@|
@=      3,@>@|
@=      Sequence @@@@(Reverse[Dimensions[ra]]),@>@|
@=      N[Flatten[ra /. RGBColor -> List]] /. 0->0.0@>@|
@=     ]@>@|

@ Send Hue arrays as RGB.
@<Additional \Math-definitions@>+=
@=:Evaluate:@>@|
@=  MVPutTexture[ra:{{Hue[__]..}..},opts___]:=@>@|
@=    Global`mvRawPutRasterTexture[@>@|
@=      3,@>@|
@=      Sequence @@@@(Reverse[Dimensions[ra]]),@>@|
@=      N[Flatten[ra /.@>@|
@=        Hue[a__]:> List @@@@ hueToRGB[a]]] /. 0->0.0@>@|
@=     ]@>@|

@ The rule to remove the \.{RasterArray}
and to convert the hue colors to RGB. We must be carefull to take
the optional rectangle coordinates of \.{RasterArray} into account.
@<Additional \Math-definitions@>+=
@=:Evaluate:@>@|
@=  MVPutTexture[RasterArray[ra_,___],opts___]:=@>@|
@=    MVPutTexture[ra /. Hue[a__]:> hueToRGB[a],opts]@>@|

@  @<Usage for \Math\ functions and symbols@>+=
@=:Evaluate:@>@|
@=  MVPutTexture::usage=@>@|
@=  "MVPutTexture[tex, opt...] will load a texture into MathGL3d.\n@>@|
@= Possible textures are PNG files, Mathematica graphics and RasterArrays.\n@>@|
@= The MVTextureSize option works only for Mathematica graphics textures\n@>@|
@= and the MVDisplayGamma option only for PNG files. The MVClipBorderColor@>@|
@= option works only for Mathematica graphics."@>@|

@=:Evaluate:@>@|
@=  MVTextureSize::usage=@>@|
@=  "MVTextureSize is an option for MVPutTexture when a Mathematica graphics@>@|
@= is send to MathGL3d. The texture size is scaled inside the OpenGL viewer@>@|
@= if the texture width and height are not powers of 2. The default size is@>@|
@= 64 x 64."@>@|

@=:Evaluate:@>@|
@=  MVClipBorderColor::usage=@>@|
@=  "MVClipBorderColor is an option for MVPutTexture when a Mathematica graphics@>@|
@= is send to MathGL3d. The Display[] and DisplayString[] functions add a small@>@|
@= border of 2-3 pixels to the graphics this option is used to remove this border.@>@|
@= The default setting is True."@>@|

@ The main function for texture mapping is \.{MVApplyTexture} it will
look for the \.{MVTexture} option, send the texture to the viewer and it
will manage the mapping of the texture to the scene of polygons or to a
mesh.

@<Additional \Math-definitions@>+=
@=:Evaluate:@>@|
@= Options[MVApplyTexture]={@>@|
@=  MVTexture->None,@>@|
@=  MVTextureMapType->MVPlaneMapping,@>@|
@=  MVTranslateTextureTarget->Automatic,@>@|
@=  MVRotateTextureTarget->Automatic,@>@|
@=  MVScaleTextureTarget->Automatic,@>@|
@=  MVScaleTexture->Automatic@>@|
@= };@>@|
@=:Evaluate:@>@|
@= MVApplyTexture::nodeftex=@>@|
@=  "Texture `1` is not defined inside of MathGL3d.";@>@|
@=:Evaluate:@>@|
@= MVApplyTexture::invalidtex=@>@|
@=  "MVTexture must be a PNG file, a graphic object or a RasterArray.";@>@|
@=:Evaluate:@>@|
@= MVApplyTexture::notex=@>@|
@=  "Can't define the texture in MathGL3d.";@>@|
@=:Evaluate:@>@|
@= MVApplyTexture::unknowmap=@>@|
@=  "MVTextureMapType must be one of `1`, use MVPlaneMapping.";@>@|
@=:Evaluate:@>@|
@= MVApplyTexture::invmove=@>@|
@=  "MVTranslateTextureTarget must be a list of 3 numbers.";@>@|
@=:Evaluate:@>@|
@= MVApplyTexture::invrot=@>@|
@=  "MVRotateTextureTarget must be a list of a vector and an angle.";@>@|
@=:Evaluate:@>@|
@= MVApplyTexture::invscale=@>@|
@=  "MVScaleTextureTarget must be a list of 3 numbers > 0.";@>@|
@=:Evaluate:@>@|
@= MVApplyTexture::invtscale=@>@|
@=  "MVScaleTexture must be a list of two numbers >0.";@>@|

@ All possible graphics types.
@<Additional \Math-definitions@>+=
@=:Evaluate:@>@|
@= allgraph={@>@|
@=   Graphics,ContourGraphics,@>@|
@=   DensityGraphics,Graphics3D,@>@|
@=   SurfaceGraphics,MeshGraphics3D,@>@|
@=   RasterArray};@>@|

@ Rules to extract the target identification number. The OpenGL viewer will uses
integers instead of the complicated mesh,scene and texture identifyers.
Here are the rules for silent replacement of the \Math{} names by numbers.
@<Additional \Math-definitions@>+=
@=:Evaluate:@>@|
@= MVApplyTexture[Global`MVScene3D[],args___]:=MVApplyTexture[0,args]@>@|
@=:Evaluate:@>@|
@= MVApplyTexture[Global`MVMesh3D[i_Integer],args___]:=MVApplyTexture[i,args]@>@|
@=:Evaluate:@>@|
@= MVApplyTexture[target_Integer,MVTexture2D[texid_Integer],opts___?OptionQ]:=@>@|
@=   MVApplyTexture[target,texid,opts]@>@|

@ \.{MVApplyTexture} will do two things. It looks for a texture argument
and transfer this texture to MathGL3d. When the texture is accepted
by MathGL the target and the texture are connected by the transfer of the
mapping parameter.
@<Additional \Math-definitions@>+=
@=:Evaluate:@>@|
@= MVApplyTexture[target_Integer,opts__?OptionQ]:=@>@|
@=   Module[{tex,texid,lst},@>@|
@=     tex=MVTexture /. {opts} /. Options[MVApplyTexture];@>@|
@=     If[tex===None,Return[]];@>@|
@=     If[Head[tex]===Global`MVTexture2D,@>@|
@=       tlst=First /@@ MVGetTextureInformation[];@>@|
@=       If[MemberQ[tlst,tex],@>@|
@=         Message[MVApplyTexture::nodeftex,tex];@>@|
@=         Return[];@>@|
@=        ];@>@|
@=       MVApplyTexture[target,First[tex],opts]@>@|
@=      ]@>@|
@=     If[!StringQ[tex] && !MemberQ[allgraph,Head[tex]],@>@|
@=       Message[MVApplyTexture::invalidtex];@>@|
@=       Return[];@>@|
@=      ];@>@|
@=     cleanMVLink[];@>@|
@=     tex=MVPutTexture[tex,FilterOptions[MVPutTexture,opts]];@>@|
@=     If[tex===$Failed,@>@|
@=       Message[MVApplyTexture::notex];@>@|
@=       Return[];@>@|
@=      ];@>@|
@=     texid=First[First[tex]];@>@|
@=       (* get the texture number from {MVTexture2D[id],..} *)@>@|
@=     MVApplyTexture[target,texid,opts]@>@|
@=    ]@>@|

@ If we come here a texture is copyed to \Math{} and we
can pass the parameters to map the texture to the three dimensional
mesh or scene.
@<Additional \Math-definitions@>+=
@=:Evaluate:@>@|
@= MVApplyTexture[target_Integer,texid_Integer,opts___?OptionQ]:=@>@|
@=  Module[{prange,maptype,move,rot,alpha,scale,scaletex},@>@|
@=    maptype=MVTextureMapType /. {opts} /. Options[MVApplyTexture];@>@|
@=    maptype=maptype /. textureMapToInt;@>@|
@=    If[!IntegerQ[maptype],@>@|
@=      Message[MVApplyTexture::unknowmap,@>@|
@=        First /@@ textureMapToInt];@>@|
@=      maptype=If[0==target,2 (* plane *),128 (* mesh *)];@>@|
@=     ];@>@|
@=    move=N[MVTranslateTextureTarget /. {opts} /.Options[MVApplyTexture]] /. 0->0.0;@>@|
@=    rot=N[MVRotateTextureTarget /. {opts} /.Options[MVApplyTexture]] /. 0->0.0;@>@|
@=    scale=N[MVScaleTextureTarget /. {opts} /.Options[MVApplyTexture]] /. 0->0.0;@>@|
@=    scaletex=N[MVScaleTexture /. {opts} /.Options[MVApplyTexture]] /. 0->0.0;@>@|
@=    prange=Global`MVGetPlotRange[];@>@|
@=    If[Automatic===move,move=0.5*(Plus @@@@ prange)];@>@|
@=    If[Automatic===rot,rot={{0.,0.,1.0},0.0}];@>@|
@=    If[Automatic===scale,@>@|
@=      scale= If[#!=0.0,1./#,#] & /@@ (prange[[2]]-prange[[1]])@>@|
@=     ];@>@|
@=    If[Automatic===scaletex,scaletex={1.0,1.0}];@>@|
@=    If[!MatchQ[move,{_Real,_Real,_Real}],@>@|
@=      Message[MVApplyTexture::invmove];@>@|
@=      Return[];@>@|
@=     ];@>@|
@=    If[!MatchQ[rot,{{_Real,_Real,_Real},_Real}],@>@|
@=      Message[MVApplyTexture::invrot];@>@|
@=      Return[];@>@|
@=     ];@>@|
@=    If[!MatchQ[scale,{_Real,_Real,_Real}],@>@|
@=      Message[MVApplyTexture::invscale];@>@|
@=      Return[];@>@|
@=     ];@>@|
@=    If[!MatchQ[scaletex,{_Real,_Real}],@>@|
@=      Message[MVApplyTexture::invtscale];@>@|
@=      Return[];@>@|
@=     ];@>@|
@=    Global`mvRawMapTexture[target,texid,maptype,move,@>@|
@=      Sequence @@@@ rot,scale,@>@|
@=      Sequence @@@@ scaletex]@>@|
@=  ]@>@|

@  @<Usage for \Math\ functions and symbols@>+=
@=:Evaluate:@>@|
@=  MVApplyTexture::usage=@>@|
@=  "MVApplyTexture[target, opt...] will map a texture given by the@>@|
@= MVTexture option to the target. The target may be the scene or a@>@|
@= mesh inside the MathGL3d window. Possible options are:\n@>@|
@= MVTexture                 a texture object\n@>@|
@= MVTextureMapType          the type of the texture mapping\n@>@|
@= MVTranslateTextureTarget  the translation vector to move the traget\n@>@|
@= MVRotateTextureTarget     axis and angle to rotate the target\n@>@|
@= MVScaleTextureTarget      the scaling of the target\n@>@|
@= MVScaleTexture            the scaling of the texture."@>@|

@ @<Usage for \Math\ functions and symbols@>+=
@=:Evaluate:@>@|
@=  Map[@>@|
@=    (#::usage=StringJoin[@>@|
@=                ToString[#],@>@|
@=                " is an option for MVApplyTexture and MVShow3D."]) &,@>@|
@=    {MVTexture,MVTextureMapType,MVTranslateTextureTarget,@>@|
@=     MVRotateTextureTarget,MVScaleTextureTarget,MVScaleTexture}@>@|
@=   ]@>@|

@* Light source positions.
\Math{} uses light sources in display coordinates. The OpenGL viewer
use the world coordinates for the light positions. The conversion
is done by the two \Math-functions \.{MVWorldLightSources} and
\.{MVDisplayLightSources}.

@ @<Additional \Math-definitions@>+=
@=:Evaluate:normalizeVec[v_]:=@>@|
@=  Module[{mag,nv=v},@>@|
@=    mag=Sqrt[N[Dot[#,#]]] & [v];@>@|
@=    If[mag>0.0,@>@|
@=	nv/=mag,@>@|
@=	nv]@>@|
@=   ]@>@|

@ Convert the translation by the vector |t| to a transformation
matrix in homogenous coordinates.
@<Additional \Math-definitions@>+=
@=:Evaluate:homogenTranslate[t_List]:=@>@|
@=  Transpose[ReplacePart[IdentityMatrix[4],Append[t,1.],4]]@>@|

@ The \.{MVLookAtMatrix} function returns the homogenous transformation
matrix to transform the world coordinates into display coordinates.
It is similar to the GLU function |gluLookAt()| function.
@<Additional \Math-definitions@>+=
@=:Evaluate:MVLookAtMatrix[viewpnt_List,viewvert_List,viewcntr_]:=@>@|
@=  Module[{vc,x,y,z},@>@|
@=    If[Automatic===viewcntr,@>@|
@=      vc={0.5,0.5,0.5},@>@|
@=      vc=viewcntr@>@|
@=     ];@>@|
@=    z=normalizeVec[viewpnt-vc];@>@|
@=    y=normalizeVec[viewvert];@>@|
@=    x=normalizeVec[Cross[y,z]];@>@|
@=    y=normalizeVec[Cross[z,x]];@>@|
@=    Dot[{Append[x,0.],@>@|
@=	   Append[y,0.],@>@|
@=	   Append[z,0.],{0.,0.,0.,1.0}},@>@|
@=	  homogenTranslate[-0.5*viewpnt]]@>@|
@=  ]@>@|

@ MathGL3d needs the light position in world coordinates instead
of display coordinates and we must invert the transformation matrix
that maps world to display coordinates to obtain the light positions
for MathGL3d.
@<Additional \Math-definitions@>+=
@=:Evaluate:@>@|
@=  MVWorldLightSources[@>@|
@=    gr:(_Graphics3D | _SurfaceGraphics | _MeshGraphics3D)]:=@>@|
@=  Module[{ls,vp,vv,vc,opt,hmat},@>@|
@=    opt=FullOptions[gr];@>@|
@=    {ls,vp,vv,vc}=@>@|
@=      {LightSources,ViewPoint,@>@|
@=       ViewVertical,ViewCenter} /. opt;@>@|
@=    hmat=Inverse[MVLookAtMatrix[vp,vv,vc]];@>@|
@=    ls /. {v_?VectorQ,col_} :>@>@|
@=	{Drop[Dot[hmat,Append[v,1.] ],-1],col}@>@|
@=  ]@>@|

@ @<Usage for \Math\ functions and symbols@>+=
@=:Evaluate:@>@|
@=  MVWorldLightSources::usage=@>@|
@=  "MVWorldLightSources[graph3d] calculates the light sources with positions@>@|
@=  in the coordinate system of the ViewPoint of the graphics 3d object graph3d."@>@|


@ When MathGL3d returns the light sources to \Math{}
the positions must be converted to display coordinates.
\.{MVDisplayLightSources} will do this inside \Math{}.
@<Additional \Math-definitions@>+=
@=:Evaluate:MVDisplayLightSources[ls:{{_List,_}..}]:=@>@|
@=  MVDisplayLightSources[ls,Graphics3D[{}]]@>@|

@ @<Additional \Math-definitions@>+=
@=:Evaluate:MVDisplayLightSources[ls:{{_List,_}..},gr_]:=@>@|
@=  Module[{vp,vv,vc,opt,hmat},@>@|
@=	opt=FullOptions[gr];@>@|
@=	{vp,vv,vc}={ViewPoint,ViewVertical,ViewCenter} /. opt;@>@|
@=	hmat=MVLookAtMatrix[vp,vv,vc];@>@|
@=	ls /. {v_?VectorQ,col_} :>@>@|
@=	  {Drop[Dot[hmat,Append[v,1.] ],-1],col}@>@|
@=   ]@>@|

@ @<Usage for \Math\ functions and symbols@>+=
@=:Evaluate:@>@|
@=  MVDisplayLightSources::usage=@>@|
@=  "MVDisplayLightSources[lightsources] will calculate the light source@>@|
@=  position for Mathematica's LightSource option from positions@>@|
@=  in the coordinate system of the ViewPoint.\n@>@|
@=  MVDisplayLightSources[ls,graph3d] will return the light sources using@>@|
@=  the options of the graphics 3d object graph3d."@>@|

@ @<Additional \Math-definitions@>+=
@=:Evaluate:MVGetLightSources[]:=@>@|
@=  MVDisplayLightSources[Global`mvRawGetLightSources[]]@>@|

@ @<Additional \Math-definitions@>+=
@=:Evaluate:MVGetLightSources[@>@|
@=  gr:(_Graphics3D | _SurfaceGraphics | _MeshGraphics3D)]:=@>@|
@=  MVDisplayLightSources[Global`mvRawGetLightSources[],gr]@>@|

@ @<Usage for \Math\ functions and symbols@>+=
@=:Evaluate:MVGetLightSources::usage=@>@|
@= "MVGetLightSources[] returns the list of light sources used by MathGL3d."@>@|

@* {\tt Show3D}.
 This \Math{} function build the basic interface between
\Math{} and MathGL3d. The main task is to build a nice user interface
and to bring the graphics data into a \CEE/ like format for easy reading
of the data in the MathGL3d binary.
@ Color conversion rules from \Math to the RGB model of
OpenGL
@<Additional \Math-definitions@>+=
@=:Evaluate:@>@|
@=  Options[MVShow3D]={MVNewScene->False,@>@|
@=   MVLineTubeSize->0.01,@>@|
@=   MVTubeSegments->12,@>@|
@=   MVTubeAngle->30,@>@|
@=   MVPointSphereSize-> 0.01,@>@|
@=   MVPolygonShading -> MVSmooth,@>@|
@=   MVGrayBackground->False}@>@|

@=:Evaluate:@>@|
@=   mvShade={MVSmooth,MVFlat,MVWireFrame}@>@|

@=:Evaluate:@>@|
@=   mvShadeID[a_]:=Switch[a,@>@|
@=    MVSmooth,       1,@>@|
@=    MVFlat,         2,@>@|
@=    MVWireFrame,    3,@>@|
@=    _,              1]@>@|

@ @<Additional \Math-definitions@>+=
@=:Evaluate:@>@|
@=  MVShow3D::noint="MVTubeSegments must be an integer."@>@|
@=:Evaluate:@>@|
@=  MVShow3D::noreal="`1` must be a number."@>@|

@=:Evaluate:If[$VersionNumber<4,(* Then *)@>@|
@=  colorRules=Dispatch[@>@|
@=   {SurfaceColor[col_,__] :>  SurfaceColor[col],@>@|
@=    Hue[a__]:> hueToRGB[a],@>@|
@=    Thickness[___] :> Sequence[],@>@|
@=    GrayLevel[a_]:> RGBColor[a,a,a],@>@|
@=    EdgeForm[___]:> Sequence[],@>@|
@=    FaceForm[___]:> Sequence[]}], (* Else *)@>@|
@=   colorRules=Dispatch[@>
@=   {SurfaceColor[col_,__] :>  SurfaceColor[col],@>@|
@=    h : (_Hue | _GrayLevel | _CMYKColor) :> @>@| 
@=      ToColor[h, RGBColor], @>@|
@=    Thickness[___] :> Sequence[],@>@|
@=    EdgeForm[___]:> Sequence[],@>@|
@=    FaceForm[___]:> Sequence[]}] @>@|
@=  ]@>@|

@=:Evaluate:@>@|
@=   convColors[gr_]:=gr //. colorRules @>@|

@ @<Additional \Math-definitions@>+=
@=:Evaluate: convertNumbersToC=@>@|
@=  {0->0.0,@>@|
@=   a_Complex :> Abs[a],@>@|
@=   Overflow[]->1.0/$MachineEpsilon};@>@|

@ @<Additional \Math-definitions@>+=
@=:Evaluate:makeShow3DArg[gr_]:=@>@|
@=    Block[{args},@>@|
@=      args=N[{@>@|
@=        pltrange,vp,vert,@>@|
@=        Flatten[lpos],Flatten[lcol],@>@|
@=        List @@@@ ambient,boxratio,psize,@>@|
@=        ltube,@>@|
@=        tangle} ] //. convertNumbersToC;@>@|
@=    PrependTo[args,newscene];@>@|
@=    args=Join[args,{shade,tseg,graybk}];@>@|
@=    If[Head[gr]===Graphics3D,(* Then *)@>@|
@=      AppendTo[@>@|
@=        args,@>@|
@=        convColors[Flatten[N[{First[gr]}] //.@>@|
@=           convertNumbersToC]]@>@|
@=       ],@>@|
@=     (* Else *)@>@|
@=     AppendTo[args,						@>@|
@=       {MeshGraphics3D[gr[[1]],gr[[2]],@>@|
@=          N[Flatten[gr[[3]]]],@>@|
@=          Sequence @@@@ prepMeshColors[gr[[4]]]@>@|
@=         ] /. convertNumbersToC }@>@|
@=      ]@>@|
@=    ]@>@|
@=  ]@>@|

@ @<Additional \Math-definitions@>+=
@=:Evaluate:mergePlotRange[pltr_]:=@>@|
@=  Module[{plotr=Transpose[pltr],mvpr},@>@|
@=    mvpr=Global`MVGetPlotRange[];@>@|
@=    If[Indeterminate===First[Union[Flatten[mvpr]]],@>@|
@=      Return[plotr],@>@|
@=    (* Else *)@>@|
@=        {Min /@@ Transpose[{plotr[[1]],mvpr[[1]]}],@>@|
@=         Max /@@ Transpose[{plotr[[2]],mvpr[[2]]}]}@>@|
@=     ]@>@|
@=   ]@>@|

@ Convert \.{SurfaceGraphics} to general meshes.
@<Additional \Math-definitions@>+=
@=:Evaluate:@>@|
@=   MVShow3D[surf_SurfaceGraphics,opt___]:=@>@|
@=    MVShow3D[surfToMesh[surf],opt]@>@|

@ @<Additional \Math-definitions@>+=
@=:Evaluate:@>@|
@=   MVShow3D[gr:(_Graphics3D | _MeshGraphics3D),opt___]:=@>@|
@=   Block[{vp,vert,pltrange,light,lpos,lcol,a,col,graybk,@>@|
@=          ambient,ltube,psize,shade,args,tseg,tangle,res,newscene,@>@|
@=          boxratio,gropt},@>@|
@=    If[Head[gr]===Graphics3D, (* Then *)@>@|
@=      If[MatchQ[gr,Graphics3D[_,_]],@>@|
@=        gropt=Last[gr],@>@|
@=        gropt={BoxRatios->Automatic}@>@|
@=       ];@>@|
@=      {pltrange,vp,vert,ambient}=@>@|
@=           FullOptions[gr,#] & /@@@>@|
@=              {PlotRange,ViewPoint,ViewVertical,AmbientLight} /.@>@|
@=                GrayLevel[x_] :> RGBColor[x,x,x];@>@|
@=       boxratio=BoxRatios /. gropt /. Options[Graphics3D];,@>@|
@=      (* Else *)@>@|
@=      pltrange=PlotRange[gr];@>@|
@=      {vp,vert,light,ambient,boxratio}=@>@|
@=         {ViewPoint,ViewVertical,LightSources,AmbientLight,BoxRatios} /.@>@|
@=            Last[gr] /.@>@|
@=            GrayLevel[x_]:>RGBColor[x,x,x]@>@|
@=     ];@>@|
@=    If[Automatic===boxratio || !(VectorQ[boxratio,NumericQ] && Length[boxratio]==3),@>@|
@=     boxratio={1.,1.,1.},@>@|
@=     boxratio=#/Max[#] &[Abs[N[boxratio]/. 0->0.]];@>@|
@=     ];@>@|
@=    newscene=MVNewScene /. {opt} /. Options[MVShow3D];@>@|
@=    If[TrueQ[newscene],newscene=1,newscene=0];@>@|
@=    light=MVWorldLightSources[gr];@>@|
@=    If[0===newscene,@>@| 
@=      pltrange=mergePlotRange[pltrange],@>@|
@=      pltrange=Transpose[pltrange]@>@|
@=     ];@>@|
@=    pltrange=Partition[Flatten[pltrange],3];@>@|
@=    {lpos,lcol}=@>@|
@=           Partition[Flatten[Transpose[light] /.@>@|
@=             RGBColor[args__] :> List[args],1],@>@|
@=             Length[light]];@>@|
@=    ltube=MVLineTubeSize /. {opt} /.Options[MVShow3D];@>@|
@=    If[!NumericQ[ltube],@>@|
@=      Message[MVShow3D::noreal,"MVLineTubeSize"];@>@|
@=      Return[$Failed];@>@|
@=     ];@>@|
@=    tangle=MVTubeAngle /. {opt} /. Options[MVShow3D];@>@|
@=    If[!NumericQ[tangle],@>@|
@=      Message[MVShow3D::noreal,"MVTubeAngle"];@>@|
@=      Return[$Failed];@>@|
@=     ];@>@|
@=    psize=MVPointSphereSize /. {opt} /.Options[MVShow3D];@>@|
@=    If[!NumericQ[psize],@>@|
@=      Message[MVShow3D::noreal,"MVPointSphereSize"];@>@|
@=      Return[$Failed];@>@|
@=     ];@>@|
@=    shade=MVPolygonShading /. {opt}/.Options[MVShow3D];@>@|
@=    shade=mvShadeID[shade];@>@|
@=    tseg=MVTubeSegments /. {opt} /. Options[MVShow3D];@>@|
@=    graybk=MVGrayBackground /. {opt} /. Options[MVShow3D];@>@|
@=    If[TrueQ[graybk], graybk=1, graybk=0];@>@|
@=    args=makeShow3DArg[gr];@>@|
@=    res=Global`MVPutGraphics3D[args];@>@|
@=    If[$Failed=!=res && MemberQ[First /@@ {opt},MVTexture] &&@>@|
@=       None=!=(MVTexture /. {opt}), (* Then *)@>@|
@=     res=MVApplyTexture[@>@|
@=           First[res],@>@|
@=           FilterOptions[MVApplyTexture,opt],@>@|
@=           FilterOptions[MVPutTexture,opt]@>@|
@=          ], (* Else *)@>@|
@=     res@>@|
@=    ]@>@|
@=   ]@>@|

@ @<Additional \Math-definitions@>+=
@=:Evaluate:@>@|
@=  MVShow3D[ms:{_MeshGraphics3D..},opts___]:=@>@|
@=    Module[{rangeall},@>@|
@=      rangeall=PlotRange[ms];@>@|
@=        MVShow3D /@@ ( ms /. Rule[PlotRange,_] :>@>@|
@=                             Rule[PlotRange,rangeall])@>@|
@=     ]@>@|

@ @<Usage for \Math\ functions and symbols@>+=
@=:Evaluate:@>@|
@=  MVShow3D::usage=@>@|
@=    "MVShow3D[graph3d, opt...] will transfer a Graphics3D object to MathGL3d."@>@|
@=:Evaluate:@>@|
@= MVLineTubeSize::usage="MVLineTubeSize is an option for MVShow3D@>@|
@= and MVWritePOVRay. The number given determines the absolute radius@>@|
@= of the tubes arround lines."@>@|
@=:Evaluate:@>@|
@= MVTubeSegments::usage="MVTubeSegments is an option for MVShow3D@>@|
@= and MVWritePOVRay. The integer determines the number of segments@>@|
@= for the tube approximation."@>@|
@=:Evaluate:@>@|
@= MVTubeAngle::usage="MVTubeAngle is an option for MVShow3D@>@|
@= and MVWritePOVRay. The angle (in degree) is used to determine if@>@|
@= continued lines can smoothly continued with tubes."@>@|
@=:Evaluate:@>@|
@= MVPointSphereSize::usage="MVPointSphereSize is an option for MVShow3D@>@|
@= and MVWritePOVRay. The number gives the absolute size of spheres@>@|
@= for point drawing."@>@|
@=:Evaluate:@>@|
@= MVPolygonShading::usage="MVPolygonShading is an option for MVShow3D@>@|
@= and MVWritePOVRay. The values MVSmooth (default), MVFlat and@>@|
@= MVWireFrame are possible."@>@|
@=:Evaluate:@>@|
@=   MVSmooth::usage="MVSmooth is a value for MVPolygonShading."@>@|
@=:Evaluate:@>@|
@=   MVFlat::usage="MVFlat is a value for MVPolygonShading."@>@|
@=:Evaluate:@>@|
@=   MVWireFrame::usage="MVWireFrame is a value for MVPolygonShading."@>@|
@=:Evaluate:@>@|
@=   MVGrayBackground::usage="MVGrayBackground is a option for MVShow3D."@>@|
@=:Evaluate:@>@|
@=  MVNewScene::usage="MVNewScene is an option for MVShow3D[], MVNewScene->True@>@|
@=  will clear the data give in previous MVShow3D[] commands,MVNewScene->False@>@|
@=  will add the new data to the scene."@>@|

@ @<Additional \Math-definitions@>+=
@=:Evaluate:@>@|
@= MVPasteGraphics[opt___]:=Show[@>@|
@=   Graphics[@>@|
@=    Global`MVGetRasterImage[],@>@|
@=    AspectRatio->Automatic,@>@|
@=    FilterOptions[Graphics,opt]@>@|
@=   ]@>@|
@=  ]@>@|

@ @<Usage for \Math\ functions and symbols@>+=
@=:Evaluate:MVPasteGraphics::usage=@>@|
@=  "MVPasteGraphics[opts] paste the bitmap image in the MathGL3d window to Mathematica."@>@|


@* Export data from MathGL3d.
The \Math\ function \.{MVWritePOVRay} will write a input
file for the Persistence Of Vision Raytracer. It takes the
same options as \.{MVShow3D} and alllow
different settings for the for the ray tracer file.
@ @<Additional \Math-definitions@>=
@=:Evaluate: Options[MVWritePOVRay]={MVTextureFilePrefix->"mv"}@>@|

@ This tis the default usage. The data previously transfered
  to \.{mathview3d} are now saved in a output file \.{fname}
  for POVRay.

@<Additional \Math-definitions@>=
@=:Evaluate:@>@|
@=  MVWritePOVRay[fname_String,opts___Rule]:=@>@|
@=    Module[{filename,texpre},@>@|
@=      texpre=MVTextureFilePrefix /. {opts} /.Options[MVWritePOVRay];@>@|
@=      filename=StringReplace[@>@|
@=                 fname,@>@|
@=                 "/"->$PathnameSeparator];@>@|
@=      filename=MakeSaveFilename[filename];@>@|
@=      Global`mvRawWritePOVRay[filename,texpre<>"s",texpre<>"m"]@>@|
@=     ]@>@|

@ The second pattern will allow to send a 3d graphics to \.{mathview3d}
and to save it.
@<Additional \Math-definitions@>=
@=:Evaluate:@>@|
@=  MVWritePOVRay[fname_String,@>@|
@=    gr:(_Graphics3D|_SurfaceGraphics | _MeshGraphics3D),@>@|
@=    opts___?OptionQ]:=@>@|
@=    (Global`MVClear[];MVShow3D[gr,opts];@>@|
@=    MVWritePOVRay[fname,opts])@>@|

@ @<Usage for \Math\ functions and symbols@>+=
@=:Evaluate:@>@|
@= MVWritePOVRay::usage="MVWritePOVRay[fname, opt..] writes the current@>@|
@= object in the MathGL3d window to the POVRay 3.0 input file fname.@>@|
@= MVWritePOVRay[fname, graph3d, opt..] transfers the Graphics3D graph3d@>@|
@= to MathGL3d and savs it as a POVRay file."@>@|

@ @<Usage for \Math\ functions and symbols@>+=
@=:Evaluate:@>@|
@= MVWriteDXF::usage="MVWriteDXF[fname,opt..] writes the current object@>@|
@= in the MathGL3d window to a DXF file fname.\n@>@|
@= MVWriteDXF[fname,graph3d,opt..] transfer the Graphics3D to MathGL3d@>@|
@= and save a DXF file. Lines will only exported as as tubes, points as@>@|
@= spheres."@>@|

@ The interface function to write AutoCAD DXF files.
@<Additional \Math-definitions@>+=
@=:Evaluate:Options[MVWriteDXF]={MVLineTubeSize->0.01,@>@|
@=		MVTubeSegments->12,@>@|
@=		MVPointSphereSize->0.01,@>@|
@=		MVTubeAngle->30.}@>@|

@ @<Additional \Math-definitions@>+=
@=:Evaluate: MVWriteDXF::noreal="`1` must be a floating point number"@>@|

@ The standard pattern to write DXF files.
@<Additional \Math-definitions@>+=
@=:Evaluate:MVWriteDXF[fname_String,opt___?OptionQ]:=@>@|
@=	  Module[{ts,tseg,psize,tangle,filename},@>@|
@=	    ts=MVLineTubeSize /. {opt} /. Options[MVWriteDXF];@>@|
@=	    tseg=MVTubeSegments /. {opt} /. Options[MVWriteDXF];@>@|
@=	    psize=MVPointSphereSize /. {opt} /. Options[MVWriteDXF];@>@|
@=	    tangle=MVTubeAngle /. {opt} /. Options[MVWriteDXF];@>@|
@=	    {ts,psize,tangle}=N[{ts,psize,tangle}] /. 0-> 0.0;@>@|
@=	    If[!IntegerQ[tseg],@>@|
@=	      Message[MVShow3D::noint,"MVTubeSegments"];@>@|
@=	      Return[$Failed];@>@|
@=	     ];@>@|
@=	    If[!NumericQ[ts],@>@|
@=	      Message[MVWriteDXF::noreal,"MVLineTubeSize"];@>@|
@=	      Return[$Failed];@>@|
@=	     ];@>@|
@=	    If[!NumericQ[psize],@>@|
@=	      Message[MVWriteDXF::noreal,"MVPointSphereSize"];@>@|
@=	      Return[$Failed];@>@|
@=	     ];@>@|
@=	    If[!NumericQ[tangle],@>@|
@=	      Message[MVWriteDXF::noreal,"MVTubeAngle"];@>@|
@=	      Return[$Failed];@>@|
@=	     ];@>@|
@=	    filename=StringReplace[fname,"/" -> $PathnameSeparator];@>@|
@=      filename=MakeSaveFilename[filename];@>@|
@=	    Global`mvWriteDXF[filename,ts,tseg,psize,tangle]@>@|
@=	   ]@>@|

@ The pattern with a \.{Graphics3D}-object as second argument.
@<Additional \Math-definitions@>+=
@=:Evaluate:MVWriteDXF[fname_String,@>@|
@=	          gr_ /;@>@|
@=                         Head[gr]===Graphics3D ||@>@|
@=                         Head[gr]===SurfaceGraphics ||@>@|
@=                         Head[gr]===MeshGraphics3D,@>@|
@=	            opts___?OptionQ]:=@>@|
@=	          (Global`MVClear[];@>@|
@=	           MVShow3D[gr,opts];MVWriteDXF[fname,opts])@>@|

@ Save a PNG file from \Math.
@<Additional \Math-definitions@>+=
@=:Evaluate:Options[MVWritePNG]=@>@|
@=            {MVDisplayGamma->1.0,MVInterlacePNG->False}@>@|

@=:Evaluate:MVWritePNG::noreal="MVDisplayGamma must be an real number."@>@|
@=:Evaluate:MVWritePNG::nobool="MVInterlacePNG must be True or False."@>@|

@=:Evaluate:MVWritePNG[fname_String,opt___?OptionQ]:=@>@|
@=  Module[{interl,gamma,filename},@>@|
@=    gamma=MVDisplayGamma /. {opt} /. Options[MVWritePNG];@>@|
@=    interl=MVInterlacePNG /. {opt} /. Options[MVWritePNG];@>@|
@=    gamma=N[gamma];@>@|
@=    interl= interl /. {True->1,False->0};@>@|
@=    If[!NumericQ[gamma],@>@|
@=	     Message[MVWritePNG::noreal];@>@|
@=	     Return[$Failed];@>@|
@=     ];@>@|
@=    If[!MemberQ[{0,1},interl],@>@|
@=	     Message[MVWritePNG::nobool];@>@|
@=	     Return[$Failed];@>@|
@=     ];@>@|
@=	  filename=StringReplace[fname,"/" -> $PathnameSeparator];@>@|
@=    filename=MakeSaveFilename[filename];@>@|
@=    Global`mvRawWritePNG[filename,gamma,interl]@>@|
@=   ]@>@|

@ @<Additional \Math-definitions@>+=
@=:Evaluate:MVWritePNG[fname_String,@>@|
@=            gr:(_Graphics3D|_SurfaceGraphics | _MeshGraphics3D),@>@|
@=            opts___?OptionQ]:=@>@|
@=	  (MVClear[];MVShow3D[gr,opts];MVWritePNG[fname,opts])@>@|

@ @<Usage for \Math\ functions and symbols@>+=
@=:Evaluate:MVWritePNG::usage=@>@|
@= "MVWritePNG[file,opt] write the image of the MathGL3d window to  \n@>@|
@= a portable network graphics file. Valid options are MVDisplayGamma\n@>@|
@= for gamma correction and MVInterlacePNG for interlacing the image.\n@>@|
@= MVWritePNG[file,gr3d,opts] copys the 3d graphics to the MathGL3d\n@>@|
@= window and saves the png image."@>@|

@=:Evaluate:MVDisplayGamma::usage=@>@|
@=  "MVDisplayGamma is a option for MVWritePNG[]."@>@|

@=:Evaluate:MVInterlacePNG::usage=@>@|
@=  "MVInterlacePNG is a option for MVWritePNG[] and MVPutTexture[]."@>@|

@ Write a QuickDraw3D meta file from \Math{}.
@<Additional \Math-definitions@>+=
@=:Evaluate:Options[MVWrite3DMF]=@>@|
@=   {MVQuickDrawLights->True,MVQuickDrawViewPoint->True};@>@|

@=:Evaluate:MVWrite3DMF[fname_String,opts___?OptionQ]:=@>@|
@=   Module[{wlight,wview,filename},@>@|
@=     wlight=MVQuickDrawLights /. {opts} /. Options[MVWrite3DMF];@>@|
@=     wview=MVQuickDrawViewPoint /. {opts} /. Options[MVWrite3DMF];@>@|
@=     If[TrueQ[wlight],wlight=1,wlight=0];@>@|
@=     If[TrueQ[wview],wview=1,wview=0];@>@|
@=	   filename=StringReplace[fname,"/" -> $PathnameSeparator];@>@|
@=     filename=MakeSaveFilename[filename];@>@|
@=     Global`mvWrite3DMF[filename,wlight,wview]@>@|
@=    ]@>@|

@=:Evaluate:MVWrite3DMF[fname_String,@>@|
@=            gr:(_Graphics3D|_SurfaceGraphics|_MeshGraphics3D),@>@|
@=            opts___?OptionQ]:=@>@|
@=	  (MVClear[];MVShow3D[gr,opts];MVWrite3DMF[fname,opts])@>@|

@ @<Usage for \Math\ functions and symbols@>+=
@=:Evaluate:MVWrite3DMF::usage=@>@|
@= "MVWrite3DMF[qdfile,opts] writes the 3d data in the viewer window@>@|
@= into a QuickDraw3D metafile qdfile. Options are MVQuickDrawLights@>@|
@= (True or False) to write the lights of the scene and@>@|
@= MVQuickDrawViewPoint (True or False) to save the view point of the@>@|
@= scene."@>@|

@ @<Usage for \Math\ functions and symbols@>+=
@=:Evaluate:MVQuickDrawLights::usage=@>@|
@=  "MVQuickDrawLights is a option for MVWrite3DMF."@>@|

@ @<Usage for \Math\ functions and symbols@>+=
@=:Evaluate:MVQuickDrawViewPoint::usage=@>@|
@=  "MVQuickDrawViewPoint is a option for MVWrite3DMF."@>@|


@ The \Math{}-functions to write VRML 2.0 scenes.
@<Additional \Math-definitions@>+=
@=:Evaluate:Options[MVWriteVRML]=@>@|
@=           {VRMLHeadLight->False,VRMLExtrusion->True,@>@|
@=            MVTextureFilePrefix->"mv"}@>@|

@=:Evaluate:@>@|
@=  MVWriteVRML[fname_String,opts___?OptionQ]:=@>@|
@=    Module[{vrHeadlight,vrUseExtrude,texpre,filename},@>@|
@=	     vrHeadlight=VRMLHeadLight /. {opts} /.@>@|
@=                    Options[MVWriteVRML];@>@|
@=	     vrUseExtrude=VRMLExtrusion /. {opts} /.@>@|
@=                    Options[MVWriteVRML];@>@|
@=	     texpre=MVTextureFilePrefix /. {opts} /.@>@|
@=                    Options[MVWriteVRML];@>@|
@=	     If[TrueQ[vrHeadlight],vrHeadlight=1,vrHeadlight=0];@>@|
@=      If[TrueQ[vrUseExtrude],vrUseExtrude=1,vrUseExtrude=0];@>@|
@=	    filename=StringReplace[fname,"/" -> $PathnameSeparator];@>@|
@=      filename=MakeSaveFilename[filename];@>@|
@=      Global`mvRawWriteVRML[@>@|
@=        filename,vrHeadlight,vrUseExtrude,texpre<>"s",texpre<>"m"]@>@|
@=     ]@>@|


@=:Evaluate:@>@|
@=   MVWriteVRML[fname_String,@>@|
@=     gr:(_Graphics3D|_SurfaceGraphics | _MeshGraphics3D),@>@|
@=     opts___?OptionQ]:=@>@|
@=     (MVClear[];MVShow3D[gr,opts];@>@|
@=        MVWriteVRML[fname,FilterOptions[MVWriteVRML,opts]])@>@|


@ @<Usage for \Math\ functions and symbols@>+=
@=:Evaluate:MVWriteVRML::usage=@>@|
@= "MVWriteVRML[vrfile,opts] writes the 3d data in the viewer window@>@|
@= into a VRML 2.0 file. MVWriteVRML[vrfile,graph3d,opts] sends@>@|
@= the graphics to the viewer window and saves the VRML file.\n@>@|
@= Options are VRMLHeadLight (True or False) to use a head light and@>@|
@= VRMLExtrusion (True or False) to save thick lines as extrusions@>@|
@= (True) or expanded polygons (False)."@>@|


@ @<Usage for \Math\ functions and symbols@>+=
@=:Evaluate:VRMLHeadLight::usage=@>@|
@=  "VRMLHeadLight is an option for MVWriteVRML[]."@>@|

@ @<Usage for \Math\ functions and symbols@>+=
@=:Evaluate:VRMLExtrusion::usage=@>@|
@=  "VRMLExtrusion is an option for MVWriteVRML[]."@>@|

@ @<Usage for \Math\ functions and symbols@>+=
@=:Evaluate:MVTextureFilePrefix::usage=@>@|
@=  "MVTextureFilePrefix is an option for MVWriteVRML[].@>@|
@=  The textures are stored as png-files with file names that begin with@>@|
@=  the string given in this option."@>@|

@ Finaly we add a \Math 3.0 palette.
@ @<Additional \Math-definitions@>=
@=:Evaluate:@>@|
@=  mvPaletteHead =@>@|
@=   {@>@|
@=    FrameBox[StyleBox[RowBox[{"Actions"}]]],@>@|
@=    FrameBox[StyleBox[RowBox[{"Main"}   ]]],@>@|
@=    FrameBox[StyleBox[RowBox[{"Spin"}   ]]],@>@|
@=    FrameBox[StyleBox[RowBox[{"Window"} ]]]@>@|
@=   };@>@|
@=:Evaluate:@>@|
@=  mvShowButton = ButtonBox[@>@|
@=    StyleBox[@>@|
@=    RowBox[{"MVShow3D","[","\\[Placeholder]","]"}]],@>@|
@=    ButtonData :>@>@|
@=      BoxData[@>@|
@=        RowBox[{"MVShow3D","[","\[Placeholder]",",",@>@|
@=          "MVLineTubeSize","->","0.01",",",@>@|
@=          "MVPolygonShading","->","MVSmooth",",",@>@|
@=          "MVTubeSegments","->","12",",",@>@|
@=          "MVTubeAngle","->","30",",",@>@|
@=          "MVPointSphereSize","->","0.01","]"}]@>@|
@=         ]];@>@|

@ @<Additional \Math-definitions@>=
@=:Evaluate:@>@|
@=  mvVRMLButton = ButtonBox[@>@|
@=  StyleBox[@>@|
@=    RowBox[{"MVWriteVRML","[","\\[Placeholder]","]"}]],@>@|
@=    ButtonData :>@>@|
@=      BoxData[@>@|
@=        RowBox[{@>@|
@=          "MVWriteVRML","[","\[Placeholder]",",",@>@|
@=          "\[Placeholder]",",",@>@|
@=          "VRMLHeadLight","->","False",",",@>@|
@=          "VRMLExtrusion","->","True",",",@>@|
@=          "MVPolygonShading","->","MVSmooth",@>@|
@=          "]"}]@>@|
@=         ]];@>@|

@ @<Additional \Math-definitions@>=
@=:Evaluate:@>@|
@=  mv3DMFButton = ButtonBox[@>@|
@=    StyleBox[@>@|
@=      RowBox[{"MVWrite3DMF","[","\\[Placeholder]","]"}]],@>@|
@=      ButtonData :>@>@|
@=      BoxData[@>@|
@=        RowBox[{@>@|
@=          "MVWrite3DMF","[","\[Placeholder]",",",@>@|
@=          "\[Placeholder]",",",@>@|
@=          "MVQuickDrawLights","->","True",",",@>@|
@=          "MVQuickDrawViewPoint","->","True",",",@>@|
@=          "MVPolygonShading","->","MVSmooth",@>@|
@=         "]"}]]];@>@|

@ @<Additional \Math-definitions@>=
@=:Evaluate:@>@|
@=  mvPNGButton = ButtonBox[@>@|
@=   StyleBox[@>@|
@=     RowBox[{"MVWritePNG","[","\\[Placeholder]","]"}]],@>@|
@=     ButtonData :>@>@|
@=       BoxData[@>@|
@=         RowBox[{@>@|
@=           "MVWritePNG","[","\[Placeholder]",",",@>@|
@=           "\[Placeholder]",",",@>@|
@=           "MVDisplayGamma","->","True",",",@>@|
@=           "MVInterlacePNG","->","True",",",@>@|
@=           "MVPolygonShading","->","MVSmooth",@>@|
@=           "]"}]]];@>@|

@ @<Additional \Math-definitions@>=
@=:Evaluate:@>@|
@=  mvEPSButton = ButtonBox[@>@|
@=  StyleBox[@>@|
@=    RowBox[{"MVWriteEPS","[","\\[Placeholder]","]"}]],@>@|
@=     ButtonData :>@>@|
@=      BoxData[@>@|
@=       RowBox[{@>@|
@=        "MVWriteEPS","[","\[Placeholder]",",",@>@|
@=        "\[Placeholder]",",",@>@|
@=        "MVPolygonShading","->","MVSmooth",",",@>@|
@=        "MVGrayBackground","->","True",@>@|
@=        "]"}]]];@>@|

@ @<Additional \Math-definitions@>=
@=:Evaluate:@>@|
@=  mvSPOVButton = ButtonBox[@>@|
@=   StyleBox[@>@|
@=     RowBox[{"Smooth"," ","MVWritePOVRay","[","\\[Placeholder]","]"}]],@>@|
@=      ButtonData :>@>@|
@=       BoxData[@>@|
@=        RowBox[{"MVWritePOVRay", "[", "\\[Placeholder]",",",@>@|
@=         "MVPolygonShading", "->", "MVSmooth", "]"}]]];@>@|
@=:Evaluate:@>@|
@=  mvFPOVButton = ButtonBox[@>@|
@=  StyleBox[@>@|
@=    RowBox[{"Flat"," ","MVWritePOVray","[","\\[Placeholder]","]"}]],@>@|
@=    ButtonData :>@>@|
@=      BoxData[@>@|
@=        RowBox[{"MVWritePOVRay", "[", "\\[Placeholder]", ",",@>@|
@=          "MVPolygonShading", "->", "MVFlat", "]"}]]];@>@|

@ @<Additional \Math-definitions@>=
@=:Evaluate:@>@|
@=  mvClearButton = ButtonBox[@>@|
@=   StyleBox[@>@|
@=    RowBox[{"Clear", " ", "Window"}]],@>@|
@=    ButtonFunction :> Global`MVClear[],@>@|
@=    ButtonEvaluator -> Automatic];@>@|

@=:Evaluate:@>@|
@=  mvResetButton = ButtonBox[@>@|
@=   StyleBox[RowBox[{"Reset", " ", "view"}]],@>@|
@=   ButtonFunction :> Global`MVReset[],@>@|
@=   ButtonEvaluator -> Automatic];@>@|

@=:Evaluate:@>@|
@=  mvZoomInButton = ButtonBox[@>@|
@=    StyleBox[RowBox[{"Zoom", " ",  "in"}]],@>@|
@=    ButtonFunction :> Global`MVZoom[0.5],@>@|
@=    ButtonEvaluator -> Automatic];@>@|

@=:Evaluate:@>@|
@=  mvZoomOutButton = ButtonBox[@>@|
@=    StyleBox[RowBox[{"Zoom", " ", "out"}]],@>@|
@=    ButtonFunction :> Global`MVZoom[2.0],@>@|
@=    ButtonEvaluator -> Automatic];@>@|

@ @<Additional \Math-definitions@>=
@=:Evaluate:@>@|
@=  mvSpinXButton =  ButtonBox[@>@|
@=    StyleBox[RowBox[{"X-axis"}]],@>@|
@=     ButtonFunction :>  (@>@|
@=       Global`MVPopWindow[];@>@|
@=       Global`MVSpin[@>@|
@=       N[Pi/10],@>@|
@=       {1.0, 0.0, 0.0}]@>@|
@=      ),ButtonEvaluator->Automatic];@>@|

@ @<Additional \Math-definitions@>=
@=:Evaluate:@>@|
@=  mvSpinYButton=ButtonBox[@>@|
@=   StyleBox[RowBox[{"Y-axis"}]],@>@|
@=    ButtonFunction :>  (@>@|
@=     Global`MVPopWindow[];@>@|
@=     Global`MVSpin[@>@|
@=     N[Pi/10],@>@|
@=     {0.0, 1.0, 0.0}]@>@|
@=    ),ButtonEvaluator->Automatic];@>@|
@=:Evaluate:@>@|
@=  mvSpinZButton= ButtonBox[@>@|
@=   StyleBox[RowBox[{"Z-axis"}]],@>@|
@=    ButtonFunction :>  (@>@|
@=     Global`MVPopWindow[];@>@|
@=     Global`MVSpin[@>@|
@=     N[Pi/10],@>@|
@=     {0.0, 0.0, 1.0}]@>@|
@=    ), ButtonEvaluator -> Automatic];@>@|

@ @<Additional \Math-definitions@>=
@=:Evaluate:@>@|
@=  mvSpinHaltButton =@>@|
@=    ButtonBox[@>@|
@=      StyleBox[RowBox[{"Stop"}]],@>@|
@=      ButtonFunction :>  Global`MVStopSpin[],@>@|
@=      ButtonEvaluator -> Automatic];@>@|
@=:Evaluate:@>@|
@=  mvHideWindowButton =@>@|
@=    ButtonBox[@>@|
@=      StyleBox[RowBox[{"Hide"}]],@>@|
@=      ButtonFunction :>  Global`MVHideWindow[],@>@|
@=      ButtonEvaluator -> Automatic];@>@|
@=:Evaluate:@>@|
@=  mvShowWindowButton =@>@|
@=    ButtonBox[@>@|
@=      StyleBox[RowBox[{"Show"}]],@>@|
@=      ButtonFunction :>  Global`MVShowWindow[],@>@|
@=      ButtonEvaluator -> Automatic];@>@|

@ @<Additional \Math-definitions@>=
@=:Evaluate:@>@|
@=  mvIconifyButton =@>@|
@=    ButtonBox[@>@|
@=      StyleBox[RowBox[{"Iconify"}]],@>@|
@=      ButtonFunction :>  Global`MVIconifyWindow[],@>@|
@=      ButtonEvaluator -> Automatic];@>@|
@=:Evaluate:@>@|
@=  mvQuitButton =@>@|
@=    ButtonBox[@>@|
@=      StyleBox[RowBox[{"Quit"}]],@>@|
@=      ButtonFunction :>  MVClose[],@>@|
@=      ButtonEvaluator -> Automatic];@>@|

@ @<Additional \Math-definitions@>=
@=:Evaluate:@>@|
@=  MVCreatePalette[] :=@>@|
@=    Module[{pal},@>@|
@=    pal = Cell[@>@|
@=     BoxData[@>@|
@=      GridBox[@>@|
@=       {@>@|
@=        { " ", StyleBox[@>@|
@=         RowBox[{"OpenGL",  "Viewer"}],@>@|
@=         FontFamily -> "Helvetica"@>@|
@=         ], " "," "},@>@|
@=        mvPaletteHead,@>@|
@=        {mvShowButton, mvClearButton, mvSpinXButton, mvShowWindowButton},@>@|
@=        {mvSPOVButton, mvResetButton, mvSpinYButton, mvHideWindowButton},@>@|
@=        {mvFPOVButton, mvZoomInButton, mvSpinZButton, mvIconifyButton},@>@|
@=        {mvEPSButton,  mvZoomOutButton, mvSpinHaltButton, mvQuitButton},@>@|
@=         {FrameBox[@>@|
@=            StyleBox[@>@|
@=              RowBox[{"\\[Copyright]", " ", "1997-99",@>@|
@=                            " ", "by", " ",  "Jens-Peer"," ", "Kuska"}]]],@>@|
@=          mvVRMLButton,   mv3DMFButton,  mvPNGButton}},@>@|
@=          RowSpacings -> 0,@>@|
@=          ColumnSpacings -> 0@>@|
@=         ]],"Input", Active -> True, CellFrame -> False];@>@|
@=        FrontEndExecute[@>@|
@=          {FrontEnd`NotebookApply[FrontEnd`InputNotebook[], pal]}@>@|
@=         ]]@>@|

@ @<Additional \Math-definitions@>+=
@=:Evaluate:@>@|
@=  Options[MVPolygonReduce]={ReductionLoops->256}@>@|

@ @<Additional \Math-definitions@>+=
@=:Evaluate:@>@|
@=  MVPolygonReduce::noint="ReductionLoops must be an integer."@>@|

@ @<Additional \Math-definitions@>+=
@=:Evaluate:@>@|
@=  MVPolygonReduce[tol_?NumericQ,opts___?OptionQ]:=@>@|
@=    Module[{tt,iter},@>@|
@=      iter=ReductionLoops /. {opts} /. Options[MVPolygonReduce];@>@|
@=      tt=N[tol] /. 0->0.0;@>@|
@=      If[!IntegerQ[iter],@>@|
@=        Message[MVPolygonReduce::noint];@>@|
@=        Return[$Failed]@>@|
@=       ];@>@|
@=      Global`mvPolygonReduce[tt,iter]@>@|
@=     ]@>@|

@ @<Additional \Math-definitions@>+=
@=:Evaluate:@>@|
@=  MVPolygonReduce[graph3d_Graphics3D,tol_?NumericQ,opts___]:=@>@|
@=    (Global`MVClear[];@>@|     
@=     MVShow3D[graph3d,opts];@>@|
@=     MVPolygonReduce[tol,FilterOptions[MVPolygonReduce,opts]])@>@|

@ @<Additional \Math-definitions@>+=
@=:Evaluate:@>@|
@=  MVPolygonReduce[graph3d:(_SurfaceGraphics | _MeshGraphics3D),@>@|
@=    tol_?NumericQ,opts___]:=@>@|
@=    (Global`MVClear[];@>@|     
@=     MVShow3D[Graphics3D[graph3d],opts];@>@|
@=     MVPolygonReduce[tol,FilterOptions[MVPolygonReduce,opts]])@>@|

@ @<Usage for \Math\ functions and symbols@>+=
@=:Evaluate: MVPolygonReduce::usage=@>@|
@=  "MVPolygonReduce[graph3d,tol] will pass the data to MathGL3d and@>@|
@=  perform a polygon reduction. MVPolygonReduce[tol] will simplify the@>@|
@=  number of polygones in the current MVScene[]. The option ReductionLoops@>|
@=  is used to determine the number of iterations."@>@|

@ @<Usage for \Math\ functions and symbols@>+=
@=:Evaluate: ReductionLoops::usage=@>@|
@=  "ReductionLoops is an option for MVPolygonReduce.@>@|
@=  It gives the maximum number of polygon reduction interations."@>@|


@ Since rotations around the Euler angles are a bit hard to imagine
the functions for rotation of \Math objects is added.
@<Additional \Math-definitions@>+=
@=:Evaluate:@>@|
@=    rotationmatrix[axis_?VectorQ,theta_?NumericQ] :=@>@|
@=	Module[{nx,ny,nz,st,ct,norm},@>@|
@=    norm=Sqrt[Dot[axis,axis]];@>@|
@=    If[norm<$MachineEpsilon, Return[IndentityMatrix[3]] ];@>@|
@=    {nx,ny,nz} = N[axis/norm];@>@|
@=    {ct,st}=N[{Cos[theta],Sin[theta]}];@>@|
@=	   N[{{ nx^2 + (1 - nx^2)*ct,nx*ny*(1 - ct) + nz*st,nx*nz*(1 - ct) - ny*st},@>@|
@= 	     { nx*ny*(1 - ct) - nz*st,ny^2 + (1 - ny^2)*ct,ny*nz*(1 - ct) + nx*st},@>@|
@=	     { nx*nz*(1 - ct) + ny*st,ny*nz*(1 - ct) - nx*st,nz^2 + (1 - nz^2)*ct}}]@>@|
@=	]@>@|

@ Here is the \Math{} function that does the rotation.
@<Additional \Math-definitions@>+=
@=:Evaluate:Options[MVRotate3D]={@>@|
@=  RotationCenter->{0.,0.,0.},@>@|
@=  MVObject->All,@>@|
@=  MVUpdateDisplay->True }@>@|

@=:Evaluate:moveObjToNumber[obj_]:=@>@|
@=  Switch[obj,@>@|
@=     All, 0, @>@|
@=     Global`MVScene3D[], 1, @>@|
@=     Global`MVMesh3D[_Integer], First[obj], @>@|
@=     _, $Failed]@>@|

@=:Evaluate:MVRotate3D::invcntr="RotationCenter must be a vector of 3 numbers."@>@|
@=:Evaluate:MVRotate3D::invtrgt="MVObject must be All, MVScene3D[] or MVMesh3D[_]."@>@|
@=:Evaluate:@>@|
@=    MVRotate3D[gr_Graphics3D,axis_?VectorQ,th_?NumericQ,opts___?OptionQ]:=@>@|
@=	Module[{rmat,h,pts,pnt,cntr},@>@|
@=    cntr=N[RotationCenter /. {opts} /. Options[MVRotate3D]] /. 0->0.;@>@|
@=    If[!VectorQ[cntr,NumericQ] && 3===Length[cntr],@>@|
@=      Message[MVRotate3D::invcntr];@>@|
@=      Return[gr];@>@|
@=     ];@>@|
@=	  rmat=rotationmatrix[axis,th];@>@|
@=    gr /.{ (h:Line | Polygon)[pts_] :> h[cntr+Dot[rmat,#-cntr] & /@@ pts],@>@|
@=    Point[pnt_] :> Point[Dot[rmat,pnt]]}@>@|
@=	 ]@>@|

@ The \.{MeshGraphics3D} must be rotated as well.
@<Additional \Math-definitions@>+=
@=:Evaluate:@>@|
@=   MVRotate3D[MeshGraphics3D[n_,m_,mdata_,rargs__],@>@|
@=     axis_?VectorQ,th_?NumericQ,opts___?OptionQ]:=@>@|
@=     Module[{rmat,rot,plrange,cntr},@>@|
@=       cntr=N[RotationCenter /. {opts} /. Options[MVRotate3D]] /. 0->0.;@>@|
@=       If[!VectorQ[cntr,NumericQ] && 3===Length[cntr],@>@|
@=         Message[MVRotate3D::invcntr];@>@|
@=         Return[MeshGraphics3D[n,m,mdata,rargs]];@>@|
@=        ];@>@|
@=	     rmat=rotationmatrix[axis,th];@>@|
@=       rot=Map[cntr+Dot[rmat,#-cntr] &,mdata,{2}];@>@|
@=       plrange={Min[#],Max[#] } & /@@@>@|
@=         Transpose[Flatten[rot,1]];@>@|
@=       MeshGraphics3D[n,m,rot,rargs] /.@>@|
@=         (PlotRange->_):>(PlotRange->plrange)@>@|
@=      ]@>@|

@ @<Additional \Math-definitions@>+=
@=:Evaluate:@>@|
@=  MVRotate3D[axis_ /; VectorQ[axis,NumericQ], th_?NumericQ,opts___?OptionQ]:=@>@|
@=    Module[{cntr,target,update,updisplay},@>@|
@=       cntr=N[RotationCenter /. {opts} /. Options[MVRotate3D]] /. 0->0.;@>@|
@=       If[!VectorQ[cntr,NumericQ] && 3===Length[cntr],@>@|
@=         Message[MVRotate3D::invcntr];@>@|
@=         Return[MeshGraphics3D[n,m,mdata,rargs]];@>@|
@=        ];@>@|
@=      target=MVObject /. {opts} /. Options[MVRotate3D];@>@|
@=      updisplay=MVUpdateDisplay /. {opts} /. Options[MVRotate3D];@>@|
@=      If[All===target, update=1, update=0];@>@|
@=      If[TrueQ[updisplay],update+=2];@>@|
@=      target=moveObjToNumber[target];@>@|
@=      If[$Failed===target,@>@|
@=        Message[MVRotate3D::invtrgt]; @>@|
@=        Return[$Failed]; @>@|
@=       ];@>@|
@=      Global`mvRotate3D[target,Sequence @@@@ (N[{axis,th}] /. 0->0.0), cntr,update]@>@|
@=     ]@>@|

@ The translation may be also usefull.
@<Additional \Math-definitions@>+=
@=:Evaluate:Options[MVTranslate3D]={MVObject->All,MVUpdateDisplay->True}@>@|
@=:Evaluate:@>@|
@=    MVTranslate3D[gr_Graphics3D,move_?VectorQ]:=@>@|
@=	Module[{h,pts,pnt},@>@|
@=    gr /.{ (h:Line | Polygon)[pts_] :> h[move+# & /@@ pts],@>@|
@=	         Point[pnt_] :> Point[move+pnt]}@>@|
@=	 ]@>@|

@ @<Additional \Math-definitions@>+=
@=:Evaluate:@>@|
@=  MVTranslate3D[MeshGraphics3D[n_,m_,mdata_,rargs__],@>@|
@=   move_?VectorQ]:=@>@|
@=   Module[{tran,plrange},@>@|
@=   tran=Map[Plus[move,#] &,mdata,{2}];@>@|
@=   plrange={Min[#],Max[#] } & /@@@>@|
@=    Transpose[Flatten[tran,1]];@>@|
@=   MeshGraphics3D[n,m,tran,rargs] /.@>@|
@=     (PlotRange->_):>(PlotRange->plrange)@>@|
@=  ]@>@|

@ @<Additional \Math-definitions@>+=
@=:Evaluate:@>@|
@=   MVTranslate3D[move_ /; VectorQ[move,NumericQ],opts___?OptionQ]:=@>@|
@=     Module[{target,update,udisplay},@>@|
@=      target=MVObject /. {opts} /. Options[MVTranslate3D];@>@|
@=      If[All===target, update=1, update=0];@>@|
@=      target=moveObjToNumber[target];@>@|
@=      updisplay=MVUpdateDisplay /. {opts} /. Options[MVTranslate3D];@>@|
@=      If[TrueQ[updisplay],update+=2];@>@|
@=      If[$Failed===target,@>@|
@=        Message[MVRotate3D::invtrgt]; @>@|
@=        Return[$Failed]; @>@|
@=       ];@>@|
@=       Global`mvTranslate3D[target,Sequence @@@@ (N[move] /. 0->0.0),update]@>@|
@=      ]@>@|

@ @<Usage for \Math\ functions and symbols@>+=
@=:Evaluate: RotationCenter::usage=@>@|
@=  "RotationCenter is an option for MVRotate3D[], it specify a 3d@>@|
@= point as center of the rotation."@>@|

@ @<Usage for \Math\ functions and symbols@>+=
@=:Evaluate: MVObject::usage=@>@|
@= "MVObject is an option for MVRotate3D[] and MVTranslate3D[]. It specify the object@>@|
@= that will be transformed. Possible values are All, MVScene3D[] and a MVMesh3D[] object."@>@|
@ @<Usage for \Math\ functions and symbols@>+=

@=:Evaluate: MVUpdateDisplay::usage=@>@|
@= "MVUpdateDisplay is an option for MVRotate3D[] and MVTranslate3D[]. If True the new@>@|
@= object positions are show, if False the motion of the objects is not finshed."@>@|

@ @<Usage for \Math\ functions and symbols@>+=
@=:Evaluate: MVRotate3D::usage=@>@|
@=  "MVRotate3D[graph3d,vec,angle] will rotate the graphics 3d object arround vec by angle."@>@|

@ @<Usage for \Math\ functions and symbols@>+=
@=:Evaluate: MVTranslate3D::usage=@>@|
@=  "MVTranslate3D[graph3d,move] will translate the graphics 3d object by move."@>@|

@ @<Usage for \Math\ functions and symbols@>+=
@=:Evaluate:MVCreatePalette::usage=@>@|
@=  "MVCreatePalette[] will create a Mathematica 3.0 palette for MathGL3d."@>@|

@ @<Additional \Math-definitions@>+=
@=:Evaluate:Options[MVWriteEPS]={EPSBitmap->False}@>@|

@ @<Additional \Math-definitions@>+=
@=:Evaluate:MVWriteEPS[fname_String,opts___]:=@>@|
@=  Module[{wbitmap,filename},@>@|
@=    wbitmap=EPSBitmap /. {opts} /. Options[MVWriteEPS];@>@|
@=    If[TrueQ[wbitmap],@>@|
@=      wbitmap=1,@>@|
@=      wbitmap=0@>@|
@=     ];@>@|
@=	  filename=StringReplace[fname,"/" -> $PathnameSeparator];@>@|
@=    filename=MakeSaveFilename[filename];@>@|
@=    Global`mvWritePostScript[filename,wbitmap]@>@|
@=  ]@>@|

@ @<Additional \Math-definitions@>+=
@=:Evaluate:MVWriteEPS[fname_String,@>@|
@=            gr:(_Graphics3D|_SurfaceGraphics |_MeshGraphics3D),@>@|
@=            opts___?OptionQ]:=@>@|
@=	  (MVClear[];MVShow3D[gr,opts];@>@|
@=     MVWriteEPS[fname,FilterOptions[WVWriteEPS,opts]])@>@|

@ @<Usage for \Math\ functions and symbols@>+=
@=:Evaluate:MVWriteEPS::usage=@>@|
@= "MVWriteEPS[file] will write a encapsulate PostScript file from the current@>@|
@= contens of the MathGL3d window. MVWriteEPS[file,graph3d,opt] will clear the@>@|
@= window pass graph3d with options opt to MathGL3d and write a PostScript file."@>@|

@ @<Usage for \Math\ functions and symbols@>+=
@=:Evaluate:EPSBitmap::usage=@>@|
@= "EPSBitmap is an option vor MVWriteEPS[].@>@|
@= With EPSBitmap->True the bitmap image is saved instead of the@>@|
@= resolution independent image."@>@|

@ @<Additional \Math-definitions@>+=
@=:Evaluate:MVWriteOFF[fname_String]:=@>@|
@=  Global`mvWriteOFF[MakeSaveFilename[StringReplace[fname,"/"->$PathnameSeparator]]]@>@|

@ @<Additional \Math-definitions@>+=
@=:Evaluate:MVWriteOFF[fname_String,@>@|
@=            gr:(_Graphics3D|_SurfaceGraphics |_MeshGraphics3D),@>@|
@=            opts___?OptionQ]:=@>@|
@=	  (MVClear[];MVShow3D[gr,opts];Global`mvWriteOFF[fname])@>@|

@ @<Usage for \Math\ functions and symbols@>+=
@=:Evaluate:MVWriteOFF::usage=@>@|
@= "MVWriteOFF[file] will write a OFF file in Geomviews 3d input file format.@>@|
@= MVWriteOFF[file,graph3d,opt] will clear the window and pass graph3d to@>@|
@= MathGL3d and write a OFF file form the data."@>@|

@ @<Additional \Math-definitions@>+=
@=:Evaluate:ExpandTextureFileName[s_String /;@>@|
@=   StringMatchQ[s,"*`"] && !StringMatchQ[s,"`*"]]:=StringDrop[s,-1]<>".png"@>@|
@=:Evaluate:ExpandTextureFileName[s_String /;@>@|
@=   StringMatchQ[s,"`*"]]:=@>@|
@=  Module[{filename},@>@|
@=	   filename=ExpandTextureFileName[StringDrop[s,1]];@>@|
@=    First[@>@|
@=      Select[@>@|
@=        FileNames["*.png",StringDrop[ToFileName[#],-1] & /@@@>@|
@=            Global`$MVTexturePath],@>@|
@=        StringMatchQ[#,"*"<>filename] &@>@|
@=       ]@>@|
@=     ]@>@|                                                                  
@=   ]@>@|

@ @<Usage for \Math\ functions and symbols@>+=
@=:Evaluate:ExpandTextureFileName::usage=@>@|
@=  "ExpandTextureFileName[string] will search texture@>@|
@= names with `name` in the $MVTexturePath variable."@>@|

@ @<\ML-Functions@>=
@<Check the command line for \ML@>@;
@<Evaluate one message from \Math@>@;
@<Scan the graphics data@>@;
@<\Math-Interface for the polygon reduction@>@;
@<Get a \.{Graphics3D} object from \Math@>@;
@<Clear the display@>@;
@<Spin the graphics from \Math@>@;
@<Stop spin of the object@>@;
@<Send the pool size to \Math@>@;
@<Save a POVRay file from \Math@>@;
@<Save a QuickDraw3D file from \Math@>@;
@<Save the data in VRML 2.0 format from \Math@>@;
@<Load a 3Script into \.{mathview3d}@>@;
@<Save a DXF file from \Math@>@;
@<Load a DXF file into \.{mathview3d}@>@;
@<Write a OFF from the \.{mathview3d} data@>@;
@<Load a OFF file into \.{mathview3d}@>@;
@<Save the picture to PostScript@>@;
@<Save the bitmap of the picture as PNG graphics@>@;
@<Save the depth buffer of the OpenGL window to a PNG file@>@;
@<Save the SIRDS from the depth buffer to a file@>@;
@<Return the bounding box to \Math@>@;
@<Return the view point to \Math@>@;
@<Return the light sources to \Math@>@;
@<Stuff to send the graphics data to \Math@>@;
@<Send the image as bitmap to \Math@>@;
@<Load a PNG file as texture@>@;
@<Load a \Math{}-graphics as texture@>@;
@<Load a \.{RasterArray[]} as texture@>@;
@<Send the list of all texture data@>@;
@<Map a texture to an object@>@;
@<Reset the view parameter from \Math@>@;
@<Zoom the picture from \Math@>@;
@<Show the MathView3D window@>@;
@<Hide the MathView3D window@>@;
@<Pop the MathView3D window@>@;
@<Push the MathView3D window@>@;
@<Iconify the MathView3D window@>@;
@<Reshape the main window from \Math{}@>@;
@<Rotate the data inside \.{mathview3d}@>@;
@<Translate the data inside \.{mathview3d}@>@;

@ @<Send the pool size to \Math@>=
int mvGetPoolSize(void)
{
  return PoolSize;
}

@ @<Function prototypes@>=
void mvClearContents(void);

@ @<Clear the display@>=
void mvClearContents(void)
{ int i;
  
  @<Clear the local 3d data@>@;
  DoTracking=DoTrackSpin=GL_FALSE;
  ZoomMove.x=ZoomMove.y=ZoomMove.z=0.0;
  RadialZoom=1.0;
  TrackAngle=0.0;
  TrackAxis.x=TrackAxis.y=0.0;
  TrackAxis.z=1.0;
  ScreenXStart=ScreenX=0;
  ScreenYStart=ScreenY=0;
  BoxRatios.x=BoxRatios.y=BoxRatios.z=1.0;
  BlackBackground=GL_TRUE;
  MVFaceFlip=GL_FALSE;
  Axis.AxisType=NoAxis;
  LightNo=0;
  glutSetCursor(GLUT_CURSOR_LEFT_ARROW);
  @<Update the object and the viewpoint@>@;
  @<Finish \Math-menu@>@;
}

@ @<Clear the local 3d data@>=
  if (PointPool) free(PointPool);
  PointPool=NULL;
  if(NormalPool)
    for(i=0; i<PoolSize; i++)
      if(NormalPool[i]) free(NormalPool[i]);
  if(NormalPool) free(NormalPool);
  NormalPool=NULL;
  MaxPoolSize=PoolSize=0;
  Points=RemovePointList(Points);
  OctalPointTree=RemovePointOctTree(OctalPointTree);
  Lines=RemoveLinePolyList(Lines);
  Polygons=RemoveLinePolyList(Polygons);
  Meshes=RemoveMesh3DList(Meshes);
  Textures=RemoveTextureList(Textures);
  if(SceneTextureMap)
    SceneTextureMap=DeleteTextureMapping(SceneTextureMap);
  glDeleteLists(ObjID,1);
  ObjID=-1;

@ @<Reset the view parameter from \Math@>=
void mvReset(void);
void mvReset(void)
{
  @<Reset the global parameter@>@;
  @<Finish \Math-menu@>@;
}

@ @<Show the MathView3D window@>=
void mvShowWindow(void);
void mvShowWindow(void)
{
  glutShowWindow();
  @<Finish \Math-menu@>@;
}

@ @<Pop the MathView3D window@>=
void mvPopWindow(void);
void mvPopWindow(void)
{
  glutSetWindow(MVDrawWindow);
  glutPopWindow();
  @<Finish \Math-menu@>@;
}

@ @<Push the MathView3D window@>=
void mvPushWindow(void);
void mvPushWindow(void)
{
  glutSetWindow(MVDrawWindow);
  glutPushWindow();
  @<Finish \Math-menu@>@;
}

@ @<Hide the MathView3D window@>=
void mvHideWindow(void);
void mvHideWindow(void)
{
  glutHideWindow();
  @<Finish \Math-menu@>@;
}

@ @<Iconify the MathView3D window@>=
void mvIconifyWindow(void);
void mvIconifyWindow(void)
{
  glutIconifyWindow();
  @<Finish \Math-menu@>@;
}

@ @<Zoom the picture from \Math@>=
void mvZoom(double zoom);
void mvZoom(double zoom)
{ double vr,vphi,vtheta;

  RadialZoom*=zoom;
  @<Recalculate the zoom translation@>@;
  glutPostRedisplay();
  MLPutDouble(stdlink,RadialZoom);
}

@ @<Finish \Math-menu@>=
  glutPostRedisplay();
  if(DoMathematicaCall) {
    MLPutSymbol(stdlink,"True");
    MLFlush(stdlink);
   }

@ @<Reshape the main window from \Math{}@>=
void mvReshape(int w, int h);
void mvReshape(int w, int h)
{ int w0,h0;

  glutSetWindow(MVDrawWindow);
  w0=glutGet(GLUT_WINDOW_WIDTH);
  h0=glutGet(GLUT_WINDOW_HEIGHT);
  glutReshapeWindow(w,h);
  MLPutFunction(stdlink,"List",2);
    MLPutInteger(stdlink,w0);
    MLPutInteger(stdlink,h0);
}

@ @<Spin the graphics from \Math@>=
void mvSpin(double angle,double *axis, long int n);
void mvSpin(double angle,double *axis, long int n)
{ double atrack;

  if(3!=n) {
    MLPutSymbol(stdlink,"$Failed");
    return;
   }
  TrackAxis.x=axis[0];@+ TrackAxis.y=axis[1]; TrackAxis.z=axis[2];
  atrack=Norm(&TrackAxis);
  if(atrack!=0.0) {
    TrackAxis.x/=atrack;
    TrackAxis.y/=atrack;
    TrackAxis.z/=atrack;
   }
  else {
    MLPutSymbol(stdlink,"$Failed");
    return;
   }
  TrackAngle=angle;
  if(TrackAngle>0.0)
    DTrackAngle=MIN(TWO_PI/90.0,TrackAngle);
  else
    DTrackAngle=MAX(-TWO_PI/90.0,TrackAngle);
  DoTrackSpin=GL_TRUE;
  DoTracking=GL_TRUE;
  GetMouseTrack=GL_FALSE;
  MLPutSymbol(stdlink,"Null");
}

@ @<Stop spin of the object@>=
void mvStopSpin(void);
void mvStopSpin(void)
{
  @<Stop spining by parameter reset@>@;
  @<Finish \Math-menu@>@;
}


@ @<Return the bounding box to \Math@>=
void mvSendBoundingBox(void);
void mvSendBoundingBox(void)
{ int i;
  if(Points || Lines || Polygons || Meshes) {
    MLPutFunction(stdlink,"List",2);
    MLPutRealList(stdlink,(double *) &BoundP1,3L);
    MLPutRealList(stdlink,(double *) &BoundP2,3L);
   }
  else {
    MLPutFunction(stdlink,"List",2);
    @<Send three \.{Indeterminate} symbols@>@;
    @<Send three \.{Indeterminate} symbols@>@;
   }
}

@ @<Send three \.{Indeterminate} symbols@>=
MLPutFunction(stdlink,"List",3);
for(i=0; i<3; i++)
  MLPutSymbol(stdlink,"Indeterminate");


@ @<Return the view point to \Math@>=
void mvSendViewPoint(void)
{
  MLPutRealList(stdlink,(double *) &ViewPoint,3L);
}

@ @<Return the light sources to \Math@>=
void mvSendLightSources(void);
void mvSendLightSources(void)
{ int i;

  MLPutFunction(stdlink,"List",LightNo);
  for(i=0; i<LightNo; i++) {
    MLPutFunction(stdlink,"List",2L);
      MLPutRealList(stdlink,(double *) (LightPosition+i),3L);
      MLPutFunction(stdlink,"RGBColor",3L);
        MLPutDouble(stdlink,LightColor[i].r);
        MLPutDouble(stdlink,LightColor[i].g);
        MLPutDouble(stdlink,LightColor[i].b);
   }
}

@ The individual rotation of all scene elements, of the scene and of an individual
mesh is possible.
@d ALL_OBJECTS   (0)
@d SCENE_OBJECTS (1)
@d TransformSceneQ(type)  ((ALL_OBJECTS==type) || (SCENE_OBJECTS==type))
@d TransformMeshQ(type,meshid)  ((ALL_OBJECTS==type) || (type==meshid))
@d BoxUpdateQ(up)  (1==((up) & 1))
@d DisplayUpdateQ(up)  (2==((up) & 2))

@<Rotate the data inside \.{mathview3d}@>=
void mvRotate3D(int, double *, long int, double, double *,long int, int);
void mvRotate3D(int what, 
        double *axis, long int l1, 
        double theta, 
        double *cntr,long int l2, 
        int update)
{ double rmat[3][3];
  double norm,ct,st;
  double nx,ny,nz;
  register double x,y,z,ox,oy,oz;
  double xMin,xMax,yMin,yMax,zMin,zMax;
  Mesh3DList *mlst=Meshes;
  int i;

  if(l1!=3L || l2!=3L) {
    MLPutSymbol(stdlink,"$Failed");
    return;
   } 
  norm=sqrt(axis[0]*axis[0]+axis[1]*axis[1]+axis[2]*axis[2]);
  nx=axis[0]/norm;
  ny=axis[1]/norm;
  nz=axis[2]/norm;
  if(norm<1.0e-12) {
    MLPutSymbol(stdlink,"$Failed");
    return;
   }
  else { 
    MLPutFunction(stdlink,"List",2);
      MLPutFunction(stdlink,"List",3);
        MLPutDouble(stdlink,nx);
        MLPutDouble(stdlink,ny);
        MLPutDouble(stdlink,nz);
      MLPutDouble(stdlink,theta);
    }
  ct=cos(theta); @+ st=sin(theta);
  xMin=yMin=zMin=FLT_MAX;
  xMax=yMax=zMax=-FLT_MAX;
  @<Make rotation matrix |rmat| from the normal and the angle@>@;
  if(TransformSceneQ(what)) {
    for(i=0; i<PoolSize; i++) {
      ox=PointPool[i].x-cntr[0]; @+ 
      oy=PointPool[i].y-cntr[1]; @+ 
      oz=PointPool[i].z-cntr[2];
      @<Matrix multiplication for rotation@>@;
      if(BoxUpdateQ(update)) DXFUpdateBBox(x,y,z);
      PointPool[i].x=x+cntr[0]; @+
      PointPool[i].y=y+cntr[1]; @+
      PointPool[i].z=z+cntr[2];
     }
   }  
  while(mlst) {
    if(TransformMeshQ(what,MeshID(mlst))) {
      for(i=0; i<mlst->mPointNo; i++) {
        ox=mlst->mPoints[i].x-cntr[0]; @+ 
        oy=mlst->mPoints[i].y-cntr[1]; @+
        oz=mlst->mPoints[i].z-cntr[2];
        @<Matrix multiplication for rotation@>@;
        if(BoxUpdateQ(update)) DXFUpdateBBox(x,y,z);
        mlst->mPoints[i].x=x+cntr[0]; @+ 
        mlst->mPoints[i].y=y+cntr[1]; @+ 
        mlst->mPoints[i].z=z+cntr[2];
        ox=mlst->mNormals[i].x; @+ oy=mlst->mNormals[i].y; @+oz=mlst->mNormals[i].z;
        @<Matrix multiplication for rotation@>@;
        mlst->mNormals[i].x=x; @+ mlst->mNormals[i].y=y; @+ mlst->mNormals[i].z=z;
       }
     }  
    mlst=mlst->next;
   }
  if(BoxUpdateQ(update)) {
    BoundP1.x=xMin; @+ BoundP1.y=yMin; @+ BoundP1.z=zMin;
    BoundP2.x=xMax; @+ BoundP2.y=yMax; @+ BoundP2.z=zMax;
   } 
  if(DisplayUpdateQ(update)) {
    @<Update the object and the viewpoint@>@;
   } 
}

@ @<Matrix multiplication for rotation@>=
{
  x=rmat[0][0]*ox+rmat[0][1]*oy+rmat[0][2]*oz;
  y=rmat[1][0]*ox+rmat[1][1]*oy+rmat[1][2]*oz;
  z=rmat[2][0]*ox+rmat[2][1]*oy+rmat[2][2]*oz;
}

@ @<Make rotation matrix |rmat| from the normal and the angle@>=
{
  rmat[0][0]=nx*nx + (1. - nx*nx)*ct;    @+
  rmat[0][1]=nx*ny*(1. - ct) + nz*st;    @+
  rmat[0][2]=nx*nz*(1. - ct) - ny*st;

  rmat[1][0]=nx*ny*(1. - ct) - nz*st;    @+
  rmat[1][1]=ny*ny + (1. - ny*ny)*ct;    @+
  rmat[1][2]=ny*nz*(1. - ct) + nx*st;

  rmat[2][0]=nx*nz*(1. - ct) + ny*st;  @+
  rmat[2][1]=ny*nz*(1. - ct) - nx*st;  @+
  rmat[2][2]=nz*nz + (1. - nz*nz)*ct;
}

@ The global boundig box is update when |boxUpdate| is |GL_TRUE|,
  otherwise the bounding box is unchanged.
@<Translate the data inside \.{mathview3d}@>=
void mvTranslate3D(int what, double nx, double ny, double nz, int update);
void mvTranslate3D(int what, double nx, double ny, double nz, int update)
{ double norm;
  register double x,y,z;
  double xMin,xMax,yMin,yMax,zMin,zMax;
  register int i;
  Mesh3DList *mlst=Meshes;

  norm=sqrt(nx*nx+ny*ny+nz*nz);
  if(norm<1.0e-12) {
    MLPutSymbol(stdlink,"$Failed");
    return;
   }
  else {
    MLPutFunction(stdlink,"List",3);
      MLPutDouble(stdlink,nx);
      MLPutDouble(stdlink,ny);
      MLPutDouble(stdlink,nz);
   }
  xMin=yMin=zMin=FLT_MAX;
  xMax=yMax=zMax=-FLT_MAX;
  if(TransformSceneQ(what)) {
    for(i=0; i<PoolSize; i++) {
      x=PointPool[i].x+nx; @+ y=PointPool[i].y+ny; @+ z=PointPool[i].z+nz;
      if(BoxUpdateQ(update)) DXFUpdateBBox(x,y,z);
      PointPool[i].x=x; @+
      PointPool[i].y=y; @+
      PointPool[i].z=z;
     }
   }  
  while(mlst) {
     if(TransformMeshQ(what,MeshID(mlst))) {
       for(i=0; i<mlst->mPointNo; i++) {
         x=mlst->mPoints[i].x+=nx; @+ y=mlst->mPoints[i].y+=ny; @+ z=mlst->mPoints[i].z+=nz;
         if(BoxUpdateQ(update)) DXFUpdateBBox(x,y,z);
        }
      }
     mlst=mlst->next;
   } 
  if(BoxUpdateQ(update)) {
    BoundP1.x=xMin; @+ BoundP1.y=yMin; @+ BoundP1.z=zMin;
    BoundP2.x=xMax; @+ BoundP2.y=yMax; @+ BoundP2.z=zMax;
   } 
  if(DisplayUpdateQ(update)) {
    @<Update the object and the viewpoint@>@;
   } 
}

@ We return the number of reduced polygons to \Math.
@<\Math-Interface for the polygon reduction@>=
int MLPolygonReduce(double tol, int iter);
int MLPolygonReduce(double tol, int iter)
{ int dpoly;

  dpoly=0;
  if(Polygons) 
     dpoly=SimplifyPolygones(iter, tol,OctalPointTree);
  if(dpoly) {
    @<Update the object and the viewpoint@>@;
   }
  return dpoly;
}


@ @<Function prototypes@>=
void mlWritePOVray(const char *, const char *,const char *);

@ @<Save a POVRay file from \Math@>=
void mlWritePOVray(const char *fname, const char *ptexpre,const char *mtexpre)
{ int res;
  char filename[512];
  int i,j,n;

  @<Remove double backslashs from file |fname|@>@;
  res=WritePOVray(filename,SmoothShading,ptexpre,mtexpre);
  if(res)
    MLPutSymbol(stdlink,"$Failed");
  else
    MLPutString(stdlink,fname);
}

@ @<Function prototypes@>=
void mlWrite3DMF(const char *, int ,int);

@ @<Save a QuickDraw3D file from \Math@>=
void mlWrite3DMF(const char *fname, int savelight,int saveview)
{ int res;
  char filename[512];
  int i,j,n;

  @<Remove double backslashs from file |fname|@>@;
  res=Write3DMF(filename,savelight,saveview);
  if(res)
    MLPutSymbol(stdlink,"$Failed");
  else
    MLPutString(stdlink,fname);
}

@ @<Remove double backslashs from file |fname|@>=
  n=strlen(fname);
  for(j=i=0; i<n; i++)
    if(fname[i]!='\\')
      filename[j++]=fname[i];
    else if(fname[++i]=='\\')
      filename[j++]='\\';
  filename[j++]=fname[n]; @+ filename[j+1]='\0';
#ifdef __WIN32__
  n=strlen(filename);
  for(i=0; i<n; i++)
    if('/'==filename[i]) filename[i]='\\';
#elif MACINTOSH_MATHLINK
  n=strlen(filename);
  for(i=0; i<n; i++)
    if('/'==filename[i]) filename[i]=':';
#endif

@ @<Function prototypes@>=
void MVLoad3Script(const char *fname);

@ @<Load a 3Script into \.{mathview3d}@>=
void MVLoad3Script(const char *fname)
{ int res;
  char filename[512];
  int i,j,n;
  Point3D b1,b2;
  
  @<Hide all control dialog windows@>@; 
  @<Remove double backslashs from file |fname|@>@;
  b1=BoundP1; @+ b2=BoundP2;
  res=Read3Script(filename);
  if(res)
    MLPutSymbol(stdlink,"$Failed");
  else {
    MLPutString(stdlink,fname);
    BoundP1.x=MIN(b1.x,BoundP1.x);
    BoundP1.y=MIN(b1.y,BoundP1.y);
    BoundP1.z=MIN(b1.z,BoundP1.z);
    BoundP2.x=MAX(b2.x,BoundP2.x);
    BoundP2.y=MAX(b2.y,BoundP2.y);
    BoundP2.z=MAX(b2.z,BoundP2.z);
   }
  AveragedNormals(Polygons);
  @<Update the object and the viewpoint@>@;
}


@ @<Function prototypes@>=
void mlWriteDXF(const char *, double, int, double, double);

@ @<Save a DXF file from \Math@>=
void mlWriteDXF(const char *fname,
                   double ts, int tseg, double pssize, double tangle)
{ int res;
  double tsSave,psSave,cosaSave;
  int tsegSave;
  char filename[512];
  int i,j,n;

  tsSave=LineTubeSize;
  LineTubeSize=ts;
  tsegSave=TubeSegments;
  TubeSegments=tseg;
  psSave=PointSphereSize;
  PointSphereSize=pssize;
  cosaSave=CosSkipCont;
  CosSkipCont=cos(ToRadian*(fabs(tangle)<MaxLSAngle ? tangle : MaxLSAngle));
  @<Remove double backslashs from file |fname|@>@;
  res=WriteDXF(filename);
  LineTubeSize=tsSave;
  TubeSegments=tsegSave;
  PointSphereSize=psSave;
  CosSkipCont=cosaSave;
  if(res)
    MLPutSymbol(stdlink,"$Failed");
  else
    MLPutString(stdlink,fname);
}

@ @<Function prototypes@>=
void MVLoadDXF(const char *fname);

@ @<Load a DXF file into \.{mathview3d}@>=
void MVLoadDXF(const char *fname)
{ int res;
  char filename[512];
  int i,j,n;

  @<Hide all control dialog windows@>@;
  @<Remove double backslashs from file |fname|@>@;
  res=ReadDXF(filename);
  if(!res)
    MLPutSymbol(stdlink,"$Failed");
  else
    MLPutString(stdlink,fname);
  AveragedNormals(Polygons);
  @<Update the object and the viewpoint@>@;
}

@ @<Update the object and the viewpoint@>=
  BoxRatios.x=BoxRatios.y=BoxRatios.z=1.0;
  @<Delete the object and make a new view@>@;

@ @<Delete the object and make a new view@>=
  glutSetWindow(MVDrawWindow);
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  if(ObjID>=0) glDeleteLists(ObjID,1);
  ObjID=-1;
  InitView(GL_TRUE);
  glutPostRedisplay();
  MakeNewView=GL_TRUE;

@ @<Hide the view point control dialog@>=
{ ViewCntrlWin *vc;

  if(VCWindow) {
    vc=VCWindow;
    if(glutGetWindow()==VCWindow->WinID) {
      @<Hide the preview of the |vc| window@>@;    
      glutHideWindow();
     }
    else {
      @<Hide the preview of the |vc| window@>@;    
      glutSetWindow(VCWindow->WinID);
      glutHideWindow();
     }
   }  
  glutSetWindow(MVDrawWindow);
}

@ @<Hide the light control dialog@>=
{ LightCntrlWin *vc;

  if(LCWindow) {
    vc=LCWindow;
    if(glutGetWindow()==LCWindow->WinID) {
      @<Hide the preview of the |vc| window@>@;    
      glutHideWindow();
     }
    else {
      @<Hide the preview of the |vc| window@>@;    
      glutSetWindow(LCWindow->WinID);
      glutHideWindow();
     }
   }  
  glutSetWindow(MVDrawWindow);
}

@ @<Hide the axis control dialog@>=
{ AxisCtrlWin *vc;

  if(AxisWindow) {
    vc=AxisWindow;
    if(glutGetWindow()==AxisWindow->WinID) {
      @<Hide the preview of the |vc| window@>@;    
      glutHideWindow();
     }
    else {
      @<Hide the preview of the |vc| window@>@;    
      glutSetWindow(AxisWindow->WinID);
      glutHideWindow();
     }
   }
  glutSetWindow(MVDrawWindow);
}

@ For Macintosh computer we have to hide the seperate preview window
@<Hide the preview of the |vc| window@>=
#if MACINTOSH_MATHLINK
glutSetWindow(vc->PreviewWinID);
glutHideWindow();
glutSetWindow(vc->WinID);
#endif

@ @<Hide all control dialog windows@>=
  @<Hide the view point control dialog@>@;
  @<Hide the light control dialog@>@;
  @<Hide the axis control dialog@>@;
  
@ @<Function prototypes@>=
void mvWriteOFF(const char *fname);

@ @<Write a OFF from the \.{mathview3d} data@>=
void mvWriteOFF(const char *fname)
{ int res;
  char filename[512];
  int i,j,n;

  @<Remove double backslashs from file |fname|@>@;
  res=WriteOFF(filename);
  if(res)
    MLPutSymbol(stdlink,"$Failed");
  else
    MLPutString(stdlink,fname);
}

@ @<Function prototypes@>=
void MVLoadOFF(const char *fname);

@ @<Load a OFF file into \.{mathview3d}@>=
void MVLoadOFF(const char *fname)
{ int res;
  char filename[512];
  int i,j,n;
  
  @<Hide all control dialog windows@>@;
  @<Remove double backslashs from file |fname|@>@;
  res=ReadOFF(filename);
  if(res)
    MLPutSymbol(stdlink,"$Failed");
  else
    MLPutString(stdlink,fname);
  AveragedNormals(Polygons);
  @<Update the object and the viewpoint@>@;
}

@ @<Function prototypes@>=
void mlWritePostScript(const char *fname,int bitmapImage);

@ @<Save the picture to PostScript@>=
void mlWritePostScript(const char *fname,int bitmapImage)
{ char filename[512];
  int i,j,n;

  @<Remove double backslashs from file |fname|@>@;
  if(bitmapImage)
#if defined(__UNDEF_BACKBUFFER)
    EPSSaveBitmap(filename,
      0,0,ScreenWidth,ScreenHeight,3,DrawBufferCopy,ScreenWidth/72.);
#else
    EPSSaveFrameBuffer(filename,
      0,0,glutGet(GLUT_WINDOW_WIDTH),glutGet(GLUT_WINDOW_HEIGHT));
#endif
  else
    WritePostScript(filename);
  MLPutString(stdlink,fname);
}

@ @<Function prototypes@>=
void mlRawWriteVRML(const char *fname,int headlight,int useextrude,
     const char *ptexpre,const char *mtexpre);

@ @<Save the data in VRML 2.0 format from \Math@>=
void mlRawWriteVRML(const char *fname,int headlight,int useextrude,
     const char *ptexpre,const char *mtexpre)
{ char filename[512];
  int i,j,n;
  int res;

  @<Remove double backslashs from file |fname|@>@;
  res=WriteVRML(filename,headlight,useextrude,ptexpre,mtexpre);
  if(!res)
    MLPutString(stdlink,fname);
  else
    MLPutSymbol(stdlink,"$Failed");
}

@ @<Function prototypes@>=
void mlRawWritePNG(const char *fname,double gamma, int interlace);

@ @<Save the bitmap of the picture as PNG graphics@>=
void mlRawWritePNG(const char *fname,double gamma, int interlace)
{ char filename[512];
  int i,j,n,res;
  
  @<Hide all control dialog windows@>@;
  @<Remove double backslashs from file |fname|@>@;
  glutPostRedisplay();
#if defined(__UNDEF_BACKBUFFER)
  res=PNGSaveBitmap(filename,
     ScreenWidth,ScreenHeight,GL_RGB,
     DrawBufferCopy,interlace,gamma);  
#else
  res=PNGSaveFrameBuffer(filename,
        0,0,glutGet(GLUT_WINDOW_WIDTH),
            glutGet(GLUT_WINDOW_HEIGHT),interlace,gamma);
#endif
  if(res)
    MLPutString(stdlink,fname);
  else
    MLPutSymbol(stdlink,"$Failed");
}

@ When the data passed back to \Math{} we make explicit use of the
  fact that |ReadPNGTexture| pushes the new texture on the top
  of the texture list. We will use the \Math-symbols \.{MVScene[]}
  \.{MVMesh3D[]} and \.{MVTexture2D[]} to label the scene, the individual
  meshes and the textures.

@<Usage for functions in the Global context@>+=
@=:Evaluate:MVScene::usage=@>@|
@=  "MVScene[] is used as reference for the data in the scene for texture mapping."@>@|

@=:Evaluate:MVMesh3D::usage=@>@|
@=  "MVMesh3D[id] is used as reference for mesh number id texture mapping."@>@|

@=:Evaluate:MVTexture2D::usage=@>@|
@=  "MVTexture2D[id] is used as reference for texture number id texture mapping."@>@|

@=:Evaluate:@>@|
@=  Map[@>@|
@=    (#::usage=StringJoin[ToString[#]," is used as texture type identifyer."]) &,@>@|
@=    {MVLuminantTexture,MVLuminantAlphaTexture,MVRGBTexture,MVRGBAlphaTexture}@>@|
@=   ]@>@|

@ @<Load a PNG file as texture@>=
void mlLoadPNGTexture(const char *fname,double gamma)
{ char filename[512];
  int i,j,n;
  TextureList *tlst;

  @<Remove double backslashs from file |fname|@>@;
  tlst=ReadPNGTexture(Textures,filename,gamma,GL_TRUE);
  if(!tlst) {
    MLPutSymbol(stdlink,"$Failed");
    return;
   }
  Textures=tlst;
  @<Return the texture information from |tlst| to \Math@>@;
}

@ @<Return the texture information from |tlst| to \Math@>=
  MLPutFunction(stdlink,"List",4);
    MLPutFunction(stdlink,"MVTexture2D",1);
      MLPutInteger(stdlink,TextureID(tlst));
    @<Return the texture dimensions to \Math@>
    @<Return the texture type to \Math@>@;

@ @<Return the texture dimensions to \Math@>=
    MLPutInteger(stdlink,tlst->texWidth);
    MLPutInteger(stdlink,tlst->texHeight);

@ @<Return the texture type to \Math@>=
    switch(TextureType(tlst)) {
      case GL_LUMINANCE :
        MLPutSymbol(stdlink,"MVLuminantTexture");
        break;
      case GL_LUMINANCE_ALPHA :
        MLPutSymbol(stdlink,"MVLuminantAlphaTexture");
        break;
     case GL_RGB :
        MLPutSymbol(stdlink,"MVRGBTexture");
        break;
     case GL_RGBA :
        MLPutSymbol(stdlink,"MVRGBAlphaTexture");
        break;
     default :
        MLPutSymbol(stdlink,"Null");
        break;
    }

@ Make a texture from a \.{DisplayString[]} output.
We will get the string manual from the |stdlink|. \.{DisplayString[]}
must be used with the portable bitmap format \.{"PBM"}.
@<Load a \Math{}-graphics as texture@>=
void mlGraphicsToTexture(int clipborder)
{ int width,height,bitdepth,i,j,wclip,hclip;
  char  *unistr,*endstr,*pbm,*sp,*imagedata,*pbmclip;
  int len;
  TextureList *tlst;

  @<Convert output of \.{DisplayString[]} to an ASCII string@>@;
  @<Get the image dimensions form the |pbm| string@>@;
  @<Reverse \Math{}s bitmaps in $y$-direction@>@;
  if(clipborder) {
    ClipRGBImageBorder(width,height,(GLubyte *)pbm,
                       &wclip,&hclip,(GLubyte **) &pbmclip);
    tlst=CreateTexture(Textures,"Automatic",
           GL_RGB,wclip,hclip,(GLubyte *) pbmclip,3L*wclip*hclip,
           GL_TRUE);
   }
  else
    tlst=CreateTexture(Textures,"Automatic",
           GL_RGB,width,height,(GLubyte *) pbm,3L*width*height,
           GL_TRUE);
  if(!tlst) {
    MLPutSymbol(stdlink,"$Failed");
    free(imagedata);
    return;
   }
  Textures=tlst;
  @<Return the texture information from |tlst| to \Math@>@;
  free(imagedata);
}

@ Since |MLGetString| returns unicode we make the
  explicit conversion. The |MLNextCharacter| function is used
  to copy the ASCII characters to |pbm|.
@<Convert output of \.{DisplayString[]} to an ASCII string@>=
   MLGetString(stdlink,(const char **) &unistr);
   len=strlen(unistr);
   endstr=unistr+len;
   imagedata=pbm=(char *)calloc(len,sizeof(char));
   for(j=i=0,sp=unistr; i<len; i++) {
     pbm[j++]= (char) MLNextCharacter((const char **)&sp,(const char *)endstr);
     if(!pbm) break;
    }
   MLDisownString(stdlink,unistr);

@ @<Get the image dimensions form the |pbm| string@>=
{
  while(*pbm!='\012') pbm++; /* skip over |"P6\n"| */
  sscanf(++pbm,"%d %d\n",&width,&height);
  while(*pbm!='\012') pbm++;
  sscanf(++pbm,"%d",&bitdepth);
  bitdepth=8  /*|log((double)(bit_depth+1))/M_LN2|*/;
  while(*pbm!='\012') pbm++;
  pbm++;
}

@ The bitmap from \.{DisplayString[]} will start in the left upper corner
but for the texture mapping we need that the bitmap starts in the left lower
corner.
@ @<Reverse \Math{}s bitmaps in $y$-direction@>=
ReverseImageRows(width,height,3,(GLubyte *)pbm);

@ The native format for bitmaps in \Math{} is the \.{RasterArray[]}
primitive. |mlRasterToTexture| will be used to pass \.{RasterArray[]}s
from \Math{} to the OpenGL viewer.
|bytec| are the number of bytes uses per color
(one for gray and 3 for RGB colors), |w| is the width and |h| the height
of the image. The colors per pixel are passed as a linear |double| array in
|dpix|.
@<Load a \.{RasterArray[]} as texture@>=
void mlRasterToTexture(int bytec,int w, int h, double *dpix,long len)
{ GLubyte *pix;
  int ttype,i;
  TextureList *tlst;

  if(len!=bytec*w*h || 2==bytec || bytec>3 || bytec<1) {
    MLPutSymbol(stdlink,"$Failed");
    return;
   }
  pix=calloc(len,sizeof(GLubyte));
  ttype=(1==bytec ? GL_LUMINANCE : GL_RGB);
  for(i=0; i<len; i++) /* convert the float colors to bytes */
    pix[i]=(GLubyte ) (255*fabs(dpix[i]));
  tlst=CreateTexture(Textures,"Automatic",ttype,w,h,pix,bytec*w*h,GL_TRUE);
  if(!tlst) {
    MLPutSymbol(stdlink,"$Failed");
    free(pix);
    return;
   }
  Textures=tlst;
  @<Return the texture information from |tlst| to \Math@>@;
  free(pix);
}

@ Return the texture information to \Math{}.
@<Send the list of all texture data@>=
void mvSendTextureInfo(void)
{ TextureList *tlst;
  long int tno;

  tlst=Textures;
  tno=LengthTextureList(tlst);
  MLPutFunction(stdlink,"List",tno);
  while(tlst) {
    @<Return the texture information from |tlst| to \Math@>@;
    tlst=tlst->next;
   }
}

@ Define a mapping of an texture with |textureId| to the scene or an
existing mesh |geomId|. The map type is transfered in |texMapType|.

@ @<Additional \Math-definitions@>+=
@=:Evaluate:textureMapToInt={@>@|
@=  MVPlaneMapping->    2,@>@|
@=  MVCylinderMapping-> 4,@>@|
@=  MVSphereMapping->   8,@>@|
@=  MVTorusMapping->   16,@>@|
@=  MVMeshUVMapping-> 128,@>@|
@=  MVMeshVUMapping-> 256 }@>@|

@ @<Usage for \Math\ functions and symbols@>+=
@=:Evaluate:@>@|
@=  Map[@>@|
@=    (#::usage=StringJoin[ToString[#]," is used as texture mapping identifyer."]) &,@>@|
@=    {MVPlaneMapping,MVCylinderMapping,MVSphereMapping,@>@|
@=     MVTorusMapping,MVMeshUVMapping,MVMeshVUMapping}@>@|
@=   ]@>@|

@ @<Map a texture to an object@>=
#pragma argsused
void mlMapTexture(int geomId,int textureId,
                  int texMapType,
                  double *move, long int nm,
                  double *axis, long int na,
                  double angle,
                  double *scale,long int ns,
                  double scaleU,
                  double scaleV)
{ TextureMapping *tm,*tnew;
  Mesh3DList *mlst;
  TextureList *tlst;

  if(geomId<0 || textureId<0) @<Mapping failed@>@;
  @<Search the geometric target@>@;
  @<Search the texture target@>@;
  tnew=CreateTextureMapping(texMapType,
                     TILE_TEXTURE_S ||TILE_TEXTURE_T,
                     (Point3D *) move,
                     (Point3D *)axis,angle,
                     (Point3D *)scale,
                     scaleU,scaleV,tlst);
  if(!tnew) @<Mapping failed@>@;
  /* If we come here, it is save to delete the old mapping */
  if(tm) DeleteTextureMapping(tm);
  tm=tnew;
  if(0==geomId)
    SceneTextureMap=tm;
  else
    MeshTexMap(mlst)=tm;
  if(SceneTextureMap)
    UpdatePolygonTextureCoord(SceneTextureMap,Polygons);
  else
    UpdateMeshTextureCoordinates(mlst);
  @<Update the object and the viewpoint@>@;
  MLPutFunction(stdlink,"List",3);
    MLPutFunction(stdlink,"DoubleLeftArrow",2);
    if(0==geomId)
      MLPutFunction(stdlink,"MVScene3D",0);
    else {
      MLPutFunction(stdlink,"MVMesh3D",1);
      MLPutInteger(stdlink,MeshID(mlst));
     }
    MLPutFunction(stdlink,"MVTexture2D",1);
      MLPutInteger(stdlink,TextureID(tm->tex));
    @<Return the mapping type to \Math@>@;
    MLPutFunction(stdlink,"List",3);
      @<Return the texture dimensions to \Math@>@;
      @<Return the texture type to \Math@>@;
  MLFlush(stdlink);
  glutPostRedisplay();
}

@ @<Mapping failed@>=
{
  MLPutSymbol(stdlink,"$Failed");
  return;
}

@ If |geomID| refers to a mesh than the |mlst| will point to this mesh.
|tm| will point to the texture mapping of the scene or to the local
mesh mapping.
@<Search the geometric target@>=
{
  int found=GL_TRUE;

  if(0==geomId)
    tm=SceneTextureMap;
  else {
    mlst=Meshes;
    found=GL_FALSE;
    while(mlst) {
      if(MeshID(mlst)==geomId) {
        tm=MeshTexMap(mlst);
        found=GL_TRUE;
        break;
       }
      mlst=mlst->next;
     }
   }
  if(!found) @<Mapping failed@>@;
}

@ @<Search the texture target@>=
tlst=Textures;
while(tlst) {
  if(textureId==TextureID(tlst)) break;
  tlst=tlst->next;
 }
if(!tlst) @<Mapping failed@>@;


@ @<Return the mapping type to \Math@>=
    switch(texMapType) {
      case TEXTURE_MAP_PLANAR:
        MLPutSymbol(stdlink,"MVPlaneMapping");
        break;
      case TEXTURE_MAP_CYLINDRICAL:
        MLPutSymbol(stdlink,"MVCylinderMapping");
        break;
      case TEXTURE_MAP_SPHERICAL:
        MLPutSymbol(stdlink,"MVSphereMapping");
        break;
      case TEXTURE_MAP_TORUS:
        MLPutSymbol(stdlink,"MVTorusMapping");
        break;
      case TEXTURE_MAP_MESH_ST:
        MLPutSymbol(stdlink,"MVMeshUVMapping");
        break;
      case TEXTURE_MAP_MESH_TS:
        MLPutSymbol(stdlink,"MVMeshVUMapping");
        break;
     }


@ @<Stuff to send the graphics data to \Math@>=
@<Send a coordinate@>@;
@<Send a mesh coordinate@>@;
@<Send a \.{Point[]} object@>@;
@<Send a \.{Line[]} or \.{Polygon[]} object@>@;
@<Return the a single mesh to \Math@>@;
@<Send all graphics data back to \Math@>@;

@ @<Send a coordinate@>=
void MLSendRawPoint(MLINK lnk,int i)
{ Point3D *p=PointPool +i;

  MLPutFunction(lnk,"List",3);
  MLPutDouble(lnk,p->x);
  MLPutDouble(lnk,p->y);
  MLPutDouble(lnk,p->z);
}

@ @<Send a mesh coordinate@>=
void MLSendRawMeshPoint(MLINK lnk, Mesh3DList *lst, int i, int j)
{ Point3D *p;

  p=MeshCoordPtr(lst,i,j);
  MLPutFunction(lnk,"List",3);
  MLPutDouble(lnk,p->x);
  MLPutDouble(lnk,p->y);
  MLPutDouble(lnk,p->z);
}

@ @<Send a \.{Point[]} object@>=
PointList *MLSendPoint(MLINK lnk, PointList *lst)
{
  MLPutFunction(lnk,"Point",1);
  MLSendRawPoint(lnk,lst->point);
  return lst->next;
}

@ @<Send a \.{Line[]} or \.{Polygon[]} object@>=
LinePolyList *MLSendLinePolygon(MLINK lnk, LinePolyList *lst)
{ int i;

  MLPutFunction(lnk,lst->what==Polygon3D ? "Polygon":"Line",1);
  MLPutFunction(lnk,"List",lst->pno);
  for(i=0; i<lst->pno; i++)
    MLSendRawPoint(lnk,lst->points[i]);
  return lst->next;
}

@ The mesh structure of the data is destroyed when the |Mesh3DList| is
returned to \Math{}.
@<Return the a single mesh to \Math@>=
Mesh3DList *MLSendMesh3D(MLINK lnk, Mesh3DList *lst)
{ int polyNo;
  int i,j,n,m;

  polyNo=(n=lst->dimU-1)*(m=lst->dimV-1);
  MLPutFunction(lnk,"List",polyNo);
  if(lst->mpolyColors)
    @<Send colored polygons to \Math@>@;
  else
    @<Send polygons to \Math@>@;
  return lst->next;
}

@ @<Send polygons to \Math@>=
for(i=0; i<n; i++)
  for(j=0; j<m; j++) {
    @<Return a single mesh polygon@>@;
   }

@ @<Send colored polygons to \Math@>=
{ RGBColor *c;

  for(i=0; i<n; i++)
    for(j=0; j<m; j++) {
      c=MeshColorPtr(lst,i,j);
      MLPutFunction(lnk,"List",2);
        MLPutFunction(lnk,"SurfaceColor",1);
          MLPutFunction(lnk,"RGBColor",3);
            MLPutDouble(lnk,c->r);
            MLPutDouble(lnk,c->g);
            MLPutDouble(lnk,c->b);
        @<Return a single mesh polygon@>@;
     }
}

@ @<Return a single mesh polygon@>=
MLPutFunction(lnk,"Polygon",1);
  MLPutFunction(lnk,"List",4);
    MLSendRawMeshPoint(lnk,lst,i,j);
    MLSendRawMeshPoint(lnk,lst,i+1,j);
    MLSendRawMeshPoint(lnk,lst,i+1,j+1);
    MLSendRawMeshPoint(lnk,lst,i,j+1);


@ @<Send all graphics data back to \Math@>=
void MLSendGraphics(void)
{ int objNo=0;
  int pointNo,lineNo,polyNo,meshNo;
  PointList *plst;
  LinePolyList *llst;
  Mesh3DList *mlst;

  pointNo=lineNo=polyNo=0;
  if(Points) {
    objNo++;
    pointNo=LengthPointList(Points);
   }
  if(Lines) {
    objNo++;
    lineNo=LengthLinePolyList(Lines);
   }
  if(Polygons) {
    objNo++;
    polyNo=LengthLinePolyList(Polygons);
   }
  if(Meshes) {
    objNo++;
    meshNo=LengthMesh3DList(Meshes);
   }
  MLPutFunction(stdlink,"Graphics3D",1);
  MLPutFunction(stdlink,"List",objNo);
  if(Points) {
    plst=Points;
    MLPutFunction(stdlink,"List",pointNo);
    while(plst) plst=MLSendPoint(stdlink,plst);
   }
  if(Lines) {
    llst=Lines;
    MLPutFunction(stdlink,"List",lineNo);
    while(llst) llst=MLSendLinePolygon(stdlink,llst);
   }
  if(Polygons) {
    llst=Polygons;
    MLPutFunction(stdlink,"List",polyNo);
    while(llst) llst=MLSendLinePolygon(stdlink,llst);
   }
  if(Meshes) {
    mlst=Meshes;
    MLPutFunction(stdlink,"List",meshNo);
    while(mlst) mlst=MLSendMesh3D(stdlink,mlst);
   }
}

@ Send the frame buffer data back to \Math. We use \Math{}s \.{RasterArray[]}
to return the bitmap.
@<Send the image as bitmap to \Math@>=
void MLSendFrameBuffer(void)
{ int w,h;
  long i,size;
  unsigned char *fbuff;
  double *dfbuffer;

  glutSetWindow(MVDrawWindow);
#if defined(__UNDEF_BACKBUFFER)
  size=DrawBufferSize;
  fbuff=(unsigned char *)calloc(size,sizeof(unsigned char));
  dfbuffer=(double *)calloc(size,sizeof(double));
  memcpy(fbuff,DrawBufferCopy,size);
  w=ScreenWidth;
  h=ScreenHeight;
#else
  w=glutGet(GLUT_WINDOW_WIDTH);
  h=glutGet(GLUT_WINDOW_HEIGHT);
  size=3*w*h;
  if(!size) {
    MLPutSymbol(stdlink,"$Failed");
    return;
   }
  fbuff=(unsigned char *)calloc(size,sizeof(unsigned char));
  dfbuffer=(double *)calloc(size,sizeof(double));
  DoPSOutput=GL_TRUE;

  glFlush();
  glFinish();
  glReadBuffer(GL_BACK);
   /* OpenGL's default 4 byte pack alignment would leave extra bytes at the
     end of each image row so that each full row contained a number of bytes
     divisible by 4.  Ie, an RGB row with 3 pixels and 8-bit componets would
     be laid out like "RGBRGBRGBxxx" where the last three "xxx" bytes exist
     just to pad the row out to 12 bytes (12 is divisible by 4). To make sure
     the rows are packed as tight as possible (no row padding), set the pack
     alignment to 1. */
  glPixelStorei(GL_PACK_ALIGNMENT,1);
  glReadPixels(0,0,w,h,GL_RGB,GL_UNSIGNED_BYTE,fbuff);
#endif
  for(i=0; i<size; i++)
    dfbuffer[i]=(double) fbuff[i]/(255.0);
  free(fbuff);
  @<Send the linear array of pixels as \.{RasterArray[]}@>@;
  free(dfbuffer);
  DoPSOutput=GL_FALSE;
  glDrawBuffer(GL_BACK);
  glutPostRedisplay();
}

@ The \Math{}-commands are
\.{RasterArray[
     Map[
       Apply[RGBColor,\#] \&,
       Partition[
         Partition[dfbuffer,3],
         w
        ],
       \{2\}
      ]
   ]
} to create the \.{RasterArray[]} from the linear data.

 @<Send the linear array of pixels as \.{RasterArray[]}@>=
  MLPutFunction(stdlink,"RasterArray",1);
    MLPutFunction(stdlink,"Map",3);
      MLPutFunction(stdlink,"Function",1);
        MLPutFunction(stdlink,"Apply",2);
          MLPutSymbol(stdlink,"RGBColor");
          MLPutFunction(stdlink,"Slot",1);
            MLPutInteger(stdlink,1);
        MLPutFunction(stdlink,"Partition",2);
          MLPutFunction(stdlink,"Partition",2);
            MLPutRealList(stdlink,dfbuffer,size);
            MLPutInteger(stdlink,3);
          MLPutInteger(stdlink,w);
        MLPutFunction(stdlink,"List",1);
          MLPutInteger(stdlink,2);

@ Save the depth buffer from \Math{}.
  
@<Save the depth buffer of the OpenGL window to a PNG file@>=
void mlRawWriteDepthBuffer(const char *fname, int fmt,double gamma, 
       int interlace, double scale)
{ char filename[512];
  int i,j,n;
  
  @<Remove double backslashs from file |fname|@>@;
  PNGSaveDepthBuffer(
    filename,
    0,0,glutGet(GLUT_WINDOW_WIDTH),glutGet(GLUT_WINDOW_HEIGHT),
    fmt,
    interlace,gamma,scale
   );
  MLPutString(stdlink,fname); 
}

@ Save a single image random dot sereogram.

@<Save the SIRDS from the depth buffer to a file@>=
void mlRawWriteSIRDS(const char *fname,
       int dpiOut, double trueWidth, double eyeSeparation, 
       double mu, int osample, double scale)
{ char filename[512];
  int i,j,n;
  
  @<Remove double backslashs from file |fname|@>@;
  PNGSaveSIRDS(filename,0,0,glutGet(GLUT_WINDOW_WIDTH),glutGet(GLUT_WINDOW_HEIGHT),
    dpiOut, trueWidth, eyeSeparation, mu, osample, scale);
  MLPutString(stdlink,fname); 
}


@ @d MLPutList(n) MLPutFunction(stdlink,"List",n)
  @<Get a \.{Graphics3D} object from \Math@>=
void mvPutGraphics3D(void)
{ long int arglen,n;
  int shade,newScene=GL_FALSE;
  double *vec;
  int isMesh;
  long int count;

  @<Hide all control dialog windows@>@;
  if(MLCheckFunction(stdlink,"List",&arglen)) {
    MLGetInteger(stdlink,&newScene);
    @<Get the plot range@>@;
    @<Get the view point@>@;
    @<Get the vertical direction@>@;
    @<Get the light sources@>@;
    @<Get the ambient light@>@;
    @<Get the box ratios@>@;
    MLGetDouble(stdlink,&PointSphereSize);
    MLGetDouble(stdlink,&LineTubeSize);
    MLGetDouble(stdlink,&LineSegmentAngle);
    @<Calculate the $\cos$ of |LineSegmentAngle|@>@;
    MLGetInteger(stdlink,&shade);
    MLGetInteger(stdlink,&TubeSegments);
    MLGetInteger(stdlink,&BlackBackground);
    /* here comes the \.{MVGrayBackground} option
       and the meaning is reversed for |BlackBackground| */
    BlackBackground=!BlackBackground;
    switch(shade) {
      case 1 :
        SmoothShading=GL_TRUE;
        WireFrame=GL_FALSE;
        break;
      case 2 :
        SmoothShading=GL_FALSE;
        WireFrame=GL_FALSE;
        break;
      case 3 :
        SmoothShading=GL_FALSE;
        WireFrame=GL_TRUE;
        break;
     }
    SetBackgroundColor(BlackBackground);
    if(newScene) {
      int i;
      @<Clear the local 3d data@>@;
     }
    if(MLCheckFunction(stdlink,"List",&count)) {
      isMesh=GetGraphics3D(stdlink,"List",count);
     }
    else {
      GetGraphics3D(stdlink,"MeshGraphics3D",count);
      isMesh=GL_TRUE;
     }
   }
  else {
    MLPutSymbol(stdlink,"$Failed");
    return;
   }
  if (Polygons) AveragedNormals(Polygons);
  @<Delete the object and make a new view@>@;
  MLPutFunction(stdlink,"List",4L);
    if(isMesh) {
      MLPutFunction(stdlink,"MVMesh3D",1);
        MLPutInteger(stdlink,MeshID(Meshes));
     }
    else MLPutFunction(stdlink,"MVScene3D",0);
  @<Respond plot range@>@;
  @<Respond view point@>@;
  @<Respond ambient light@>@;
  MLFlush(stdlink);
}

@ @<Respond plot range@>=
    MLPutFunction(stdlink,"Rule",2L);
      MLPutSymbol(stdlink,"PlotRange");
      MLPutList(3L);
        MLPutList(2L);
          MLPutReal(stdlink,BoundP1.x);
          MLPutReal(stdlink,BoundP2.x);
        MLPutList(2L);
          MLPutReal(stdlink,BoundP1.y);
          MLPutReal(stdlink,BoundP2.y);
        MLPutList(2L);
          MLPutReal(stdlink,BoundP1.z);
          MLPutReal(stdlink,BoundP2.z);

@ @<Respond view point@>=
    MLPutFunction(stdlink,"Rule",2L);
      MLPutSymbol(stdlink,"ViewPoint");
      MLPutRealList(stdlink,& ViewPoint.x,3L);

@ @<Respond ambient light@>=
    MLPutFunction(stdlink,"Rule",2L);
      MLPutSymbol(stdlink,"AmbientLight");
      MLPutRealList(stdlink,& AmbientColor.r,3L);

@ @<Get the plot range@>=
if(!MLCheckFunction(stdlink,"List",&n)) {
  MLPutSymbol(stdlink,"$Failed");
  return;
 }
else {
  MLGetRealList(stdlink,& vec,&n);
  memcpy((void *) & BoundP1, vec, n*sizeof(double));
  MLDisownRealList(stdlink,vec,n);
  MLGetRealList(stdlink,& vec,&n);
  memcpy((void *) & BoundP2, vec, n*sizeof(double));
  MLDisownRealList(stdlink,vec,n);
 }

@ @<Get the view point@>=
MLGetRealList(stdlink,& vec,&n);
memcpy((void *) & ViewPoint, vec, n*sizeof(double));
MLDisownRealList(stdlink,vec,n);

@ @<Get the box ratios@>=
MLGetRealList(stdlink,& vec,&n);
memcpy((void *) & BoxRatios, vec, n*sizeof(double));
MLDisownRealList(stdlink,vec,n);


@ @<Get the vertical direction@>=
MLGetRealList(stdlink,& vec,&n);
memcpy((void *) & ViewVertical, vec, n*sizeof(double));
MLDisownRealList(stdlink,vec,n);

@ @<Get the light sources@>=
MLGetRealList(stdlink, & vec, &n);
LightNo= n/3;
memcpy((void *) LightPosition, vec,n*sizeof(double));
MLDisownRealList(stdlink,vec,n);
MLGetRealList(stdlink, &vec, &n);
memcpy((void *) LightColor, vec,n*sizeof(double));
MLDisownRealList(stdlink,vec,n);

@ @<Get the ambient light@>=
  MLGetRealList(stdlink,& vec,&n);
  memcpy((void *) & AmbientColor, vec, n*sizeof(double));
  MLDisownRealList(stdlink,vec,n);
      
@ @<Scan the graphics data@>=
int GetGraphics3D(MLINK link,const char *head,long int count)
{ long ecount,n,coord,coord1,i;
  int k,j;
#if !MACINTOSH_MATHLINK  
  int plBuffer[8192];
#else
  int plBuffer[4096];
#endif    
  double *v, vec[3],vec1[3];
  int cubep[8];
  const char *fhead;
  double red,green,blue,sred,sgreen,sblue,dummy;
  double psize;
  int isMesh=GL_FALSE;

  fhead=head;
  ecount=count;
  n=ecount;
  red=green=blue=sred=sgreen=sblue=1.0;
  psize=0.001;
  for(i=0; i<ecount; i++) {
    @<Wait until new data passed from \Math@>@;
    MLGetFunction(link,&fhead,&n);
    if(!fhead) {
      MLDisownSymbol(link,fhead);
      continue;
     } 
#if 0     
    fprintf(stderr,"Get %s with %d arguments\n",fhead,n); 
#endif    
    if(0==strcmp(fhead,"Polygon")) {
      @<Read a polygon from \ML@>@;
     }
    else if(0==strcmp(fhead,"Line")) {
      @<Read a line from \ML@>@;
     }
    else if(0==strcmp(fhead,"Point")) {
      @<Read a point from \ML@>@;
     }
    else if(0==strcmp(fhead,"RGBColor")) {
      @<Read the rgb-color from \ML@>@;
     }
    else if(0==strcmp(fhead,"SurfaceColor")) {
      @<Read the surface color from \ML@>@;
     }
    else if(0==strcmp(fhead,"PointSize")) {
      MLGetReal(link,&psize);
     }
    else if(0==strcmp(fhead,"Cuboid")) {
     @<Read \Math\ \.{Cuboid} object@>@;
     }
    else if(0==strcmp(fhead,"EdgeForm")) {
      if(n)
        MLGetReal(link,&dummy);
     }
    else if (0==strcmp(fhead,"Thickness")) {
      MLGetReal(link,&dummy);
      }
    else if(0==strcmp(fhead,"List")) {
      GetGraphics3D(link,fhead,n);
     }
    else if(0==strcmp(fhead,"MeshGraphics3D")) {
       @<Get a \.{MeshGraphics3D}-object@>@;
       isMesh=GL_TRUE;
      }
    else {
      MLDisownSymbol(link,fhead);
      MLGetNext(link);
      continue;
     }
    MLDisownSymbol(link,fhead);
   }
  return isMesh;
}


@ The \.{MVShow3D[]} function has prepared the mesh and flatten the
data of the verticies. The optional array of colors passed
as a linear list of doubles |colors| containing the RGB values. The \CEE/ code
reconstruct the color information with help of the dimensions |cn| and |cm|
of the array. Since \Math{} does the most of error checking we test only the
consistence of the data dimensions.
@<Get a \.{MeshGraphics3D}-object@>=
{ int n,m,cn,cm;
  double *data;
  double *colors;
  long dim,cdim;
  RGBColor c={1.0,1.0,1.0};

  MLGetInteger(link,&n);
  MLGetInteger(link,&m);
  MLGetRealList(link,&data,&dim);
  MLGetInteger(link,&cn);
  MLGetInteger(link,&cm);
  MLGetRealList(link,&colors,&cdim);
  if(n*m*3==dim && 3*cn*cm==cdim)
    Meshes=PrependMesh3DList(Meshes,n,m,(Point3D *)data,&c,cn,cm,colors);
  MLDisownRealList(link,data,dim);
  MLDisownRealList(link,colors,cdim);
}

@ When a large amount of data is passed to \.{mathview3d} we must
wait until new data written to the link. Since we want avoid
nonportable acess to the event loop of the main window we suspend
the reading from the link.
@<Wait until new data passed from \Math@>=
while(!MLReady(link)) {
 MVSleep(100);
}

@ @<Read a polygon from \ML@>=
MLCheckFunction(link,"List",&n);
for(k=j=0; j<n; j++) {
  @<Wait until new data passed from \Math@>@;
  MLGetRealList(link,&v,&coord);
  if(3==coord) {
    plBuffer[k++]=AddToPointPool(v[0],v[1],v[2]);
   }
  MLDisownRealList(link,v,coord);
 }
Polygons=PrependLinePolyList(Polygons,Polygon3D,plBuffer,k,sred,sgreen,sblue);

@ @<Read a line from \ML@>=
{ int *plBuffer;
  MLCheckFunction(link,"List",&n);
  plBuffer=(int *)calloc(n+1,sizeof(int));
  for(k=j=0; j<n; j++) {
    @<Wait until new data passed from \Math@>@;
    MLGetRealList(link,&v,&coord);
    if(3==coord) {
      plBuffer[k++]=AddToPointPool(v[0],v[1],v[2]);
     }
    MLDisownRealList(link,v,coord);
   }
  Lines=PrependLinePolyList(Lines,Line3D,plBuffer,k,red,green,blue);
  free(plBuffer);
}

@ @<Read a point from \ML@>=
MLGetRealList(link,&v,&coord);
if(3==coord) {
  k=AddToPointPool(v[0],v[1],v[2]);
  Points=PrependPointList(Points,k,psize,red,green,blue);
 }
MLDisownRealList(link,v,coord);

@ @<Read \Math\ \.{Cuboid} object@>=
MLGetRealList(link,&v,&coord);
vec[0]=v[0]; @+ vec[1]=v[1]; @+ vec[2]=v[2];
MLDisownRealList(link,v,coord);
if(2==n) { /* get the optional second corner of the cuboid */
  MLGetRealList(link,&v,&coord1);
  vec1[0]=v[0]; @+ vec1[1]=v[1]; @+ vec1[2]=v[2];
  MLDisownRealList(link,v,coord1);
 }
else {
  vec1[0]=vec[0]+1.0; @+  vec1[1]=vec[1]+1.0; @+  vec1[2]=vec[2]+1.0;
  coord1=3;
 }
if(3==coord && 3==coord1) {
  plBuffer[3]=cubep[0]=AddToPointPool( vec[0],  vec[1],  vec[2]);
  plBuffer[2]=cubep[1]=AddToPointPool(vec1[0],  vec[1],  vec[2]);
  plBuffer[1]=cubep[2]=AddToPointPool(vec1[0], vec1[1],  vec[2]);
  plBuffer[0]=cubep[3]=AddToPointPool( vec[0], vec1[1],  vec[2]);
  plBuffer[4]=cubep[4]=AddToPointPool( vec[0],  vec[1], vec1[2]);
  plBuffer[5]=cubep[5]=AddToPointPool(vec1[0],  vec[1], vec1[2]);
  plBuffer[6]=cubep[6]=AddToPointPool(vec1[0], vec1[1], vec1[2]);
  plBuffer[7]=cubep[7]=AddToPointPool( vec[0], vec1[1], vec1[2]);
  Polygons=PrependLinePolyList(Polygons,Polygon3D,plBuffer,4,sred,sgreen,sblue);
  Polygons=PrependLinePolyList(Polygons,Polygon3D,plBuffer+4,4,sred,sgreen,sblue);
  plBuffer[0]=cubep[0]; @+  plBuffer[1]=cubep[1];
  plBuffer[2]=cubep[5]; @+  plBuffer[3]=cubep[4];
  Polygons=PrependLinePolyList(Polygons,Polygon3D,plBuffer,4,sred,sgreen,sblue);
  plBuffer[0]=cubep[1]; @+  plBuffer[1]=cubep[2];
  plBuffer[2]=cubep[6]; @+  plBuffer[3]=cubep[5];
  Polygons=PrependLinePolyList(Polygons,Polygon3D,plBuffer,4,sred,sgreen,sblue);
  plBuffer[0]=cubep[2]; @+  plBuffer[1]=cubep[3];
  plBuffer[2]=cubep[7]; @+  plBuffer[3]=cubep[6];
  Polygons=PrependLinePolyList(Polygons,Polygon3D,plBuffer,4,sred,sgreen,sblue);
  plBuffer[0]=cubep[3]; @+  plBuffer[1]=cubep[0];
  plBuffer[2]=cubep[4]; @+  plBuffer[3]=cubep[7];
  Polygons=PrependLinePolyList(Polygons,Polygon3D,plBuffer,4,sred,sgreen,sblue);

}


@ @<Read the rgb-color from \ML@>=
MLGetReal(link,&red);
MLGetReal(link,&green);
MLGetReal(link,&blue);

@ @<Read the surface color from \ML@>=
if(MLCheckFunction(link,"RGBColor",&n)) {
  MLGetReal(link,&sred);
  MLGetReal(link,&sgreen);
  MLGetReal(link,&sblue);
 }


@ We can't call MLMain because this will initiate a loop waiting
on \Math requests. This loop alone  causes that no events from the
window system are evaluated so we split |MLMain| into three parts.
@ @<Global values@>=
       MLINK LinkToMath;
#if !MACINTOSH_MATHLINK
       int MathLinkMode=GL_FALSE;
#else 
       int MathLinkMode=GL_TRUE;
#endif       
       int MathLinkActive=GL_FALSE;
       int DoMathematicaCall=GL_FALSE;

@ @<Initialise the \ML-connection@>=
if (MathLinkMode) {
#if 0
  init_macintosh();
#endif
  if(!stdenv)
    stdenv = MLInitialize( (MLParametersPointer)0);
  if(stdenv == (MLEnvironment)0)
    return !MLDone;
#if !MACINTOSH_MATHLINK        
  if( !stdhandler)
    stdhandler = MLCreateMessageHandler( stdenv, MLDefaultHandler, 0);
#else
	if( !stdhandler)
		stdhandler = MLCreateMessageHandler( stdenv, 
			NewMLHandlerProc( MLDefaultHandler), 0);
#endif    
    LinkToMath = MLOpenArgv( stdenv, argv, argv + argc, &err);
    if( LinkToMath == (MLINK)0){
      MLAlert( stdenv, MLErrorString( stdenv, err));
      @<Close \ML-connection@>@;
     }
#if MACINTOSH_MATHLINK
	if( stdyielder) MLSetYieldFunction( LinkToMath, stdyielder);
#endif     
    if( stdhandler) MLSetMessageHandler( LinkToMath, stdhandler);
    if(!MLInstall( LinkToMath)) {
      @<Close \ML-connection@>@;
     }
    MathLinkActive=GL_TRUE;
}


@ @<Close \ML-connection@>=
    if(LinkToMath)
      MLClose(LinkToMath);
    MLDeinitialize( stdenv);
    stdenv = (MLEnvironment)0;
    exit(!MLDone);


@ @<Function prototypes@>=
int  ProcessMathLink(MLINK *mlp);

@ @<Evaluate one message from \Math@>=
static int refuse_to_be_a_frontend(MLINK);

int  ProcessMathLink(MLINK *mlp)
{ int pkt;
   
  if(MLDone && MLError(*mlp)) {
    return 0;
  }
  while(MLReady(*mlp) && !MLDone) {
    DoMathematicaCall=GL_TRUE;
    pkt=MLNextPacket(*mlp);
    MLAbort =0;
    if(RESUMEPKT==pkt) {
      if(!refuse_to_be_a_frontend(*mlp)) return 0;
      @<Close \ML-connection@>@;
     }
    glutSetWindow(MVDrawWindow);
    glutPopWindow();
    glutPostRedisplay();
    glFinish();
    if(pkt!=CALLPKT || !MLDoCallPacket(*mlp)) return 0;
    MLFlush(*mlp);
    MLAbort =0;
    DoMathematicaCall=GL_FALSE;
  }
 return 1;
}


@ @<Check the command line for \ML@>=
int IsMathLinkCall(int argc, char *argv[])
{ int i;
#if MACINTOSH_MATHLINK
  return GL_TRUE;
#else  
  for(i=0; i<argc; i++) {
    if(strcmp(argv[i],"-mathlink")==0) return GL_TRUE;
    if(strcmp(argv[i],"-linkname")==0) return GL_TRUE;
    if(strcmp(argv[i],"-linkmode")==0) return GL_TRUE;
    if(strcmp(argv[i],"-linkcreate")==0) return GL_TRUE;
    if(strcmp(argv[i],"-linkprotocol")==0) return GL_TRUE;
   }
  return GL_FALSE;
#endif  
}


@ @<String scanning@>=
@<Pop a token from line@>@;
@<Pop a |double| from the top of |*lline|@>@;
@<Scan an |int| from the top of |*lline|@>@;
@<Trim line@>@;

@ Some basic I/O functions for scaning the initial data file.

@d STRINGLEN        256
@d BEGIN_COMMENT    '#'
@d SPACE            ' '
@d NUMBER_DELIMITER " ,:=\n"

@ |FrontToken| gets from |*l| the first token from the begin of
  |l| to the first character that is in the string |demimiter|.
  The token is retuned in |token| an the |*l| is poped. |FrontToken|
  reurns |True| if a token is found otherwise |False|.

@<Pop a token from line@>=
int FrontToken(char **l, char *delimiter, char *token)
  { register char *lline=*l;
    register unsigned int i,c;

    while ((*lline) && ((*lline==SPACE) || strchr(delimiter,*lline)))
      lline++;
    i=0;
    while ((lline[i]) && (!strchr(delimiter,lline[i])))
      i++;
    if (i>strlen(lline))
      return GL_FALSE;
    for (c=0; c<i; c++)
      token[c]=lline[c];
    token[c]='\0';
    (*l)=&lline[c];
    return GL_TRUE;
  }

@ @<Pop a |double| from the top of |*lline|@>=
double ScanDouble(char **lline, double default_val, int *fail)
  { char token[25];
    double value;

    if (FrontToken(lline,NUMBER_DELIMITER,token)) {
      *fail=sscanf(token,"%lf",&value)<1;
      return !(*fail) ? value :  default_val;
     }
    *fail = GL_TRUE;
    return default_val;
  }

@ @<Scan an |int| from the top of |*lline|@>=
int ScanInt(char **lline, int default_val, int *fail)
  { char token[25];
    int value;

    if (FrontToken(lline,NUMBER_DELIMITER,token)) {
      sscanf(token,"%d",&value);
      *fail=sscanf(token,"%d",&value)<1;
      return !(*fail) ? value : default_val;
     }
    *fail = GL_TRUE;
    return default_val;
  }

@ |PrepareLine| will remove leading spaces and cut the begin
  of an comment from the line |lline|. |lline| is modifyed so
  that a comment like |" 1.2 34 # two numbers"| is changed to
  |"1.2 34"| the new begining of the line is returned in
  |*newline|. Comment must start with a |commentchar|
@<Trim line@>=
void PrepareLine(char commentchar,char **newline, char *lline)
{ char *endp;

  (*newline)=lline;
  while (**newline==SPACE)
    (*newline)++;
  if (**newline==commentchar) {
    *newline=&lline[strlen(lline)];
    return;
   }
  endp=&lline[strlen(lline)];
  while (endp!=(*newline))
    if ((*(--endp))==commentchar) {
    *endp='\0';
    break;
   }
  }


@* Graphical user interface.

@* View Control. The view control window offers an interactive
   modification of the |ViewPoint| and the box ratios as well as
   the modification of the default export prefix and the 3Script and
   DXF file to load. It makes a heavy use of the mini user interface
   functions of the mui library. To avoid a waste of global parameters
   all data are enclosed by the |ViewCtrlWin| structure.

@<View point control window@>=
@<Redisplay the preview window@>@;
@<Reset the view point control window@>@;
@<Control callbacks@>@;
@<Copy the global paramter to the view control@>@;
@<Copy the preview paramter from the view control@>@;
@<Construct the view control window@>@;

@ @<Data structures@>=
typedef struct ViewCntrlWin {
                  int  WinID;
                  int  PreviewWinID;
                  int  muiID;
                  int  CWinX;
                  int  CWinY;
                  muiObject *ApplyButton, 
                            *HideButton, 
                            *QuitButton;
                  muiObject *FilePrefixBox,
                            *ViewPointBox,
                            *Load3ScriptBox,
                            *LoadDXFBox,
                            *BoxRatioBox;
                  muiObject *RSlider,
                            *PhiSlider,
                            *ThetaSlider,
                            *XScaleSlider,
                            *YScaleSlider,
                            *ZScaleSlider;
                  char ViewPointStr[256];
                  char BoxRatioStr[256];
                  char FilePrefix[256];
                  char Load3Script[256];
                  char LoadDXF[256];
                  double PreviewR,
                         PreviewTheta,
                         PreviewPhi;
                  Point3D PreViewPoint;
                  Point3D PreviewBox;
                 } ViewCntrlWin;

@ Create the control window and all its control elements
@<Function prototypes@>=
ViewCntrlWin *CreateViewControl(void);

@ @<Construct the view control window@>=
ViewCntrlWin *CreateViewControl(void)
{ ViewCntrlWin *vc;
  int xPos,yPos,xEnd;

  VCWindow=vc=(ViewCntrlWin *)malloc(sizeof(ViewCntrlWin));
  if(NULL==vc) return NULL;
  vc->CWinX=380;
  vc->CWinY=500;
  glutInitWindowSize(vc->CWinX,vc->CWinY);
  vc->WinID=glutCreateWindow("View Point Control");
  vc->PreViewPoint=ViewPoint;
  SphericalFromCartesian(&ViewPoint,
			 &(vc->PreviewR),
			 &(vc->PreviewTheta),
			 &(vc->PreviewPhi));
  vc->PreviewBox=BoxRatios;
  muiInit();
  muiNewUIList(vc->WinID);
  @<Create the view control buttons@>@;
  @<Create the view control text boxes@>@;
  @<Recalculate the cartesian preview view point@>@;
  @<Make $(r,\theta, \phi)$ sliders@>@;
  @<Make the $(x_s,y_s,z_s)$ sliders@>@;
  glutReshapeFunc(VCReshape);
  muiAttachUIList(vc->WinID);
  vc->muiID=muiGetActiveUIList();
  @<Make the preview window@>@;
  return vc;
}

@ Transfer the data from the main window to the view point control.
@<Function prototypes@>=
void CopyToVCWindow(void);

@ @<Copy the global paramter to the view control@>=
void CopyToVCWindow(void)
{
#if 0
fprintf(stderr,"Main      %d  ",MVDrawWindow);
fprintf(stderr,"Viewpoint %d   Preview %d\n",VCWindow->WinID,VCWindow->PreviewWinID);
fprintf(stderr,"Light     %d   Preview %d\n",LCWindow->WinID,LCWindow->PreviewWinID);
fprintf(stderr,"Axes      %d   Preview %d\n",AxisWindow->WinID,AxisWindow->PreviewWinID);
fprintf(stderr,"Active    %d\n",glutGetWindow());
#endif
  VCWindow->PreViewPoint=ViewPoint;
  SphericalFromCartesian(&ViewPoint,
			 &(VCWindow->PreviewR),
			 &(VCWindow->PreviewTheta),
			 &(VCWindow->PreviewPhi));
  while(VCWindow->PreviewPhi<0.0) VCWindow->PreviewPhi+=TWO_PI;
  VCWindow->PreviewBox=BoxRatios;;
  @<Update cartesian view point string@>@;
  @<Update box ratio string@>@;
  @<Update $(x_s,y_s,z_s)$ sliders@>@;
  @<Update $(r, \theta, \phi)$ sliders@>@;
  strcpy(VCWindow->FilePrefix,WriteFilePrefix);
  muiSetTBString(VCWindow->FilePrefixBox,VCWindow->FilePrefix);
  strcpy(VCWindow->Load3Script,"None");
  muiSetTBString(VCWindow->Load3ScriptBox,VCWindow->Load3Script);
  strcpy(VCWindow->LoadDXF,"None");
  muiSetTBString(VCWindow->LoadDXFBox,VCWindow->LoadDXF);
#if !HAVE_GLUT_SUBWINDOW
  MacPreviewPlacement(VCWindow->WinID,VCWindow->PreviewWinID,VCWindow->muiID);
#endif    
}

@ @<Function prototypes@>=
int CopyFromVCWindow(void);

@ @<Copy the preview paramter from the view control@>=
int CopyFromVCWindow(void)
{ int fail=-1;
  
  ViewPoint=VCWindow->PreViewPoint;
  BoxRatios=VCWindow->PreviewBox;
  strcpy(VCWindow->FilePrefix,muiGetTBString(VCWindow->FilePrefixBox));
  strcpy(VCWindow->Load3Script,muiGetTBString(VCWindow->Load3ScriptBox));
  strcpy(VCWindow->LoadDXF,muiGetTBString(VCWindow->LoadDXFBox));
  strcpy(WriteFilePrefix,VCWindow->FilePrefix);
  if(0!=strcmp(VCWindow->Load3Script,"None") &&
     0!=strcmp(VCWindow->Load3Script,"")) {
    fail=Read3Script(VCWindow->Load3Script);
    if(!fail) {
      AveragedNormals(Polygons);
      strcpy(VCWindow->Load3Script,"None");
     }
   }
  if(0!=strcmp(VCWindow->LoadDXF,"None") && 
     0!=strcmp(VCWindow->LoadDXF,"")) {
    fail=ReadDXF(VCWindow->LoadDXF);
    if(!fail) {
      AveragedNormals(Polygons);
      strcpy(VCWindow->LoadDXF,"None");
     } 
   } 
  muiSetTBString(VCWindow->Load3ScriptBox,VCWindow->Load3Script);
  muiSetTBString(VCWindow->LoadDXFBox,VCWindow->LoadDXF);
  return fail;
}
	    
@ @<Global values@>=
int  MVDrawWindow;
ViewCntrlWin *VCWindow=NULL;

@ @<Make the preview window@>=
#if !HAVE_GLUT_SUBWINDOW
glutInitWindowSize(200,200);
vc->PreviewWinID=glutCreateWindow("Preview");
#else
vc->PreviewWinID=glutCreateSubWindow(vc->WinID,40,vc->CWinY-305,200,200);
#endif
glutDisplayFunc(DisplayPreview);
DisplayPreview();
glutHideWindow();
glutSetWindow(vc->WinID);
glutPostRedisplay();

@ @<Function prototypes@>=
void DisplayPreview(void);
  
@ @<Redisplay the preview window@>=
void DisplayPreview(void)
{

  @<Recalculate the cartesian preview view point@>@;
  glPushMatrix();

  glViewport(0,0,glutGet(GLUT_WINDOW_WIDTH),glutGet(GLUT_WINDOW_HEIGHT));
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  glClearColor(1.0,1.0,1.0,1.0);
  glColor3f(0.0,0.0,0.0);

  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(0.5*MVViewAngle,
		  1.0,
		 MVNearPlane,MVFarPlane);
  glMatrixMode(GL_MODELVIEW);
  gluLookAt(VCWindow->PreViewPoint.x,
	    VCWindow->PreViewPoint.y,
	    VCWindow->PreViewPoint.z,
	    0.0,0.0,0.0,
	    0.0,0.0,1.0);
  glScaled(VCWindow->PreviewBox.x,
	   VCWindow->PreviewBox.y,
	   VCWindow->PreviewBox.z);
  glPushMatrix();
  glScaled(0.5,0.5,0.5);
  glutWireCube(2.0);
  glutWireIcosahedron();
  glPopMatrix();
  glutSwapBuffers();
  glPopMatrix();
}  

@ We make the view point control window fixed
  width and height.
@<Function prototypes@>=  
void VCReshape(int w, int h);

@ @<Reset the view point control window@>=
void VCReshape(int w, int h)
{
  if(w!=VCWindow->CWinX || h!=VCWindow->CWinY)
   glutReshapeWindow(VCWindow->CWinX,VCWindow->CWinY);
}

@ @<Recalculate the cartesian preview view point@>=
{ double ct,st,cp,sp;

  ct=cos(VCWindow->PreviewTheta); @+ st=sin(VCWindow->PreviewTheta);
  cp=cos(VCWindow->PreviewPhi);   @+ sp=sin(VCWindow->PreviewPhi);
  VCWindow->PreViewPoint.x=VCWindow->PreviewR*cp*st; 
  VCWindow->PreViewPoint.y=VCWindow->PreviewR*sp*st; 
  VCWindow->PreViewPoint.z=VCWindow->PreviewR*ct; 
}

@ @<Create the view control buttons@>=
{ int yOffset=0;

  xPos=10;
  yPos=100;
#if !HAVE_GLUT_SUBWINDOW
  xPos+=30;
  yPos+=30;
  yOffset+=90;
#endif     
  vc->ApplyButton=muiNewButton(xPos,yPos,yOffset+10,yOffset+35);
  muiLoadButton(vc->ApplyButton,"Apply");
  muiSetCallback(vc->ApplyButton,ApplyViewPoint);

  xPos+=100;
  yPos+=100;
  vc->HideButton=muiNewButton(xPos,yPos,yOffset+10,yOffset+35);
  muiLoadButton(vc->HideButton,"Hide");
  muiSetCallback(vc->HideButton,HidePressed);
  xPos+=170;
  yPos+=170;
  if(!MathLinkMode) {
    vc->QuitButton=muiNewButton(xPos,yPos,yOffset+10,yOffset+35);
    muiLoadButton(vc->QuitButton,"Quit");
    muiSetCallback(vc->QuitButton,QuitPressed);
  }
}

@ @<Create the view control text boxes@>=
xPos=10;
xEnd=vc->CWinX-10;
yPos=vc->CWinY-25;
(void *)muiNewBoldLabel(xPos,yPos,"Export Prefix:");
vc->FilePrefixBox=muiNewTextbox(xPos+90,xEnd,yPos-15);
muiSetTBString(vc->FilePrefixBox,"mview3d");
yPos-=30;
(void *)muiNewBoldLabel(xPos,yPos,"Load 3Script: ");
vc->Load3ScriptBox=muiNewTextbox(xPos+90,xEnd,yPos-15);
muiSetTBString(vc->Load3ScriptBox,"None");
yPos-=30;
(void *)muiNewBoldLabel(xPos,yPos,"Load DXF file: ");
vc->LoadDXFBox=muiNewTextbox(xPos+90,xEnd,yPos-15);
muiSetTBString(vc->LoadDXFBox,"None");
yPos-=30;
(void *)muiNewBoldLabel(xPos,yPos,"ViewPoint -> ");
vc->ViewPointBox=muiNewTextbox(xPos+90,xEnd,yPos-15);
muiSetCallback(vc->ViewPointBox,ManualViewPoint);

@<Update cartesian view point string@>@;
yPos-=30;
(void *)muiNewBoldLabel(xPos,yPos,"BoxRatios -> ");
vc->BoxRatioBox=muiNewTextbox(xPos+90,xEnd,yPos-15);
muiSetCallback(vc->BoxRatioBox,ManualBoundingBox);
@<Update box ratio string@>@;


@ @<Make $(r,\theta, \phi)$ sliders@>=
(void *)muiNewLabel(248,303,"theta");
vc->ThetaSlider=muiNewVSlider(250,95,295,195,5);
muiSetCallback(vc->ThetaSlider,ThetaSliderMove);
muiSetVSValue(vc->ThetaSlider,1.0-vc->PreviewTheta/PI);

#if HAVE_GLUT_SUBWINDOW
xPos=10;
yPos=55;
#else
xPos=10;
yPos=vc->CWinY-245;
#endif
(void *)muiNewLabel(xPos,yPos,"r");
vc->RSlider=muiNewHSlider(xPos+30,yPos-5,240,200,10);
muiSetCallback(vc->RSlider,RSliderMove);
muiSetHSValue(vc->RSlider,(vc->PreviewR-1.0)/8.0);
yPos+=25;
(void *)muiNewLabel(xPos,yPos,"phi");
vc->PhiSlider=muiNewHSlider(xPos+30,yPos-5,240,200,10);
muiSetCallback(vc->PhiSlider,PhiSliderMove);
muiSetHSValue(vc->PhiSlider,1.0-vc->PreviewPhi/TWO_PI);

@ @<Update $(r, \theta, \phi)$ sliders@>=
muiSetHSValue(VCWindow->RSlider,(VCWindow->PreviewR-1.0)/(MVFarPlane-MVNearPlane));
muiSetVSValue(VCWindow->ThetaSlider,1.0-VCWindow->PreviewTheta/PI);
muiSetHSValue(VCWindow->PhiSlider,VCWindow->PreviewPhi/TWO_PI);


@ @<Make the $(x_s,y_s,z_s)$ sliders@>=
(void *)muiNewBoldLabel(295,vc->CWinY-175,"Box Scaling");

(void *)muiNewLabel(305,303,"x");
vc->XScaleSlider=muiNewVSlider(295,95,295,195,5);
muiSetCallback(vc->XScaleSlider,XSliderMove);
muiSetVSValue(vc->XScaleSlider,vc->PreviewBox.x);

(void *)muiNewLabel(330,303,"y");
vc->YScaleSlider=muiNewVSlider(320,95,295,195,5);
muiSetCallback(vc->YScaleSlider,YSliderMove);
muiSetVSValue(vc->YScaleSlider,vc->PreviewBox.y);

(void *)muiNewLabel(355,303,"z");
vc->ZScaleSlider=muiNewVSlider(345,95,295,195,5);
muiSetCallback(vc->ZScaleSlider,ZSliderMove);
muiSetVSValue(vc->ZScaleSlider,vc->PreviewBox.z);

@ @<Update $(x_s,y_s,z_s)$ sliders@>=
muiSetVSValue(VCWindow->XScaleSlider,VCWindow->PreviewBox.x);
muiSetVSValue(VCWindow->YScaleSlider,VCWindow->PreviewBox.y);
muiSetVSValue(VCWindow->ZScaleSlider,VCWindow->PreviewBox.z);

@ Callbacks for the control window.
@<Control callbacks@>=
  @<Quit Button pressed@>@;
  @<Hide Button pressed@>@;
  @<Apply Button pressed@>@;
  @<$r$-Slider call back@>@;
  @<$\phi$-Slider call back@>@;
  @<$\theta$-Slider call back@>@;
  @<$x$-Slider call back@>@;
  @<$y$-Slider call back@>@;
  @<$z$-Slider call back@>@;
  @<Respond to text input of the view point@>@;
  @<Respond to text input of the bounding box@>@;
@ The idle function for the view control window.

@ Exit from the program.
@<Function prototypes@>=
void QuitPressed(muiObject *obj, enum muiReturnValue r);

@ @<Quit Button pressed@>=
#pragma argsused
void QuitPressed(muiObject *obj, enum muiReturnValue r)
{
  exit(0);
}

@ @<Function prototypes@>=
void HidePressed(muiObject *obj, enum muiReturnValue r);

@ @<Hide Button pressed@>=
#pragma argsused
void HidePressed(muiObject *obj, enum muiReturnValue r)
{
#if !HAVE_GLUT_SUBWINDOW
if(VCWindow && obj==VCWindow->HideButton){
  glutSetWindow(VCWindow->PreviewWinID);
  glutHideWindow();
  glutSetWindow(VCWindow->WinID);
 } 
else if(LCWindow && obj==LCWindow->HideButton) {
  glutSetWindow(LCWindow->PreviewWinID);
  glutHideWindow();
  glutSetWindow(LCWindow->WinID);
 } 
else if(AxisWindow && obj==AxisWindow->HideButton) {
  glutSetWindow(AxisWindow->PreviewWinID);
  glutHideWindow();
  glutSetWindow(AxisWindow->WinID);
 }  
#endif  
  glutHideWindow();
  glutSetWindow(MVDrawWindow);
}

@ @<Function prototypes@>=
void ApplyViewPoint(muiObject *obj, enum muiReturnValue r);

@ @<Apply Button pressed@>=
#pragma argsused
void ApplyViewPoint(muiObject *obj, enum muiReturnValue r)
{ int res;
  void CopyToVCWindow(void);
  int CopyFromVCWindow(void);

  res=CopyFromVCWindow();
  if(res>=0) {
    AveragedNormals(Polygons);
    CopyToVCWindow();
   }
  glutSetWindow(MVDrawWindow);
  if(res>=0) {
    @<Delete the object and make a new view@>@;
   }
  else {
    InitView(GL_TRUE);
    glutPostRedisplay();
    MakeNewView=GL_TRUE;
   }
  glutSetWindow(VCWindow->WinID);
  glutPostRedisplay();
}

@ @<Function prototypes@>=
void RSliderMove(muiObject *obj, enum muiReturnValue ret);
void PhiSliderMove(muiObject *obj, enum muiReturnValue ret);
void ThetaSliderMove(muiObject *obj, enum muiReturnValue ret);
void XSliderMove(muiObject *obj, enum muiReturnValue ret);
void YSliderMove(muiObject *obj, enum muiReturnValue ret);
void ZSliderMove(muiObject *obj, enum muiReturnValue ret);

@ @<$r$-Slider call back@>=
void RSliderMove(muiObject *obj, enum muiReturnValue ret)
{ float rs;
  if(MUI_NO_ACTION!=ret) {
    rs=muiGetHSVal(obj);
    VCWindow->PreviewR=1.0+(MVFarPlane-MVNearPlane)*rs;
    @<Force update of the preview window@>@;
   }
}

@ @<$\phi$-Slider call back@>=
void PhiSliderMove(muiObject *obj, enum muiReturnValue ret)
{ float ps;
  if(MUI_NO_ACTION!=ret) {
    ps=muiGetHSVal(obj);
    VCWindow->PreviewPhi=TWO_PI*ps;
    @<Force update of the preview window@>@;
   }
}

@ @<$\theta$-Slider call back@>=
void ThetaSliderMove(muiObject *obj, enum muiReturnValue ret)
{ float ts;
  if(MUI_NO_ACTION!=ret) {
    ts=1.0-muiGetVSVal(obj);
    if(ts==0.0) ts=TINY;/* prevent a total zero polar angle */
    VCWindow->PreviewTheta=PI*ts;
    @<Force update of the preview window@>@;
   }
}

@ @<$x$-Slider call back@>=
void XSliderMove(muiObject *obj, enum muiReturnValue ret)
{ float ts;
  if(MUI_NO_ACTION!=ret) {
    ts=muiGetVSVal(obj);
    VCWindow->PreviewBox.x=ts;
    @<Force update of the preview window@>@;
   }
}

@ @<$y$-Slider call back@>=
void YSliderMove(muiObject *obj, enum muiReturnValue ret)
{ float ts;
  if(MUI_NO_ACTION!=ret) {
    ts=muiGetVSVal(obj);
    VCWindow->PreviewBox.y=ts;
    @<Force update of the preview window@>@;
   }
}

@ @<$z$-Slider call back@>=
void ZSliderMove(muiObject *obj, enum muiReturnValue ret)
{ float ts;
  if(MUI_NO_ACTION!=ret) {
    ts=muiGetVSVal(obj);
    VCWindow->PreviewBox.z=ts;
    @<Force update of the preview window@>@;
   }
}

@ @<Respond to text input of the view point@>=
void ManualViewPoint(muiObject *obj, enum muiReturnValue ret)
{ double xc,yc,zc;

  if(MUI_TEXTBOX_RETURN==ret) {
    @<Scan three |double| values from a text box@>@;
    VCWindow->PreViewPoint.x=xc;
    VCWindow->PreViewPoint.y=yc;
    VCWindow->PreViewPoint.z=zc;
    SphericalFromCartesian(&(VCWindow->PreViewPoint),
			 &(VCWindow->PreviewR),
			 &(VCWindow->PreviewTheta),
			 &(VCWindow->PreviewPhi));
    @<Update $(r, \theta, \phi)$ sliders@>@;
    @<Force update of the preview window@>@;
   }
}

@ @<Respond to text input of the bounding box@>=
void ManualBoundingBox(muiObject *obj, enum muiReturnValue ret)
{ double xc,yc,zc;

  if(MUI_TEXTBOX_RETURN==ret) {
    @<Scan three |double| values from a text box@>@;
    if(xc>=0.0 && xc<=1.0) VCWindow->PreviewBox.x=xc;
    if(yc>=0.0 && yc<=1.0) VCWindow->PreviewBox.y=yc;
    if(zc>=0.0 && zc<=1.0) VCWindow->PreviewBox.z=zc;
    @<Update $(x_s,y_s,z_s)$ sliders@>@;
    @<Force update of the preview window@>@;
   }
}

@ The doubles are stored in |xc|, |yc| and |zc|. If the conversion fail
  |return| is called.
@<Scan three |double| values from a text box@>=
{  char txtStr[512],*l;
   int i,n,fail1,fail2,fail3;

    strcpy(txtStr,muiGetTBString(obj));
    n=strlen(txtStr);
    for(i=0; i<n; i++)
      if('{'==txtStr[i] || '}'==txtStr[i] || '['==txtStr[i] || ']'==txtStr[i]) txtStr[i]=' ';
    l=txtStr;
    xc=ScanDouble(&l,0.0,&fail1);
    yc=ScanDouble(&l,0.0,&fail2);
    zc=ScanDouble(&l,0.0,&fail3);
    if(fail1 || fail2 || fail3) return;
}

@ @<Force update of the preview window@>=
    glutSetWindow(VCWindow->PreviewWinID);
    glutPostRedisplay();
    glutSetWindow(VCWindow->WinID);
    @<Update cartesian view point string@>@;
    @<Update box ratio string@>@;


@ @<Update cartesian view point string@>=
{ double r,ct,st,cp,sp;

  ct=cos(VCWindow->PreviewTheta); @+ st=sin(VCWindow->PreviewTheta);
  cp=cos(VCWindow->PreviewPhi); @+ sp=sin(VCWindow->PreviewPhi);
  r=VCWindow->PreviewR;
  sprintf(VCWindow->ViewPointStr,"{"DBL_FMT", "DBL_FMT", "DBL_FMT"}",
	  r*cp*st,r*sp*st,r*ct);
  muiSetTBString(VCWindow->ViewPointBox,VCWindow->ViewPointStr);

}

@ @<Update box ratio string@>=
{
  sprintf(VCWindow->BoxRatioStr,"{"DBL_FMT", "DBL_FMT", "DBL_FMT"}",
	  VCWindow->PreviewBox.x,
	  VCWindow->PreviewBox.y,
	  VCWindow->PreviewBox.z);
  muiSetTBString(VCWindow->BoxRatioBox,VCWindow->BoxRatioStr);
}


@* Light Control. The light control window offers an interactive
   modification of the |LightSources|. To avoid a waste of global parameters
   all data are enclosed by the |LightCtrlWin| structure.
@<Light control window@>=
  @<Light control callbacks@>@;
  @<Copy the global data to the light control window@>@;
  @<Redisplay the light preview window@>@;
  @<Reset the light control window@>@;
  @<Construct the light control window@>@;

@ @<Data structures@>+=
typedef struct LightCntrlWin {
                  int  WinID;
                  int  PreviewWinID;
                  int  muiID;
                  int  CWinX;
                  int  CWinY;
                  muiObject *NewLSButton,
                            *DelLSButton, 
                            *ApplyButton, 
                            *HideButton, 
                            *QuitButton;
                  muiObject *CubeRButton,
                            *DodecahedronRButton,
                            *TorusRButton,
                            *SphereRButton;
                  muiObject *LTextList,
                            *PositionBox,
                            *ColorBox;
                  muiObject *RSlider,
                            *PhiSlider,
                            *ThetaSlider,
                            *RedSlider,
                            *GreenSlider,
                            *BlueSlider;
                  char *LNameN[MAX_LIGHT+1];
                  char *LNames[MAX_LIGHT+1];
                  char PositionStr[256];
                  char ColorStr[256];
                  double PreviewR,
                         PreviewTheta,
                         PreviewPhi;
                  Point3D LightPosition[MAX_LIGHT];
                  RGBColor LightColor[MAX_LIGHT];
                  int LNo;
                  int sLight;
                 } LightCntrlWin;

@ @<Global values@>+=
   LightCntrlWin *LCWindow=NULL;

@ Create the control window and all its control elements
@<Construct the light control window@>=
LightCntrlWin *CreateLightControl(void)
{ LightCntrlWin *vc;
  int xPos,yPos,xEnd,i;
  static char *lname[]={"  Light[[1]]",
		    "  Light[[2]]",
		    "  Light[[3]]",
		    "  Light[[4]]",
		    "  Light[[5]]",
		    "  Light[[6]]",
		    "  Light[[7]]",
		    "  Light[[8]]",NULL};
  
  LCWindow=vc=(LightCntrlWin *)malloc(sizeof(LightCntrlWin));
  if(NULL==vc) return NULL;
  vc->CWinX=400;
  vc->CWinY=550;
  glutInitWindowSize(vc->CWinX,vc->CWinY);
  vc->WinID=glutCreateWindow("Light Control");
  vc->PreviewR=4.4;
  vc->PreviewTheta=1.13;
  vc->PreviewPhi=1.15;
  vc->LNo=0;
  vc->sLight=-1;
  for(i=0; i<=MAX_LIGHT; i++)
    vc->LNameN[i]=lname[i];
  muiInit();
  muiNewUIList(vc->WinID);
  @<Create the light conrol buttons@>@;
  @<Create radio buttons for preview object@>@;
  @<Create the light control text boxes@>@;
  @<Make light source $(r,\theta, \phi)$ sliders@>@;
  @<Make the $(r,g,b)$ sliders@>@;
  muiAttachUIList(vc->WinID);
  vc->muiID=muiGetActiveUIList();

  @<Update color sliders@>@;
  @<Update position sliders@>@;
  @<Make the light preview window@>@;
  glutSetWindow(vc->WinID);
  glutReshapeFunc(LCReshape);
  return vc;
}

@ @<Copy the global data to the light control window@>=
void CopyToLCWindow(void)
  { int i;
    
    LCWindow->LNo=LightNo;
    for(i=0; i<LightNo; i++) {
      LCWindow->LightPosition[i]=LightPosition[i];
      LCWindow->LightColor[i]=LightColor[i];
      LCWindow->LNames[i]=LCWindow->LNameN[i];
     }
    LCWindow->LNames[LightNo]=NULL;
    muiSetTLStrings(LCWindow->LTextList,(char **)(LCWindow->LNames));
    @<Force update of the light preview window@>@;
#if !HAVE_GLUT_SUBWINDOW
    MacPreviewPlacement(LCWindow->WinID, LCWindow->PreviewWinID,LCWindow->muiID);
#endif    

  }

@ @<Make the light preview window@>=
#if HAVE_GLUT_SUBWINDOW
vc->PreviewWinID=glutCreateSubWindow(vc->WinID,40,vc->CWinY-305,200,200);
#else
glutInitWindowSize(200,200);
vc->PreviewWinID=glutCreateWindow("Preview");
#endif  
glutDisplayFunc(DisplayLightPreview);
DisplayLightPreview(); 
glutHideWindow();


@ @<Function prototypes@>=
void DisplayLightPreview(void);

@ @<Redisplay the light preview window@>=
void DisplayLightPreview(void)
{
  Point3D *p;

  glPushMatrix();

  glViewport(0,0,glutGet(GLUT_WINDOW_WIDTH),glutGet(GLUT_WINDOW_HEIGHT));
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  glClearColor(0.0,0.0,0.0,0.0);
  glColor3f(1.0,1.0,1.0);

  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(MVViewAngle,
		  1.0,
		 MVNearPlane,MVFarPlane);
  glMatrixMode(GL_MODELVIEW);
  gluLookAt(ViewPoint.x,
	    ViewPoint.y,
	    ViewPoint.z,
	    0.0,0.0,0.0,
	    0.0,0.0,1.0);
  glScaled(BoxRatios.x,
	   BoxRatios.y,
	   BoxRatios.z);
  glEnable(GL_DEPTH_TEST);
  glutWireCube(2.0);
  glShadeModel(GL_SMOOTH);
  @<Draw a line from the light position to the center@>@;
  @<Setup the lights for preview@>@;
  DefineMaterial(INHERITE_COLOR,White);
  glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
  @<Draw the body used for the preview@>@;

  glDisable(GL_LIGHTING);
  glutSwapBuffers();
  glPopMatrix();
}

@ @<Draw a line from the light position to the center@>=
  if(LCWindow->LNo>0 && 
     LCWindow->sLight>=0 && 
     LCWindow->sLight<LCWindow->LNo) {
    glLineWidth(3.0);
    glBegin(GL_LINES);
      glVertex3d(0.0,0.0,0.0);
      p=LCWindow->LightPosition+LCWindow->sLight;
      glVertex3d(p->x,p->y,p->z);
    glEnd();
    glLineWidth(1.0);
   }

@ @<Draw the body used for the preview@>=
  glPushMatrix();
  if(muiGetActive(LCWindow->SphereRButton)) 
     glutSolidSphere(1.0,36,18);
  else if(muiGetActive(LCWindow->TorusRButton))
     glutSolidTorus(0.25,0.75,18,36);	     
  else if(muiGetActive(LCWindow->DodecahedronRButton)) {
     glPushMatrix();
     glScaled(0.58,0.58,0.58);
     glutSolidDodecahedron();	     
     glPopMatrix();
    }
  else if(muiGetActive(LCWindow->CubeRButton))
     glutSolidCube(1.73);
  else
    glutSolidSphere(1.0,18,9);     
  glPopMatrix();

@  The light control window must have a fixed size as well as the
   view point control.
@<Function prototypes@>=
void LCReshape(int w, int h);
   
@ @<Reset the light control window@>=
void LCReshape(int w, int h)
{
  if(w!=LCWindow->CWinX || h!=LCWindow->CWinY)
    glutReshapeWindow(LCWindow->CWinX,LCWindow->CWinY);
}
	    
@ @<Create the light conrol buttons@>=
xPos=115;
yPos=vc->CWinY-40;
vc->NewLSButton=muiNewButton(xPos,xPos+100,yPos,yPos+30);
muiLoadButton(vc->NewLSButton,"New Light");
muiSetCallback(vc->NewLSButton,NewLightPressed); 
yPos-=35;
vc->DelLSButton=muiNewButton(xPos,xPos+100,yPos,yPos+30);
muiLoadButton(vc->DelLSButton,"Delete Light");
muiSetCallback(vc->DelLSButton,DeleteLightPressed); 

{int yOffset=0;
  
#if !HAVE_GLUT_SUBWINDOW
  yOffset+=90;
#endif       
  xPos=10;
  yPos=100;
  vc->ApplyButton=muiNewButton(xPos,yPos,10+yOffset,35+yOffset);
  muiLoadButton(vc->ApplyButton,"Apply");
  muiSetCallback(vc->ApplyButton,ApplyLightSources);
  xPos+=100;
  yPos+=100;
  vc->HideButton=muiNewButton(xPos,yPos,10+yOffset,35+yOffset);
  muiLoadButton(vc->HideButton,"Hide");
  muiSetCallback(vc->HideButton,HidePressed);
  xPos+=170;
  yPos+=170;
  if(!MathLinkMode) {
    vc->QuitButton=muiNewButton(xPos,yPos,10+yOffset,35+yOffset);
    muiLoadButton(vc->QuitButton,"Quit");
    muiSetCallback(vc->QuitButton,QuitPressed);
  }
}
	    
@ @<Create radio buttons for preview object@>=
xPos=250;
yPos=vc->CWinY-25;
muiNewBoldLabel(xPos,yPos,"Solid for Preview");
yPos-=30;
vc->CubeRButton=muiNewRadioButton(xPos,yPos);
muiLoadButton(vc->CubeRButton,"Cube");
yPos-=30;
vc->DodecahedronRButton=muiNewRadioButton(xPos,yPos);
muiLoadButton(vc->DodecahedronRButton,"Dodecahedron");
yPos-=30;
vc->TorusRButton=muiNewRadioButton(xPos,yPos);
muiLoadButton(vc->TorusRButton,"Torus");
yPos-=30;
vc->SphereRButton=muiNewRadioButton(xPos,yPos);
muiLoadButton(vc->SphereRButton,"Sphere");

muiLinkButtons(vc->CubeRButton,vc->DodecahedronRButton);
muiLinkButtons(vc->DodecahedronRButton,vc->TorusRButton);
muiLinkButtons(vc->TorusRButton,vc->SphereRButton);
muiSetActive(vc->SphereRButton,GL_TRUE);
muiSetCallback(vc->CubeRButton,SwitchSolid);
muiSetCallback(vc->DodecahedronRButton,SwitchSolid);
muiSetCallback(vc->TorusRButton,SwitchSolid);
muiSetCallback(vc->SphereRButton,SwitchSolid);

@ @<Create the light control text boxes@>=
xPos=10;
xEnd=vc->CWinX-10;
yPos=vc->CWinY-150;
vc->LTextList=muiNewTextList(xPos,yPos,xPos+100,8);
muiSetCallback(vc->LTextList,TLLightSelected);

yPos-=20;
(void *)muiNewBoldLabel(xPos,yPos-5,"Position -> ");
vc->PositionBox=muiNewTextbox(xPos+120,xEnd,yPos-15);
muiSetCallback(vc->PositionBox,ManualLightPosBox);
@<Update light position string@>@;
yPos-=30;
(void *)muiNewBoldLabel(xPos,yPos-5,"Color -> RGBColor");
vc->ColorBox=muiNewTextbox(xPos+120,xEnd,yPos-15);
muiSetCallback(vc->ColorBox,ManualLightColorBox);
@<Update $(r,g,b)$ string@>@;


@ @<Make light source $(r,\theta, \phi)$ sliders@>=
(void *)muiNewLabel(248,303,"theta");
vc->ThetaSlider=muiNewVSlider(250,95,295,195,5);
muiSetCallback(vc->ThetaSlider,LThetaSliderMove);
muiSetVSValue(vc->ThetaSlider,1.0-vc->PreviewTheta/PI);
#if HAVE_GLUT_SUBWINDOW
xPos=10;
yPos=55;
#else
xPos=10;
yPos=vc->CWinY-295;
#endif
(void *)muiNewLabel(xPos,yPos,"r");
vc->RSlider=muiNewHSlider(xPos+30,yPos-5,240,200,10);
muiSetCallback(vc->RSlider,LRSliderMove);
muiSetHSValue(vc->RSlider,(vc->PreviewR-1.0)/8.0);
yPos+=25;
(void *)muiNewLabel(xPos,yPos,"phi");
vc->PhiSlider=muiNewHSlider(xPos+30,yPos-5,240,200,10);
muiSetCallback(vc->PhiSlider,LPhiSliderMove);
muiSetHSValue(vc->PhiSlider,vc->PreviewPhi/TWO_PI);

@ @<Make the $(r,g,b)$ sliders@>=

(void *)muiNewLabel(290,303,"Red");
vc->RedSlider=muiNewVSlider(295,95,295,195,5);
muiSetCallback(vc->RedSlider,RedSliderMove);

(void *)muiNewLabel(315,303,"Green");
vc->GreenSlider=muiNewVSlider(325,95,295,195,5);
muiSetCallback(vc->GreenSlider,GreenSliderMove);

(void *)muiNewLabel(355,303,"Blue");
vc->BlueSlider=muiNewVSlider(355,95,295,195,5);
muiSetCallback(vc->BlueSlider,BlueSliderMove);

@ @<Get the selected light source@>=
LCWindow->sLight=muiGetTLSelectedItem(LCWindow->LTextList)

@ @<Update color sliders@>=
if (LCWindow->LNo>0) {
  int what;

  what=@<Get the selected light source@>;
  muiSetEnable(LCWindow->RedSlider,GL_TRUE);
  muiSetEnable(LCWindow->GreenSlider,GL_TRUE);
  muiSetEnable(LCWindow->BlueSlider,GL_TRUE);

  muiSetVSValue(LCWindow->RedSlider,LCWindow->LightColor[what].r);  
  muiSetVSValue(LCWindow->GreenSlider,LCWindow->LightColor[what].g);  
  muiSetVSValue(LCWindow->BlueSlider,LCWindow->LightColor[what].b);  
 }
else {
  muiSetVSValue(LCWindow->RedSlider,0.0);  
  muiSetVSValue(LCWindow->GreenSlider,0.0);  
  muiSetVSValue(LCWindow->BlueSlider,0.0);  
  muiSetEnable(LCWindow->RedSlider,GL_FALSE);
  muiSetEnable(LCWindow->GreenSlider,GL_FALSE);
  muiSetEnable(LCWindow->BlueSlider,GL_FALSE);
}

@ @<Update position sliders@>=
if (LCWindow->LNo>0) {
  int what;

  what=@<Get the selected light source@>;
  SphericalFromCartesian(
    LCWindow->LightPosition+what,
    &(LCWindow->PreviewR),
    &(LCWindow->PreviewTheta),
    &(LCWindow->PreviewPhi));
  while(LCWindow->PreviewPhi <0.0) LCWindow->PreviewPhi+=TWO_PI;

  muiSetEnable(LCWindow->RSlider,GL_TRUE);
  muiSetEnable(LCWindow->ThetaSlider,GL_TRUE);
  muiSetEnable(LCWindow->PhiSlider,GL_TRUE);
  muiSetHSValue(LCWindow->RSlider,(LCWindow->PreviewR-1.0)/8.0);
  muiSetVSValue(LCWindow->ThetaSlider,1.0-LCWindow->PreviewTheta/PI);
  muiSetHSValue(LCWindow->PhiSlider,LCWindow->PreviewPhi/TWO_PI);
  }
else {
  muiSetEnable(LCWindow->RSlider,GL_FALSE);
  muiSetEnable(LCWindow->ThetaSlider,GL_FALSE);
  muiSetEnable(LCWindow->PhiSlider,GL_FALSE);

  }

@ @<Disable all light source sliders@>=
  muiSetEnable(LCWindow->RSlider,GL_FALSE);
  muiSetEnable(LCWindow->ThetaSlider,GL_FALSE);
  muiSetEnable(LCWindow->PhiSlider,GL_FALSE);
  muiSetEnable(LCWindow->RedSlider,GL_FALSE);
  muiSetEnable(LCWindow->GreenSlider,GL_FALSE);
  muiSetEnable(LCWindow->BlueSlider,GL_FALSE);
  muiSetEnable(LCWindow->PositionBox,GL_FALSE);
  muiSetEnable(LCWindow->ColorBox,GL_FALSE);

@ @<Enable all light source sliders@>=
  if(!muiGetEnable(LCWindow->RSlider))
    muiSetEnable(LCWindow->RSlider,GL_TRUE);
  if(!muiGetEnable(LCWindow->ThetaSlider))
    muiSetEnable(LCWindow->ThetaSlider,GL_TRUE);
  if(!muiGetEnable(LCWindow->PhiSlider))
    muiSetEnable(LCWindow->PhiSlider,GL_TRUE);
  if(!muiGetEnable(LCWindow->RedSlider))
    muiSetEnable(LCWindow->RedSlider,GL_TRUE);
  if(!muiGetEnable(LCWindow->GreenSlider))
    muiSetEnable(LCWindow->GreenSlider,GL_TRUE);
  if(!muiGetEnable(LCWindow->BlueSlider))
    muiSetEnable(LCWindow->BlueSlider,GL_TRUE);
  if(!muiGetEnable(LCWindow->PositionBox))
    muiSetEnable(LCWindow->PositionBox,GL_TRUE);
  if(!muiGetEnable(LCWindow->ColorBox))
  muiSetEnable(LCWindow->ColorBox,GL_TRUE);

@ Callbacks for the control window.
@<Light control callbacks@>=
  @<Apply light button pressed@>@;
  @<Light $r$-Slider call back@>@;
  @<Light $\phi$-Slider call back@>@;
  @<Light $\theta$-Slider call back@>@;
  @<Red-slider call back@>@;
  @<Green-slider call back@>@;
  @<Blue-slider call back@>@;
  @<Add a new Light@>@;
  @<Delete last light@>@;
  @<Light source selected@>@;
  @<Preview Solid choosen@>@;
  @<Respond to light position text input@>@;
  @<Respond to light color text input@>@;

@ @<Apply light button pressed@>=
#pragma argsused
void ApplyLightSources(muiObject *obj, enum muiReturnValue r)
{
  int i;
  LightNo=LCWindow->LNo;
  for(i=0; i<LightNo; i++) {
    LightPosition[i]=LCWindow->LightPosition[i];
    LightColor[i]=LCWindow->LightColor[i];
   }
  glutSetWindow(MVDrawWindow);
  for(i=0; i<MAX_LIGHT; i++)
    glDisable(GL_LIGHT0+i);
  InitView(GL_TRUE);
  glutPostRedisplay();
  MakeNewView=GL_TRUE;
  glutSetWindow(LCWindow->WinID);
  glutPostRedisplay();
}

@ @<Add a new Light@>=
#pragma argsused
void NewLightPressed(muiObject *obj, enum muiReturnValue res)
{ int save;

  if(LCWindow->LNo < MAX_LIGHT) {
    (LCWindow->LNo)++;
    LCWindow->LNames[LCWindow->LNo-1]=LCWindow->LNameN[LCWindow->LNo-1];
    save=LCWindow->sLight;
    LCWindow->sLight=LCWindow->LNo-1;
    CurrentPos.x=0.0;
    CurrentPos.y=0.0;
    CurrentPos.z=1.5;
    LCWindow->PreviewR=1.5;
    LCWindow->PreviewPhi=0.0;
    LCWindow->PreviewTheta=0.0;
    CurrentColor.r=CurrentColor.g=CurrentColor.b=1.0;
    LCWindow->LNames[LCWindow->LNo]=NULL;
    LCWindow->sLight=save;
    muiSetTLStrings(LCWindow->LTextList,(char **)(LCWindow->LNames));
    @<Force update of the light preview window@>@;
   }

}

@ @<Delete last light@>=
#pragma argsused
void DeleteLightPressed(muiObject *obj, enum muiReturnValue res)
{
  if(LCWindow->LNo > 0) {
    (LCWindow->LNo)--;
    LCWindow->LNames[LCWindow->LNo]=NULL;
    muiSetTLStrings(LCWindow->LTextList,(char **)(LCWindow->LNames));
    @<Force update of the light preview window@>@;
   }
}

@ @<Preview Solid choosen@>=
#pragma argsused
void SwitchSolid(muiObject *obj, enum muiReturnValue res)
{
  if(MUI_BUTTON_PRESS==res) {
    @<Force update of the light preview window@>@;
   }
}

@ @<Light source selected@>=
#pragma argsused
void TLLightSelected(muiObject *obj, enum muiReturnValue res)
{ int save,what;

  if(MUI_TEXTLIST_RETURN==res) {
    save=LCWindow->sLight;
    what=@<Get the selected light source@>;
    if(what>=LCWindow->LNo) {
      @<Disable all light source sliders@>@;
      LCWindow->sLight=save;
      return;
     }
    @<Enable all light source sliders@>@;
    @<Force update of the light preview window@>@;
   }
}

@ @<Light $r$-Slider call back@>=
void LRSliderMove(muiObject *obj, enum muiReturnValue ret)
{ float rs;

  if(MUI_SLIDER_RETURN==ret && LCWindow->LNo>=0) {
    rs=muiGetHSVal(obj);
    LCWindow->PreviewR=1.0+8.0*rs;
    @<Set cartesian light position@>@;
    @<Force update of the light preview window@>@;
   }
}

@ @<Light $\phi$-Slider call back@>=
void LPhiSliderMove(muiObject *obj, enum muiReturnValue ret)
{ float ps;

  if(MUI_SLIDER_RETURN==ret && LCWindow->LNo>=0) {
    ps=muiGetHSVal(obj);
    LCWindow->PreviewPhi=TWO_PI*ps;
    @<Set cartesian light position@>@;
    @<Force update of the light preview window@>@;
   }
}

@ @<Light $\theta$-Slider call back@>=
void LThetaSliderMove(muiObject *obj, enum muiReturnValue ret)
{ float ts;

  if(MUI_SLIDER_RETURN==ret && LCWindow->LNo>=0) {
    ts=1.0-muiGetVSVal(obj);
    LCWindow->PreviewTheta=PI*ts;
    @<Set cartesian light position@>@;
    @<Force update of the light preview window@>@;
   }
}

@ @<Red-slider call back@>=
void RedSliderMove(muiObject *obj, enum muiReturnValue ret)
{ float ts;
  if(MUI_SLIDER_RETURN==ret && LCWindow->sLight>=0) {
    ts=muiGetVSVal(obj);
    @<Get the selected light source@>;
    CurrentColor.r=ts;
    @<Force update of the light preview window@>@;
   } 
}  

@ @<Green-slider call back@>=
void GreenSliderMove(muiObject *obj, enum muiReturnValue ret)
{ float ts;
  if(MUI_SLIDER_RETURN==ret && LCWindow->sLight>=0) {
    ts=muiGetVSVal(obj);
    @<Get the selected light source@>;
    CurrentColor.g=ts;
    @<Force update of the light preview window@>@;
   }
}  

@ @<Blue-slider call back@>=
void BlueSliderMove(muiObject *obj, enum muiReturnValue ret)
{ float ts;
  if(MUI_SLIDER_RETURN==ret && LCWindow->sLight>=0) {
    ts=muiGetVSVal(obj);
    @<Get the selected light source@>;
    CurrentColor.b=ts;
    @<Force update of the light preview window@>@;
   } 
}  

@ @<Respond to light position text input@>=
void ManualLightPosBox(muiObject *obj, enum muiReturnValue ret)
{ double xc,yc,zc;

  if(MUI_TEXTBOX_RETURN==ret) {
    @<Get the selected light source@>;
    @<Scan three |double| values from a text box@>@;
    CurrentPos.x=xc;
    CurrentPos.y=yc;
    CurrentPos.z=zc;
    @<Force update of the light preview window@>@;
   }
}

@ @<Respond to light color text input@>=
void ManualLightColorBox(muiObject *obj, enum muiReturnValue ret)
{ double xc,yc,zc;

  if(MUI_TEXTBOX_RETURN==ret) {
    @<Get the selected light source@>;
    @<Scan three |double| values from a text box@>@;
    CurrentColor.r=xc;
    CurrentColor.g=yc;
    CurrentColor.b=zc;
    @<Force update of the light preview window@>@;
   }
}
 
	    
@ @<Force update of the light preview window@>=
    @<Update position sliders@>@;
    @<Update light position string@>@;
    @<Update color sliders@>@;
    @<Update $(r,g,b)$ string@>@;
    glutSetWindow(LCWindow->PreviewWinID);
    glutPostRedisplay();
    glutSetWindow(LCWindow->WinID);

@ @<Update light position string@>=
{
  if(LCWindow->LNo>=0) {
    @<Get the selected light source@>;
    @<Set cartesian light position@>@;
    sprintf(LCWindow->PositionStr,"{"DBL_FMT", "DBL_FMT", "DBL_FMT"}",
  	    CurrentPos.x,CurrentPos.y,CurrentPos.z);
   }
  else
    strcpy(LCWindow->PositionStr,"");
  muiSetTBString(LCWindow->PositionBox,LCWindow->PositionStr);

}

@ @<Set cartesian light position@>=
{ double r,ct,st,cp,sp;

  @<Get the selected light source@>;
  ct=cos(LCWindow->PreviewTheta); @+ st=sin(LCWindow->PreviewTheta);
  cp=cos(LCWindow->PreviewPhi); @+ sp=sin(LCWindow->PreviewPhi);
  r=LCWindow->PreviewR;
  CurrentPos.x=r*cp*st;
  CurrentPos.y=r*sp*st;
  CurrentPos.z=r*ct;
}

@
@d CurrentColor LCWindow->LightColor[LCWindow->sLight]
@d CurrentPos LCWindow->LightPosition[LCWindow->sLight]

@<Update $(r,g,b)$ string@>=
{ if(LCWindow->LNo>=0) {
    sprintf(LCWindow->ColorStr,"["DBL_FMT", "DBL_FMT", "DBL_FMT"]",
  	    CurrentColor.r,
	    CurrentColor.g,
	    CurrentColor.b);
   }
  else
    strcpy(LCWindow->ColorStr,"");
  muiSetTBString(LCWindow->ColorBox,LCWindow->ColorStr);
}

@ @<Setup the lights for preview@>=
  DefineLightSources(
       LCWindow->LightPosition,
       LCWindow->LightColor,
       LCWindow->LNo,
       AmbientColor);

@* Axis Editor window.

@ We will use a global |struct| that store the axis information and a |struct| for
the window data.

@ The |Origin| entry store the position of the axis origin,
  |AxisType| determine the shape of the axis, the boolean
  |NumericLabels| switch the numbers at the axis on and of.
  |FontScale| allow an additional size change of the characters.
 
@d NoAxis 0
@d CrossAxis 1
@d BoxAxis   2
@d PlaneAxis 4
@<Data structures@>+=
typedef struct AxisData3D {
                  Point3D Origin;
                  int AxisType;
                  int NumericLabels;
                  double FontScale;  
                  char XLabel[128], 
                       YLabel[128], 
                       ZLabel[128];

                } AxisData3D;

typedef struct AxisCtrlWin {
                  int  WinID;
                  int  PreviewWinID;
                  int  muiID;
                  int  CWinX;
                  int  CWinY;
                  int  VObject;
                  muiObject *ApplyButton, 
                            *HideButton, 
                            *QuitButton;
                  muiObject *NoneRButton,
                            *CrossRButton,
                            *BoxRButton,
                            *PlaneRButton;  
             
                  muiObject *NumLabelRButton;
                  muiObject *XLabelBox,
                            *YLabelBox,
                            *ZLabelBox,    
                            *OriginBox;
                  muiObject 
                            *XOriginSlider,
                            *YOriginSlider,
                            *ZOriginSlider,
                            *FontScaleSlider;
                  Point3D Origin;
                  char OriginStr[512];
                  int AxisType;
                  int NumericLabels;
                  double FontScale;  
                  char XLabel[128], 
                       YLabel[128], 
                       ZLabel[128];
                 } AxisCtrlWin;


@ @<Global values@>=
AxisCtrlWin *AxisWindow;
static AxisData3D Axis={ {0.0,0.0,0.0}, NoAxis, GL_FALSE, 0.25, "x","y","z"};

@ Create the control window and all its control elements
@<Function prototypes@>=
AxisCtrlWin *CreateAxisControl(void);

@ @<Construct the axis editor window@>=
AxisCtrlWin *CreateAxisControl(void)
{ AxisCtrlWin *vc;
  int xPos,yPos,xEnd;
  
  AxisWindow=vc=(AxisCtrlWin *)malloc(sizeof(AxisCtrlWin));
  if(NULL==vc) return NULL;
  vc->CWinX=400;
  vc->CWinY=550;
  vc->FontScale=0.25;
  glutInitWindowSize(vc->CWinX,vc->CWinY);
  vc->WinID=glutCreateWindow("Axis Editor");
  muiInit();
  muiNewUIList(vc->WinID);
  @<Create the axis conrol buttons@>@;
  @<Create the buttons for the axis type@>@; 
  @<Create the axis control text boxes@>@;
  @<Create the button for the numeric labels@>@;
  @<Make the $(x,y,z)$ origin sliders@>@;

  muiAttachUIList(vc->WinID);
  vc->muiID=muiGetActiveUIList();
  
  @<Make the axis preview window@>@;
  glutSetWindow(vc->WinID);
  glutReshapeFunc(AWReshape);
  return vc;
}

@ @<Axis editor creation@>=
@<Redisplay the axis preview window@>@;
@<Construct the axis editor window@>@;

@ @<Make the axis preview window@>=
#if HAVE_GLUT_SUBWINDOW
vc->PreviewWinID=glutCreateSubWindow(vc->WinID,10,vc->CWinY-305,250,250);
#else
glutInitWindowSize(250,250);
vc->PreviewWinID=glutCreateWindow("Preview");
#endif  
glutDisplayFunc(DisplayAxisPreview);
DisplayAxisPreview(); 
glutHideWindow();
glutSetWindow(vc->WinID);


@ @<Function prototypes@>=
void DisplayAxisPreview(void);
 
@ @<Redisplay the axis preview window@>=
void DisplayAxisPreview(void)
{
  glPushMatrix();
  glPushAttrib(GL_ALL_ATTRIB_BITS);
  glViewport(0,0,glutGet(GLUT_WINDOW_WIDTH),glutGet(GLUT_WINDOW_HEIGHT));
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);


  glColor3f(1.0,1.0,1.0);

  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(MVViewAngle,
		  1.0,
		 MVNearPlane,MVFarPlane);
  glMatrixMode(GL_MODELVIEW);
  gluLookAt(ViewPoint.x,
	    ViewPoint.y,
	    ViewPoint.z,
	    0.0,0.0,0.0,
	    0.0,0.0,1.0);
  ScalingToUnitCube(&BoundP1,&BoundP2);
  glTranslated(-CenterOfScene.x,-CenterOfScene.y,-CenterOfScene.z);

  glEnable(GL_DEPTH_TEST);
  DefineLightSources(LightPosition,LightColor,LightNo,AmbientColor);
  DrawAxis(AxisWindow->AxisType,
    & AxisWindow->Origin,& BoundP1,& BoundP2,
    AxisWindow->XLabel,AxisWindow->YLabel,AxisWindow->ZLabel,
    AxisWindow->FontScale,AxisWindow->NumericLabels);
  glShadeModel(GL_SMOOTH);

  glutSwapBuffers();
  glPopAttrib();
  glPopMatrix();
}

@ This stuff is adapted from P. Heckberts \.{Label.c} to draw nice labels
along the axis.
@<Axis drawing@>=
@<Render a string@>@;
@<Integer power@>@;
@<Nice number close to |x|@>@;
@<Label the axis with numbers@>@;
@<Draw the 3d axis@>@;

@ @<Function prototypes@>=
void RenderString(char *label);

@ @<Render a string@>=
void RenderString(char *label)
{
  while(*label)
    glutStrokeCharacter(GLUT_STROKE_ROMAN,*(label++));
}

@ @<Function prototypes@>=
double expt(double a,register int  n);

@ @<Integer power@>= 
double expt(double a,register int  n)
{
    double x;

    x = 1.;
    if (n>0) for (; n>0; n--) x *= a;
    else for (; n<0; n++) x /= a;
    return x;
}


@ Nice numbers. |nicenum| finds a ``nice'' number approximately equal to |x|.
 * Round the number if |round=1|, take ceiling if |round=0|
@<Function prototypes@>=
double nicenum(double x, int round);

@ @<Nice number close to |x|@>=
double nicenum(double x, int round)
{
  int expv;				/* exponent of x */
  double f;				/* fractional part of x */
  double nf;				/* nice, rounded fraction */

  expv = floor(log10(x));
  f = x/expt(10., expv);		/* between 1 and 10 */
  if (round)
    if (f<1.5) nf = 1.;
    else if (f<3.) nf = 2.;
    else if (f<7.) nf = 5.;
    else nf = 10.;
  else
    if (f<=1.) nf = 1.;
    else if (f<=2.) nf = 2.;
    else if (f<=5.) nf = 5.;
    else nf = 10.;
  return nf*expt(10., expv);
}

@ |loose_label| demonstrate loose labeling of data range from min to max.
@d NTICK (5)
@<Function prototypes@>=
void loose_label(double min, double max,
            Point3D *p1, Point3D *p2, double fntscale,
            double alpha, Point3D *axis,
            Point3D *offset);
            
@ @<Label the axis with numbers@>= 
void loose_label(double min, double max,
            Point3D *p1, Point3D *p2, double fntscale,
            double alpha, Point3D *axis,
            Point3D *offset)
{  double t;
   Point3D p;
    char str[6], temp[20];
    int nfrac;
    double d;				/* tick mark spacing */
    double graphmin, graphmax;		/* graph range min and max */
    double range, x,boxSize;

    if(min==max) return;
    boxSize=MAX3(offset->x,offset->y,offset->z);
    /* we expect min!=max */
    range = nicenum(max-min, 0);
    d = nicenum(range/(NTICK-1), 1);
    graphmin = floor(min/d)*d;
    graphmax = ceil(max/d)*d;
    nfrac = MAX(-floor(log10(d)), 0);	/* # of fractional digits to show */
    sprintf(str, "%%.%df", nfrac);	/* simplest axis labels */

    glPushAttrib(GL_ALL_ATTRIB_BITS); 
    for (x=graphmin; x<graphmax+.5*d; x+=d) {
      sprintf(temp, str, x);
      t=(x-min)/(max-min);
      if(t<0.0 || t> 1.0) continue;
      p.x=p1->x*(1.-t)+t*p2->x;
      p.y=p1->y*(1.-t)+t*p2->y;
      p.z=p1->z*(1.-t)+t*p2->z;
      glPushMatrix();
      glTranslated(p.x,p.y,p.z);
      glEnable(GL_LIGHTING);
      glutSolidCube(boxSize);
      glDisable(GL_LIGHTING);
      glPopMatrix();
      glPushMatrix();
      glTranslated(p.x+offset->x,p.y+offset->y,p.z+offset->z);
      glRotated(alpha,axis->x,axis->y,axis->z);
      glScaled(fntscale,fntscale,fntscale);
      RenderString(temp);
      glPopMatrix();
    }
   glPopAttrib(); 
}

@ @<Function prototypes@>=
void DrawAxis(int type, Point3D *origin, 
       Point3D *p1, Point3D *p2,
       char *xlabel,char *ylabel,char *zlabel, double fntScale,int numlabel);

@ @<Draw the 3d axis@>=
void DrawAxis(int type, Point3D *origin, 
       Point3D *p1, Point3D *p2,
       char *xlabel,char *ylabel,char *zlabel, double fntScale,int numlabel)
{ double f;
  double scale;

  glPushAttrib(GL_ALL_ATTRIB_BITS);

  scale=0.5*MAX3(p2->x-p1->x,p2->y-p1->y,p2->z-p1->z);
  glColor3d(1.0-ClearColor.r,1.0-ClearColor.g,1.0-ClearColor.b);
  if(NoAxis==type) return;
  glDisable(GL_LIGHTING);
  @<Draw the axis origin@>@;
  glEnable(GL_LIGHTING);
  if(CrossAxis==type) 
    @<Draw arrow heads@>@;
  if(type>CrossAxis) {
    if(BoxAxis==(type & BoxAxis)) {
     @<Draw the box axis@>@;
     }
    else {
     @<Draw the plane axis@>@;
     }
   }
  @<Draw the axis labels@>@;
  glPopAttrib();
}

@ @<Draw the axis origin@>=
  glColor3f(0.0f,1.0f,0.0f);
  glBegin(GL_LINES);
  glVertex3d(p1->x,origin->y,origin->z);
  glVertex3d(p2->x,origin->y,origin->z);
  glEnd();
  glBegin(GL_LINES);
  glVertex3d(origin->x,p1->y,origin->z);
  glVertex3d(origin->x,p2->y,origin->z);
  glEnd();
  glBegin(GL_LINES);
  glVertex3d(origin->x,origin->y,p1->z);
  glVertex3d(origin->x,origin->y,p2->z);
  glEnd();

@ Draw arrow heads at the end of the axis.
@d AxisArrowBase (0.05*scale) 
@<Draw arrow heads@>=
{
  glPushMatrix();
  glEnable(GL_LIGHTING);
  glTranslated(p2->x,origin->y,origin->z);
  glRotated(0.5*PI*ToDegree,0.,1.,0.);
  glColor3d(0.0,1.0,0.0);
  glutSolidCone(AxisArrowBase,2.*AxisArrowBase,18,2);
  glPopMatrix();
  glPushMatrix();
  glTranslated(origin->x,p2->y,origin->z);
  glRotated(-0.5*PI*ToDegree,1.,0.,0.);
  glutSolidCone(AxisArrowBase,2.*AxisArrowBase,18,2);
  glPopMatrix();
  glPushMatrix();
  glTranslated(origin->x,origin->y,p2->z);
  glutSolidCone(AxisArrowBase,2.*AxisArrowBase,18,2);
  glDisable(GL_LIGHTING);
  glPopMatrix();
}

@ @<Draw the box axis@>=
  glDisable(GL_LIGHTING);
  glColor3d(1.0-ClearColor.r,1.0-ClearColor.g,1.0-ClearColor.b);

  glBegin(GL_LINE_STRIP);
  glVertex3d(p1->x,p1->y,p1->z);
  glVertex3d(p2->x,p1->y,p1->z);
  glVertex3d(p2->x,p2->y,p1->z);
  glVertex3d(p1->x,p2->y,p1->z);
  glVertex3d(p1->x,p1->y,p1->z);

  glVertex3d(p1->x,p1->y,p2->z);
  glVertex3d(p2->x,p1->y,p2->z);
  glVertex3d(p2->x,p2->y,p2->z);
  glVertex3d(p1->x,p2->y,p2->z);
  glVertex3d(p1->x,p1->y,p2->z);
  glEnd();
  glBegin(GL_LINES);
  glVertex3d(p2->x,p1->y,p1->z);
  glVertex3d(p2->x,p1->y,p2->z);
  glEnd();
  glBegin(GL_LINES);
  glVertex3d(p2->x,p2->y,p1->z);
  glVertex3d(p2->x,p2->y,p2->z);
  glEnd();
  glBegin(GL_LINES);
  glVertex3d(p1->x,p2->y,p1->z);
  glVertex3d(p1->x,p2->y,p2->z);
  glEnd();
  glBegin(GL_LINE_STRIP);
  glVertex3d(origin->x,p1->y,p1->z);
  glVertex3d(origin->x,p2->y,p1->z);
  glVertex3d(origin->x,p2->y,p2->z);
  glVertex3d(origin->x,p1->y,p2->z);
  glVertex3d(origin->x,p1->y,p1->z);
  glEnd();
  glBegin(GL_LINE_STRIP);
  glVertex3d(p1->x,origin->y,p1->z);
  glVertex3d(p2->x,origin->y,p1->z);
  glVertex3d(p2->x,origin->y,p2->z);
  glVertex3d(p1->x,origin->y,p2->z);
  glVertex3d(p1->x,origin->y,p1->z);
  glEnd();
  glBegin(GL_LINE_STRIP);
  glVertex3d(p1->x,p1->y,origin->z);
  glVertex3d(p2->x,p1->y,origin->z);
  glVertex3d(p2->x,p2->y,origin->z);
  glVertex3d(p1->x,p2->y,origin->z);
  glVertex3d(p1->x,p1->y,origin->z);
  glEnd();
  glEnable(GL_LIGHTING);

@ @<Draw the plane axis@>=
glDisable(GL_LIGHTING);
glColor3d(1.0-ClearColor.r,1.0-ClearColor.g,1.0-ClearColor.b);

glBegin(GL_LINE_STRIP);
glVertex3d(p1->x,p1->y,origin->z);
glVertex3d(p2->x,p1->y,origin->z);
glVertex3d(p2->x,p2->y,origin->z);
glVertex3d(p1->x,p2->y,origin->z);
glVertex3d(p1->x,p1->y,origin->z);
glEnd();
glBegin(GL_LINE_STRIP);
glVertex3d(p1->x,origin->y,p1->z);
glVertex3d(p2->x,origin->y,p1->z);
glVertex3d(p2->x,origin->y,p2->z);
glVertex3d(p1->x,origin->y,p2->z);
glVertex3d(p1->x,origin->y,p1->z);
glEnd();
glBegin(GL_LINE_STRIP);
glVertex3d(origin->x,p1->y,p1->z);
glVertex3d(origin->x,p2->y,p1->z);
glVertex3d(origin->x,p2->y,p2->z);
glVertex3d(origin->x,p1->y,p2->z);
glVertex3d(origin->x,p1->y,p1->z);
glEnd();
  
glEnable(GL_LIGHTING);


@ @<Draw the axis labels@>=
{ Point3D tp1,tp2,axis,offset;

  if(BlackBackground)
    glColor3d(1.0,1.0,1.0);
  else
    glColor3d(0.0,0.0,0.0);
   
  f=fntScale*scale/119.5;
  @<Draw the $x$-label@>@;
  @<Draw the $y$-label@>@;
  @<Draw the $z$-label@>@;
  if(numlabel) {
    f*=0.5; /* make the numeric label smaller */
    axis.x=1.0; @+ axis.y=0.0; axis.z=0.0;
  
    tp1=tp2=AxisWindow->Origin;
    tp1.x=BoundP1.x; @+ tp2.x=BoundP2.x;
    offset.x=0.0; offset.y=AxisArrowBase; @+offset.z=0.0;
    loose_label(BoundP1.x,BoundP2.x,&tp1,&tp2,f,0.0,&axis,&offset);

    tp1=tp2=AxisWindow->Origin;
    tp1.y=BoundP1.y; @+ tp2.y=BoundP2.y;
    offset.x=AxisArrowBase; offset.y=0; @+offset.z=0.0;
    loose_label(BoundP1.y,BoundP2.y,&tp1,&tp2,f,0.0,&axis,&offset);

    tp1=tp2=AxisWindow->Origin;
    tp1.z=BoundP1.z; @+ tp2.z=BoundP2.z;
    loose_label(BoundP1.z,BoundP2.z,&tp1,&tp2,f,0.5*PI*ToDegree,&axis,&offset);
   }
}

@ @<Draw the $x$-label@>=
  if(*xlabel) {
    glPushMatrix();
    glTranslated(p2->x+AxisArrowBase,origin->y+AxisArrowBase,origin->z+AxisArrowBase);
    glRotated(0.5*PI*ToDegree,1.0,0.0,0.0);
    glScaled(f,f,f);
    RenderString(xlabel);
    glPopMatrix();
   }

@ @<Draw the $y$-label@>=
  if(*ylabel) {
    glPushMatrix();
    glTranslated(origin->x+AxisArrowBase,p2->y+AxisArrowBase,origin->z+AxisArrowBase);
    glRotated(0.5*PI*ToDegree,1.0,0.0,0.0);
    glScaled(f,f,f);
    RenderString(ylabel);
    glPopMatrix();
   }

@ @<Draw the $z$-label@>=
  if(*zlabel) {
    glPushMatrix();
    glTranslated(origin->x+AxisArrowBase,origin->y+AxisArrowBase,p2->z+2.*AxisArrowBase);
    glRotated(0.5*PI*ToDegree,1.0,0.0,0.0);
    glScaled(f,f,f);
    RenderString(zlabel);
    glPopMatrix();
   }

@ @<Create the axis conrol buttons@>=
{ int yOffset=0;

  xPos=10;
  yPos=100;
#if !HAVE_GLUT_SUBWINDOW
  yOffset+=90;
#endif    
  vc->ApplyButton=muiNewButton(xPos,yPos,10+yOffset,35+yOffset);
  muiLoadButton(vc->ApplyButton,"Apply");
  muiSetCallback(vc->ApplyButton,ApplyAxis);

  xPos+=100;
  yPos+=100;
  vc->HideButton=muiNewButton(xPos,yPos,10+yOffset,35+yOffset);
  muiLoadButton(vc->HideButton,"Hide");
  muiSetCallback(vc->HideButton,HidePressed);
  if(!MathLinkMode) {
    xPos+=170;
    yPos+=170;
    vc->QuitButton=muiNewButton(xPos,yPos,10+yOffset,35+yOffset);
    muiLoadButton(vc->QuitButton,"Quit");
    muiSetCallback(vc->QuitButton,QuitPressed);
  }
}  


@ @<Create the buttons for the axis type@>=
xPos=10;
yPos=vc->CWinY-25;
muiNewBoldLabel(xPos,yPos,"Axis Type");
yPos-=30;
vc->NoneRButton=muiNewRadioButton(xPos,yPos);
muiLoadButton(vc->NoneRButton,"None");
yPos-=30;
vc->CrossRButton=muiNewRadioButton(xPos,yPos);
muiLoadButton(vc->CrossRButton,"Cross");
yPos-=30;
vc->BoxRButton=muiNewRadioButton(xPos,yPos);
muiLoadButton(vc->BoxRButton,"Box");
yPos-=30;
vc->PlaneRButton=muiNewRadioButton(xPos,yPos);
muiLoadButton(vc->PlaneRButton,"Plane");

muiLinkButtons(vc->NoneRButton,vc->CrossRButton);
muiLinkButtons(vc->CrossRButton,vc->BoxRButton);
muiLinkButtons(vc->BoxRButton,vc->PlaneRButton);
muiSetActive(vc->NoneRButton,GL_TRUE);
muiSetCallback(vc->NoneRButton,SwitchAxis);
muiSetCallback(vc->CrossRButton,SwitchAxis);
muiSetCallback(vc->BoxRButton,SwitchAxis);
muiSetCallback(vc->PlaneRButton,SwitchAxis);

@ @<Create the button for the numeric labels@>=
xPos=10;
yPos=vc->CWinY-190;
vc->NumLabelRButton=muiNewRadioButton(xPos,yPos);
muiLoadButton(vc->NumLabelRButton,"Numeric Labels");
muiSetCallback(vc->NumLabelRButton,SwitchAxisSolid);

@ @<Create the axis control text boxes@>=
xPos=155;
xEnd=vc->CWinX-10;
yPos=vc->CWinY-25;
muiNewBoldLabel(xPos,yPos,"AxesLabel");
yPos-=30;
vc->XLabelBox=muiNewTextbox(xPos,xEnd-60,yPos-15);
muiNewLabel(xEnd-50,yPos,"x-Axis");
yPos-=40;
vc->YLabelBox=muiNewTextbox(xPos,xEnd-60,yPos-15);
muiNewLabel(xEnd-50,yPos,"y-Axis");
yPos-=40;
vc->ZLabelBox=muiNewTextbox(xPos,xEnd-60,yPos-15);
muiNewLabel(xEnd-50,yPos,"z-Axis");

xPos=10;
yPos=vc->CWinY-200;

yPos-=20;
(void *)muiNewBoldLabel(xPos,yPos-5,"Origin -> ");
vc->OriginBox=muiNewTextbox(xPos+80,xEnd,yPos-15);

muiSetCallback(vc->XLabelBox,AxesTextChange);
muiSetCallback(vc->YLabelBox,AxesTextChange);
muiSetCallback(vc->ZLabelBox,AxesTextChange);
muiSetCallback(vc->OriginBox,AxesTextChange);


@ @<Make the $(x,y,z)$ origin sliders@>=

(void *)muiNewLabel(300,303,"x");
vc->XOriginSlider=muiNewVSlider(295,95,295,195,5);
muiSetCallback(vc->XOriginSlider,OriginSliderMove); 

(void *)muiNewLabel(330,303,"y");
vc->YOriginSlider=muiNewVSlider(325,95,295,195,5);
muiSetCallback(vc->YOriginSlider,OriginSliderMove); 

(void *)muiNewLabel(360,303,"z");
vc->ZOriginSlider=muiNewVSlider(355,95,295,195,5);
muiSetCallback(vc->ZOriginSlider,OriginSliderMove); 

xPos=155;
xEnd=vc->CWinX-10;
yPos=vc->CWinY-185;

(void *) muiNewBoldLabel(xPos,yPos,"FontSize");
vc->FontScaleSlider=muiNewHSlider(xPos+60,yPos-5,xEnd,xPos+60,5);
muiSetHSValue(vc->FontScaleSlider,AxisWindow->FontScale);
muiSetCallback(vc->FontScaleSlider,OriginSliderMove);


@ @<Update axis origin sliders@>=
{ Point3D so;
  
  so.x=(AxisWindow->Origin.x-BoundP1.x)/(BoundP2.x-BoundP1.x);
  so.y=(AxisWindow->Origin.y-BoundP1.y)/(BoundP2.y-BoundP1.y);
  so.z=(AxisWindow->Origin.z-BoundP1.z)/(BoundP2.z-BoundP1.z);

  muiSetVSValue(AxisWindow->XOriginSlider,so.x);  
  muiSetVSValue(AxisWindow->YOriginSlider,so.y);  
  muiSetVSValue(AxisWindow->ZOriginSlider,so.z);  
}  


@ Callbacks for the control window.
@<Control callbacks@>+=
  @<Reshape the axis editor window@>@;
  @<Copy the global data to the axis window@>@;
  @<Apply axis button pressed@>@;
  @<Axis preview Solid choosen@>@;
  @<Axis type choosen@>@;
  @<Axis control textboxes callback@>@;
  @<Origin slider call back@>@;

@ @<Reshape the axis editor window@>=
void AWReshape(int w, int h)
{
  if(w!=AxisWindow->CWinX || h!=AxisWindow->CWinY)
    glutReshapeWindow(AxisWindow->CWinX,AxisWindow->CWinY);
}


@ @<Apply axis button pressed@>=
#pragma argsused
void ApplyAxis(muiObject *obj, enum muiReturnValue r)
{
  Axis.AxisType=AxisWindow->AxisType;
  Axis.Origin=AxisWindow->Origin;
  Axis.NumericLabels=AxisWindow->NumericLabels;
  Axis.FontScale=AxisWindow->FontScale;
  @<Textbox axis label to axis data@>@;
  strcpy(Axis.XLabel,AxisWindow->XLabel);
  strcpy(Axis.YLabel,AxisWindow->YLabel);
  strcpy(Axis.ZLabel,AxisWindow->ZLabel);

  glutSetWindow(MVDrawWindow);
  InitView(GL_TRUE);
  glutPostRedisplay();
  MakeNewView=GL_TRUE;
  glutSetWindow(AxisWindow->PreviewWinID);
  glutPostRedisplay();
  glutSetWindow(AxisWindow->WinID);
  glutPostRedisplay();

}

@ @<Copy the global data to the axis window@>=
void CopyToAxisWindow(void)
{

  AxisWindow->AxisType=Axis.AxisType;
  AxisWindow->Origin=Axis.Origin;
  AxisWindow->NumericLabels=Axis.NumericLabels;
  AxisWindow->FontScale=Axis.FontScale;
  strcpy(AxisWindow->XLabel,Axis.XLabel);
  strcpy(AxisWindow->YLabel,Axis.YLabel);
  strcpy(AxisWindow->ZLabel,Axis.ZLabel);
  @<Axis data to Textbox@>@;
  @<Update the origin string@>@;
#if !HAVE_GLUT_SUBWINDOW
  MacPreviewPlacement(AxisWindow->WinID, AxisWindow->PreviewWinID,AxisWindow->muiID);
#endif   
}

@ @<Axis preview Solid choosen@>=
#pragma argsused
void SwitchAxisSolid(muiObject *obj, enum muiReturnValue res)
{
  if(MUI_BUTTON_PRESS==res) {
    @<Force update of the axis preview window@>@;
   } 
}

@ @<Axis type choosen@>=
#pragma argsused
void SwitchAxis(muiObject *obj, enum muiReturnValue res)
{
  if(muiGetActive(AxisWindow->CrossRButton))
    AxisWindow->AxisType=CrossAxis;
  else if(muiGetActive(AxisWindow->BoxRButton))
    AxisWindow->AxisType=BoxAxis;
  else if(muiGetActive(AxisWindow->PlaneRButton))
    AxisWindow->AxisType=PlaneAxis;
  else
    AxisWindow->AxisType=NoAxis; 
  if(MUI_BUTTON_PRESS==res) {
    @<Force update of the axis preview window@>@;
   } 
}

@ @<Axis control textboxes callback@>=
void AxesTextChange(muiObject *obj,enum muiReturnValue res) 
{ double xc,yc,zc;

  if(MUI_TEXTBOX_RETURN==res) {
    if(obj==AxisWindow->XLabelBox || obj==AxisWindow->YLabelBox || obj==AxisWindow->ZLabelBox) {
      @<Textbox axis label to axis data@>@;
     } 
    else if(obj==AxisWindow->OriginBox) {
      @<Scan three |double| values from a text box@>@;
      AxisWindow->Origin.x=xc;
      AxisWindow->Origin.y=yc;
      AxisWindow->Origin.z=zc;
     }
    @<Force update of the axis preview window@>@;
   }
}

@ @<Textbox axis label to axis data@>=
 strcpy(AxisWindow->XLabel,muiGetTBString(AxisWindow->XLabelBox));
 strcpy(AxisWindow->YLabel,muiGetTBString(AxisWindow->YLabelBox));
 strcpy(AxisWindow->ZLabel,muiGetTBString(AxisWindow->ZLabelBox));

@ @<Axis data to Textbox@>=
 muiSetTBString(AxisWindow->XLabelBox,AxisWindow->XLabel);
 muiSetTBString(AxisWindow->YLabelBox,AxisWindow->YLabel);
 muiSetTBString(AxisWindow->ZLabelBox,AxisWindow->ZLabel);

@ @<Origin slider call back@>=
void OriginSliderMove(muiObject *obj, enum muiReturnValue ret)
{ float ts;
  if(MUI_SLIDER_RETURN==ret) {
    ts=muiGetVSVal(obj);
  
    if(obj==AxisWindow->XOriginSlider)
      AxisWindow->Origin.x=ts*(BoundP2.x-BoundP1.x) + BoundP1.x;
    else if(obj==AxisWindow->YOriginSlider)
      AxisWindow->Origin.y=ts*(BoundP2.y-BoundP1.y) + BoundP1.y;
    else if(obj==AxisWindow->ZOriginSlider)
      AxisWindow->Origin.z=ts*(BoundP2.z-BoundP1.z) + BoundP1.z;
    else if(obj==AxisWindow->FontScaleSlider) {
       ts=muiGetHSVal(obj);
       AxisWindow->FontScale=ts;
      }
    @<Force update of the axis preview window@>@;
   } 
}  


@ @<Force update of the axis preview window@>=
    AxisWindow->NumericLabels=muiGetActive(AxisWindow->NumLabelRButton);
    @<Update the origin string@>@;
    glutSetWindow(AxisWindow->PreviewWinID);
    SetBackgroundColor(BlackBackground);

    glutPostRedisplay();
    glutSetWindow(AxisWindow->WinID);


@ @<Update the origin string@>=
{ 
  sprintf(AxisWindow->OriginStr,"{"DBL_FMT", "DBL_FMT", "DBL_FMT"}",
  	    AxisWindow->Origin.x,
	    AxisWindow->Origin.y,
	    AxisWindow->Origin.z);
  muiSetTBString(AxisWindow->OriginBox,AxisWindow->OriginStr);
} 


@*Header. We must define |MATHGL_MAIN| here to get the proper storage class
for the global data from the other modules.
@<Header@>=
#define MATHGL_MAIN
#include <assert.h>
#include <stdlib.h>				
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <ctype.h>
#include <float.h>
#include "GL/glut.h"
#include "mui/mui.h"
#include "mathlink.h"
#include "cmdln.h"
#include "savepng.h"
#if !(defined(__WIN32__) && defined(__BORLANDC__))
# include <unistd.h>
#endif
#ifdef __WIN32__
#  include <commdlg.h>
#  include <dos.h>
#  include <alloc.h>
#endif
#if MACINTOSH_MATHLINK
#  include <StandardFile.h>
#endif
@* Index.
